//STRIPPEDSOURCE//

package com.ms.wfc.app;

import com.ms.dll.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ole32.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates the Win32 system Clipboard. 
 *
 * @security(checkDllCalls=off)
 * @security(checkClassLinking=on)
 */
public final class Clipboard {

    
    private static native IOleDataObject OleGetClipboard();
    
    private static native void OleSetClipboard(IOleDataObject pDataObj);
    
    private static native void OleFlushClipboard();
    
    private static native void OleIsCurrentClipboard(IOleDataObject ppDataObj);

    /**
     * Sends data to the system Clipboard. 
     * This function places a reference to the data on the clipboard. If the
     * application is shutdown, the data will be removed from the clipboard.
     *
     * @param data Data to place on the clipboard.
     */
    public static void setDataObject(Object data) {}

    /**
     * Sends data to the system Clipboard. 
     * This function places data on the clipboard. If <i>copy</i> is set to true
     * then a persistent copy of the data will be placed on the clipboard, else
     * a reference to the data will be put on the clipboard, and the data will
     * be removed when the application is shutdown.
     *
     * @param data Data to place on the clipboard.
     * @param copy Determines if the data is copied to the clipboard, or placed
     *        on the clipboard as a reference.
     */
    public static void setDataObject(Object data, boolean copy) {}

    /**
     * Retrieves any data that is currently on the Clipboard. 
     *
     * @returns data that is currently on the clipboard.
     */
    public static IDataObject getDataObject() {}
}