//STRIPPEDSOURCE//

package com.ms.wfc.app;

/**
 * MethodInvoker is a simple delegate that is used to invoke a method with 
 * a void parameter list.  This is handy when making calls to a control's
 * <b>invoke</b> method, or anytime you need a simple delegate but don't
 * want to define one yourself.
 * <p>
 * Here is a simple example of using a MethodInvoker to start a new thread
 * in a WFC application:
 * <p>
 * <pre>
 * private void threadRoutine() {
 *     // Thread loop goes here
 * }
 * Application.createThread(new MethodInvoker(this.threadRoutine));
 * </pre>
 * MethodInvoker is very similar to Java's Runnable method, except that the 
 * method can have any name and can be declared to be private.
 *
 * @security(checkClassLinking=on)
 */
public delegate void MethodInvoker();