//STRIPPEDSOURCE//
package com.ms.wfc.app;

import com.ms.wfc.core.*;


/**
 * Provides fields that represent special system folders.
 * @security(checkClassLinking=on)
 */
public class SpecialFolder extends Enum {
    /**
     * Specifies the file system directory that serves as a common repository for
     * application-specific data.
     */
    public static final int APPLICATION_DATA = 1;
    /**
     * Specifies the file system directory that serves as a common repository for documents.
     */
    public static final int USER_DATA = 2;
    /**
     * Specifies the file system directory that serves as a common repository for Internet
     * cookies.
     */
    public static final int COOKIES = 3;
    /**
     * Specifies the file system directory used to physically store file objects on the
     * desktop.
     */
    public static final int DESKTOP_DIRECTORY = 4;
    /**
     * Specifies the file system directory that serves as a common repository for the user's
     * favorite items.
     */
    public static final int FAVORITES = 5;
    /**
     * Specifies the file system directory that serves as a common repository for Internet
     * history items.
     */
    public static final int HISTORY = 6;
    /**
     * Specifies the file system directory that serves as a common repository for temporary
     * Internet files.
     */
    public static final int INTERNET_CACHE = 7;
    /**
     * Specifies the file system directory that contains the user's program groups.
     */
    public static final int PROGRAMS = 8;
    /**
     * Specifies the file system directory that contains shortcuts to the user's most recently
     * used documents.
     */
    public static final int RECENT = 9;
    /**
     * Specifies the file system directory that contains Send To menu items.
     */
    public static final int SENDTO = 10;
    /**
     * Specifies the file system directory containing Start menu items.
     */
    public static final int START_MENU = 11;
    /**
     * Specifies the file system directory that corresponds to the user's Startup program
     * group. The system starts these programs whenever any user logs on to 
     * Windows NT or starts Windows 95.
     */
    public static final int STARTUP = 12;
    /**
     * Specifies the file system directory that serves as a common repository for document
     * templates.
     */
    public static final int TEMPLATES = 13;

    public static boolean valid(int value) {}
}