//STRIPPEDSOURCE//

package com.ms.wfc.app;

import com.ms.wfc.ui.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.com.*;
import com.ms.wfc.ole32.*;

/**
 * Provides information about the operating system.
 * @security(checkDllCalls=off)
 * @security(checkClassLinking=on)
 */
public class SystemInformation {

    
    
    private SystemInformation() {}

    
    
    private static boolean multiMonitorSupport = false;
    private static boolean nativeMouseWheelSupport = true;
    private static boolean hasGetSpecialFolderPath = true;

    private static final int CSIDL_DESKTOP                   = 0x0000;
    private static final int CSIDL_INTERNET                  = 0x0001;
    private static final int CSIDL_PROGRAMS                  = 0x0002;
    private static final int CSIDL_CONTROLS                  = 0x0003;
    private static final int CSIDL_PRINTERS                  = 0x0004;
    private static final int CSIDL_PERSONAL                  = 0x0005;
    private static final int CSIDL_FAVORITES                 = 0x0006;
    private static final int CSIDL_STARTUP                   = 0x0007;
    private static final int CSIDL_RECENT                    = 0x0008;
    private static final int CSIDL_SENDTO                    = 0x0009;
    private static final int CSIDL_BITBUCKET                 = 0x000a;
    private static final int CSIDL_STARTMENU                 = 0x000b;
    private static final int CSIDL_DESKTOPDIRECTORY          = 0x0010;
    private static final int CSIDL_DRIVES                    = 0x0011;
    private static final int CSIDL_NETWORK                   = 0x0012;
    private static final int CSIDL_NETHOOD                   = 0x0013;
    private static final int CSIDL_FONTS                     = 0x0014;
    private static final int CSIDL_TEMPLATES                 = 0x0015;
    private static final int CSIDL_COMMON_STARTMENU          = 0x0016;
    private static final int CSIDL_COMMON_PROGRAMS           = 0X0017;
    private static final int CSIDL_COMMON_STARTUP            = 0x0018;
    private static final int CSIDL_COMMON_DESKTOPDIRECTORY   = 0x0019;
    private static final int CSIDL_APPDATA                   = 0x001a;
    private static final int CSIDL_PRINTHOOD                 = 0x001b;
    private static final int CSIDL_ALTSTARTUP                = 0x001d;         
    private static final int CSIDL_COMMON_ALTSTARTUP         = 0x001e;         
    private static final int CSIDL_COMMON_FAVORITES          = 0x001f;
    private static final int CSIDL_INTERNET_CACHE            = 0x0020;
    private static final int CSIDL_COOKIES                   = 0x0021;
    private static final int CSIDL_HISTORY                   = 0x0022;
    private static final int CSIDL_FLAG_CREATE               = 0x8000;      
    
    
    private static native int SHGetSpecialFolderPath(int hwndOwner, StringBuffer lpszPath, int nFolder, boolean fCreate);
    
    private static native int SHGetSpecialFolderLocation(int hwndOwner, int nFolder, int[] pidl);
    
    private static native int SHGetPathFromIDList(int pidl, StringBuffer lpszPath);
    
    private static native int SHGetMalloc(IMalloc[] ppunk);
    
    /**
     * Retrieves the path to a specific special folder.  Special folders are
     * common locations to store various types of data.
     *
     * @param folder Special folder to retrieve the path to.
     *
     * @return a path to the special folder.
     *
     * @see com.ms.wfc.app.SpecialFolder
     */
    public static final String getSpecialFolderPath(int folder) {}
    
    
    
    
    
    private static native boolean SystemParametersInfo(int nAction, int nParam, RECT rc, int nUpdate);
    
    private static native boolean SystemParametersInfo(int nAction, int nParam, int[] rc, int nUpdate);

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    /**
     * Determines if the user has enabled full window drag. When this is set to
     * <b>true</b>, the contents of windows will be displayed when moving and
     * sizing.
     *
     * @return <b>true</b> if the user has enabled full window drag.
     */
    public static boolean getDragFullWindows() {}
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    /**
     * Retrieves the number of lines to scroll when the mouse wheel is rotated.  
     *
     * @return the number of lines to scroll.
     */
    public static final int getMouseWheelScrollLines() {}
    

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    


    
    
    
    
    /**
     * Retrieves the width and height, in pixels, of the screen of the primary display monitor
     * when multiple monitors are installed. 
     *
     * @return the size, in pixels of the primary monitor.
     */
    public static final Point getPrimaryMonitorSize() {}
    
    /**
     * Retrieves the width, in pixels, of the vertical scroll bar.  
     *
     * @return the width of a vertical scroll bar.
     */
    public static final int getVertScrollBarWidth() {}
    
    /**
     * Retrieves the height, in pixels, of the horizontal scroll bar. 
     *
     * @return the height of a horizontal scroll bar.
     */
    public static final int getHorizScrollBarHeight() {}
    
    /**
     * Retrieves the height, in pixels, of the normal caption area of a window. 
     *
     * @return the height of the caption area.
     */
    public static final int getCaptionHeight() {}
    
    /**
     * Retrieves the width and height, in pixels, of a window border.  This is equivalent to  
     * 3DBorderSize for windows with a 3D look.
     *
     * @return the size of a sizeable window border.
     */
    public static final Point getBorderSize() {}
    
    /**
     * Retrieves the thickness, in pixels, of the frame around the perimeter of a window that
     * is not sizable. 
     *
     * @return the size of a fixed sized window border.
     */
    public static final Point getFixedFrameBorderSize() {}
    
    /**
     * Retrieves the height, in pixels, of the scroll box on a vertical scroll bar. 
     *
     * @return the height of a vertical scroll thumb.
     */
    public static final int getVertScrollBarThumbHeight() {}
    
    /**
     * Retrieves the width, in pixels, of the scroll box in a horizontal scroll bar. 
     *
     * @return the width of a horizontal scroll thumb.
     */
    public static final int getHorizScrollBarThumbWidth() {}
    
    /**
     * Retrieves the default width and height, in pixels, of an icon. 
     *
     * @return the default icon size.
     */
    public static final Point getIconSize() {}
    
    /**
     * Retrieves the width and height, in pixels, of a cursor.  The system cannot create 
     * cursors of other sizes.
     *
     * @return the system cursor size.
     */
    public static final Point getCursorSize() {}
    
    /**
     * Retrieves the height, in pixels, of a single-line menu bar. 
     *
     * @return the height of one line of a menu.
     */
    public static final int getMenuHeight() {}
    
    /**
     * Retrieves the size of the working area.   The working area is the
     * portion of the screen not obscured by the system tray.
     *
     * @return the size of the working area, in pixels.
     */
    public static final Rectangle getWorkingArea() {}
    
    /**
     * For double-byte character set (DBCS) versions of Windows, retrieves the height, in
     * pixels, of the Kanji window at the bottom of the screen. 
     * 
     * @return the height of the Kanji window.
     */
    public static final int getKanjiWindowHeight() {}
    
    /**
     * Determines whether the system has a mouse installed. 
     * 
     * @return <b>True</b> if a mouse is installed, <b>false</b> otherwise. 
     */
    public static final boolean getMousePresent() {}
    
    /**
     * Retrieves the height, in pixels, of the arrow image on the vertical scroll bar. 
     *
     * @return the height of a vertical scroll bar arrow.
     */
    public static final int getVertScrollBarArrowHeight() {}
    
    /**
     * Retrieves the width, in pixels, of the arrow on a horizontal scroll bar. 
     *
     * @return the width of a horizontal scroll bar arrow.
     */
    public static final int getHorizScrollBarArrowWidth() {}
    
    /**
     * Determines whether your application is running on a debug version of the operating
     * system.  
     * 
     * @return <b>true</b> if the debugging version of USER.EXE is installed, 
     *         <b>false</b> otherwise.
     */
    public static final boolean getDebug() {}
    
    /**
     * Determines whether the usage of the left and right mouse buttons has been swapped. 
     * 
     * @return <b>true</b> if the meanings of the left and right mouse buttons are swapped,
     *         <b>false</b> otherwise.
     */
    public static final boolean getMouseButtonsSwapped() {}
    
    /**
     * Retrieves the minimum width and height, in pixels, of a window. 
     *
     * @return the minimum allowable size of a window.
     */
    public static final Point getMinimumWindowSize() {}
    
    /**
     * Retrieves the width and height, in pixels, of a button in a window's caption or title
     * bar.  
     *
     * @return the dimensions of a caption bar button.
     */
    public static final Point getCaptionButtonSize() {}
    
    /**
     * Retrieves the thickness, in pixels, of the sizing border around the perimeter of a
     * window that can be resized. 
     *
     * @return the width and height of a sizing border for a sizeable window.
     */
    public static final Point getFrameBorderSize() {}
    
    /**
     * Retrieves the minimum tracking width and height, in pixels, of a window.  The user 
     * cannot drag the window frame to a size smaller that these dimensions. A
     * Form can override these values by overriding getMinTrackSize.
     *
     * @see cor.ms.wd.ui.Form.getMinTrackSize
     *
     * @return the default minimum tracking size the system will allow.
     */
    public static final Point getMinWindowTrackSize() {}
    
    /**
     * Retrieves the width and height, in pixels, of the rectangle around the location of a
     * first click in a double-click sequence.  The second click must occur
     * within this rectangle for the system to consider the two clicks a 
     * double-click. (The two clicks must also occur within a specified time.)
     *
     * @return the size of an imaginary rectangle around which a double click must occur.
     */
    public static final Point getDoubleClickSize() {}
    
    /**
     * Retrieves the dimensions, in pixels, of a grid cell for items in a large icon view.  
     * each item fits into a rectangle of this size when arranged. This value
     * is always greater than or equal to IconSize.
     *
     * @see #getIconSize
     * @return the icon arranging grid dimensions.
     */
    public static final Point getIconSpacingSize() {}
    
    /**
     * Determines whether drop-down menus are right-aligned. 
     * 
     * @return <b>true</b> if drop-down menus are right-aligned with the 
     *         corresponding menu-bar item, <b>false</b> if the menus are left-aligned.
     */
    public static final boolean getRightAlignedMenus() {}
    
    /**
     * Determines whether the Microsoft Windows for Pen Computing extensions are installed. 
     * 
     * @return <b>true</b> if the extensions are installed, <b>false</b> if not.
     */
    public static final boolean getPenWindows() {}
    
    /**
     * Determines whether the operating system supports the double-byte character set (DBCS).   Note that just because an operating system supports
     * DBCS, that does not mean that the user is running a locale that uses it.
     * 
     * @return <b>true</b> if the operating system supports DBCS, <b>false</b>
     *         otherwise.  
     */
    public static final boolean getDBCSEnabled() {}
    
    /**
     * Retrieves the number of buttons on the mouse connected to the system. 
     *
     * @return the number of buttons on the mouse.
     */
    public static final int getMouseButtons() {}
    
    /**
     * Determines whether security is present on this operating system. 
     * 
     * @return <b>true</b> if security is present, <b>false</b> if otherwise.
     */
    public static final boolean getSecure() {}
    
    /**
     * Retrieves the dimensions, in pixels, of a three-dimensional border.  This is the 3-D counterpart of
     * BorderSize.
     *
     * @see #getBorderSize
     * @return the dimensions of the border.
     */
    public static final Point get3DBorderSize() {}
    
    /**
     * Retrieves the dimensions, in pixels, of a grid cell for minimized windows.  Each 
     * minimized window fits into a rectangle this size when arranged. This
     * value is always greater than or equal to MinimizedSize.
     *
     * @see #getMinimizedSize
     * @return the grid into which minimized windows will be placed.
     */
    public static final Point getMinimizedWindowSpacingSize() {}
    
    /**
     * Retrieves the recommended dimensions, in pixels, of a small icon.  Small icons typically
     * appear in window captions and in small icon view.
     *
     * @return the size of a small icon.
     */
    public static final Point getSmallIconSize() {}
    
    /**
     * Retrieves the height, in pixels, of a small caption.   Small captions are
     * used in floating tool windows.
     *
     * @return the height of a small caption.
     */
    public static final int getToolWindowCaptionHeight() {}
    
    /**
     * Retrieves the dimensions, in pixels, of small caption buttons.   Small
     * captions are used in floating tool windows.
     *
     * @return the size of small caption buttons.
     */
    public static final Point getToolWindowCaptionButtonSize() {}
    
    /**
     * Retrieves the dimensions, in pixels, of menu bar buttons. 
     *
     * @return the size of menu bar buttons.
     */
    public static final Point getMenuButtonSize() {}
    
    /**
     * Provides information about the operating system.
     *
     * @security(checkClassLinking=on)
     */
    public static class ArrangeStartingPosition {
        
        /**
         * Start at the lower-left corner of the screen (default position).
         */
        public static final int BOTTOMLEFT = win.ARW_BOTTOMLEFT;
        
        /**
         * Start at the lower-right corner of the screen.
         */
        public static final int BOTTOMRIGHT = win.ARW_BOTTOMRIGHT;
        
        /**
         * Hide minimized windows by moving them off the visible area of the 
         * screen.
         */
        public static final int HIDE = win.ARW_HIDE;
        
        /**
         * Start at the upper-left corner of the screen.
         */
        
        public static final int TOPLEFT = win.ARW_TOPLEFT;
        
        /**
         * Start at the upper-right corner of the screen.
         */
        public static final int TOPRIGHT = win.ARW_TOPRIGHT;
    }

    /**
     * Provides information about the operating system.
     *
     * @security(checkClassLinking=on)
     */
    public static class ArrangeDirection {
        
        /**
         * Arrange vertically, top to bottom.
         */
        public static final int DOWN = win.ARW_DOWN;
        
        /**
         * Arrange horizontally, left to right.
         */
        public static final int LEFT = win.ARW_LEFT;
        
        /**
         * Arrange horizontally, right to left.
         */
        public static final int RIGHT = win.ARW_RIGHT;
        
        /**
         * Array vertically, bottom to top.
         */
        public static final int UP = win.ARW_UP;
    }

    /**
     * Retrieves a flag specifying how the system arranges minimized windows.  The value
     * is a combination of one StartingPosition value and one Direction value.
     *  
     * @return a boolean combination of ArrangeStartingPosition and ArrangeDirection
     *         values.
     *
     * @see com.ms.wfc.app.SystemInformation.ArrangeStartingPosition
     * @see com.ms.wfc.app.SystemInformation.ArrangeDirection
     */
    public static final int getArrange() {}
    
    /**
     * Retrieves the dimensions, in pixels, of a normal minimized window. 
     *
     * @return the size of a normal minimized window.
     */
    public static final Point getMinimizedWindowSize() {}
    
    /**
     * Retrieves the default maximum dimensions, in pixels, of a window that has a caption and
     * sizing borders.  This metric refers to the entire desktop. The user cannot
     * drag the window frame to a size larger than these dimensions. A Form can
     * override this value by overriding the getMaxTrackSize method.
     *
     * @return the maximum size a window can be sized to.
     *
     * @see com.ms.wfc.ui.Form#getMaxTrackSize
     */
    public static final Point getMaxWindowTrackSize() {}
    
    /**
     * Retrieves the default dimensions, in pixels, of a maximized top-left window on the
     * primary monitor. 
     *
     * @return the dimensions of a maximized window on the primary monitor.
     */
    public static final Point getPrimaryMonitorMaximizedWindowSize() {}
    
    /**
     * Determines whether this computer is on a network. 
     * 
     * @return <b>true</b> if a network is present, <b>false</b> otherwise.
     */
    public static final boolean getNetwork() {}
    
    /**
     * Retrieves a value that specifies how the system was started.   It may be one
     * of the following values:
     * <pre>
     * 0 Normal boot
     * 1 Fail-safe boot
     * 2 Fail-safe with network boot
     * </pre>
     * Fail-safe boot (also called SafeBoot) bypasses the user's startup files.
     * 
     * @return a code indicating how the system was booted.
     */
    public static final int getCleanBoot() {}
    
    /**
     * Retrieves the width and height, in pixels, of a rectangle centered on a drag point to
     * allow for limited movement of the mouse pointer before a drag operation begins.  This allows the user to click and release the mouse button easily
     * without unintentionally starting a drag operation.
     *
     * @return a rectangle that a drag must extend to be considered a drag.
     */
    public static final Point getDragSize() {}
    
    /**
     * Determines whether the user requires an application to present information visually in
     * situations where it would otherwise present the information audibly. 
     * 
     * @return <b>true</b> if the application should visually show audible output,
     *         or <b>false</b> if the application can freely use audio.
     */
    public static final boolean getShowSounds() {}
    
    /**
     * Retrieves the dimensions, in pixels, of the default menu check mark. 
     *
     * @return the default size of a menu checkmark.
     */
    public static final Point getMenuCheckSize() {}
    
    /**
     * Determines if the operating system supports Hebrew and Arabic languages. 
     *
     * @return <b>true</b> if the system is enabled for Hebrew or Arabic, <b>false</b>
     *         otherwise.
     */
    public static final boolean getMidEastEnabled() {}

    /**
     * Determines whether the operating system natively supports a mouse wheel. 
     * Note that mouse wheel operations that occur through a com.ms.wfc.ui.Control object
     * work even if the system does not natively support the wheel.
     * 
     * @return <b>true</b> if the system natively supports the mouse wheel, or
     *         <b>false</b> otherwise.
     */
    public static final boolean getNativeMouseWheelSupport() {}


    /**
     * Determines whether the mouse that is currently installed on the system has a mouse
     * wheel.
     * 
     * @return <b>true</b> if a mouse with a mouse wheel is installed, <b>false</b>
     *         otherwise.
     */
    public static final boolean getMouseWheelPresent() {}

    
    /**
     * Retrieves the bounds of the virtual screen.  The virtual screen is the bounding 
     * rectangle of all display monitors.
     *
     * @return the bounding rectangle of the entire virtual screen.  Note that the left
     *         and top coordinates can be nonzero or negative.
     */
    public static final Rectangle getVirtualScreen() {}

    
    /**
     * Retrieves the number of monitors that are connected to the system. 
     *
     * @return the number of monitors that make up the desktop.
     */
    public static final int getMonitorCount() {}

    
    /**
     * Determines if all monitors currently connected to the system have the same color
     * format. For example red, green, and blue pixels can
     * be encoded with different number of bits, or those bits can be located
     * in different places in a pixel's color value.
     *
     * @return <b>true</b> if all monitors have the same color format, <b>false</b>
     *         otherwise.
     */
    public static final boolean getMonitorsSameDisplayFormat() {}

    
    
    
    
    private static native boolean GetComputerName(StringBuffer lpBuffer, int[] nSize);
    
    private static native boolean GetUserName(StringBuffer lpBuffer, int[] nSize);
    
    private static native int GetDoubleClickTime();
    
    
    /**
     * Retrieves the computer name of the current system.  This name is 
     * established at system startup, when it is initialized from the registry.
     *
     * @return the name of this computer.
     */
    public static final String getComputerName() {}
    
    /**
     * Retrieves the current double-click time for the mouse.  A double-click is 
     * a series of two clicks of the mouse button, the second occuring within a
     * specified time after the first. The double-click time is the maximum number
     * of milliseconds that may occur between the first and second click of a 
     * double-click.
     * 
     * @return the number of milliseconds allowed between clicks for a double-click.
     */
    public static final int getDoubleClickTime() {}
    
    /**
     * Retrieves the user name for the current thread.  This is the name of the 
     * user currently logged onto the system.
     *
     * @return the current user name.
     */
    public static final String getUserName() {}
}