//STRIPPEDSOURCE//

package com.ms.wfc.app;

import com.ms.dll.*;
import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Implements the Timer control.  You can specify the timer interval
 * as well as start and stop the timer.
 *
 * @security(checkClassLinking=on)
 */
public class Timer extends Component { 

    
    private int interval;

    
    private boolean enabled;

    
    private EventHandler onTimer;

    
    private int timerProcRoot;

    
    private int timerID;

    /**
     * Default constructor.  The timer will be disposed when it
     * garbage collects.  Note that if the timer is enabled, this
     * will prevent it from being garbage collected.
     */
    public Timer() {}

    /**
     * Container constructor.  The timer will be disposed when
     * <i>container</i> tells it to do so.
     */
    public Timer(IContainer container) {}

    /**
     * Adds a timer event handler to the Timer control.   This event
     * will fire for every timer tick.
     * 
     * @param value The EventHandler to add.
     * @see #removeOnTimer
     */
    public final void addOnTimer(EventHandler value) {}

    /**
     * Disposes of the Timer control. ms.wfc.core.Component.dispose.
     */
    public void dispose() {}

    /**
     * Retrieves a boolean value indicating whether the control is enabled.  If the timer is enabled
     * it will fire events at its defined interval.
     * 
     * @return <b>true</b> if the timer is currently enabled, or <b>false</b>
     *         if it is disabled.
     */
    public final boolean getEnabled() {}

    /**
     * Retrieves the interval, in milliseconds, of the Timer control's
     * interval. 
     * 
     * @return the number of milliseconds between each timer tick.
     */
    public final int getInterval() {}

    /**
     * Provides repeated calls based on the Timer control's interval
     * property setting.  Timer's implementation of this method
     * will call any EventHandler objects that were added through 
     * addOnTimer.  If you are extending Timer, you may override this
     * method.
     * 
     * @param e The timer event, which is always Event.EMPTY.
     * @see com.ms.wfc.core.Event
     */
    protected void onTimer(Event e) {}

    /**
     * Removes a timer event handler from the Timer control.
     *   This event
     * will fire for every timer tick.
     * 
     * @param value The EventHandler to remove.
     * @see #addOnTimer
     */
    public final void removeOnTimer(EventHandler value) {}

    /**
     * Determines whether the Timer control's timer event is
     * being triggered.   Also, this may help
     * determine the lifetime of the timer object.  As long as the timer
     * is enabled and is firing events (even if no event handlers have
     * been added), the timer will not garbage collect.
     * 
     * @param value <b>true</b> to enable the timer and allow it to
     *              fire events, <b>false</b> to disable it and allow
     *              it to be garbage collected.
     */
    public final synchronized void setEnabled(boolean value) {}

    /**
     * Sets the time between timer events. 
     * 
     * @param value The number of milliseconds between timer events.  If this
     *              value is less than 1 millisecond the interval will be
     *              set to one millisecond.
     */
    public final synchronized void setInterval(int value) {}

    /**
     * Starts the Timer control.  This is identical to calling
     * setEnabled(true).
     */
    public final void start() {}

    /**
     * Stops the Timer control.  This is identical to calling
     * setEnabled(false).
     */
    public final void stop() {}

    /**
     * returns us as a string.
     * @internalonly
     * @hidden
     */
    public String toString() {}

    
    class TimerProc extends Callback { 
        public void callback(int hWnd, int msg, int idEvent, int dwTime) {}
    }

    /**
     * Implements the Timer control.  This class contains method and
     * property description information for use by the form designer.
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Component.ClassInfo { 
        public static final PropertyInfo enabled = new PropertyInfo(
            Timer.class, "enabled", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("TimerEnabledDescr")));

        public static final PropertyInfo interval = new PropertyInfo(
            Timer.class, "interval", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(100)),
            new DescriptionAttribute(Sys.getString("TimerIntervalDescr")));

        public static final EventInfo timer = new EventInfo(
            Timer.class, "timer", EventHandler.class,
            CategoryAttribute.Behavior, 
            new DescriptionAttribute(Sys.getString("TimerTimerDescr")));

        public String getDefaultPropertyName() {}

        public String getDefaultEventName() {}

        public void getAttributes(IAttributes attrs) {}

        public void getProperties(IProperties props) {}

        public void getEvents(IEvents events) {}
    }
}