//STRIPPEDSOURCE//

package com.ms.wfc.app;

import com.ms.dll.DllLib;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Retrieves version information about the underlying operating system. 
 *
 * @security(checkClassLinking=on)
 */
public class Version extends Object {
    
    /**
     * Determines whether the operating system is Win32s running on a 16-bit version of
     * Windows.
     */
    public static final int WIN32S          = win.VER_PLATFORM_WIN32s;
    
    /**
     * Determines whether the operating system is Windows 95 or later. */
    public static final int WIN32_WINDOWS   = win.VER_PLATFORM_WIN32_WINDOWS;
    
    /**
     * Determines whether the operating system is Windows NT. */
    public static final int WIN32_NT        = win.VER_PLATFORM_WIN32_NT;
    
    /**
     * Major version number of the OS.  Version numbers are typically represented
     * in the following format:  major.minor.buildNumber.
     */
    public final int    major;
    
    /**
     * Minor version number of the OS.  Version numbers are typically represented
     * in the following format:  major.minor.buildNumber.
     */
    public final int    minor;
    
    /**
     * Build number of the OS.  Version numbers are typically represented
     * in the following format:  major.minor.buildNumber.
     */
    public final int    buildNumber;
    
    /**
     * Platform ID of the os.  This will be one of WIN32S, WIN32_WINDOWS, or WIN32_NT.
     */
    public final int    platformId;
    
    /**
     * OS defined version information.
     */
    public final String text;

    private static Version         m_version;

    
    private Version(OSVERSIONINFO v) {}

    /**
     * Retrieves the version information for the operating system. 
     * 
     * @return the version infromation for the OS.
     */
    public static Version getVersion() {}
}