//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.app.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;



/**
 * ArrayDialog is a modal dialog that allows editing of arrays.
 * With it, you can add, remove, and sort the items in the array.
 * It requires an ArrayEditor which it calls to create new values.
 * 
 * @see ArrayEditor
 *
 * @security(checkClassLinking=on)
 */
public class ArrayDialog extends Form { 
    private static final int     TEXT_INDENT = 1;
    private static final int     PAINT_WIDTH = 20;
    private static final int     PAINT_INDENT = 26;

    private static final double  LOG10 = Math.log(10);

    /**
     * Type of the elements of the array.
     */
    protected Class type;
    
    /**
     * Associated ArrayEditor.
     */
    protected ArrayEditor editor;
    
    /**
     * Value editor for type.
     */
    protected IValueEditor valEditor;

    /**
     * This draws a row of the listbox. 
     */
    protected void listbox_drawItem(Object sender, DrawItemEvent e) {}

    private void listbox_keyPress(Object sender, KeyEvent event) {}
    
    private void upButton_click(Object sender, Event e) {}
    
    private void downButton_click(Object sender, Event e) {}
    
    private void removeButton_click(Object sender, Event e) {}
    
    private void addButton_click(Object sender, Event e) {}
    
    /**
     * Returns an array of items, typed as type[] (where type was passed in to
     * the constructor). 
     * 
     * @return array that was constructed using the ArrayDialog.
     */
    public Object[] getItems() {}
    
    /**
     * Sets the array of items to be edited by the ArrayDialog.
     * 
     * @param array of items to be edited.
     */
    public void setItems(Object[] items) {}
    
    /**
     * Constructs an ArrayDialog given a type and the ArrayEditor.
     * 
     * @param type of the array to be edited.
     * @param arrayEditor that contains a method to create new elements.
     * 
     * @see ArrayEditor
     */
    public ArrayDialog(Class type, ArrayEditor editor) {}
    
    /**
     * @internalonly
     */
    public void dispose() {}
    
    private void updateEnabled() {}
    
    private void listbox_selectedIndexChanged(Object sender, Event e) {}

    
    private	Container components = new Container();
    private ListBox listbox = new ListBox();
    private Button addButton = new Button();
    private Button removeButton = new Button();
    private GroupBox groupBox1 = new GroupBox();
    private Button cancelButton = new Button();
    private Button okButton = new Button();
    private Button downButton = new Button();
    private Button upButton = new Button();

    private void initForm() {}
    
}