//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;



/**
 * ArrayEditor is a value editor that intelligently edits arrays.
 * It uses ArrayDialog in editValue to visually add, remove, and sort
 * arrays.  It is a value editor that takes a Class in it's constructor
 * so it knows the type of the array it is editing.
 * 
 * ArrayEditor supports editing values, but does not convert text into values.
 * 
 * @see ArrayDialog
 * @see ValueEditor
 *
 * @security(checkClassLinking=on)
 */
public class ArrayEditor extends ValueEditor { 
    /**
     * type of the elements of the array.
     */
    protected Class type;
    
    /**
     * the default property info for the elements being edited,
     * if it is a string.  Used to set the default text.
     */
    protected PropertyInfo defaultPropInfo;

    /**
     * Constructs the ArrayEditor.  Takes a Class an an argument
     * which is the type of the object being edited (should be
     * an array).
     * 
     * @param type of the array being edited.
     */
    public ArrayEditor(Class type) {}

    /**
     * Retrieves a visible description of the array type.
     * 
     * @return a description of the array type.
     */
    public String getTypeDescription() {}

    /**
     * Retrieves the base name of the type of the elements being edited.
     * 
     * @return the base name of the type of the elements of the array.
     */
    public String getBaseName() {}

    /**
     * Retrieves the text that should be displayed in the ArrayDialog
     * for a given element.
     * 
     * @return displayable text for the object.
     */
    public String getDisplayText(Object value) {}

    /**
     * Creates a new instance of an element.  The index is solely for
     * assisting in coming up with default text.
     * 
     * @param index A hint for coming up with default text.
     * 
     * @return new element.
     */
    public Object createNewInstance(int index) {}
    
    /**
     * This launches the ArrayDialog.
     * This is a base function of IValueEditor.
     * 
     * @param valueAccess an interface that allows access to the value being edited.
     * 
     * @see IValueEditor
     */
    public void editValue(IValueAccess valueAccess) {}
    
    /**
     * @internalonly
     */
    public int getStyle() {}

    /**
     * @internalonly
     */
    public String getTextFromValue(Object value) {}
}