//STRIPPEDSOURCE//
package com.ms.wfc.core;

/**
 * Represents an event that can be canceled.   The 'cancel' field lets you specify true or false as to whether
 * the event should be cancelled [true means cancel, false means don't]
 *
 * @security(checkClassLinking=on)
 */
public class CancelEvent extends Event {

    /**
     * Indicates, on return, whether or not the operation should be cancelled
     * or not.  'true' means cancel it, 'false' means don't.
     */
    public boolean cancel;

    /**
     * Creates a new CancelEvent object with 'false' as the default value
     * for the cancel field.
     */
   public CancelEvent() {}

    /**
     * Creates a new CancelEvent object with the given default value for the
     * cancel field.
     */
    public CancelEvent(boolean cancel) {}
}