//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.ui.*;

/**
 * Implements the customizer of a component.
 * 
 * @security(checkClassLinking=on)
 */
public class Customizer implements ICustomizer {
    
    /**
     * Implements the customizer of a component.
     * 
     * @return an array of design page classes.  This default implementation
     *         returns <b>null</b>.
     */
    public Class [] getDesignPages() {}

    /**
     * Determines whether the specified point is active.  A TabStrip
     * control, for example, has a design time user interface that allows the user
     * to click the tabs to change tabs.  To implement this, TabStrip returns 
     * <b>true</b> whenever the given point is within its tabs.
     *
     * @param point A point relative to the upper left of the control.
     * @return <b>true</b> if the given point should be considered "active" or <b>false</b>
     *         if it is not something the user can interact with.  This default
     *         implementation always returns <b>false</b>.
     */
    public boolean getHitTest(Point point) {}

    /**
     * Returns the design-time verbs supported by the associated component.  The verbs returned by this method are typically displayed
     * in a right-click menu by the design-time environment. The return value may
     * be null if the component has no design-time verbs. When a user selects one
     * of the verbs, the performVerb() method is invoked with the the
     * corresponding CustomizerVerb object.
     *
     * NOTE: A design-time environment will typically provide a "Properties..."
     * entry on a component's right-click menu. The getVerbs() method should
     * therefore not include such an entry in the returned list of verbs.
     * 
     * @return an array of design-time verb objects.  This default implementation
     *         always returns <b>null</b>.
     */
    public CustomizerVerb[] getVerbs() {}
}