//STRIPPEDSOURCE//
package com.ms.wfc.core;

import com.ms.wfc.ui.*;
import com.ms.lang.Delegate;

/**
 * Represents a verb that can be run by a component's customizer. 
 *
 * @security(checkClassLinking=on)
 */
public class CustomizerVerb {
    private Bitmap bitmap;
    private boolean enabled;
    private boolean checked;
    private Object data;
    private VerbExecuteEventHandler verbExecute = null;

    /**
     * Creates a new CustomizerVerb.
     * Verbs are commands that a customizer can execute on a given object. When
     * the verb is executed by the user the VerbExecute event will occur. This
     * allows the customizer to add functionality to the designer. Typically
     * verbs are implemented in the designer through a menu that appears when
     * the user right clicks on the component. The text of the menu item for 
     * a specific verb is determined by the toString of <i>data</i>. By default
     * <i>handler</i> will be called when the menu item is selected.
     *
     * @param data Verb data. <i>data</i>.toString() will determine the text
     *        associated with the verb.
     * @param handler Event handler that will be invoked when the verb is 
     *        executed.
     */
    public CustomizerVerb(Object data, VerbExecuteEventHandler handler) {}

    /**
     * Creates a new CustomizerVerb.
     * Verbs are commands that a customizer can execute on a given object. When
     * the verb is executed by the user the VerbExecute event will occur. This
     * allows the customizer to add functionality to the designer. Typically
     * verbs are implemented in the designer through a menu that appears when
     * the user right clicks on the component. The text of the menu item for 
     * a specific verb is determined by the toString of <i>data</i>. By default
     * <i>handler</i> will be called when the menu item is selected.
     *
     * @param data Verb data. <i>data</i>.toString() will determine the text
     *        associated with the verb.
     * @param handler Event handler that will be invoked when the verb is 
     *        executed.
     * @param bitmap Small icon to associated with the verb.
     * @param enabled Determines if the verb should appeared enabled.
     * @param checked Determines if the verb should be shown "checked".
     */
    public CustomizerVerb(Object data, VerbExecuteEventHandler handler, Bitmap bitmap, boolean enabled, boolean checked) {}

    public final void addOnVerbExecute(VerbExecuteEventHandler handler) {}

    public final Bitmap getBitmap() {}

    public final boolean getChecked() {}

    public final boolean getEnabled() {}

    public String getText() {}

    protected void onVerbExecute(VerbExecuteEvent event) {}
    public final void performVerbExecute() {}

    public final void removeOnVerbExecute(VerbExecuteEventHandler handler) {}

    public final void setBitmap(Bitmap bitmap) {}

    public final void setChecked(boolean value) {}

    public final void setEnabled(boolean value) {}

    public final Object getData() {}

    public final void setData(Object data) {}

}