//STRIPPEDSOURCE//

package com.ms.wfc.core;

/**
 * DescriptionAttribute marks a property, event, or extender with a 
 * description. Visual designers can display this description when referencing 
 * the member.
 * 
 * @see MemberAttribute
 * @see PropertyInfo
 * @see EventInfo
 * @see ExtenderInfo
 *
 * @security(checkClassLinking=on)
 */
public class DescriptionAttribute extends MemberAttribute
{
    /**
     * This is the description.
     */
    public final String description;

    /**
     * Constructs a new description.
     * 
     * @param description description text.
     */
    public DescriptionAttribute(String description) {}

    /**
     * Retrieves the description text.
     * 
     * @return description
     */
    public String getDescription() {}
}