//STRIPPEDSOURCE//
package com.ms.wfc.core;



import com.ms.wfc.app.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Implements a DesignForm object.  A DesignForm extends @see com.ms.wfc.ui.Form
 * and shows a tabbed view of available design pages.  Design pages are
 * objects that implement @see IDesignPage.  @see DesignPage is a stock
 * implementation of a design page.
 *
 * @security(checkClassLinking=on)
 */
public class DesignForm extends Form {
    Object [] objects;
    PageSite [] pages;
    Point maxSize;
    int activePage;
    boolean dirty;

    TabStrip tabs = new TabStrip();
    Button   okButton;
    Button   cancelButton;
    Button   applyButton;

    private static final int BUTTON_WIDTH  = 15;
    private static final float BUTTON_HEIGHT = 1.75f;
    private static final int BUTTON_PAD    = 6;

    /**
     * Creates a new DesignForm object.
     * 
     * @param <i>objectList</i> A list of objects that the design form should
     *                          show properties for.  The design form will
     *                          find the common DesignPages for all the objects.
     */
    public DesignForm(Object [] objectList) {}

    
    void applyChanges() {}

    
    static private final Class [] getDesignPages(Object obj) {}

    /**
     * Retrieves the requested design page.
     *
     * @param <i>index</i> The index to the page to return.
     * @return an IDesignPage interface for the page.
     */
    public IDesignPage getPage(int index) {}

    /**
     * Retrieves the number of design pages on this form.
     *
     * @return design page count.
     */
    public int getPageCount() {}

    
    private void onButtonClick(Object sender, Event e) {}

    
    private final void onConfigureUI() {}

    
    private void onFormCreate(Object sender, Event e) {}

    
    private final void onNewObjects() {}

    
    private void onTabChange(Object sender, Event e) {}

    /**
     * This method is called by the application's message loop to pre-process
     * input messages before they are dispatched. This forwards IDesignPage
     * messages as necessary.
     */
    public boolean preProcessMessage(MSG msg) {}

    
    void setDirty() {}

    /**
     * Shows the design form.  The form will have no owner window.
     *
     * @return the dialog return code.
     */
    public int showForm() {}

    /**
     * Shows the design form.  The form will have no owner window.
     *
     * @param <i>page</i> Index of the page to show.
     * @return the dialog return code.
     */
    public int showForm(int page) {}

    /**
     * Shows the design form.
     *
     * @param <i>owner</i> Owning form for the dialog.
     * @return the dialog return code.
     */
    public int showForm(Form owner) {}

    /**
     * Shows the design form.
     *
     * @param <i>owner</i>  Owning form for the dialog.
     * @param <i>page</i>   Index of the page to show.
     * @return the dialog return code.
     */
    public int showForm(Form owner, int page) {}

    
    private final static class EmptyDesignPage extends DesignPage {

        /**
         * Creates an empty design page.
         */
        public EmptyDesignPage() {}

        
        void initForm() {}

        /**
         * Handles painting of the design page.
         * 
         * @param <i>e</i>  The PaintEvent the page uses to paint with.
         */
        protected void onPaint(PaintEvent e) {}

        /**
         * Called when we need to read a property from the property page
         * and store it in an object.
         * 
         * @param <i>name</i>   The name of the property to read.
         * @return an object representing the value of the property, or null
         *         if the page doesn't understand the property name or 
         *         the property on multiple objects is indeterminate.
         */
        protected Object onReadProperty(String name) {}

        /**
         * Called when we need to put a property value into the page's UI.
         *
         * @param <i>name</i>   The name of the property to write.
         * @param <i>value</i>  The value of the property.  This will be null if 
         *                      several objects are in the object list and
         *                      they have inconsistent values for the 
         *                      property.  The UI should show an indeterminate
         *                      state for this property.
         */
        protected void onWriteProperty(String name, Object value) {}
    }

    
    private final class PageSite implements IDesignPageSite {
        Object [] objects;
        IDesignPage page;
        Control parent;
        boolean isActive;

        
        PageSite(Control client, Class pageClass, Object [] objects) {}

        /**
         * Called by a page to return a parenting control for the page.
         *
         * @return the parenting control object for the page.
         * @see IDesignPageSite
         * @internalonly
         */
        public Control getControl() {}

        
        IDesignPage getDesignPage() {}

        
        void setActive(boolean active) {}

        /**
         * Called by a page to mark it's contents as dirty.
         *
         * @see IDesignPageSite
         * @internalonly
         */
        public void setDirty() {}
    }

    /**
     * ClassInfo for a DesignForm.
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Form.ClassInfo {
    }        
}


final class PageList {
    Class [] mergedClasses;
    ClassNode head;

    
    void addClasses(Class classes[]) {}

    
    Class [] getClasses() {}

    
    void merge(int requiredHitCount) {}

    
    static final class ClassNode {
        public Class pageClass;
        public ClassNode next;
        public int hitCount;

        
        ClassNode(Class cls, ClassNode nextNode) {}
    }
}