//STRIPPEDSOURCE//
package com.ms.wfc.core;



import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines a base implementation for @see IDesignPage.  With this class,
 * you will get a complete implementation for a design page that consists of
 * an empty window.  Extend this page to add your own controls.
 *
 * @security(checkClassLinking=on)
 */
public class DesignPage extends Form implements IDesignPage {

    /**
     * Used to indicate a property value of <b>null</b>.
     */
    public static final Object NULLVALUE = new Object();

    protected IDesignPageSite  site;
    protected Object []        objects;
    protected PropertyList     properties;

    private boolean firstActivate;

    /**
     * Creates a Designpage.
     */
    public DesignPage() {}

    /**
     * Activates and displays the page.
     *
     * @see IDesignPage
     */
    public void activate() {}

    /**
     * Applies changes to all the objects in this page's object list.
     *
     * @see IDesignPage
     */
    public void apply() {}

    /**
     * Deactivates the page.  A page may be deactivated and later reactivated.
     *
     * @see IDesignPage
     */
    public void deactivate() {}

    /**
     * Retrieves the control that represents the window for this page.
     *
     * @return a Control object.
     */
    public Control getControl() {}

    /**
     * Retrieves the creation parameters for this control
     * 
     * @return a @see com.ms.wfc.ui.CreateParams object.
     * @see com.ms.wfc.ui.Control
     */
    protected CreateParams getCreateParams() {}

    /**
     * Retrieves the title of the design page.  The caller may use this to show
     * the name of this page before it's actually activated.
     *
     * @return the title of the page.
     * @see IDesignPage
     */
    public String getTitle() {}

    /**
     * Gives the design page a chance to process messages before the caller
     * uses them.
     *
     * @param   <i>msg</i> Message to process.
     * @return  <b>true</b> if this page processed the message, or <b>false</b>
     *          otherwise. If this returns true, the message will be eaten.
     *          Otherwise, the caller will continue to process the message.
     * @see IDesignPage
     */
    public boolean getPageMessage(MSG msg) {}

    
    private void readPropValues() {}

    /**
     * Called when we need to read a property from the property page
     * and store it in an object.
     *
     * @param <i>name</i> The name of the property to read.
     * @return an object that reflects what the UI currently contains for
     *         the property.  If the UI doesn't support the property, or if the
     *         UI contains the original, default value for the property, this
     *         should return null.  If the value from the object truly is 
     *         null, use DesignPage.NULLVALUE.
     */
    protected Object onReadProperty(String name) {}

    /**
     * Called when we need to put a property value into the page's UI.
     *
     * @param <i>name</i>  The name of the property to write.
     * @param <i>value</i> The value of the property.  This will be null if 
     *                     several objects are in the object list and they
     *                     have inconsistent values for the property.  
     *                     The UI should show an indeterminate state for this
     *                     property.  If the object's value truly is null,
     *                     this will contain the value DesignPage.NULLVALUE.
     */
    protected void onWriteProperty(String name, Object value) {}

    /**
     * Called by an extending object's UI to mark this page as dirty.
     */
    protected void setDirty() {}

    /**
     * Called before activation to setup the array of objects that this page is
     * modifying properties for.  The objects are not guarenteed to be of any
     * particular type; their only commonality is that they have all specified 
     * that they use this design page class.
     *
     * @param <i>objects</i> The array of objects this page is to modify.
     * @see IDesignPage
     */
    public void setObjects(Object [] objects) {}

    /**
     * Called before this page is activated to setup the site we are to use
     * to notify the caller of changes.
     *
     * @param <i>site</i> The design page site to which this page is attached.
     * @see IDesignPage
     */
    public void setSite(IDesignPageSite site) {}

    /**
     * Called to determine whether or not the help icon should be shown at the
     * top of the dialog.  If one or more pages supports the icon, then it will
     * appear.  It will be greyed out for pages that do not support help.
     *
     * @return <b>true</b> to enable the help icon for this page, or <b>false</b>
     *         to disable it.
     * @see IDesignPage
     */ 
    public boolean supportsHelp() {}

    
    private void writePropValues() {}

    /**
     * ClassInfo for a DesignPage.
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Form.ClassInfo {
    }        
}


final class PropertyList implements IProperties {
    private PropertyGroup [] properties;
    private int              propertyCount;
    private Object           workingObject;
    private static Object    COMPOSITE_VALUE = new Object();

    /**
     * Adds a new property to the property list.
     * 
     * @param <i>p</i> The PropertyInfo to add.
     * @internalonly
     */
    public void add(PropertyInfo p) {}

    /**
     * Removes the specified property from the PropertyList
     * 
     * @param <i>p</i>  The PropertyInfo to remove.
     * @internalonly
     */
    public void remove(PropertyInfo p) {}

    /**
     * Defines a property with the given name and type, and also specifies various
     * attributes, including currently Category,DefaultValue,Description, and ValueEditor.
     * 
     * @param <i>propertyName</i>   The name of the property.
     * @param <i>propertyType</i>   The type of the property.
     * @param <i>attributes</i>     An array of MemberAttributes for the property.
     * @internalonly
     */
    public void add(String propertyName, Class propertyType, MemberAttribute attributes[]) {}

    /**
     * Adds an object to the current property list.
     * 
     * @param <i>obj</i>    The object to add.
     * @internalonly
     */
    public void addObject(Object obj) {}

    /**
     * Retrieves the count of properties in this property list.
     * 
     * @return a count of properties.
     * @internalonly
     */
    public int getCount() {}

    /**
     * Retrieves a PropertyGroup for the requested property.
     * 
     * @param <i>index</i>  The index of the property to get.
     * @internalonly
     */
    public PropertyGroup getPropertyGroup(int index) {}

    
    class PropertyGroup {
        private PropertyInfo  prop;
        private Object [] objects;
        private int       objectCount;
        private Object    value;
        private Class     valueType;

        
        PropertyGroup(PropertyInfo p) {}

        /**
         * Adds an object to this PropertyGroup.
         * 
         * @param <i>newObject</i> The object to add.
         */
        public void addObject(Object newObject) {}

        /**
         * Retrieves the name of this property group.
         * 
         * @return the property group name.
         * @internalonly
         */
        public String getName() {}

        /**
         * Retrieves the value of this property group.  If the value is 
         * indeterminate, this will return ProperyGroup.COMPOSITE_VALUE.
         * 
         * @return the value for this property group.
         * @internalonly
         */
        public Object getValue() {}

        /**
         * Retrieves true if this property group is empty.
         * 
         * @return <b>true</b> if the property group is empty, or <b>false</b>
         *         otherwise.
         * @internalonly
         */
        public boolean getEmpty() {}

        /**
         * Removes an object from this property group.
         * 
         * @param <i>obj</i> The object to remove.
         * @internalonly
         */
        public void removeObject(Object obj) {}

        /**
         * Sets a new value for this property group.  This sets the value of
         * the property for all objects in the group.
         * 
         * @param <i>newValue</i> The new value for the property.
         * @internalonly
         */
        public void setValue(Object newValue) {}

        
        void updateValue(Object obj) {}
    }
}