//STRIPPEDSOURCE//

package com.ms.wfc.core;

/**
 * DispidAttribute is an attribute that marks a property with a
 * specific "DISPID".  A DISPID is a dispatch identifier that is used by 
 * OLE when a WFC control is exposed as an ActiveX control.  Normally,
 * you do not need to specify this attribute as the values for most
 * DISPID's are arbitrary.  However, ActiveX controls do define a 
 * small list of specific DISPID's for common properties.  WFC 
 * handles most of these common properties for you.
 * 
 * @security(checkClassLinking=on)
 */
public class DispidAttribute extends MemberAttribute { 
    
    /**
     * The actual dispatch identifier
     */
    public final int dispid;
    
    /**
     * Creates a new instance of this attribute
     * @param dispid the dispatch identifier to wrap
     */
    public DispidAttribute(int dispid) {}
}