//STRIPPEDSOURCE//

package com.ms.wfc.core;

/**
 * HelpAttribute marks a property, extender, or event with help information.
 * A visual designer can use this information to present help for this
 * member. When overriding a property with different help information,
 * a user can pass in a new HelpAttribute to replace the old information.
 * 
 * @see MemberAttribute
 * @see PropertyInfo
 * @see EventInfo
 * @see ExtenderInfo
 *
 * @security(checkClassLinking=on)
 */
public class HelpAttribute extends MemberAttribute {

    /**
     * This is the URL link.
     */
    public final String url;
    
    /**
     * This is the topic on the URL.
     */
    public final String topic;

    /**
     * Constructs a HelpAttribute that points to the given URL.
     * 
     * @param url URL to point to.
     */
    public HelpAttribute(String url) {}

    /**
     * Constructs a HelpAttribute that points to the topic on the given URL.
     *  
     * @param url URL to point to.
     * @param topic on URL to point at.  
     */
    public HelpAttribute(String url, String topic) {}

    /** 
     * Retrieves the URL.
     * 
     * @return URL
     */
    public String getURL() {}
    
    /**
     * Retrieves the topic.
     * 
     * @return topic
     */
    public String getTopic() {}
}