//STRIPPEDSOURCE//
package com.ms.wfc.core;

/**
 * The IAttributes interface is a callback interface that is used in
 * implementations of the getAttributes() method of the @see IClassInfo interface.
 * An implementation of IClassInfo.getAttributes() is provided an instance of
 * the IAttributes interface and is responsible for calling the add() method
 * to enumerate the attributes of the associated component class.
 *
 * @security(checkClassLinking=on)
 */
public interface IAttributes {
    /**
     * Adds an attribute to the associated component class. 
     * 
     * @param <i>a</i> The @see MemberAttribute to define.
     */
    public void add(MemberAttribute a);
}