//STRIPPEDSOURCE//
package com.ms.wfc.core;

    /**
     * The IConstructable interface allows for immutable objects
     * to indicate what constructor arguments would result in
     * an equivalent object. NOTE: not having a constructor which
     * maps to what getConstructorArgs returns will keep the object
     * from being persisted properly.
     *
     * @security(checkClassLinking=on)
     */

public interface IConstructable {
    /**
     * Retrieves the constructor arguments that are needed to instantiate the class. 
     */
    public ConstructorArg[] getConstructorArgs();
}