//STRIPPEDSOURCE//
package com.ms.wfc.core;

import com.ms.wfc.ui.Control;

/**
 * This interface defines a site for an @see IDesignPage.  A "site" just a logical
 * living space for the page and provides services for that page.
 * @see DesignForm is a stock implementation of IDesignPageSite.
 *
 * @security(checkClassLinking=on)
 */
public interface IDesignPageSite {

    /**
     * Called by a page to retrieve a parenting control for the page.
     *
     * @return the parenting control object for the page.
     */
    public Control getControl();

    /**
     * Called by a page to mark it's contents as dirty.  This may be 
     * used to enable a parenting form's Apply button.
     */
    public void setDirty();
}