//STRIPPEDSOURCE//
package com.ms.wfc.core;

/**
 * The IEvents interface is a callback interface that is used in
 * implementations of the getEvents() method of the IClassInfo interface.
 * An implementation of IClassInfo.getEvents() is provided an instance of
 * the IEvents interface and is responsible for calling the add() method
 * to enumerate the events of the associated component class.
 *
 * @security(checkClassLinking=on)
 */
public interface IEvents
{
    /**
    * Adds an event to the associated component class. 
    */
    public void add(EventInfo e);
}