//STRIPPEDSOURCE//
package com.ms.wfc.core;

/** 
 * A component extends IExtenderProvider when it wants to provide extender 
 * properties for other components in a container.  A tool that handles
 * extender properties will call canExtend on every instance to see whether
 * it should provide the extender properties to a particular instance.
 * 
 * @see ExtenderInfo
 *
 * @security(checkClassLinking=on)
 */
public interface IExtenderProvider {

    /** 
     * Determines whether an object can receive the extender properties. 
     * 
     * @param extendee The object which wants extender properties.
     * 
     * @return whether this object wants to proffer extender properties to 
     * extendee.
     */
    public boolean canExtend(Object extendee);
}