//STRIPPEDSOURCE//
package com.ms.wfc.core;

/**
 * The IExtenders interface is a callback interface that is used in
 * implementations of the getExtenderProperties() method of the IClassInfo interface.
 * An implementation of IClassInfo.getExtenderProperties() is provided an instance of
 * the IExtenders interface and is responsible for calling the add() method
 * to enumerate the Extenders of the associated component class.
 *
 * @security(checkClassLinking=on)
 */
public interface IExtenders
{
    /**
    * Adds an extender property to the associated component class. 
    */
    public void add(ExtenderInfo e);
}