//STRIPPEDSOURCE//
package com.ms.wfc.core;

import com.ms.wfc.io.*;

/**
 * The IPersistable interface allows an object to be persisted
 * to a stream and depersisted from a stream.
 * You MUST implement a constructor that takes an IDataStream to
 * correctly implement IPersistable.
 *
 * @security(checkClassLinking=on)
 */

public interface IPersistable {
    /**
     * The constructor takes a stream which to depersist from.
     */


    /**
     * save takes a stream into which it can save itself.  It
     * can return an extension ("bmp","wav") in case the stream
     * is saved to a file, or return null.
     */
    public void save(IDataStream stream);


    /**
     * Retrieves the extension for the file name of the stream.  */
    public String getExtension();

}