//STRIPPEDSOURCE//
package com.ms.wfc.core;

/**
 * The IProperties interface is a callback interface that is used in
 * implementations of the getProperties() method of the IClassInfo interface.
 * An implementation of IClassInfo.getProperties() is provided an instance of
 * the IProperties interface and is responsible for calling the add() method
 * to enumerate the properties of the associated component class.
 *
 * @security(checkClassLinking=on)
 */
public interface IProperties
{
    /**
    * Adds a property to the associated component class. 
    */
    public void add(PropertyInfo p);
}