//STRIPPEDSOURCE//
package com.ms.wfc.core;

/**
 * Any object that implements this method requires the begin method to be
 * called before the object is usable. Once the begin method is called the
 * component becomes active and can assume that all peers are loaded, and
 * all property sets are complete. WFC code generation will add a call
 * to begin for all IRequireBegin components at the end of initForm().
 *
 * @security(checkClassLinking=on)
 */
public interface IRequireBegin {
    /**
     * Signals the component that all peer components are loaded and the property sets are
     * complete. 
     */
    public void begin();
}