//STRIPPEDSOURCE//


package com.ms.wfc.core;

import com.ms.wfc.io.*;

/**
 * IResourceLoader represents a component that supports retrieving a resource
 * from that component's namespace.
 *
 * @security(checkClassLinking=on)
 */
public interface IResourceLoader
{
    /**
     * Retrieves a data stream for the specified resource. 
     * 
     * @param resource Resource to retrieve.
     * 
     * @return IDataStream for the resource.
     */
    public IDataStream getResource(String resource);

}