//STRIPPEDSOURCE//


package com.ms.wfc.core;

import com.ms.wfc.io.*;
import com.ms.wfc.util.*;

/**
 * Interface that allows an object to depersist resource data from a binary
 * resource file. The file will be stored by something that supports 
 * IResourceWriter.
 *
 * @security(checkClassLinking=on)
 */
public interface IResourceReader {

    /**
     * Reads all resource data from the specified stream.
     *
     * @param stream IDataStream containing the resource data.
     *
     * @return HashTable containing the properties.
     */
    public IResourceSet depersistProperties(IDataStream stream);
}