//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.util.*;

/**
 * ReferenceEditor is an editor that handles references to other components.
 * When asked to list the possible values, it will query the container of
 * the hosting component for all components that implement the given type
 * and return that list.
 * 
 * @see IValueEditor
 * @see IContainer
 * @see IComponent
 *
 * @security(checkClassLinking=on)
 */
public class ReferenceEditor extends ValueEditor {

    /**
     * The type to find references for.
     */
    protected Class type;
    
    /**
     * The container we look for the references in.
     */
    protected IContainer container;
    
    /**
     * What we return textually for null.
     */
    protected static final String none = Sys.getString("toStringNone");

    /**
     * Constructs a ReferenceEditor.  The site contains the hosting component
     * and the type to look for.
     * 
     * @param site
     */
    public ReferenceEditor(IEditorSite site) {}

    /**
     * @internalonly
     */
    public int getStyle() {}

    /**
     * @internalonly
     */
    public String getTextFromValue(Object value) {}

    /**
     * @internalonly
     */
    public Object getValueFromText(String text) {}

    /**
     * Retrieves the components on the form that can be assigned to the type 
     * of the editor.
     * 
     * @return references list of components that can be assigned to the type
     * of the editor.
     */
    public Object[] getValues() {}
}