//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.util.*;

/**
 * Represents a set of named resource-based properties. This works with
 * com.ms.wfc.core.ResourceReader and com.ms.wfc.core.ResourceWriter.
 * 
 * @see com.ms.wfc.core.IResourceSet
 *
 * @security(checkClassLinking=on)
 */
public class ResourceSet implements IResourceSet {
    HashTable data = null;

    /**
     * Creates a new ResourceSet.
     */
    public ResourceSet() {}
    
    /**
     * Creates a new ResourceSet. This resource set will copy the data
     * contained in <i>ht</i>.
     * 
     * @param ht HashTable to copy data from.
     */
    public ResourceSet(HashTable ht) {}
    
    /**
     * Creates a new Resourceset. This resource set will store and retrieve
     * data from <i>ht</i> if <i>ownHashTable</i> is set to <b>true</b>, 
     * otherwise it will copy the data from <i>ht</i>.
     * 
     * @param ht HashTable to retrieve data from.
     * @param ownHashTable If set to <b>true</b> the resource set will own 
     *        <i>ht</i>, otherwise, the resource set will copy <i>ht</i>.
     */
    public ResourceSet(HashTable ht, boolean ownHashTable) {}
    /**
     * Represents a set of named resource-based properties.
     * @internalonly
     */
    public Class getWriter() {}
    /**
     * Retrieves the value of the specified property.
     * @internalonly
     */
    public Object getProperty(String name) {}
    /**
     * Sets the value of the specified property.
     * @internalonly
     */
    public void setProperty(String name, Object value) {}
    /**
     * Determines whether the specified property is stored in the resource set.
     * @internalonly
     */
    public boolean contains(String name) {}
    /**
     * Retrieves the names of all properties that are stored in the resource set.
     * @internalonly
     */
    public synchronized String[] getNames() {}
    /**
     * Retrieves the values of all properties that are stored in the resource set. 
     * @internalonly
     */
    public synchronized Object[] getProperties() {}
}