//STRIPPEDSOURCE//

package com.ms.wfc.core;

/**
 * ShowInToolboxAttribute marks a component's visibility.  If 
 * ShowInToolboxAttribute.YES is present, a visual designer can show
 * this component in a toolbox and display it on a form, either natively
 * or through a wrapper. It is added to a component's ClassInfo.
 * 
 * @see MemberAttribute
 * @see ClassInfo
 *
 * @security(checkClassLinking=on)
 */
public class ShowInToolboxAttribute extends MemberAttribute { 
    
    private ShowInToolboxAttribute() {}

    /**
     * Marks a component as visible in a visual designer.
     */
    public static final ShowInToolboxAttribute YES = new ShowInToolboxAttribute();

    /**
     * Marks a component as not visible in a visual designer.
     */
    public static final ShowInToolboxAttribute NO = new ShowInToolboxAttribute();

    /**
     * The default visiblity. (equal to NO.)
     */
    public static final ShowInToolboxAttribute DEFAULT = NO;

    public boolean isDefaultAttribute() {}
}