//STRIPPEDSOURCE//

package com.ms.wfc.core;

/**
 * ValueEditorAttribute marks a property or extender with a specific
 * value editor to be associated with.  A visual designer should instantiate
 * this value editor when editing this member and not use the default editor
 * for the given type.
 * 
 * @see IValueEditor
 * @see MemberAttribute
 * @see PropertyInfo
 * @see ExtenderInfo
 *
 * @security(checkClassLinking=on)
 */
public class ValueEditorAttribute extends MemberAttribute { 
    /**
     * The type of the value editor.
     */
    public final Class valueEditorType;

    /**
     * Constructs a ValueEditorAttribute that holds the type
     * of the value editor to be used.
     * 
     * @param valueEditorType type of value editor.
     */
    public ValueEditorAttribute(Class valueEditorType) {}

    /**
     * Retrieves the type of the value editor.
     * 
     * @return valueEditor
     */
    public Class getValueEditorType() {}
}