//STRIPPEDSOURCE//

package com.ms.wfc.core;

import java.lang.reflect.*;
import java.io.*;

/**
 * Represents the WFC base exception class.  All WFC exception deriver from this class. WFC
 * excpetions have an innerException that allows the creation of exception
 * trees. Use getBaseException to return the lowest exception in the tree.
 *
 * @security(checkClassLinking=on)
 */
public class WFCException extends RuntimeException {

    public final Throwable innerException;
    private boolean superCall = false;

    /**
     * Creates a new WFCException. This exception will have no innerException
     * and no detailed description.
     */
    public WFCException() {}

    /**
     * Creates a new WFCException. This exception will have no innerException
     * and <i>message</i> as the detailed description.
     *
     * @param message Detailed description for the exception.
     */
    public WFCException(String message) {}

    /**
     * Creates a new WFCException. This exception will have an innerException
     * and <i>message</i> as the detailed description.
     *
     * @param message Detailed description for the exception.
     * @param innerException Inner exception.
     */
    public WFCException(String message, Throwable innerException) {}

    /**
     * Creates a new WFCException. This exception will have an innerException
     * and will adopt the message of <i>innerException</i>.
     *
     * @param innerException Inner exception.
     */
    public WFCException(Throwable innerException) {}

    
    private static Throwable getTargetException(Throwable e) {}
    
    /**
     * Retrieves the string representation of the WFCException object.  This will
     * display the full hierarchy of inner exceptions.
     * 
     * @return string representation of this exception.
     */
    public String toString() {}
    
    /**
     * Prints the stack trace of the WFCException object. 
     */
    public void printStackTrace() {}
    
    /**
     * Prints the stack trace of the WFCException object. 
     * 
     * @param stream Stream to print the stack trace to.
     */
    public void printStackTrace(java.io.PrintStream stream) {}
    
    /**
     * Prints the stack trace of the WFCException object. 
     * 
     * @param writer Writer to print the stack trace to.
     */
    public void printStackTrace(java.io.PrintWriter writer) {}

    /**
     * Retrieves the stack trace for the specified exception. 
     *
     * @param e Throwable to get the stack trace for.
     *
     * @return stack trace for the specified trowable.
     */
    public static final String getStackTrace(Throwable e) {}

    /**
     * Retrieves the lowest, inner-most exception for the specified exception.  This
     * will traverse WFC exceptions using the innerException property, and will
     * also look for ExceptionInInitializerErrors and InvocationTargetExceptions
     * that may also contain exceptions.
     *
     * @param e Throwable to find the base exception for.
     *
     * @return the base exception.
     */
    public static final Throwable getBaseException(Throwable e) {}

    /**
     * Rethrows an exception, wrapping it in a WFCException object.   This new
     * exception will adopt the message of the existing exception. The
     * exception not be wrapped with a new exception if it is of type
     * WFCException, or if it is a descendant of RuntimeException.
     *
     * @param e Throwable to rethrow
     */
    public static final void rethrowException(Throwable e) {}
    
    /**
     * Rethrows an exception, wrapping it in a WFCException object. 
     *
     * @param message Detailed description of the outer exception.
     * @param e Throwable to rethrow
     */
    public static final void rethrowException(String message, Throwable e) {}
}