//STRIPPEDSOURCE//

package com.ms.wfc.core;

/**
 * Represents an exception for invalid arguments that are enumerators. 
 *
 * @security(checkClassLinking=on)
 */
public class WFCInvalidEnumException extends WFCInvalidArgumentException {

    /**
     * Creates a new WFCInvalidEnumException. This will not
     * have any message associated with it.
     */
    public WFCInvalidEnumException() {}

    /**
     * Creates a new WFCInvalidEnumException. This will have
     * <i>message</i> as the associated message.
     * 
     * @param message Message to display with this exception.
     */
    public WFCInvalidEnumException(String message) {}
    
    /**
     * Creates a new WFCInvalidEnumException. This will have a localized
     * message saying that the parameter <i>argumentName</i> was invalid
     * becuase the value was <i>invalidValue</i> and that the value
     * should be from the enum class <i>enumClass</i>.
     * 
     * @param argumentName Name of the argument that failed.
     * @param invalidValue Value of the argument that failed.
     * @param enumClass Class that contains the enum of valid values.
     * 
     */
    public WFCInvalidEnumException(String argumentName, int invalidValue, Class enumClass) {}
}