//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.util.*;
import com.ms.dll.*;

/**
 * Represents a warning rather than an error.  If not caught this will be presented to the user as a 
 * warning message, instead of an "error".
 *
 * @security(checkClassLinking=on)
 */
public class WFCWarning extends WFCException {
    public final String helpURL;
    public final String helpTopic;

    /**
     * Creates a new WFCWarning. The created warning will have <i>message</i>
     * as the message, and no help associated with it.
     *
     * @param message Message to display to the end user.
     */
    public WFCWarning(String message) {}
    
    /**
     * Creates a new WFCWarning. The created warning will have <i>message</i>
     * as the message, and the specified help associated with it.
     *
     * @param message Message to display to the end user.
     * @param helpURL Help file to show if the user requests help.
     */
    public WFCWarning(String message, String helpURL) {}

    /**
     * Creates a new WFCWarning. The created warning will have <i>message</i>
     * as the message, and the specified help associated with it.
     *
     * @param message Message to display to the end user.
     * @param helpURL Help file to show if the user requests help.
     * @param helpTopic Help topic to show if the user requests help.
     */
    public WFCWarning(String message, String helpURL, String helpTopic) {}
}