//STRIPPEDSOURCE//

package com.ms.wfc.core;

import com.ms.wfc.util.*;
import com.ms.dll.*;

/**
 * Represents an exception for a Win32 error code. 
 *
 * @security(checkClassLinking=on)
 */
public class WFCWin32Exception extends WFCSystemException {
    public final int errorCode;

    /**
     * Creates a new WFCWin32Exception. The exception will contain the last
     * Win32 error reported by J/Direct. The detail description of the error
     * will be determined by the Win32 error message associated with the error.
     */
    public WFCWin32Exception() {}
    /**
     * Creates a new WFCWin32Exception. The exception will contain the specified
     * error. The detail description of the error will be determined by the
     * Win32 error message associated with the error.
     *
     * @param error Win32 error code
     */
    public WFCWin32Exception(int error) {}
    /**
     * Creates a new WFCWin32Exception. The exception will contain the specified
     * error, with the specified detailed description.
     *
     * @param error Win32 error code
     * @param message Detailed description of the error.
     */
    public WFCWin32Exception(int error, String message) {}
}