//STRIPPEDSOURCE//

package com.ms.wfc.data;

import com.ms.wfc.app.*;
import com.ms.wfc.ole32.*;
import com.ms.wfc.util.*;
import com.ms.wfc.core.*;
import com.ms.com.*;
import com.ms.lang.Delegate;
import com.ms.dll.*;

/**
 * Represents the abstract implementation of the IDataFormat  interface. This class also converts between the OLE interface IOleDataFormat and  the WFC IDataFormat interface.  This class also converts between
 * the OLE interface IOleDataFormat and the WFC IDataFormat interface.
 *
 * @security(checkClassLinking=on)
 */
public abstract class DataFormat implements IOleDataFormat, IDataFormat {
    private Locale locale = null;
    private EventHandler formatChanged = null;
    private IDataFormat bound;
    private Variant variantBind = new Variant();

    /**
     * @internalonly
     */
    public abstract Object format(Locale locale, Object data);
    /**
     * @internalonly
     */
    public abstract Object unformat(Locale locale, Object data);

    /**
     * Assigns a delegate to the formatChanged event. 
     * @internalonly
     */
    public void addOnFormatChanged(EventHandler handler) {}
    /**
     * Removes the delegate assigned to the formatChanged event. 
     * @internalonly
     */
    public void removeOnFormatChanged(EventHandler handler) {}
    /**
     * Triggers the formatChanged event.  Inheriting classes should always call
     * <i>super.onFormatChanged</i>.
     * 
     * @param event Event data
     */
    protected void onFormatChanged(Event event) {}
    
    /**
     * Generates a formatChanged event. 
     */
    public void performFormatChanged() {}

    /**
     * Creates a new DataFormat.
     */
    public DataFormat() {}

    /**
     * Creates a new DataFormat. This object will wrap <i>format</i>.
     * 
     * @param format IDataFormat object to wrap.
     */
    public DataFormat(IDataFormat format) {}

    /**
     * Determines whether the data format object can receive com.ms.com.Variant
     * objects. ms.com.Variant objects in the <i>format</i> method. By default
     * this will alway return <b>false</b> in which case any Variants will
     * first me converted to Java objects (i.e. Integer, Double, etc) before
     * the <i>format</i> method is called.
     * 
     * @return <b>true</b> if <i>format</i> should be called with Variants.
     */
    protected boolean getUseVariant() {}

    private Locale getLocale() {}

    private Object toObject(Variant data) {}

    
    
    
    /**
     * @internalonly
     */
    public final void getOleBinding(short vtPropHint, int rgfDataFormat, IUnknown prowset, DBCOLUMNINFO pcolinfo, DBBINDING pbinding, int[] pcbSize, int[] pdwCookie) {}
    
    private final Variant varBindToVariant(VARIANTBIND bind) {}

    private final void bindVariant(Variant variant,VARIANTBIND bind) {}

    /**
     * @internalonly
     */
    public final void getOleData(int dwCookie, int pvFrom, Variant pvarTo, int[] pdbstatus, Object pdispObject) {}
    /**
     * @internalonly
     */
    public final void setOleData(int dwCookie, Variant pvarFrom, int pvTo, Object pdispObject) {}
    /**
     * @internalonly
     */
    public final void releaseOleData(int dwCookie, int pv) {}
    /**
     * @internalonly
     */
    public final void releaseOleBinding(int dwCookie) {}
    /**
     * @internalonly
     */
    public final void getOleRawData(int dwCookie, int pvFrom, Variant pvarTo, int[] pdbstatus) {}
    /**
     * @internalonly
     */
    public final void setOleRawData(int dwCookie, Variant pvarFrom, int pvTo) {}
    /**
     * @internalonly
     */
    public final void cloneOle(IOleDataFormat[] ppDataFormat) {}
    /**
     * @internalonly
     */
    public final void convertOle(int dwCookie, Variant pvarFrom, Variant pvarTo) {}
    /**
     * @internalonly
     */
    public final void setOleLcid(int lcid) {}
    /**
     * @internalonly
     */
    public final void defaultOle(int[] fDefault) {}

    
    private final static class VARIANTBIND {
        long data1;
        long data2;
        int status;
    }

    private static final int DBTYPE_VARIANT	= 12;


    
    private interface DBPART {
        public static final int DBPART_INVALID = 0;
        public static final int DBPART_VALUE = 1;
        public static final int DBPART_LENGTH = 2;
        public static final int DBPART_STATUS = 3;
    }


    
    private interface DBSTATUS {
        public static final int DBSTATUS_S_OK = 0;
        public static final int DBSTATUS_E_BADACCESSOR = 1;
        public static final int DBSTATUS_E_CANTCONVERTVALUE = 2;
        public static final int DBSTATUS_S_ISNULL = 3;
        public static final int DBSTATUS_S_TRUNCATED = 4;
        public static final int DBSTATUS_E_SIGNMISMATCH = 5;
        public static final int DBSTATUS_E_DATAOVERFLOW = 6;
        public static final int DBSTATUS_E_CANTCREATE = 7;
        public static final int DBSTATUS_E_UNAVAILABLE = 8;
        public static final int DBSTATUS_E_PERMISSIONDENIED = 9;
        public static final int DBSTATUS_E_INTEGRITYVIOLATION = 10;
        public static final int DBSTATUS_E_SCEMAVIOLATION = 11;
        public static final int DBSTATUS_E_BADSTATUS = 12;
        public static final int DBSTATUS_S_DEFAULT = 13;
    }


    /**
     * Represents the abstract implementation of the IDataFormat  interface. This class also converts between the OLE interface IOleDataFormat and  the WFC IDataFormat interface. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {
        public static final EventInfo formatChanged = new EventInfo(
            DataFormat.class, "formatChanged", EventHandler.class,
            new DescriptionAttribute(Sys.getString("DataFormatOnFormatChangedDescr")));

        public String getDefaultEventName() {}

        public void getEvents(IEvents events) {}
    }


    /**
     * Represents the abstract implementation of the IDataFormat  interface. This class also converts between the OLE interface IOleDataFormat and  the WFC IDataFormat interface. 
     * @security(checkClassLinking=on)
     */
    public static class FormatWrapper extends DataFormat {
        public FormatWrapper(IDataFormat format) {}

        public Object format(Locale locale, Object data) {}
        public Object unformat(Locale locale, Object data) {}
    }

}