//STRIPPEDSOURCE//

package com.ms.wfc.data;

import com.ms.wfc.app.*;
import com.ms.wfc.util.*;
import com.ms.wfc.core.*;
import com.ms.com.*;

/**
 * Represents a data format object for formatting date data types. 
 *
 * @security(checkClassLinking=on)
 */
public class DateDataFormat extends DataFormat implements IConstructable {
    private int format;
    private String customFormat = "";

    /**
     * Creates a new DateDataFormat. The resulting DateDataFormat will be
     * set to format short dates.
     */
    public DateDataFormat() {}

    /**
     * Creates a new DateDataFormat. The format of the DateDataFormat will
     * be set to <i>format</i>.
     * 
     * @param format Format to use to format dates.
     */
    public DateDataFormat(int format) {}

    /**
     * Creates a new DateDataFormat. The format of the DateDataFormat will
     * be set to custom format, with the specified string.
     * 
     * @param <i>customFormat</i> Custom format to use to format dates.
     */
    public DateDataFormat(String customFormat) {}

    /**
     * Creates a new DateDataFormat. The format of the DateDataFormat will
     * be set to <i>format</i>, with the specified string.
     * 
     * @param format Format to use to format dates.
     * @param <i>customFormat</i> Custom format to use to format dates.
     */
    public DateDataFormat(int format, String customFormat) {}

    /**
     * @internalonly
     */
    public Object format(Locale locale, Object data) {}

    /**
     * @internalonly
     */
    public Object unformat(Locale locale, Object data) {}

    /**
     * Sets the custom format string.  The custom format
     * will only be used if the <i>format</i> of the DateDataFormat is
     * set to CUSTOM.
     * 
     * @param value Custom format to format the date with.
     */
    public void setCustomFormat(String value) {}
    
    /**
     * Sets the format type. 
     * 
     * @param value Any value from com.ms.wfc.data.DateFormat
     * 
     * @see com.ms.wfc.data.DateFormat
     */
    public void setFormat(int value) {}
    
    /**
     * Retrieves the custom format string. 
     * 
     * @return custom format.
     */
    public String getCustomFormat() {}
    
    /**
     * Retrieves the format type. 
     * 
     * @param type of format.
     * 
     * @see com.ms.wfc.data.DateFormat
     */
    public int getFormat() {}

    /**
     * @internalonly
     */
    public ConstructorArg[] getConstructorArgs() {}


    /**
     * Represents a data format object for formatting date data types. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends DataFormat.ClassInfo {
        public static final PropertyInfo customFormat = new PropertyInfo(
            DateDataFormat.class, "customFormat", String.class,
            new DefaultValueAttribute(""),
            new DescriptionAttribute(Sys.getString("DateDataFormatCustomFormatDescr")));

        public static final PropertyInfo format = new PropertyInfo(
            DateDataFormat.class, "format", DateFormat.class,
            new DefaultValueAttribute(new Integer(DateFormat.SHORT)),
            new DescriptionAttribute(Sys.getString("DateDataFormatFormatDescr")));

        public void getProperties(IProperties props) {}

    }
}