//STRIPPEDSOURCE//

package com.ms.wfc.data;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify the date and time formats used by a DateDataFormat object. Use these constants to set  the value of the object's format  property. 
 *
 * @security(checkClassLinking=on)
 */
public final class DateFormat extends Enum {
    /**
     * Specifies the Long Date format, as defined in the Regional Settings section of the
     * Windows Control Panel.
     */
    public static final int LONG    = 0x0001;
    /**
     * Specifies the Short Date format, as defined in the Regional Settings section of the
     * Windows Control Panel.
     */
    public static final int SHORT   = 0x0002;
    /**
     * Specifies the hh:mm format, in 24-hour time.
     */
    public static final int TIME    = 0x0004;
    /**
     * Specifies a custom date or time format.
     */
    public static final int CUSTOM  = 0x0008;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     * @internalonly 
     */
    public static boolean valid(int value) {}
}