//STRIPPEDSOURCE//

package com.ms.wfc.data;

import com.ms.wfc.app.*;
import com.ms.wfc.util.*;
import com.ms.wfc.core.*;

/**
 * Represents a data format object for formatting numeric data types. 
 *
 * @security(checkClassLinking=on)
 */
public class NumberDataFormat extends DataFormat implements IConstructable {
    private static final String DEFAULT_FORMAT = "#";
    private String format=null;

    /**
     * Creates a new NumberDataFormat.
     */
    public NumberDataFormat() {}

    /**
     * Creates a new NumberDataFormat. The resulting NumberDataFormat will
     * have the specified format.
     * 
     * @param format Format to use to format numbers.
     */
    public NumberDataFormat(String format) {}

    /**
     * @internalonly
     */
    public Object format(Locale locale, Object data) {}

    /**
     * @internalonly
     */
    public Object unformat(Locale locale, Object data) {}

    /**
     * Determines if the format needs to be persisted into code.
     * 
     * @return <b>true</b> if the property needs to be persisted.
     * 
     * @internalonly
     */
    public boolean shouldPersistFormat() {}
    
    /**
     * Resets the format to the default value.
     * 
     * @internalonly
     */
    public void resetFormat() {}
    
    /**
     * Retrieves the format string. 
     * 
     * UNDONE : ChrisAn, 3/22/1998 - get VB Format$ docs to explain
     * format.
     * 
     * @return the format that will be used for format numbers.
     */
    public String getFormat() {}
    
    /**
     * Sets the format string. 
     * 
     * UNDONE : ChrisAn, 3/22/1998 - get VB Format$ docs to explain
     * format.
     * 
     * @param value The format that will be used for format numbers.
     */
    public void setFormat(String value) {}
    
    /**
     * @internalonly
     */
    public ConstructorArg[] getConstructorArgs() {}

    /**
     * Represents a data format object for formatting numeric data types. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends DataFormat.ClassInfo {
        public static final PropertyInfo format = new PropertyInfo(
            NumberDataFormat.class, "format", String.class,
            new DescriptionAttribute(Sys.getString("NumberDataFormatFormatDescr")));

        public void getProperties(IProperties props) {}
    }
}