//STRIPPEDSOURCE//


package com.ms.wfc.data.ui;

import com.ms.dll.*;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.data.*;
import com.ms.lang.Delegate;

/**
 * Represents a single column in a DataGrid  control.  Each column is
 * bound to exactly one Field in the underlying recordset. You can have
 * multiple columns bound to the same Field.
 *
 * @security(checkClassLinking=on)
 */
public final class Column extends Component {
    /**
     * @internalonly
     */
    protected static final int PROP_ALIGNMENT   = 1;
    /**
     * @internalonly
     */
    protected static final int PROP_ALLOWSIZING = 2;
    /**
     * @internalonly
     */
    protected static final int PROP_BOUNDCOLUMN = 3;
    /**
     * @internalonly
     */
    protected static final int PROP_BACKCOLOR   = 4;
    /**
     * @internalonly
     */
    protected static final int PROP_WIDTH       = 5;
    /**
     * @internalonly
     */
    protected static final int PROP_CAPTION     = 6;
    /**
     * @internalonly
     */
    protected static final int PROP_INDEX= 7;
    /**
     * @internalonly
     */
    protected static final int PROP_DATATYPE    = 8;
    /**
     * @internalonly
     */
    protected static final int PROP_FORECOLOR   = 10;
    /**
     * @internalonly
     */
    protected static final int PROP_LEFT        = 9;
    /**
     * @internalonly
     */
    protected static final int PROP_READONLY    = 11;
    /**
     * @internalonly
     */
    protected static final int PROP_SELBACKCOLOR= 12;
    /**
     * @internalonly
     */
    protected static final int PROP_SELFORECOLOR= 13;
    /**
     * @internalonly
     */
    protected static final int PROP_VALUE       = 14;
    /**
     * @internalonly
     */
    protected static final int PROP_WRAPTEXT    = 16;
    /**
     * @internalonly
     */
    protected static final int PROP_HEADERDRAW  = 17;
    /**
     * @internalonly
     */
    protected static final int PROP_CELLDRAW    = 18;
    /**
     * @internalonly
     */
    protected static final int PROP_FONT        = 19;
    /**
     * @internalonly
     */
    protected static final int PROP_VISIBLE     = 20;
    /**
     * @internalonly
     */
    protected static final int PROP_DATAFORMAT  = 21;


    /**
     * @internalonly
     */
    protected CellDisplayer                 cellDisplayer = null;
    /**
     * @internalonly
     */
    protected ColumnHeaderDisplayer         headerDisplayer = new ColumnHeaderDisplayer();
    /**
     * @internalonly
     */
    protected ICellEditor                   editor = new DataGridTextEditor();
    /**
     * @internalonly
     */
    protected int                           dbColumnId = -1;
    /**
     * @internalonly
     */
    protected String                        caption = null;
    private int                             width = -1;
    /**
     * @internalonly
     */
    protected int                           x = 0;
    /**
     * @internalonly
     */
    protected boolean                       wrap = false;
    /**
     * @internalonly
     */
    protected DataGrid                      parent = null;
    /**
     * @internalonly
     */
    protected Font                          font = null;
    /**
     * @internalonly
     */
    protected Color                         foreColor = null;
    /**
     * @internalonly
     */
    protected Color                         backColor = null;
    /**
     * @internalonly
     */
    protected Color                         selectedForeColor = null;
    /**
     * @internalonly
     */
    protected Color                         selectedBackColor = null;


    private boolean                         allowSizing = true;
    private String                          boundFieldName = null;
    private int                             alignment = ContentAlignment.MIDDLELEFT;
    private boolean                         visible = true;
    private com.ms.wfc.data.Field           boundReadField = null;
    private com.ms.wfc.data.Field           boundWriteField = null;
    private int                             bestFitWidth = -1;
    private boolean                         readonly = false;
    private int                             index = -1;
    private IDataFormat                     dataFormat = null;

    /**
     * @internalonly
     *
     * Create a new column. You must specify the parent grid, and the
     * boundFieldName
     */
    public Column() {}

    /**
     * @internalonly
     *
     * This is called by the DataGrid to signal that one or more ambient
     * property has changed.
     */
    protected void ambientsChanged() {}

    private int calcBestFitWidth() {}
    
    private int getBestWidth() {}
    
    private void formatChanged(Object sender, Event event) {}

    /**
     * Retrieves a value indicating the alignment of the values in the column. 
     *
     * @return Current value of the Alignment property.
     *
     * @see #setAlignment
     */
    public int getAlignment() {}

    /**
     * Retrieves the background color of the cells in the column.  This property
     * is implemented as an "ambient" and will never return a null.
     *
     * @return Current back color for cells
     *
     * @see #setBackColor
     */
    public Color getBackColor() {}

    /**
     * Retrieves the name of the field in the recordset that the column is bound to. 
     *
     * @return Bound Field name from the recordset.
     *
     * @see #setBoundFieldName
     */
    public String getBoundFieldName() {}

    /**
     * Retrieves the text displayed in the column's header. 
     *
     * @return String that will be displayed at the top of the column.
     *
     * @see #setCaption
     */
    public String getCaption() {}

    public IDataFormat getDataFormat() {}

    /**
     * Retrieves the data type of the field in the recordset that the column is bound to. 
     *
     * @return Datatype of the Field.
     */
    public int getDataType() {}

    /**
     * Retrieves the color of the text in the column.  This property
     * is implemented as an "ambient" and will never return a null.
     *
     * @return Current fore color for cells
     *
     * @see #setForeColor
     */
    public Color getForeColor() {}

    /**
     * Retrieves the font of the text in the column.  This property is
     * implemented as an "ambient" and will never return null.
     *
     * @return Current font for cells.
     *
     * @see #setFont
     */
    public Font getFont() {}

    /**
     * Retrieves the index of the column in the grid.  This is a zero based index that
     * represents the visual position of the column.
     *
     * @return Current dispayIndex of the column.
     *
     * @see #setIndex
     */
    public int getIndex() {}

    void setInternalWidth(int n) {}

    /**
     * Retrieves the x-coordinate of the column. 
     *
     * @return Left coordinated of the column.
     */
    public int getLeft() {}

    /**
     * Retrieves the background color for selected cells in the column.  This
     * property is implemented as an "ambient" and will never return a null.
     *
     * @return Current back color for selected cells
     *
     * @see #setSelectedBackColor
     */
    public Color getSelectedBackColor() {}

    /**
     * Retrieves the color for selected text in the column.  This
     * property is implemented as an "ambient" and will never return a null.
     *
     * @return Current fore color for selected cells
     *
     * @see #setSelectedForeColor
     */
    public Color getSelectedForeColor() {}

    /**
     * Retrieves the value of the cell in the grid's current row. 
     *
     * @return Formatted value of the current row in the recordset for the
     *         bound field.
     *
     * @see #setValue
     */
    public String getValue() {}

    /**
     * Retrieves the width of the column. 
     *
     * @return Current width of the column
     *
     * @see #setWidth
     */
    public int getWidth() {}

    /**
     * @internalonly
     *
     * Returns the bound field used for reading data
     */
    protected com.ms.wfc.data.Field getBoundReadField() {}

    /**
     * @internalonly
     *
     * Returns the build field used for writing data
     */
    protected com.ms.wfc.data.Field getBoundWriteField() {}

    /**
     * @internalonly
     *
     * Sets the index without sending a property change notification.
     * Used by the DataGrid to reorder all the columns after one column has
     * been moved.
     */
    protected void internalSetIndex(int index) {}

    /**
     * Retrieves a boolean value indicating whether the column can be resized at run
     * time. 
     *
     * @return Current value of the AllowSizing property
     *
     * @see #setAllowSizing
     */
    public boolean getAllowSizing() {}

    /**
     * Retrieves a boolean value indicating whether the data in the column is
     * read-only. 
     *
     * @return Current value of the ReadOnly property
     *
     * @see #setReadOnly
     */
    public boolean getReadOnly() {}

    /**
     * Retrieves a boolean value indicating whether the underlying field supports write
     * operations. 
     *
     * @return <b>true</b> if the underlying field supports writes.
     */
    public boolean getWriteAllowed() {}

    /**
     * Retrieves a boolean value indicating whether the column is visible (meaning it
     * can be scrolled into view). 
     *
     * @return Current value of the Visible property
     *
     * @see #setVisible
     */
    public boolean getVisible() {}

    /**
     * Retrieves a boolean value indicating whether the text values in the column can
     * wrap within their cells. 
     *
     * @return Current value of the WrapText property
     *
     * @see #setWrapText
     */
    public boolean getWrapText() {}


    /**
     * @internalonly
     *
     * Rebinds the column to the recordset field. Forces the bound fields to
     * be looked up by name again.
     */
    protected void rebind() {}

    /**
     * Sets the alignment of the text in the column. 
     *
     * @param align New value for the Alignment property.
     *
     * @see #getAlignment
     *
     * @exception WFCInvalidArgumentException Thrown if align is not a valid
     *            Alignment value.
     */
    public void setAlignment(int align) {}

    /**
     * Sets a boolean value indicating whether the column can be resized at run time.  When AllowSizing is set to false then
     * the column's width cannot be changed.
     *
     * @param allow New value for the AllowSizing property.
     *
     * @see #getAllowSizing
     */
    public void setAllowSizing(boolean allow) {}

    /**
     * Sets the background color for the cells in the column. 
     *
     * @param color New value for the BackColor property.
     *
     * @see #getBackColor
     */
    public void setBackColor(Color color) {}

    /**
     * Sets the name of the field in the recordset that the column is bound to. 
     *
     * @param name Name of the field to bind to.
     *
     * @see #getBoundFieldName
     */
    public void setBoundFieldName(String name) {}

    /**
     * Sets the text to be displayed in the column's header. 
     *
     * @param caption New value for the Caption property.
     *
     * @see #getCaption
     */
    public void setCaption(String caption) {}

    public void setDataFormat(IDataFormat value) {}

    /**
     * Sets the color of the text in the column. 
     *
     * @param color New value for the ForeColor property.
     *
     * @see #getForeColor
     */
    public void setForeColor(Color color) {}

    /**
     * Sets the font of the text in the column. 
     *
     * @param font New value for the Font property.
     *
     * @see #getFont
     */
    public void setFont(Font font) {}

    /**
     * Sets the index of the column in the grid.  This has the effect of reording
     * the columns in the grid. If the index that is specified is outside of the
     * bounds of the columns collection in the grid, then the column is
     * reposition as either the first or last column, depending on if the
     * index is greater than the total number of columns, or less than 0.<p>
     *
     * When setting the index of the column, keep in mind that the
     * column will be placed at that index, and any column currently
     * at that display index will be shifted down (to the right).
     *
     * @param index New index for the column.
     *
     * @see #getIndex
     */
    public void setIndex(int index) {}

    DataGrid getParent() {}
    void setParent(DataGrid parent) {}

    /**
     * Sets a boolean value indicating whether the data in the column is read-only.  When the column is readonly then no data
     * can be edited in the column. This will be enforced through all DataGrid
     * controled members, Column.setValue and DataGrid.setCurrentValue will
     * both fail to update the recordset if readonly is set to true.
     *
     * @param readonly New value for the ReadOnly property.
     *
     * @see #getReadOnly
     */
    public void setReadOnly(boolean readonly) {}

    /**
     * Sets the background color for selected cells in the column. 
     *
     * @param color New value for the SelectedBackColor property.
     *
     * @see #getSelectedBackColor
     */
    public void setSelectedBackColor(Color color) {}

    /**
     * Sets the color for selected text in the column. 
     *
     * @param color New value for the SelectedForeColor property.
     *
     * @see #getSelectedForeColor
     */
    public void setSelectedForeColor(Color color) {}

    /**
     * Sets the value of the cell in the grid's current row. 
     *
     * @param value New value for the bound field.
     *
     * @see #getValue
     */
    public void setValue(String value) {}

    /**
     * Sets a boolean value indicating whether the column is visible (meaning it can be
     * scrolled into view).  When
     * a column is set to be non-visible, it still has a index and
     * will still be taken into account when returning columns from the
     * DataGrid. The only effect of hiding a column is that it won't be drawn.
     *
     * @param visible New value for the Visible property
     *
     * @see #getVisible
     */
    public void setVisible(boolean visible) {}

    /**
     * Sets a boolean value indicating whether the values in the column can wrap within
     * their cells.  When WrapText is turned on then any value
     * displayed in the column that is longer that the width of the column
     * will be wrapped to multiple lines.
     *
     * @param wrap New value for the WrapText property.
     *
     * @see #getWrapText
     */
    public void setWrapText(boolean wrap) {}

    /**
     * Sets the width of the column.  If AllowSizing is set to false then
     * this function has no effect.
     *
     * @param width New width for the Column
     *
     * @see #getWidth
     *
     * @exception WFCInvalidArgumentException Thrown if the width is below the
     *            DataGrid's minimum column width.
     */
    public void setWidth(int width) {}

    public boolean shouldPersistBackColor() {}
    public boolean shouldPersistFont() {}
    public boolean shouldPersistForeColor() {}
    public boolean shouldPersistSelectedBackColor() {}
    public boolean shouldPersistSelectedForeColor() {}

    /**
     * Retrieves a description of the column. 
     *
     * @return String representation of the column.
     */
    public String toString() {}

    
    private void updateBindingFromName() {}
    /**
     * Represents a single column in a DataGrid  control. 
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Component.ClassInfo {
        public static final PropertyInfo alignment = new PropertyInfo(
            Column.class, "alignment", ContentAlignment.class,
            DefaultValueAttribute.ZERO,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnAlignment")));
        public static final PropertyInfo allowSizing = new PropertyInfo(
            Column.class, "allowSizing", boolean.class,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("ColumnAllowSizing")));
        public static final PropertyInfo backColor = new PropertyInfo(
            Column.class, "backColor", Color.class,
            new DescriptionAttribute(Sys.getString("ColumnBackColor")));
        public static final PropertyInfo boundFieldName = new PropertyInfo(
            Column.class, "boundFieldName", String.class,
            new ValueEditorAttribute(FieldNameEditor.class),
            new DescriptionAttribute(Sys.getString("ColumnBoundFieldName")));
        public static final PropertyInfo caption = new PropertyInfo(
            Column.class, "caption", String.class,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnCaption")));
        public static final PropertyInfo dataFormat = new PropertyInfo(
            Column.class, "dataFormat", IDataFormat.class,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("ColumnDataFormat")));
        public static final PropertyInfo index = new PropertyInfo(
            Column.class, "index", int.class,
            new DescriptionAttribute(Sys.getString("ColumnIndex")));
        public static final PropertyInfo font = new PropertyInfo(
            Column.class, "font", Font.class,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnFont")));
        public static final PropertyInfo foreColor = new PropertyInfo(
            Column.class, "foreColor", Color.class,
            new DescriptionAttribute(Sys.getString("ColumnForeColor")));
        public static final PropertyInfo readOnly = new PropertyInfo(
            Column.class, "readOnly", boolean.class,
            DefaultValueAttribute.FALSE,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnReadOnly")));
        public static final PropertyInfo selectedBackColor = new PropertyInfo(
            Column.class, "selectedBackColor", Color.class,
            new DescriptionAttribute(Sys.getString("ColumnSelectedBackColor")));
        public static final PropertyInfo selectedForeColor = new PropertyInfo(
            Column.class, "selectedForeColor", Color.class,
            new DescriptionAttribute(Sys.getString("ColumnSelectedForeColor")));
        public static final PropertyInfo visible = new PropertyInfo(
            Column.class, "visible", boolean.class,
            DefaultValueAttribute.TRUE,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnVisible")));
        public static final PropertyInfo wrapText = new PropertyInfo(
            Column.class, "wrapText", boolean.class,
            DefaultValueAttribute.FALSE,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnWrapText")));
        public static final PropertyInfo width = new PropertyInfo(
            Column.class, "width", int.class,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ColumnWidth")));
        public void getAttributes(IAttributes attrs) {}

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties iprop) {}
    };

}