//STRIPPEDSOURCE//


package com.ms.wfc.data.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Provides data for the columnEditing  event of the DataGrid control. 
 * @security(checkClassLinking=on)
 */
public final class ColumnEditingEvent extends Event {

    /**
     * DisplayIndex of the column that the event applies to.
     */
    public final int column;
    /**
     * Key that was pressed that cause the edit to occur.
     */
    public final int keyAscii;
    /**
     * Cancel flag. Set to true to cancel the column edit.
     */
    public boolean cancel;

    /**
     * Creates a new ColumnEditingEvent object.
     *
     * @param column Column that the event applies to
     * @param keyAscii Key that was pressed that caused the edit to occur
     * @param cancel Default state of the cancel flag
     */
    public ColumnEditingEvent(int column, int keyAscii, boolean cancel) {}
}