//STRIPPEDSOURCE//


package com.ms.wfc.data.ui;

import com.ms.wfc.core.*;

/**
 * Provides data for the columnUpdating  event of the DataGrid control. 
 * @security(checkClassLinking=on)
 */
public final class ColumnUpdatingEvent extends Event {

    /**
     * Display index of the column that this event applies to
     */
    public int column;
    /**
     * Old value of the column
     */
    public String oldValue;
    /**
     * Cancel flag. Set to true to cancel the update.
     */
    public boolean cancel;

    /**
     * Creates a new ColumnUpdatingEvent object.
     *
     * @param column Column this event applies to
     * @param oldValue Old value of the column
     * @param cancel Default value of the cancel flag
     */
    public ColumnUpdatingEvent(int column, String oldValue, boolean cancel) {}
}