//STRIPPEDSOURCE//


package com.ms.wfc.data.ui;

import com.ms.wfc.core.*;


/**
 * Defines the constants that specify the behavior of the ENTER key within a DataGrid control. 
 * @security(checkClassLinking=on)
 */
public class EnterAction extends Enum {
    /**
     * Specifies that the ENTER key cannot be used to move the current cell focus within the
     * grid.
     */
    public static final int NONE = 0;
    /**
     * Specifies that the ENTER key will move focus to the cell in the next column, within the
     * same row.
     */
    public static final int COLUMNNAVIGATION = 1;
    /**
     * Specifies that the ENTER key will move focus to the cell in the next row, within the
     * same column.
     */
    public static final int ROWNAVIGATION = 2;
}