//STRIPPEDSOURCE//
#define USE_ASYNC

package com.ms.wfc.data.ui;

import com.ms.wfc.data.*;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.ole32.*;


final class ScrollableDataStore {

    
    
    

    private static final float INVALID_RATIO = (float)-23.23;

    private static final int WM_DELAY_ACTION = (win.WM_USER + 1452);
    private List actions = new List();

    
    
    private float           cacheStartRatio = INVALID_RATIO;
    private float           cacheRowRatioSize = INVALID_RATIO;
    private Object[]        bookmarkCache = new Object[30];
    private int             pageSize = 10;
    private int             cacheSize = 30;
    private int             currentRecordCacheIndex = -1;
    private int             topRowCacheIndex = -1;
    private int             bofCacheIndex = -1;
    private int             eofCacheIndex = -1;

    
    
    private Object          currentBookmark = null;
    private Recordset       externalRecordset = null;
    private Recordset       internalRecordset = null;
    private IDataConsumer   dataConsumer = null;
    private int             recordCount = -1;
    private boolean         empty = false;
    private boolean         addNewOnEOF = false;
    private Recordset       deleteRecordset = null;
    private boolean         lastAddNewStatus = false;
    
    #if DEBUG
    #endif 
    
    /**
     * Creates a new ScrollableDataStore. You must supply a non-null recordset that
     * this ScrollableDataStore will be wrapping. The ScrollableDataStore will also clone
     * this recordset to provide arbitrary reads.
     *
     * @param external Recordset that will be wrapped.
     *
     * @exception WFCInvalidArgumentException This will be thrown if you pass a
     *            null value in for external.
     */
    public ScrollableDataStore(Recordset external) {}

    private void hookEvents(Recordset rs) {}

    public void addNew() {}

    /**
     * Called by the consumer when the consumer's wndProc recieves a message
     * that has the AsyncMessage id.
     *
     * @param msg Full message that was sent to the consumer
     */
    public void asyncMessageRecieved(Message msg) {}

    
    private void doActions() {}        
    
    /**
     * Compares two bookmarks as literals. Recordsets do not always allow
     * comparisons as literals. Check isBookmarksLiteral to see if literal
     * bookmarks are supported. Use compareBookmarks for non-literal bookmark
     * comparisons.
     *
     * @param left bookmark to compare
     * @param right bookmark to compare
     *
     * @return true if the bookmarks are literally equal
     *
     * @see #isBookmarksLiteral
     * @see #compareBookmarks
     */
    public boolean bookmarksEqual(Object left, Object right) {}

    public void cancelUpdate() {}
    
    
    private void clearCache() {}

    /**
     * Deletes the specified rows.
     *
     * @param rows Array of DataRows to delete
     */
    public void deleteRows(DataRow[] rows) {}

    
    private void fillCacheIndex(int cacheIndex) {}

    public boolean fireViewScrollEvent() {}

    private void fireErrorEvent(Throwable t) {}
    
    public boolean getAddNewOnEOF() {}
    
    private boolean getConnectionReadOnly() {}        
    
    public boolean getUpdateAllowed() {}
    
    public boolean getAddNewAllowed() {}
    
    public boolean getDeleteAllowed() {}
    
    /**
     * Returns the bookmark for the row that is displayed at the given display
     * index.
     *
     * @param displayIndex Display index of the row
     *
     * @return Bookmark for the requested row
     */
    public Object getBookmarkFromDisplayIndex(int displayIndex) {}


    /**
     * Returns the bookmark for any row relative to another row.
     *
     * @param offset Number of rows from bookmark
     * @param bookmark Bookmark to use as a "base"
     *
     * @return Bookmark for the row that is offset rows away from bookmark
     */
    public Object getBookmarkRelative(int offset, Object bookmark) {}

    /**
     * @internalonly
     *
     * Returns the cacheIndex for the specified bookmark
     */
    protected int getCacheIndexFromBookmark(Object bookmark) {}

    /**
     * Returns the number of Fields in the current recordset.
     *
     * @return Count of fields in the current recordset
     */
    public int getColumnCount() {}

    /**
     * Returns the current row.
     *
     * @return Current row.
     */
    public DataRow getCurrentRow() {}

    /**
     * Returns the displayIndex for the specified row.
     *
     * @param bookmark Bookmark of the row to lookup
     *
     * @return displayIndex of the specified row. -1 if the row isn't displayed.
     *
     */
    public int getDisplayIndexFromBookmark(Object bookmark) {}

    /**
     * Returns the DataRow for the specified bookmark.
     *
     * @param bookmark Bookmark of the row to retrieve
     *
     * @return Row refered to be the bookmark
     */
    public DataRow getDisplayRow(Object bookmark) {}

    /**
     * Returns the row that has the specified displayIndex.
     *
     * @param displayIndex Index of the row to retrieve.
     *
     * @return Row displayed at displayIndex
     */
    public DataRow getDisplayRow(int displayIndex) {}


    /**
     * Moves the read recordset to the requested position. This allows for more
     * effecient reading by performing the move once, and then reading each
     * column.
     *
     * @param row DataRow to move the read recordset to
     */
    public void setReadPosition(DataRow row) {}

    /**
     * Returns the data in specified row and field. This will apply formatting
     * to the data.
     *
     * @param row Row to lookup the data in
     * @param field Field to get the data from.
     *
     * @return String data from the recordset
     */
    public String getFormattedData(DataRow row, Field field) {}

    /**
     * Determines if the recordset is currently on a new uncomitted row.
     *
     * @return <b>true</b> if the recordset is on the new row.
     */
    public boolean getNewRow() {}

    /**
     * Returns the displayIndex of the last row in the recordset. Returns
     * -1 if the last row isn't displayed.
     *
     * @return DisplayIndex of the last row
     */
    public int getLastDisplayIndex() {}

    /**
     * Returns the number of rows in a single page.
     *
     * @return Number of rows in a single page.
     */
    public int getPageSize() {}

    /**
     * Returns the number of valid rows visible in the current page.
     *
     * @return Number of rows visible
     */
    public int getPageRowCount() {}

    /**
     * Returns a field from the internal "read" recordset.
     *
     * @param i Index of the field to return
     *
     * @return Field from the internal "read" recordset
     */
    public Field getReadField(int i) {}

    /**
     * Returns a field from the internal "read" recordset.
     *
     * @param name Name of the field to return
     *
     * @return Field from the internal "read" recordset
     */
    public Field getReadField(String name) {}

    
    private int getExtraRowCount() {}
    
    /**
     * Determines the minimum ratio increment that would result in the movement
     * of the visual region.
     */
    public float getMinVisualRatioIncrement() {}
    

    /**
     * Returns the ratio (0.0 - 1.0) that the top display row is in the
     * recordset. Use this to position a scrollbar.
     *
     * <p><b>This can be a very slow operation depending on the cursor type. Use
     * with caution. </b>
     *
     * @return Ratio that the top display row is in the recordset.
     */
    public float getTopRowRatio() {}

    /**
     * Returns the total number of rows in the recordset. This may change over
     * time depending on the cursor type of the underlying recordset.
     *
     * <p><b>This can be a very slow operation depending on the cursor type. Use
     * with caution. </b>
     *
     * @return Number of rows in the recordset.
     */
    public int getTotalRowCount() {}

    /**
     * Returns a field from the external "write" recordset.
     *
     * @param i Index of the field to return
     *
     * @return Field from the external "write" recordset
     */
    public Field getWriteField(int i) {}

    /**
     * Returns a field from the external "write" recordset.
     *
     * @param name Name of the field to return
     *
     * @return Field from the external "write" recordset
     */
    public Field getWriteField(String name) {}

    /**
     * Returns the status of the DBPROP_LITERALBOOKMARKS property in the
     * underlying recordset. If this returns true, then bookmarks can be
     * compared using bookmarksEqual.
     *
     * @return True if literal bookmarks are supported.
     */
    public boolean getBookmarksLiteral() {}

    /**
     * Returns the status of the DBPROP_ORDEREDBOOKMARKS property in the
     * underlying recordset. If this returns true, then bookmarks can be
     * converted to longs and compared for relative position (i.e. a < b)
     *
     * @return True if bookmarks are ordered.
     */
    public boolean getBookmarksOrdered() {}

    /**
     * Returns true if the current row has pending changes...
     */    
    public boolean getCurrentRowModified() {}

    /**
     * Moves the current position offset rows away from row.
     *
     * @param row "Base" row
     * @param offset Number of rows from row to move.
     */
    public void move(DataRow row, int offset) {}

    /**
     * Moves the current position to the specified row.
     *
     * @param row Row to make the current row.
     */
    public void move(DataRow row) {}

    /**
     * Moves the current position to the next row.
     */
    public void moveNext() {}

    /**
     * Moves the current position to the first row in the recordset.
     */
    public void moveFirst() {}

    /**
     * Moves the current position to the last row in the recordset.
     */
    public void moveLast() {}

    /**
     * Moves the current position to the previous row.
     */
    public void movePrevious() {}

    
    private void optimizeCache() {}

    private void onEndOfRecordsetHandler(Object sender, RecordsetEvent event) {}

    private void onFieldChangeCompleteHandler(Object sender, RecordsetEvent event) {}

    private void resetBinding(boolean reclone) {}        
    
    private void moveComplete(int reason) {}
    
    private void onMoveCompleteHandler(Object sender, RecordsetEvent event) {}

    private void deleteComplete() {}
    
    private void addnewComplete() {}
    
    private void undoComplete() {}
    
    private void onRecordChangeCompleteHandler(Object sender, RecordsetEvent event) {}

    private void onRecordsetChangeCompleteHandler(Object sender, RecordsetEvent event) {}

    private void onWillChangeFieldHandler(Object sender, RecordsetEvent event) {}

    private void onWillChangeRecordHandler(Object sender, RecordsetEvent event) {}

    private void onWillChangeRecordsetHandler(Object sender, RecordsetEvent event) {}

    private void onWillMoveHandler(Object sender, RecordsetEvent event) {}

    private void postMessage(MethodInvoker handler) {}
    
    /**
     * Dumps the cache, but keeps track of the current top row. This enables
     * someone to refresh the display of a bound control without loosing the
     * current scroll position.
     */
    public void refresh() {}        

    /**
     * Compares two rows for equality. This function only works if both rows
     * came from the same recordset and isBookmarksLiteral is true for the
     * source dataprovider.
     *
     * @param left Row to compare
     * @param right Row to compare
     *
     * @return True if both rows refer to the same underlying row in the
     *         recordset.
     */
    public boolean rowsEqual(DataRow left, DataRow right) {}

    /**
     * Scrolls the toprow to the row in the recordset that is ratio percent the
     * way through the recordset. Usefull for scrolling the display from a
     * scrollbar
     *
     * <p><b>This can be a very slow operation depending on the cursor type. Use
     * with caution. </b>
     *
     * @param ratio Ratio in the recordset to make the top row
     */
    public void scroll(float ratio) {}

    /**
     * Sets the top row of the display to the row that is offset rows away
     * from bookmark.
     *
     * @param offset Number of rows from bookmark to make the toprow
     * @param bookmark Base row
     */
    public void scroll(int offset, Object bookmark) {}


    /**
     * Scrolls the display to make the current row visible.
     */
    public void scrollCurrentIntoView() {}

    /**
     * Scrolls the display to the bottom of the recordset
     */
    public void scrollToBottom() {}

    /**
     * Scrolls the display to the top of the recordset
     */
    public void scrollToFirst() {}

    public void setAddNewOnEOF(boolean value) {}
    
    /**
     * Sets the current row to be the row with the bookmark specified.
     *
     * @param bookmark Bookmark of the row to make current.
     */
    public void setCurrentRow(Object bookmark) {}

    /**
     * Sets the DataConsumer of this provider.
     *
     * @param consumer Object that will be notified of events on this
     *        dataProvider.
     */
    public void setDataConsumer(IDataConsumer consumer) {}

    /**
     * Sets the data for the current row and specified field. This will remove
     * formatting from the data.
     *
     * @param field Field to set the data in.
     * @param data Data to save in the field
     */
    public void setFormattedData(Field field, IDataFormat format, String data) {}

    /**
     * Sets the size of the visible page. This also affects the cache size.
     *
     * @param pageSize Number of rows visible
     */
    public void setPageSize(int value) {}

    
    private void verifyValidCache() {}


    
    private static class Property {
        public static final int DBPROP_ACTIVESESSIONS       =   0x3;
        public static final int DBPROP_APPENDONLY       =   0xbb;
        public static final int DBPROP_ASYNCTXNABORT        =   0xa8;
        public static final int DBPROP_ASYNCTXNCOMMIT       =   0x4;
        public static final int DBPROP_AUTH_CACHE_AUTHINFO      =   0x5;
        public static final int DBPROP_AUTH_ENCRYPT_PASSWORD        =   0x6;
        public static final int DBPROP_AUTH_INTEGRATED      =   0x7;
        public static final int DBPROP_AUTH_MASK_PASSWORD       =   0x8;
        public static final int DBPROP_AUTH_PASSWORD        =   0x9;
        public static final int DBPROP_AUTH_PERSIST_ENCRYPTED       =   0xa;
        public static final int DBPROP_AUTH_PERSIST_SENSITIVE_AUTHINFO      =   0xb;
        public static final int DBPROP_AUTH_USERID      =   0xc;
        public static final int DBPROP_BLOCKINGSTORAGEOBJECTS       =   0xd;
        public static final int DBPROP_BOOKMARKS        =   0xe;
        public static final int DBPROP_BOOKMARKSKIPPED      =   0xf;
        public static final int DBPROP_BOOKMARKTYPE     =   0x10;
        public static final int DBPROP_BYREFACCESSORS       =   0x78;
        public static final int DBPROP_CACHEDEFERRED        =   0x11;
        public static final int DBPROP_CANFETCHBACKWARDS        =   0x12;
        public static final int DBPROP_CANHOLDROWS      =   0x13;
        public static final int DBPROP_CANSCROLLBACKWARDS       =   0x15;
        public static final int DBPROP_CATALOGLOCATION      =   0x16;
        public static final int DBPROP_CATALOGTERM      =   0x17;
        public static final int DBPROP_CATALOGUSAGE     =   0x18;
        public static final int DBPROP_CHANGEINSERTEDROWS       =   0xbc;
        public static final int DBPROP_COL_AUTOINCREMENT        =   0x1a;
        public static final int DBPROP_COL_DEFAULT      =   0x1b;
        public static final int DBPROP_COL_DESCRIPTION      =   0x1c;
        public static final int DBPROP_COL_FIXEDLENGTH      =   0xa7;
        public static final int DBPROP_COL_NULLABLE     =   0x1d;
        public static final int DBPROP_COL_PRIMARYKEY       =   0x1e;
        public static final int DBPROP_COL_UNIQUE       =   0x1f;
        public static final int DBPROP_COLUMNDEFINITION     =   0x20;
        public static final int DBPROP_COLUMNRESTRICT       =   0x21;
        public static final int DBPROP_COMMANDTIMEOUT       =   0x22;
        public static final int DBPROP_COMMITPRESERVE       =   0x23;
        public static final int DBPROP_CONCATNULLBEHAVIOR       =   0x24;
        public static final int DBPROP_CURRENTCATALOG       =   0x25;
        public static final int DBPROP_DATASOURCENAME       =   0x26;
        public static final int DBPROP_DATASOURCEREADONLY       =   0x27;
        public static final int DBPROP_DBMSNAME     =   0x28;
        public static final int DBPROP_DBMSVER      =   0x29;
        public static final int DBPROP_DEFERRED     =   0x2a;
        public static final int DBPROP_DELAYSTORAGEOBJECTS      =   0x2b;
        public static final int DBPROP_DSOTHREADMODEL       =   0xa9;
        public static final int DBPROP_GROUPBY      =   0x2c;
        public static final int DBPROP_HETEROGENEOUSTABLES      =   0x2d;
        public static final int DBPROP_IAccessor        =   0x79;
        public static final int DBPROP_IColumnsInfo     =   0x7a;
        public static final int DBPROP_IColumnsRowset       =   0x7b;
        public static final int DBPROP_IConnectionPointContainer        =   0x7c;
        public static final int DBPROP_IConvertType     =   0xc2;
        public static final int DBPROP_IRowset      =   0x7e;
        public static final int DBPROP_IRowsetChange        =   0x7f;
        public static final int DBPROP_IRowsetIdentity      =   0x80;
        public static final int DBPROP_IRowsetIndex     =   0x9f;
        public static final int DBPROP_IRowsetInfo      =   0x81;
        public static final int DBPROP_IRowsetLocate        =   0x82;
        public static final int DBPROP_IRowsetResynch       =   0x84;
        public static final int DBPROP_IRowsetScroll        =   0x85;
        public static final int DBPROP_IRowsetUpdate        =   0x86;
        public static final int DBPROP_ISupportErrorInfo        =   0x87;
        public static final int DBPROP_ILockBytes       =   0x88;
        public static final int DBPROP_ISequentialStream        =   0x89;
        public static final int DBPROP_IStorage     =   0x8a;
        public static final int DBPROP_IStream      =   0x8b;
        public static final int DBPROP_IDENTIFIERCASE       =   0x2e;
        public static final int DBPROP_IMMOBILEROWS     =   0x2f;
        public static final int DBPROP_INDEX_AUTOUPDATE     =   0x30;
        public static final int DBPROP_INDEX_CLUSTERED      =   0x31;
        public static final int DBPROP_INDEX_FILLFACTOR     =   0x32;
        public static final int DBPROP_INDEX_INITIALSIZE        =   0x33;
        public static final int DBPROP_INDEX_NULLCOLLATION      =   0x34;
        public static final int DBPROP_INDEX_NULLS      =   0x35;
        public static final int DBPROP_INDEX_PRIMARYKEY     =   0x36;
        public static final int DBPROP_INDEX_SORTBOOKMARKS      =   0x37;
        public static final int DBPROP_INDEX_TEMPINDEX      =   0xa3;
        public static final int DBPROP_INDEX_TYPE       =   0x38;
        public static final int DBPROP_INDEX_UNIQUE     =   0x39;
        public static final int DBPROP_INIT_DATASOURCE      =   0x3b;
        public static final int DBPROP_INIT_HWND        =   0x3c;
        public static final int DBPROP_INIT_IMPERSONATION_LEVEL     =   0x3d;
        public static final int DBPROP_INIT_LCID        =   0xba;
        public static final int DBPROP_INIT_LOCATION        =   0x3e;
        public static final int DBPROP_INIT_MODE        =   0x3f;
        public static final int DBPROP_INIT_PROMPT      =   0x40;
        public static final int DBPROP_INIT_PROTECTION_LEVEL        =   0x41;
        public static final int DBPROP_INIT_PROVIDERSTRING      =   0xa0;
        public static final int DBPROP_INIT_TIMEOUT     =   0x42;
        public static final int DBPROP_LITERALBOOKMARKS     =   0x43;
        public static final int DBPROP_LITERALIDENTITY      =   0x44;
        public static final int DBPROP_MARSHALLABLE     =   0xc5;
        public static final int DBPROP_MAXINDEXSIZE     =   0x46;
        public static final int DBPROP_MAXOPENROWS      =   0x47;
        public static final int DBPROP_MAXPENDINGROWS       =   0x48;
        public static final int DBPROP_MAXROWS      =   0x49;
        public static final int DBPROP_MAXROWSIZE       =   0x4a;
        public static final int DBPROP_MAXROWSIZEINCLUDESBLOB       =   0x4b;
        public static final int DBPROP_MAXTABLESINSELECT        =   0x4c;
        public static final int DBPROP_MAYWRITECOLUMN       =   0x4d;
        public static final int DBPROP_MEMORYUSAGE      =   0x4e;
        public static final int DBPROP_MULTIPLEPARAMSETS        =   0xbf;
        public static final int DBPROP_MULTIPLERESULTS      =   0xc4;
        public static final int DBPROP_MULTIPLESTORAGEOBJECTS       =   0x50;
        public static final int DBPROP_MULTITABLEUPDATE     =   0x51;
        public static final int DBPROP_NOTIFICATIONGRANULARITY      =   0xc6;
        public static final int DBPROP_NOTIFICATIONPHASES       =   0x52;
        public static final int DBPROP_NOTIFYCOLUMNSET      =   0xab;
        public static final int DBPROP_NOTIFYROWDELETE      =   0xad;
        public static final int DBPROP_NOTIFYROWFIRSTCHANGE     =   0xae;
        public static final int DBPROP_NOTIFYROWINSERT      =   0xaf;
        public static final int DBPROP_NOTIFYROWRESYNCH     =   0xb1;
        public static final int DBPROP_NOTIFYROWSETRELEASE      =   0xb2;
        public static final int DBPROP_NOTIFYROWSETFETCHPOSITIONCHANGE      =   0xb3;
        public static final int DBPROP_NOTIFYROWUNDOCHANGE      =   0xb4;
        public static final int DBPROP_NOTIFYROWUNDODELETE      =   0xb5;
        public static final int DBPROP_NOTIFYROWUNDOINSERT      =   0xb6;
        public static final int DBPROP_NOTIFYROWUPDATE      =   0xb7;
        public static final int DBPROP_NULLCOLLATION        =   0x53;
        public static final int DBPROP_OLEOBJECTS       =   0x54;
        public static final int DBPROP_ORDERBYCOLUMNSINSELECT       =   0x55;
        public static final int DBPROP_ORDEREDBOOKMARKS     =   0x56;
        public static final int DBPROP_OTHERINSERT      =   0x57;
        public static final int DBPROP_OTHERUPDATEDELETE        =   0x58;
        public static final int DBPROP_OUTPUTPARAMETERAVAILABILITY      =   0xb8;
        public static final int DBPROP_OWNINSERT        =   0x59;
        public static final int DBPROP_OWNUPDATEDELETE      =   0x5a;
        public static final int DBPROP_PERSISTENTIDTYPE     =   0xb9;
        public static final int DBPROP_PREPAREABORTBEHAVIOR     =   0x5b;
        public static final int DBPROP_PREPARECOMMITBEHAVIOR        =   0x5c;
        public static final int DBPROP_PROCEDURETERM        =   0x5d;
        public static final int DBPROP_PROVIDERNAME     =   0x60;
        public static final int DBPROP_PROVIDEROLEDBVER     =   0x61;
        public static final int DBPROP_PROVIDERVER      =   0x62;
        public static final int DBPROP_QUICKRESTART     =   0x63;
        public static final int DBPROP_QUOTEDIDENTIFIERCASE     =   0x64;
        public static final int DBPROP_REENTRANTEVENTS      =   0x65;
        public static final int DBPROP_REMOVEDELETED        =   0x66;
        public static final int DBPROP_REPORTMULTIPLECHANGES        =   0x67;
        public static final int DBPROP_RETURNPENDINGINSERTS     =   0xbd;
        public static final int DBPROP_ROWRESTRICT      =   0x68;
        public static final int DBPROP_ROWSETCONVERSIONSONCOMMAND       =   0xc0;
        public static final int DBPROP_ROWTHREADMODEL       =   0x69;
        public static final int DBPROP_SCHEMATERM       =   0x6a;
        public static final int DBPROP_SCHEMAUSAGE      =   0x6b;
        public static final int DBPROP_SERVERCURSOR     =   0x6c;
        public static final int DBPROP_SESS_AUTOCOMMITISOLEVELS     =   0xbe;
        public static final int DBPROP_SQLSUPPORT       =   0x6d;
        public static final int DBPROP_STRONGIDENTITY       =   0x77;
        public static final int DBPROP_STRUCTUREDSTORAGE        =   0x6f;
        public static final int DBPROP_SUBQUERIES       =   0x70;
        public static final int DBPROP_SUPPORTEDTXNDDL      =   0xa1;
        public static final int DBPROP_SUPPORTEDTXNISOLEVELS        =   0x71;
        public static final int DBPROP_SUPPORTEDTXNISORETAIN        =   0x72;
        public static final int DBPROP_TABLETERM        =   0x73;
        public static final int DBPROP_TBL_TEMPTABLE        =   0x8c;
        public static final int DBPROP_TRANSACTEDOBJECT     =   0x74;
        public static final int DBPROP_UPDATABILITY     =   0x75;
        public static final int DBPROP_USERNAME     =   0x7;
        public static final int DBPROP_FILTERCOMPAREOPS     =   0xd1;
        public static final int DBPROP_FINDCOMPAREOPS       =   0xd2;
        public static final int DBPROP_IChapteredRowset     =   0xca;
        public static final int DBPROP_IDBAsynchStatus      =   0xcb;
        public static final int DBPROP_IRowsetFind      =   0xcc;
        public static final int DBPROP_INIT_ASYNCH      =   0xc8;
        public static final int DBPROP_MAXOPENCHAPTERS      =   0xc7;
        public static final int DBPROP_MAXORSINFILTER       =   0xcd;
        public static final int DBPROP_MAXSORTCOLUMNS       =   0xce;
        public static final int DBPROP_ROWSET_ASYNCH        =   0xc9;
        public static final int DBPROP_SORTONINDEX      =   0xc;
        public static final int DBPROP_ICommandTree     =   0x8e;
        public static final int DBPROP_ICommandValidate     =   0x8f;
        public static final int DBPROP_IDBSchemaCommand     =   0x90;
        public static final int DBPROP_IDBSecurityInfo      =   0x91;
        public static final int DBPROP_IProvideMoniker      =   0x7d;
        public static final int DBPROP_IQuery       =   0x92;
        public static final int DBPROP_IReadData        =   0x93;
        public static final int DBPROP_IRowsetAsynch        =   0x94;
        public static final int DBPROP_IRowsetCopyRows      =   0x95;
        public static final int DBPROP_IRowsetKeys      =   0x97;
        public static final int DBPROP_IRowsetNewRowAfter       =   0x98;
        public static final int DBPROP_IRowsetNextRowset        =   0x99;
        public static final int DBPROP_IRowsetExactScroll       =   0x9a;
        public static final int DBPROP_IRowsetWatchAll      =   0x9b;
        public static final int DBPROP_IRowsetWatchNotify       =   0x9c;
        public static final int DBPROP_IRowsetWatchRegion       =   0x9d;
        public static final int DBPROP_IRowsetWithParameters        =   0x9;
    }
}