//STRIPPEDSOURCE//


package com.ms.wfc.data.ui;









import com.ms.dll.*;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.data.*;


class Selection {
    private List  m_ranges = new List();
    private List  m_removedRanges = new List();
    private int   m_type = SelectionRange.SELTYPE_CELL;
    ScrollableDataStore m_dataStore = null;

    /**
     * @internalonly
     *
     * Removes all selections.
     */
    public void clearSelection() {}

    /**
     * @internalonly
     *
     * Deselects the specified column
     */
    public void deselectColumn(int nColumn) {}

    /**
     * @internalonly
     *
     * Deselects the specified range
     */
    
    
    

    /**
     * @internalonly
     *
     * Deselects the specified row
     */
    public void deselectRow(DataRow row) {}

    
    private void forceRangeType(int nType) {}

    /**
     * @internalonly
     *
     * Returns an array of currently selected columns.
     */
    public int[] getColumns() {}

    /**
     * @internalonly
     *
     * Returns an array of currently selected ranges.
     */
    
    
    

    /**
     * @internalonly
     *
     * Returns an array of selected rows. This uses DataRows to try and keep
     * the bookmarks that are stored there.
     */
    public DataRow[] getRows() {}

    /**
     * @internalonly
     *
     * Returns true if the specified cell is selected by any of the ranges.
     */
    public boolean getCellSelected(int column, DataRow row) {}

    /**
     * @internalonly
     *
     * Returns true if the specified column is selected.
     */
    public boolean getColumnSelected(int column) {}

    /**
     * @internalonly
     *
     * Returns true if the sepecified row is selected.
     */
    public boolean getRowSelected(DataRow row) {}

    /**
     * @internalonly
     *
     * Selects the specified column.
     */
    public void selectColumn(int nColumn) {}

    /**
     * @internalonly
     *
     * Selects the specified range.
     */
    
    
    

    /**
     * @internalonly
     *
     * Selects the specified row.
     */
    public void selectRow(DataRow row) {}


    
    private void updateSelectionRange(DataGrid grid, SelectionRange range) {}

    /**
     * @internalonly
     *
     * Forces a repaint of all the dirty selection ranges. Also consolidates
     * any split ranges in the "ideal" ranges.
     */
    public void updateSelections(DataGrid grid) {}
}


class SelectionRange {
    public static final int SELTYPE_ROW         = 1;
    public static final int SELTYPE_COLUMN      = 2;
    public static final int SELTYPE_CELL        = 3;
    public ScrollableDataStore m_dataStore = null;

    /**
     * @internalonly
     *
     * This represents the merged range that this range is part of. The reason
     * this exists is that for optimal painting we want to break a new selection
     * up into it's component ranges, and sort them by "newly selected", "newly
     * deselected", and "still selected". The idealRange is the full range that
     * should be selected. This way, after a paint we can reform that "ideal"
     * range for optimal use later.
     */
    public SelectionRange   m_idealRange = null;
    /**
     * @internalonly
     *
     * Top row of the range
     */
    public DataRow          m_topRow = null;
    /**
     * @internalonly
     *
     * Left column of the range
     */
    public int              m_leftColumn = -1;
    /**
     * @internalonly
     *
     * Bottom row of the range
     */
    public DataRow          m_bottomRow = null;
    /**
     * @internalonly
     *
     * Right column of the range
     */
    public int              m_rightColumn = -1;
    /**
     * @internalonly
     *
     * Type of range... cell, row, or column
     */
    public int              m_type = SELTYPE_CELL;
    /**
     * @internalonly
     *
     * The dirty bit is set if this range hasn't been repainted yet.
     */
    public boolean          m_dirty = true;
    /**
     * @internalonly
     *
     * Array of DataRows that are contained in this range. Only used for
     * m_type == SELTYPE_ROW ranges. This allows us to do operations like
     * delete based on the bookmark contained in the DataRow instead of the
     * absolute position that is stored in m_topRow.
     */
    public DataRow[]       m_rows = null;


    
    
    
    
    

    public SelectionRange(int displayIndexOfColumn) {}

    public SelectionRange(DataRow row) {}

    

    /**
     * @internalonly
     *
     * Returns true if column, row is contained in this selection
     */
    public boolean contains(int columnDisplayIndex, DataRow row) {}

    

    /**
     * @internalonly
     *
     * <b>Problem<b><br>
     * Given a rectange (range) I want to exclude an overlapping
     * rectangular region. The remaining area needs to be returned
     * in an array of rectangles, so that I can invalidate that region
     * using invalidate()/update().<p>
     *
     * <b>Solution<b><br>
     * This function solves that problem. The basic idea is to divide the
     * rects into the 25 composite rects that are created when you merge the
     * two together. (There are 25 rects because the single "pixel" lines are
     * considered rects).<p>
     *
     * Once you get these rects, simply include all the rects that are in
     * "this" rect, and not in the "exclude" rect.<p>
     *
     * Now that you have the correct area, we merge all the small rectangles
     * together to get the minimum number of rects.<p>
     *
     */
    

    /**
     * Returns true if the specified cell is in this range.
     *
     * @param column DisplayIndex of the column to check.
     * @param row AbsolutePosition of the row to check.
     *
     * @return True if the cell is in this range.
     */
    public boolean getCellInRange(int column, DataRow row) {}

    /**
     * Returns true if there is any intersected area between the two
     * ranges.
     *
     * @param range SelectionRange to compare to.
     *
     * @return True if the ranges intersect.
     *
     * @see #intersectRange
     */
    public boolean intersectsWith(SelectionRange range) {}

    /**
     * Returns the SelectionRange that represents the intersected area
     * between this range, and the intersect range.
     *
     * @param intersect The range to intersect with this range.
     *
     * @return SelectionRange of the intersected region.
     *
     * @see #intersectsWith
     */
    

    /**
     * Returns a string representation of the current objec.t
     *
     * @return String
     */
    public String toString() {}
}