//STRIPPEDSOURCE//


package com.ms.wfc.data.ui;

import com.ms.wfc.core.*;


/**
 * Defines the constants that specify the behavior of the TAB key within a DataGrid control. 
 * @security(checkClassLinking=on)
 */
public class TabAction extends Enum {
    /**
     * Specifies that the TAB key will move focus between controls on the form. The TAB key
     * cannot be used to move the current cell focus within the grid. 
     */
    public static final int CONTROLNAVIGATION = 0;
    /**
     * Specifies that the TAB key will move focus to the cell in the next column, within the
     * same row.
     */
    public static final int COLUMNNAVIGATION = 1;
    /**
     * Specifies that the TAB key will move the focus to the cell in the next row, within the
     * same column.
     */
    public static final int ROWNAVIGATION = 2;
}