//STRIPPEDSOURCE//

package com.ms.wfc.html;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;

/**
 * Defines alignment constants. 
 * @security(checkClassLinking=on)
 */
public class DhAlignment extends Enum {

    /**
     * Specifies top alignment. */
    public static final int TOP         = 0;
    
    /**
     * Specifies text on the left, button on the right for DhRadioButton, DhCheckBox.  */
    public static final int LEFT        = 1;
    
    /**
     * Specifies bottom alignment. */    
    public static final int BOTTOM      = 2;
    
    /**
     * Text on the right, button on the left for DhRadioButton,
     * DhCheckBox.  */    
    public static final int RIGHT       = 3;
    
    /**
     * Specifies center alignment. */    
    public static final int CENTER      = 4;
    
    /**
     * Specifies vertical middle alignment. */    
    public static final int ABSMIDDLE   = 5;
    
    /**
     * Specifies vertical bottom alignment. */    
    public static final int ABSBOTTOM   = 6;
    
    /**
     * Specifies alignment at the baseline of the current line's text. */    
    public static final int BASELINE    = 7;
    
    /**
     * Specifies alignment with the top of the current line's text. */    
    public static final int TEXTTOP     = 8;
    
    /**
     * Specifies justified alignment. */    
    public static final int JUSTIFY     = 9;
    
    /**
     * Specifies a superscript attribute. */    
    public static final int SUPERSCRIPT = 10;
    
    /**
     * Specifies a subscript attribute. */    
    public static final int SUBSCRIPT   = 11;

    /**
     * Text on the left, button on the right for DhRadioButton, DhCheckBox:
     * <LABEL FOR=cbox2>Left Aligned Label<INPUT ID=cbox2 TYPE="CHECKBOX" VALUE=2 CHECKED></LABEL>
     */
    public static final int TEXT_LEFT   = LEFT;

    /**         
     * Text on the right, button on the left for DhRadioButton, DhCheckBox:
     * <LABEL FOR=cbox><INPUT ID=cbox TYPE="CHECKBOX" VALUE=1 CHECKED>Right Aligned Label</LABEL>
     */
    public static final int TEXT_RIGHT  = RIGHT;    

    
    static int mapToStrId( int n ){}

    
    static int mapFromStrId( int strId ){}

    public static boolean valid(int n) {}
}