//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.*;
import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhDivListener;

import com.ms.com.*;
import com.ms.wfc.util.List;
import com.ms.wfc.util.IEnumerator;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.Control;

/**
 * Represents the base class for all container elements.   This class should never
 * be instantiated, but should be derived from.
 *
 * @security(checkClassLinking=on)
 */
public abstract class DhBaseContainer extends DhElement { 
    DhElementArray m_elems;
    DhSemaphore wrt;
    Object mutex;
    int m_nreaders;
    
    protected DhBaseContainer() {}
    
    protected DhBaseContainer( String id ) {}
    
    protected DhBaseContainer( IHTMLElement peer, DhDocument document, String id ) {}

    /**
     * Ensures that the m_elems collection is fully populated from peers.
     * If the DhForm was created via findElement then we may have deferred
     * creating DhElement derived instances for all the section's contents (i.e.
     * we may have only the ones explicitly added if any).
     *
     * This method fully populates the m_elems array (but just one level down,
     * not recursively).
     * @internalonly
     */
    protected void ensureElemsComplete() {}
    
    
    void ensureElemsCompleteAux(IHTMLElement peerParent) {}

    /**
     * @internalonly
     */ 
    public void setHTMLGenerator( DhHTMLGenerator htmlGen ){}
    
    
    /**
     * @internalonly
     */
    protected void setServerSent(){}
    
    private void readerEnter() {}
    
    private void readerExit() {}
    
    private void writerEnter() {}
    
    private void writerExit() {}
    
    /**
     * @internalonly
     */
    protected void transitionTo(int state) {}
    
    /**
     * @internalonly
     */
    protected void makeChildrenPeer(IHTMLElement peer) {}
    
    
    
    
    
    
    
    /**
     * Called by the framework after a child element is added to this container. This method will be called when
     * the user calls <a href="com.ms.wfc.html.DhBaseContainer.html#add"> on this container, or binds to children of this container
     * that are already on the HTML page, using  <a href="com.ms.wfc.html.DhBaseContainer.html#findElement"> etc.
     * Be careful not to call functions that will add elements to this class (e.g. <i>addText()</i> or <i>newLine()</i>
     * or it will infinitely recurse.  You can, however, add elements to other containers from this function.
     *     
     * @param addedChild A reference to the child element.
     */
    protected void onChildAdded( DhElement addedChild ){}
    
    /**
     * Called after a child element is removed from this container. 
     * 
     * @param eChild A reference to the child element that has been removed.
     */
    protected void onChildRemoved( DhElement removedChild ){}                
    
    /**
     * Called when all the direct children of this container are available.   This occurs after you do a 
     * <a href="com.ms.wfc.html.DhDocument.html#findElement">DhDocument.findElement( id )</a> on a 
     * container element in an existing web page, and then perform an operation which requires the children
     * to be inspected.  The library attempts to delay this operation until the data is required,
     * for performance reasons.  Generally, you would expect this to be called when attaching an exisiting
     * element to a DhForm-derived class.
     */
    protected void onChildrenFound(){}
    
    /**
     * @internalonly
     */ 
    protected StringBuffer getContent( StringBuffer sb ) {}
    
    /**
     * Locates the child element with the specified peer, ID, index, or DhElement
     * object. 
     * @param peer A reference to the peer object
     * @return The element, or <b>null</b> if one is not located.
     * @exception DhElementNotFound exception if a suitable child element is not found.
     */
    public DhElement findElement( IUnknown peer ) {}
    

    /**
     * Locates the child element with the specified peer, ID, index, or DhElement
     * object. 
     * @param ID The ID value of the element to find.
     * @return A child element with the specified ID
     * @exception DhElementNotFoundException if no child element had id <i>ID</i>
     */
    public DhElement findElement( String ID ) {}
    
    final DhElement internalFindElement( String ID ){}
    
    /**
     * Locates the child element with the specified peer, ID, index, or DhElement
     * object. 
     * @param index The ordinal position of the child element to return.
     * @return A child element at position <i>index</i>
     * @exception DhElementNotFoundException If no immediate child element at index <i>index</i>
     */    
    public DhElement findElement( int index ) {}
    
    /**
     * Locates the child element with the specified peer, ID, index, or DhElement
     * object. 
     * 
     * @param e The child element to retieve index of.
     * @return The index of the specified child element.
     * @exception DhElementNotFoundException If <i>e</i> is not an immediate child element.
     */
    public int findElement( DhElement e ) {}
    
    /**
     * Retrieves the number of child elements in this container. 
     * @return The numer of child elements
     */
    public int getElementCount() {}
    
    /**
     * Retrieves the direct child elements of this container. 
     * @return An array of direct child elements.
     */      
    public DhElement[] getElements(){}
    
    /**
     * Recursively retrieves all child elements and their children. 
     * @return An array of all child elements
     */
    public DhElement[] getAllElements(){}
    
    protected DhElement[] getAllElements( DhElementVector v ){}    
    
    /**
     * Adds a Windows Foundation Classes for Java (WFC) control to the container. 
     * @param e The element to add
     */
    protected void add( DhElement e ){}
    
    
    /**
     * Adds a Windows Foundation Classes for Java (WFC) control to the container. 
     * @param e The element to add
     * @param insertFlag The insert position from DhInsertOptions
     */
    protected void add( DhElement e, int insertFlag ){}
    
    /**
     * Adds a Windows Foundation Classes for Java (WFC) control to the container. 
     * @param e The element to add
     * @param relativeTo The element to add relative to
     * @param insertFlag The insert position from DhInsertOptions
     */    
    protected void add( DhElement e, DhElement relativeTo, int insertFlag ){}


    /**
     * Adds a Windows Foundation Classes for Java (WFC) control to the container. 
     * 
     * @param  c  The WFC control to be added.
     */
    public void add( Control c ){}

    void addWashed(DhElement element, DhElement relativeTo, int insertFlag ) {}
    
    
    protected int getElementIndex( DhElement element ) {}
    
    protected void moveElement( DhElement element, int newZOrder ) {}

    /**
     * Removes an element from this container.   The element must be a direct
     * child of this container.
     *  
     * @param element The element to remove
     * @return the original ordinal position of the removed element.
     * @exception WFCInvalidArgumentException If the element is not a child of this container. 
     */
    public int remove( DhElement element ){}
    
    /**
     * Removes an element from this container. 
     * 
     * @param  c  Control to be removed.
     */
    public final void remove(Control c) {}

    int removeWashed(DhElement element) {}
    
    /**
     * Replaces a child element with another.  The element eCur must exist
     * in the container.
     * @param eCur The element to replace
     * @param eNew The new element to place in the array
     * @exception DhElementNotFoundException if <i>eCur</i> is not a direct child of this container.
     */
    protected void replace( DhElement eCur, DhElement eNew ){}
    
    private void destroyChildren() {}
    
    /**
     * Frees all resources associated with this element.  This method may not be
     * called at runtime. Any resources used by the element should be setup to
     * be released when the element is GC'ed. Inheriting classes should always
     * call <i>super.dispose</i>.
     */
    public void dispose() {}
    
    private void removeChildren() {}
    
    public void removeAll() {}
    
    public void setDocument( DhDocument document ) {}
    
    /**
     * Adds the components to the container.  Components can only be derived off 
     * com.ms.wfc.ui.Control or com.ms.wfc.ui.DhElement.
     * 
     * @param  comps  Array representing the components to be added to the control.
     */
    public final void setNewComponents(Component[] comps) {}

    /**
     * Adds the HTML elements to the container.  Components can only be derived off 
     * com.ms.wfc.ui.DhElement.
     * 
     * @param  elems  Array representing the HTML elements to be added to the container.
     */
    public final void setNewElements(DhElement[] elems) {}

    /**
     * Do we want to doc this?
     * @internalonly
     */
    protected  void setFound() {}

    /**
     * Represents the base class for all container elements. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhElement.ClassInfo {
    }
}