//STRIPPEDSOURCE//

package com.ms.wfc.html;
import com.ms.wfc.ui.Color;

/**
 * Provides structured information about an element's border styles. 
 *
 * @security(checkClassLinking=on)
 */
public class DhBorderInfo { 
    /**
     *    The default ctor
     */    
    public DhBorderInfo(){}

    /**
     *    Make a new object as a copy of an existing one
     */    
    public DhBorderInfo( DhBorderInfo biInit ) {}

    /**
     * Copies another DhBorderInfo object's internal data to this one. 
     *
     * @param biOther the DhBorderInfo class to clone.
     */
    public void copy( DhBorderInfo biOther ) {}
    
    /**
     * Retrieves an identical copy of this DhBorderInfo object. 
     * @return a new DhBorderInfo object.
     */ 
    public Object clone() {}

    /**
     * The top border color.
     */
    public  Color topColor;

    /**
     * The right border color.
     */
    public  Color rightColor;

    /**
     * The bottom border color.
     */
    public  Color bottomColor;

    /**
     * The left border color.
     */
    public  Color leftColor;      

    /**
     * The current top border style, as a constant from <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a>
     */
    public  int topStyle;

    /**
     * The current right border style, as a constant from <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a>
     */        
    public  int rightStyle;

    /**
     * The current bottom border style, as a constant from <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a>
     */        
    public  int bottomStyle;

    /**
     * The current left border style, as a constant from <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a>
     */        
    public  int leftStyle;       
    
    /**
     * Integer value of the width of the top border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and <a href="#topWidthUnit">topWidthUnit</a> does
     * not equal <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */
    public  int     topWidth;

    /**
     * Integer value of the width of the right border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and <a href="#rightWidthUnit">rightWidthUnit</a> does
     * not equal <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */        
    public  int     rightWidth;

    /**
     * Integer value of the width of the bottom border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and <a href="#bottomWidthUnit">bottomWidthUnit</a> does
     * not equal <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */        
    public  int     bottomWidth;

    /**
     * Integer value of the width of the left border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and <a href="#leftWidthUnit">leftWidthUnit</a> does
     * not equal <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */        
    public  int     leftWidth;

    /**
     * Unit label of the width of the top border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and value is not 
     * <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */
    public  int     topWidthUnit;

    /**
     * Unit label of the width of the right border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and value is not 
     * <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */        
    public  int     rightWidthUnit;

    /**
     * Unit label of the width of the bottom border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and value is not 
     * <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */        
    public  int     bottomWidthUnit;

    /**
     * Unit label of the width of the left border.  Only valid if 
     * width is in value/unit form (e.g. 20px), and value is not 
     * <a href="com.ms.wfc.html.DhUnits.html#NULL">NULL</a>.
     */        
    public  int     leftWidthUnit;
}