//STRIPPEDSOURCE//
package com.ms.wfc.html;
import com.ms.wfc.core.*;



/**
 * Defines constants for border styles. 
 * @security(checkClassLinking=on)
 */
public class DhBorderStyle extends Enum{
    
    
    /**
     * Specifies that no border is drawn (regardless of any border width). */
    public static final int NONE           = 0;
    
    /**
     * Specifies that the border is a solid line.
     */
    public static final int SOLID           = 1;
    
    /**
     * Specifies that a border is a double line drawn on top of the background of the element. 
     * The sum of the two single lines and the space between equals the border-width value. 
     * The border width must be at least 3 pixels wide to draw a double border.  
     */
    public static final int DOUBLE           = 2;
    
    /**
     * Specifies that a three-dimensional ridge is drawn in colors based on the value.
     */
    public static final int RIDGE           = 3;
    
    
    /**
     * Specifies that a three-dimensional groove is drawn in colors based on the value.
     */
    public static final int GROOVE           = 4;
    
    /**
     * Specifies that a three-dimensional inset is drawn in colors based on the value.
     */
    public static final int INSET           = 5;                                                       

    /**
     * Specifies that a three-dimensional outset is drawn in colors based on the value. */
    public static final int OUTSET           = 6;
    
    static int  mapFromStrId( int strid ){}
    
    static int mapToStrId( int borderStyle ){}
    
    
    public static boolean valid(int n) {}
}