//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;

/**
 * Implements an HTML line break (&lt;BR&gt;) element. <BR>) element
 *
 * @security(checkClassLinking=on)
 */
public class DhBreak extends DhElement { 
        /**
         * Inserts a standard line break (the default). */
        public static final int CLEAR_NONE  = DhStringIDs.STR_NONE;
        
        /**
         * Inserts vertical space so that the next text displayed is past all floating images. */                     
        public static final int CLEAR_ALL   = DhStringIDs.STR_ALL;
        
        /**
         * Inserts vertical space so that the next text displayed is past right-aligned floating
     * images. */                     
        public static final int CLEAR_RIGHT = DhStringIDs.STR_RIGHT;
        /**
         * Inserts vertical space so that the next text displayed is past left-aligned floating
     * images. */                     
        public static final int CLEAR_LEFT  = DhStringIDs.STR_LEFT;

        /**
         * The default constructor
         */
        public DhBreak() {}

        /**
         * One-step ctor specifying the clear type
         * @param The clear type flag, from DhBreak
         * @see #CLEAR_NONE
         * @see #CLEAR_LEFT
         * @see #CLEAR_RIGHT
         * @see #CLEAR_ALL
         */
        public DhBreak( int clearFlag ) {}

        /**
         * Retrieves the current clear flag. 
         * @return The current flag type
         * @see #CLEAR_NONE
         * @see #CLEAR_LEFT
         * @see #CLEAR_RIGHT
         * @see #CLEAR_ALL
         */
        public int getClearFlag() {}
        
        /**
         * Sets the current clear flag. 
         * @param The new flag type
         * @see #CLEAR_NONE
         * @see #CLEAR_LEFT
         * @see #CLEAR_RIGHT
         * @see #CLEAR_ALL
         */
        public void setClearFlag(int clearFlag) {}

        /**
         * @internalonly 
         */
        public int getTagNameID() {}

    /**
    * Implements an HTML line break (&lt;BR&gt;) element.
    * @hidden
    * @internalonly
    *
    * @security(checkClassLinking=on)
    */        
        public static class ClassInfo extends DhElement.ClassInfo {
                public static final PropertyInfo clearFlag =
                                                            new PropertyInfo(DhBreak.class, "clearFlag", Integer.TYPE,
                                                                             CategoryAttribute.Appearance,
                                                                             new DefaultValueAttribute(new Integer(2147483647)),
                                                                             new DescriptionAttribute(Sys.getString("DhBreakClearFlag")));

                public void getProperties(IProperties props) {}
        }
}