//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.*;
import com.ms.wfc.core.*;
import com.ms.wfc.html.event.*;

/**
 * Implements ordered and unordered bulleted and numbered lists in HTML.   It is a simple container class
 * into which items can be added, each getting its own bullet or number, as appropriate.
 *
 *
 * @security(checkClassLinking=on)
 */
public class DhBulletedList extends DhBaseContainer implements DhStringIDs { 
    int m_type;

    /**
     * Creates a default list of DhListType.BULLETED type.
     */ 
    public DhBulletedList(){}

    
    /**
     * Creates a list of specified type. See <a href="com.ms.wfc.html.DhListType.html">DhListType</a> for possible
     * values.
     *
     * @param listType type of list, from DhListType
     * @exception WFCInvalidArgumentException If type is not one of class constants.
     */ 
    public DhBulletedList( int listType ) {}

    /**
     *@internalonly
     */
    protected int getTagNameID() {}
    
    private final int getTagType( int listType ){}

    /**
     * @internalonly
     */        
    protected void init( DhParseInfo ph ) {}
    
    /**
     * @hidden
     * @internalonly
     */
    public void add( DhElement e ){}

    
    void addWashed(DhElement element, DhElement relativeTo, int insertFlag ) {} 
    
    /**
     * Inserts an element into the list at the specified index. 
     * @param newElement the new element to insert
     * @param index the zero-based index to place the element at
     *
     */
    public void insertItem( DhElement newElement, int index ) {}

    /**
     * Retrieves the element at the specified index. 
     * @param the index of the element to retrieve
     * @exception WFCInvalidArgumentException if <b>index</b> is not in the list
     */
    public DhElement getItem( int index ) {}
    
    public DhElement[] getItems(){}
    
    /**
     * Adds the specified element to the end of the list. 
     * @param e The item to add
     */
    public void addItem( DhElement e ){}
    
    /**
     * Sets or replaces the item at the specified index.   If the given index
     * is not present in the list, the item is added
     * @param index The index to set the item at.  If the index is less than 0 or greater than the list length, the item is added to the list
     * @param e The element to add.
     */
    public void setItem( int index, DhElement e ){}
    
    /**
     * Sets all the items in the list.   Any current items in the list will be replaced.
     * @param elements A DhElement array of the new items
     */
    public void setItems( DhElement[] elements ){}

    /**
     * Removes the specified element from the list. 
     *
     * @return the index of the element that was removed, or -1 if the element was not found
     */
    public int remove( DhElement e ) {}

    /**
     * Removes an element at the specified index from the list. 
     *
     * @return the index of the element that was removed
     */        
    public void removeItem( int index ) {}

    /**
     * Retrieves the current list type.   See <a href="com.ms.wfc.html.DhListType.html">DhListType</a> for possible
     * values.
     *
     * @return current list type
     */
    public int getListType() {}

    /**
     * Sets the current list type.   See <a href="com.ms.wfc.html.DhListType.html">DhListType</a> for possible
     * values.
     * @param newType type of list, from DhListType
     */
    public void setListType( int newType ) {}
    
    /**
     * @internalonly
     */
    protected DhEvents createEvents() {}
    
    /**
     * Retrieves the index of the selected element if it is a direct child of this list. 
     * @param e The element find the index of
     * @return The zero-based index of the element, or -1 if it is not in the list
     */
    public int getElementIndex( DhElement e ){}
    
    /**
     * @internalonly
     */
    public DhElement[] getElements(){}
    
    /**
     * Recursively retrieves all child elements and their children. 
     * @return An array of all child elements
     */
    public DhElement[] getAllElements(){}
    
    protected DhElement[] getAllElements( DhElementVector v ){}    

    /**
     * Returns the first-level child element at ordinal position <i>index</i>
     * @param index The ordinal position of the child element to return.
     * @return A child element at position <i>index</i>
     * @exception DhElementNotFoundException If no immediate child element at index <i>index</i>
     */    
    public DhElement findElement( int index ) {}
    
    /**
     * Retreive the ordinal index of child element <i>e</i>, if that element
     * exists as an immediate child.
     * 
     * @param e The child element to retieve index of.
     * @return The index of the specified child element.
     * @exception DhElementNotFoundException If <i>e</i> is not an immediate child element.
     */
    public int findElement( DhElement e ) {}
    
    /**
     * Implements ordered and unordered bulleted and numbered lists in HTML. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends DhForm.ClassInfo {
    }
}






class DhListItem extends DhBaseContainer implements DhStringIDs { 
    DhElement m_item;
    
    public DhListItem(){}

    public DhListItem( DhElement e ) {}

    protected int getTagNameID() {}

    public void setItemValue( String n ) {}

    public String getItemValue() {}

    
    
    public void add(DhElement element) {}

    /**
     * @hidden
     * @internalonly
     */
    protected void initFromPeer( IHTMLElement peer ){}    

    public DhElement getElement(){}
    
    public int remove( DhElement e ){}
    
    public void removeAll(){}
    
    public void setElement( DhElement e ){}
}