//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhButtonListener;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLControlElement;
import com.ms.com.Variant;

import com.ms.wfc.core.*;

/**
 * This is a base class in the package and cannot be instantiated. 
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */
public abstract class DhButtonBase extends DhElement { 
    
    protected DhButtonBase() {}
    
    void ensureButtonType(){}
    
    /**
     * @internalonly
     */
    protected StringBuffer generateHTML( StringBuffer sb ){}
    
    /**
     *@internalonly
     */
    protected int buttonType(){};       
    
    /**
     *@internalonly
     */
    protected int getTagNameID() {}

    /**
     * Sets the text label or caption from this button element
     * @param t The new text label or caption
     */
    public void setText( String text ){};
    
    /**
     * Retrieve the text label or caption from this button element
     * @return The text label or caption
     */
    public String getText( ) {}
    
    
    /**
     *@internalonly
     */
    public boolean shouldPersistDefaultText() {}

    
    /**
     * Sets the HTML 'Name' attribute for this item.  Name is usually used in HTTP forms 
     * as the identifier for this elements data item
     * @param n The new name string
     * @hidden
     * @internalonly
     */    
    public void setName( String n ) {}

    /**
     * Retreives the HTML 'Name' attribute for this item.  Name is usually used in HTTP forms 
     * as the identifier for this elements data item
     * @return The current name string
     * @hidden
     * @internalonly
     */       
    public String getName( ) {}

    /**
     * @internalonly
     */
    protected DhEvents createEvents() {}
    
    /** 
     * Sets the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Sets the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Sets the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void addOnResize( EventHandler h ) {}

    /** 
     * Removes the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void removeOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Removes the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void removeOnLostFocus    ( EventHandler h ) {}

    /**
     * Remove the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnResize( EventHandler h ) {}

    
    /**
     * Sets the input focus to this control
     */
    public void focus() {}
    
     /** 
     * Sets the button's disabled state
     * @param f <b>false</b> to disable, otherwise <b>true</b>(default).
     */
    public void setEnabled(boolean f) {}

    /**
     * Retrieves the disabled state of the button.
     *
     * @return <b>true</b> if button is enabled, otherwise <b>false</b>
     */
    public boolean getEnabled(){}


    /**
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhElement.ClassInfo {
        public static final PropertyInfo text =
                                               new PropertyInfo(DhButtonBase.class, "text", String.class,
                                                                CategoryAttribute.Appearance,
                                                                new DescriptionAttribute(Sys.getString("DhButtonBaseText")));
        public static final EventInfo gotFocus = new EventInfo(DhButtonBase.class,
                                                               "gotFocus", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(DhButtonBase.class,
                                                               "lostFocus", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(DhButtonBase.class,
                                                               "resize", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        
          public static final PropertyInfo enabled =
                                                      new PropertyInfo(DhButtonBase.class, "enabled", Boolean.TYPE,
                                                                       DefaultValueAttribute.TRUE,
                                                                       CategoryAttribute.Appearance,
                                                                       new DescriptionAttribute(Sys.getString("DhButtonBaseEnabled")));
            
          

        public void getProperties(IProperties props) {}
        
        public void getEvents(IEvents events) {}
    }
}