//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLTableRow;
import com.ms.wfc.html.om.IHTMLTableCell;
import com.ms.wfc.html.om.IHTMLElementCollection;
import com.ms.wfc.html.event.DhTextContainerListener;
import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhEventID;

import com.ms.com.Variant;

import com.ms.wfc.core.*;
import com.ms.wfc.html.om.*;

/**
 * Creates a table cell. ms.wfc.html.DhTable.html>table</a> cell. 
 * Make sure to see the <a href="commshtml_ovr.html#tables">overview</a> 
 * for working with tables. You can <a href="com.ms.wfc.html.DhForm.html#add(DhElement)">add</a>
 * any number of elements in any kind of layout to a cell.
 *
 * @security(checkClassLinking=on)
 */
public class DhCell extends DhForm { 

    private DhText m_text;
    private boolean m_defText = true;

    /**
     * Creates an DhStringIDs.EMPTY cell.
     */
    public DhCell(){}

    /**
     * Creates cell with the specified text contents
     * @param text The text contents of the cell
     */
    public DhCell( String text ){}


    /**
     * Retrieves the number of columns this cell spans. 
     *
     * @return Number of columns this cell spans.
     */
    public int getColSpan(){}

    
    /**
     * Sets the number of columns this cell spans. 
     *
     * @param span Number of column this cell should span.
     */
    public void setColSpan(int span){}

    /**
     *@internalonly
     */
    protected DhEvents createEvents(){}

    /**
     *@internalonly
     */
    protected void makePeer(IHTMLElement parentPeer,boolean fInsert,DhElement relativeTo,int insertFlag){}
    
    /**
     *  Retrieves the row number that this cell is in. 
     * @return The cell's row number, or <b>-1</b> if the cell is not within a table
     */
    public int getRowNumber(){}
    
    /**
     *  Retrieves the column number that this cell is in. 
     * @return The cell's column number, or <b>-1</b> if the cell is not within a table
     */
    public int getColumnNumber(){}

    /**
     * Determines how many rows this cell spans. 
     *
     * @param span Number of rows this cell should span.
     */
    public void setRowSpan(int span){}

    /**
     * Retrieves the number of rows this cell spans. 
     *
     * @return Number of rows this cell spans.
     */
    public int getRowSpan(){}

    /**
     *@internalonly
     */
    protected int getTagNameID(){}
    
    /**
     * Sets the text of the cell.  (Setting this value overwrites any previous call to 
     * <a>setText</a> or <a>setValue</a>.
     *
     * @param text String to display to user.
     */
    public void setText( String text ){}
    
    /**
     * Retrieves the text of the cell. 
     * @see setText
     * @return The text use sees.
     */
    public String getText(){}

    /**
     * Sets a numeric value for the cell.  Setting this value overwrites any previous
     * call to <a>setText</a> or <a>setValue</a>.
     * @param i The int value to display in the cell.
     */
    public void setValue( int i ){}

    /**
     * Retrieves the numeric value displayed in the cell. 
     * @see setValue
     * @see setText
     * @return The int value as displayed in the cell.
     */
    public int getValue(){}

    /**
     * Adds an element to the cell. 
     * @param e The element to add
     */        
    public void add(DhElement e) {}
    
    void addWashed( DhElement e, DhElement rel, int insertType){}
    
    /**
     *  Removes an element from this cell. 
     * @parmam e The element to remove from this cell.
     */
    public int remove( DhElement e ){}

    
    
    
    
    
    
    boolean removeStylePeerAttribute( String attrName, int flags ){}
    
    /**
     * @hidden
     * @internalonly
     */
    protected void initFromPeer( IHTMLElement peer ){}    
    
    /**
     * @hidden
     * @internalonly
     */
    public void mergeSettings( DhElement eSrc, boolean overWrite ) {}
    
    
    /**
     * @internalonly
     */
    protected  void regenerate() {}
    
    /**
     * @internalonly
     */
    public void removeAll(){}
    
    /**
     * Creates a table cell. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhForm.ClassInfo {
        public static final PropertyInfo rowSpan =
                                                  new PropertyInfo(DhCell.class, "rowSpan", Integer.TYPE,
                                                                   CategoryAttribute.Appearance,
                                                                   new DescriptionAttribute(Sys.getString("DhCellRowSpan")));
        public static final PropertyInfo colSpan =
                                                  new PropertyInfo(DhCell.class, "colSpan", Integer.TYPE,
                                                                   CategoryAttribute.Appearance,
                                                                   new DescriptionAttribute(Sys.getString("DhCellColSpan")));
        public static final PropertyInfo text =
                                               new PropertyInfo(DhCell.class, "text", String.class,
                                                                CategoryAttribute.Appearance,
                                                                new DescriptionAttribute(Sys.getString("DhCellText")));
        public static final PropertyInfo value =
                                                new PropertyInfo(DhCell.class, "value", Integer.TYPE,
                                                                 CategoryAttribute.Appearance,
                                                                 new DescriptionAttribute(Sys.getString("DhCellValue")));

        public static final EventInfo formReset = new EventInfo(DhForm.ClassInfo.formReset,
                                                                BrowsableAttribute.NO);
        public static final EventInfo formSubmit = new EventInfo(DhForm.ClassInfo.formSubmit,
                                                                BrowsableAttribute.NO);

        public void getProperties(IProperties props) {}
        
        public void getEvents(IEvents events) {}
    }
}