//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.*;
import com.ms.com.Variant;
import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhEventID;
import com.ms.wfc.html.event.DhOptionButtonListener;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.lang.Delegate;


/**
 * Implements an intrinsic HTML check box control with a text label. 
 *  
 *
 * @security(checkClassLinking=on)
 */
public class DhCheckBox extends DhBaseContainer { 
    private         DhInnerCheckBox         m_checkbox;
    private         DhText                  m_text;
    int                                     m_align = LeftRightAlignment.RIGHT;
    
    /**
     * Default ctor.  Creates DhCheckBox with no label, and no check box, if not initialized.
     */
    public DhCheckBox() {}

    /**
     * Creates a DhCheckBox with a right-aligned label.
     *
     * @param strText text label
     * @param fChecked initial checked state of the checkbox
     */
    public DhCheckBox( String strText, boolean fChecked ) {}
    
    /**
     *@internalonly
     */
    protected int getTagNameID() {}

    /** 
     * Sets the enabled state of the check box. 
     * @param f Boolean defining the enabled state--default it <b>true</b>
     */
    public void setEnabled(boolean f) {}

    /**
     * Retrieves the enabled state of the check box. 
     *
     * @param The current caption String.
     */
    public boolean getEnabled(){}

    /**
     * Sets the checked state of the check box. 
     * @param fChecked True for checked, false for cleared.
     */
    public void setChecked( boolean fChecked ) {}

    /**
     * Retrieves the checked state of the check box. 
     *
     * @return <b>true</b> if checked, <b>false</b> if not.
     */
    public boolean getChecked() {}

    /**
     * Sets the HTTP submit name for this check box.   The name is used during HTTP form submission as 
     * the HTML 'name' attribute.
     *
     * @param strName The name to use.  This name should be unique on the form.
     */
    public void setSubmitName( String strName ) {}

    /**
     * Retrieves the current NAME attribute for this check box. 
     *
     * @returns Name attribute.  This attribute is used for HTTP form submission, and is otherwise not required.
     * @see #setSubmitName
     */
    public String getSubmitName( ) {}


    /**
     * Sets the text label for the check box.   The checkbox may be checked or unchecked by clicking on this label.
     * 
     * @param strText the label to display for the checkbox. 
     */ 
    public void setText( String strText ) {}

    /**
     * Retrieves the current text label for the check box. 
     *
     * @return The text label.
     *
     */
    public String getText( ) {}
    
    /** 
     * Sets the HTTP submit value for this check box.  This represents the HTML 'value' attribute.
     *
     * @param strName The submit value. 
     */
    public void setSubmitValue( String strValue ) {}

    /**
     * Retrieves the submit value for this check box. 
     *  This represents the HTML 'value' attribute.
     *
     * @return The submit value.
     * @see #setSubmitValue
     */
    public String getSubmitValue( ) {}
    
    
    /**
     * Retrieves the current alignment.   Can be RIGHT or LEFT.
     *
     * @return The current alignment, from LeftRightAlignment.
     */
    public int getTextAlign() {}

    /**
     * Sets the current alignment. RIGHT or LeftRightAlignment.LEFT.
     * <p>Example:
     * <pre>
     *  RIGHT: <SPAN FOR=cbox><INPUT ID=cbox TYPE="CHECKBOX" VALUE=1 CHECKED>Right Aligned Label</SPAN>
     *  LEFT:  <SPAN FOR=cbox2>Left Aligned Label<INPUT ID=cbox2 TYPE="CHECKBOX" VALUE=2 CHECKED></SPAN>
     * </pre>
     *
     * @param newAlignment LeftRightAlignment.LEFT or LeftRightAlignment.RIGHT
     * @see com.ms.wfc.ui.LeftRightAlignment
     */
    public void setTextAlign( int newAlignment ) {}

    /**
     * Sets the input focus to this control. */
    public void focus() {}

    /**
     * Set a specific event handler for this element. Most the of the common event handlers
     * have a more direct way of setting the event handler. This method is exposed for
     * cases not covered by the direct set methods.
     *
     * @see #addOnClick
     * @see #addOnKeyPress
     *
     * @param id The instance of an <a href="com.ms.wfc.html.event.DhEventID.html">event id</a> of the specific 
     * event you want to sink. See <a href="com.ms.wfc.html.event.DhEvents.html">DhEvents</a>
     * for some of the possible IDs.
     * @param handler The <a href="com.ms.wfc.html.EventHandler.html">EventHandler</a> callback
     * method to invoke every time the specific event is triggered.
     */
    protected void addEventHandler( Object id, Delegate handler ) {}
    
    /**
     * Appends the event handlers of the element passed in as a parameter, to this
     * element's event handler list.
     * 
     * @param   e  DhElement containing the event handler list to be added to this element.
     */
    public void appendEventHandlers(DhElement e) {}
    
    /**
     * Removes a specific event handler, which will no longer be called when the specified
     * event occurs.  Most DhEvents have a specialized remove method which is a more direct
     * way of removing the event handler.  This method is exposed for
     * cases not covered by the direct remove methods.
     *
     * @see #removeOnClick
     * @see #removeOnKeyPress
     *
     * @param id The instance of an <a href="com.ms.wfc.html.event.DhEventID.html">event id</a> of the specific 
     * event you want to stop sinking. See <a href="com.ms.wfc.html.event.DhEvents.html">DhEvents</a>
     * for some of the possible IDs.
     * @param handler The <a href="com.ms.wfc.html.EventHandler.html">EventHandler</a> callback
     * method which should no longer be invoked when the specific event is triggered.
     */
    protected void removeEventHandler(Object id, Delegate handler) {}
    
    

    /**
     * @hidden
     * @internalonly
     */    
    public void add(DhElement element, DhElement relativeTo, int insertFlag ) {}

    /**
     * @hidden
     * @internalonly
     */    
    public void add(DhElement element, DhElement relativeTo ) {}

    /**
     * @hidden
     * @internalonly
     */    
    public  void add(DhElement element ) {}

        
    void addWashed( DhElement e, DhElement relTo, int insertFlag ) {}

    /**
     *  @internalonly
     */
    public void setElementPeer( IHTMLElement peer ){}
    
    
    private final IHTMLElement findLabelText( IHTMLElement inputPeer ){}
    
    

    private void ensureText() {}

    private void ensureCheck() {}
    
    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    private void handleClick(Object sender, com.ms.wfc.core.Event e) {}
    
    /**
     * @hidden
     * @internalonly
     */
    protected void init( DhParseInfo ph ) {}

    /** 
     * Assigns a delegate to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void addOnResize(EventHandler h) {}

    /**
     * Assigns a delegate to the select event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void addOnSelect( EventHandler h ) {}
    
    /** 
     * Removes the delegate that is assigned to the gotFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnGotFocus(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnLostFocus(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void removeOnResize(EventHandler h) {}
    /**
     * Removes the delegate that is assigned to the select event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void removeOnSelect(EventHandler h) {}

    /**
     * Add an event handler to be fired if the current checked state is changed
     * @param h An event handler to be fired when the when the checked state is changed           
     * */    
    final public void addOnCheckedChanged   ( EventHandler h ) {}
    
    /**
     * Remove an event handler to be fired if the current checked state is changed
     * @param h An event handler to be fired when the when the checked state is changed           
     * */    
    final public void removeOnCheckedChanged (EventHandler h)     {}
    

    /**
     * Implements an intrinsic HTML check box control with a text label. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo checked =
                                                  new PropertyInfo(DhCheckBox.class, "checked", Boolean.TYPE,
                                                                   CategoryAttribute.Appearance,
                                                                   DefaultValueAttribute.FALSE,
                                                                   new DescriptionAttribute(Sys.getString("DhCheckBoxChecked")));
        
        public static final PropertyInfo enabled =
                                                  new PropertyInfo(DhCheckBox.class, "enabled", Boolean.TYPE,
                                                                   CategoryAttribute.Appearance,
                                                                   DefaultValueAttribute.TRUE,
                                                                   new DescriptionAttribute(Sys.getString("DhCheckBoxEnabled")));
        
        
        public static final PropertyInfo submitName =
                                                     new PropertyInfo(DhCheckBox.class, "submitName", String.class,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.EMPTY_STRING,
                                                                      new DescriptionAttribute(Sys.getString("DhCheckBoxSubmitName")));
        public static final PropertyInfo text =
                                               new PropertyInfo(DhCheckBox.class, "text", String.class,
                                                                CategoryAttribute.Appearance,
                                                                new DefaultValueAttribute(new String("CheckBox")),
                                                                new DescriptionAttribute(Sys.getString("DhCheckBoxText")));
        public static final PropertyInfo submitValue =
                                                      new PropertyInfo(DhCheckBox.class, "submitValue", String.class,
                                                                       CategoryAttribute.Behavior,
                                                                       new DefaultValueAttribute(new String("on")),
                                                                       new DescriptionAttribute(Sys.getString("Value to use for HTTP form submission")));
        public static final PropertyInfo textAlign =
                                                        new PropertyInfo(DhCheckBox.class, "textAlign", Integer.TYPE,
                                                                         CategoryAttribute.Appearance,
                                                                         new DefaultValueAttribute(new Integer(3)),
                                                                         new DescriptionAttribute(Sys.getString("DhCheckBoxTextAlign")));
        public static final EventInfo change =
                                              new EventInfo(DhCheckBox.class, "checkedChanged", EventHandler.class,
                                                            CategoryAttribute.Action,
                                                            new DescriptionAttribute(Sys.getString("DhCheckBoxChange")));
        public static final EventInfo gotFocus = new EventInfo(
                                                               DhCheckBox.class,"gotFocus",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(
                                                                DhCheckBox.class,"lostFocus",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(
                                                                DhCheckBox.class,"resize",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo select =
                                              new EventInfo(DhCheckBox.class, "select", EventHandler.class,
                                                            CategoryAttribute.Action,
                                                            new DescriptionAttribute(Sys.getString("DhCheckBoxSelect")));

        public void getProperties(IProperties props) {}
        public void getEvents(IEvents events) {}
    }
}



class DhInnerCheckBox extends DhButtonBase { 

    private DhCheckBox container;
    
    public DhInnerCheckBox(){}
    
    public DhInnerCheckBox(DhCheckBox container) {}

    public DhInnerCheckBox( DhCheckBox container, boolean fChecked ) {}
    
    public void setParent( DhElement parent ){}

    protected int buttonType(){};

    public void setChecked( boolean fChecked ) {}
    
    public boolean getChecked() {}

    public void setSubmitName( String n ) {}

    public String getSubmitName( ) {}

    
    public void setSubmitValue( String s ) {}

    public String getSubmitValue( ) {}

    protected DhEvents createEvents() {}
    
    /**
     * @hidden
     * @internalonly
     */
    public DhElement getEventSender() {}
}