//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;
import com.ms.wfc.util.*;

/**
 * Defines constants for controlling an element's cursor style.    
 * See <a href="com.ms.wfc.html.DhStyleBase.html#setCursor">DhStyleBase.setCursor()</a>
 *
 * @security(checkClassLinking=on)
 */
public class DhCursor extends Enum {
    /**
     * Specifies that the browser determines the cursor to display based on the current
     * context. 
     */
    public static final int AUTO      =0;

    /**
     * Specifies a simple cross-hair cursor. 
     */
    public static final int CROSSHAIR = 1;

    /**
     * Specifies a platform-dependent default cursor (usually an arrow). 
     */
    public static final int DEFAULT   =2;

    /**
     * Specifies a hand pointer cursor. 
     */
    public static final int HAND      = 3;

    /**
     * Specifies an arrow cursor with a question mark indicating Help. 
     */
    public static final int HELP      = 4; 
    
    /**
     * Specifies a cursor with crossed arrows indicating something is to be moved. 
     */
    public static final int MOVE      = 5;  
    
    /**
     * Specifies an editable text cursor (usually an I-bar). 
     */
    public static final int TEXT      = 6;

    /**
     * Specifies an hourglass or watch indicating that the program is busy and the user should
     * wait. 
     */
    public static final int WAIT      = 7;

    /**
     * Specifies an arrow cursor indicating that an edge is to be moved in an eastern
     * direction. 
     */    
    public static final int E_RESIZE  = 8;
    public static final int N_RESIZE  = 9;
    public static final int NE_RESIZE = 10;
    public static final int NW_RESIZE = 11;
    public static final int S_RESIZE  = 12;
    public static final int SE_RESIZE = 13;
    public static final int SW_RESIZE = 14;
    public static final int W_RESIZE  = 15;

    
    static int mapToStrId( int n ){}

    
    static int mapFromStrId( int strId ){}

    public static boolean valid(int n) {}
}