//STRIPPEDSOURCE//

package com.ms.wfc.html;

import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.util.*;
import com.ms.wfc.ui.*;

import java.util.StringTokenizer;
import java.util.Date;
import java.lang.reflect.*;

import com.ms.wfc.html.om.*;
import com.ms.wfc.ax.*;
import com.ms.wfc.core.Event;
import com.ms.wfc.html.DhCantAddElementException;
import com.ms.wfc.html.DhElementNotFoundException;
import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhDocumentListener;
import com.ms.wfc.core.EventHandler;
import com.ms.wfc.app.*;

import com.ms.wfc.ui.Point;

import com.ms.com.*;
import com.ms.lang.*;

/**
 * Represents a Hypertext Markup Language (HTML) document.  You can use it to bind
 * to a "pre-authored" HTML page and traverse the elements on that
 * page. Alternatively, you can create whole new elements and add them to the 
 * page through this class. <p>
 * This class can not be created directly; instead, you acquire a 
 * reference to it via a <a href="com.ms.wfc.html.DhModule.html>DhModule</a>,
 * <p>Also see <a href="com.ms.wfc.html.DhStyle.html">DhStyle</a>, 
 * <a href="com.ms.wfc.html.DhText.html">DhText</a>,
 * <a href="com.ms.wfc.html.DhElement.html">DhElement</a> 
 * <a href="com.ms.wfc.html.DhForm.html>DhForm</a>  
 *
 * @security(checkClassLinking=on)
 */
public class DhDocument extends DhBaseContainer implements ITopLevelWindow { 
    
    
    
    
    
    
    
    

    DhStyleManager  m_styleMgr;
    private boolean fSetGenerateTags = false;
    private String  m_title = null;   
    private char[] m_generatedIDPrefix = null;
    
    
    
    DhElement m_rgelement[] = new DhElement[32];
    int m_idNext = 0;    
    HashTable m_idTable;

    public DhDocument( DhModule module, IHTMLDocument2 document, IHTMLWindow2 window ) {}

    /**
     * Create a blank document with no object model binding
     */
    public DhDocument(){}

    
    void bindExistingPeer(IHTMLElement peer, String tagID, DhElement element) {}
    
    private String unpackHashCode(int hashCode) {}
    
    void setDocumentPeer(IHTMLDocument2 docPeer) {}

    /**
     * Frees all resources associated with this element.  This method may not be
     * called at runtime. Any resources used by the document should be setup to
     * be released when the document is GC'ed. Inheriting classes should always
     * call <i>super.dispose</i>.
     */
    public void dispose() {}
    
    
    
    
    
    
    

    /**
     * Sets the title of the document.  
     * In the case of a browser, the title will show up
     * in the caption of the browser window.
     *
     * @param newTitle text that will go into the caption of the host
     */
    public void setTitle( String newTitle ) {}


    /**
     * Retrieves the title of the document. 
     * In the case of a browser, the title will show up
     * in the caption of the browser window.
     *
     * @return Title of document in String.
     */
    public String getTitle() {}

    
    
    
    
    

    /**
     * @internalonly
     */
    protected DhEvents createEvents() {}
    
    /**
     * Assigns a delegate to the readyStateChange event.
     * @param h The handler to be called when the ready state changes
     */
    final public void addOnReadyStateChange    (ReadyStateEventHandler h) {}
    
    /**
     * Removes the delegate that is assigned to the readyStateChange event. 
     * @param The handler to remove.
     */
    final public void removeOnReadyStateChange    (ReadyStateEventHandler h) {}
    
    /**
     *  @internalonly
     */
    public String getReadyState(){}


    /**
    * This method simply provides a way of calling initForm() from other classes within
    * the package (effectively treating the DhModule siting code as a "friend").
    */
    /**
     * Event handler for the Load event.
     */
    protected void onDocumentLoad(Object sender, Event event) {}
    
    /**
     * Implements an event handler for the unload event.
     */
    protected void onDocumentUnload(Object sender, Event event) {}    
    
    
    void internalOnDocumentUnload( Object s, Event e ){}
    
    /**
     * Implements an event handler for the beforeUnload event.
     */
    protected void onDocumentBeforeUnload(Object sender, Event event) {}    
    
    
    
    
    
    

    
    protected void regenerate() {}

    /**
     * @internalonly
     */
    protected char[] getGeneratedIDPrefix() {}
    
    /**
     * Retrieves the representative HTML of this document (also known as the page). k.a page). 
     *
     * @return The generated or bound HTML text in the form of a String.
     */
    public String getHTML() {}

    
    
    
    
    
    

    private DhWindow    m_window;

    /** 
     * Retrieves the Window object of this document. 
     *
     * @return Window of the document.
     */
    final public DhWindow getWindow() {}

    /** 
     * Retrieves the window peer of this document. 
     *
     * @return WindowPeer of the document.
     */
    final protected IHTMLWindow2 getWindowPeer() {}


    
    
    
    
    
    
    
    
    /**
     * @internalonly
     */
    protected int valueOfGeneratedID( char[] szID ) {}      

    /**
     * @internalonly
     */
    protected int valueOfGeneratedID(String strID) {}
    
    /**
     * @internalonly
     */
    static protected boolean isGeneratedID(String str) {}
    
    /**
     * @internalonly
     */
    static protected boolean isGeneratedID(char[] str) {}
    
    /** 
     * Displays a modal user message box. 
     *
     * @param s Message to display.
     */
    final public void messageBox( String s ) {}

    
    
    
    
    
    

    private DhModule                    module;

    /**
     * Retrieves the DhModule associated with this
     * document. ms.wfc.html.DhModule.html>DhModule</a> associated with this
     * document. DhDocument can not be created directly; instead, you acquire a 
     * reference to it via a <a href="com.ms.wfc.html.DhModule.html>DhModule</a>,
     * <a href="com.ms.wfc.html.DhApplet.html>DhApplet</a> or
     * <a href="com.ms.wfc.html.DhBean.html>DhBean</a>.
     *
     * @return The DhModule this document came from.
     */
    public DhModule getModule() {}

    
    public int getHandle() {}
    
    
    
    
    
    
    
    
    
    
    
    
    

    private IHTMLDocument2              m_documentPeer;
    private IHTMLBodyElement    m_body;

    /**
     * Retrieves the underlying HTML peer element for this class.  This method may return <b>null</b>
     * if the document is not bound to this class. Java code that is running in a 
     * trusted environment can freely cast the resulting reference to a specific element peer type 
     * (e.g. com.ms.wfc.html.om.IHTMLDocument2). This method will always return <b>null</b> if the
     * code is running in a Web server environment.<p>
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em>
     *
     * @return The element peer underlying the HTML peer for this class.
     */
    public IUnknown getPeer() {}

    protected IHTMLDocument2 getDocumentPeer() {}

    
    
    
    
    
    

    
    void setWindow(DhWindow window) {}

    
    
    
    
    

    /**
     * Adds an element into this container. 
     *
     * @param element The DhElement to add to the end of the flow of this container.
     */
    public void add(DhElement element) {}

    /**
     * Adds an element into this container. ms.wfc.html.DhInsertOptions.html>insertFlag</a> parameter.
     * The valid values for <i>insertFlag</i> are:
     * <UL>
     * <LI><b>INSERT_END</b> 
     * <LI><b>INSERT_BEGINNING</b>
     * </UL>
     *
     *  @param element The DhElement to add to this container
     *  @param insertFlag One of the valid and applicable <a href="com.ms.wfc.html.DhInsertOptions.html>insert constants</a>.
     */
    public void add(DhElement element, int insertFlag ) {}

    /**
     * Adds an element into this container. <p>
     * See 
     * <a href="com.ms.wfc.html.DhForm.html#add">DhForm.add</a> 
     * for details of this method and other flavors available.
     * 
     * @param element The element to be added.
     * @param relativeTo An element to which the insertFlags relate (can be <b>null</b> depending on insertFlags).
     * @param insertFlags One of the  <a href="com.ms.wfc.html.DhInsertOptions.html">DhInsertOptions* flags</a>
     */
    public void add( DhElement element, DhElement relativeTo, int insertFlag ) {}
    
    /**
     * Determines if the document is on the server or client.
     * @return <b>true</b> if the DhDocument is sited on a web server, <b>false</b>
     *             if it is sited on a client or other container.
     */
    public boolean getServerMode(){}
    
    /**
     * Moves an element to a new numeric order in the layout flow. 
     *
     * @param element The DhElement to move.
     * @param newOrder The new numeric order in the flow of this container.
     */
    public void moveElement( DhElement element, int newOrder ) {}

    /**
     * Appends a new line to the current document.  All elements added after this call will be on a 
     * new line.
     */
    public void newLine() {}

    /**
     * Appends a text string to the current document. 
     * @param text The text string.
     */
    public void addText( String text ) {}    
    
    /**
     * This method is called after a bound element on the server has been processed
     * but just before it is written out to the client.  You can inspect, manipulate, or 
     * replace <i>boundElement</i>, before returning it to be written.  If <b>null</b> is returned,
     * nothing will be written to the client.  The default implementation simply
     * returns <i>boundElement</i>.
     * 
     * @param boundElement The element that was specified for binding, after it has been bound to an element found in the HTML stream.
     * @return The element you wish to write to the stream, or <b>null</b> to write nothing for this element.
     */
    public DhElement onElementServerBound( DhElement boundElement ){}
    
              
    void setHTMLDocument( String fileName ){}
    
    private boolean htmlSent = false;
    
          
    void setHTMLDocument( IDataStream inputStream ){}
    
    void writeEndBodyTag( Object s, Event e ){}
    
    String leftOver;
    HashTable m_bindTable = null;

    /**
     * Binds the elements of the specified array to their peers.
     * 
     * @param  elems  Array of elements that need to be bound to their peers.
     * @exception  WFCException  If the ID does not match existing elements in the HTML content.
     * @exception  WFCException  If the element is already bound to another Java object (through findElement).
     * @exception  WFCException  If the class type of the peer and the given Java object do not match.
     */
    public void setBoundElements(DhElement[] elems) {}
    
    void internalBindElements() {}
    
    static Variant sm_opt;

    /**
     * Searches for an element in the document. 
     *
     * @param id The HTML ID attribute of the element to search for (e.g. in the case of <code>ID="Caption1"</code> then this argument would be: "Caption1").
     * @return The <A HREF="com.ms.wfc.html.DhElement.html">DhElement</A> representing the element
     *   in the document. This element can then be cast to the actual element type (e.g.
     * <a HREF="com.ms.wfc.html.DhText.html">DhText</a>).
     */
    public DhElement findElement( String id ) {}

    protected IHTMLElement findElementPeer( String id ) {}

    /**
     * Retrieves the corresponding derivation of DhElement given the
     * underlying HTML element peer.  This peer might have been acquired using 
     * <a href="com.ms.wfc.html.DhElement.html#getPeer">DhElement.getPeer</a>.<p>
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em> <b>null</b> may be returned if the element represented
     * by the peer is not implemented within the library.
     *
     * @param peer The underlying HTML element peer.
     * @return The specific derivation that corresponds to the peer parameter.
     */
    public DhElement getElement( IHTMLElement peer ) {}

    
    private final DhElement getElementHelper(IHTMLElement peer, HashTable bindElems) {}
    
    final static Variant vOne = new Variant( 1 );
    
    final boolean processMemberChildren( DhBaseContainer bcNewE, IHTMLElement peer ){}
    
    
    
    
    
    final private String fixupID( IHTMLElement peer, DhElement element ){}
    
    /**
     * Merges two elements and return the merged element
     * @hidden
     * @internalonly
     */
    static final public DhElement mergeElements( DhElement createdElement, DhElement htmlElement, boolean memberChildren ){}
    
    final DhBaseContainer findElementParent( IHTMLElement peer ){}
    
    final static DhElement findElementPos( DhElement[] childList, int pos ){}

    DhElement createElement( String tagType, String tagID, IHTMLElement peer ) {}
    
    private DhElement createElement(Class c, String tagID, IHTMLElement peer) {}
    
    /**
     * Creates an element from the name of an HTML tag if possible. This method is used
     * internally by the package.  It is used
     * internally by the package. If the tag name is not recognized by this package it
     * will return an instance of the <a href="com.ms.wfc.html.DhRawHTML.html>DhRawHTML</a>
     * class.
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em>
     *
     * @see #mapTagName
     * @param tagType The name of the package class to create (usually the result of <a>mapTagName</a>.
     * @return Returns the newly created derivation of DhElement that corresponds to the tagType.
     */
    public DhElement createElement( String tagType, String tagID ) {}

    /**
     * Deserializes HTML text generated by getHTML.
     * ms.wfc.html.DhElement.html#generateHTML">generateHTML</a>. 
     * The default case of calling this method will ignore the ID attributes of the HTML
     * and in fact override those with IDs that are unique to this document. See
     * <a href="recreateElements(String,boolean)">recreateElement(String,boolean)</a> to
     * control this behavior.
     *
     * @param html The text that was generated by calling generateHTML on a given DhElement.
     * @return The corresponding tree of derivations of DhElements that originally created the text in the <i>html</i> parameter.
     */
    public DhElement[] recreateElements( String html ) {}

    /**
     * Deserializes HTML text generated by getHTML.
     * ms.wfc.html.DhElement.html#generateHTML">generateHTML</a>. Passing
     * <b>true</b> to <i>fHonorIDs</i> tells this method not to destroy or overwrite
     * the ID attributes of the HTML tags in the <i>html</i> parameter. <em>Doing so
     * is a very advanced usage of this method because if there are conflicts of ID
     * attributes with elements already on the page then the resultant behavior is 
     * undefined in the rest of the package.</em>
     *
     * @see #recreateElements
     * @param html The text that was generated by calling generateHTML on a given DhElement.
     * @param fHonorIDs <b>true</b> tells the method not to destroy ID attributes.
     * @return The corresponding tree of derivations of DhElements that originally created the text in the <i>html</i> parameter.
     */
    public DhElement[] recreateElements( String html, boolean fHonorIDs ) {}

    static private String sm_codeClass;
    
    static protected String mapTagName( IHTMLElement peer ){}
    
    static protected String mapTagName( String tagName, IHTMLElement peer ) {}

    static String mapTagName( String tagName, IHTMLElement peer, DhParseInfo parseInfo ) {}

    /**
     * Returns an enumerator that represents
     * the collection of elements. ms.wfc.html.DhEnumeration.html>enumerator</a> that represents the
     * collection of elements of the following types:
     * <UL>
     * <LI><b>ELEMENTS</b> all elements (i.e. tags, including the HEAD and BODY)
     * <LI><b>IMAGES</b> only the images (i.e. IMG tags)
     * <LI><b>HLINKS</b> only the links (i.e. A tags)
     * </UL>
     * @param type One of the types enumerated by the <a href="com.ms.wfc.html.DhEnumeration.html>DhEnumeration</a> class
     * @return An <a href="com.ms.wfc.html.DhEnumeration.html>enumerator</a> that represents the
     * collection of elements of the types defined by the <i>type</i> parameter.
     */
    public DhEnumeration enumerate( int type ) {}

    
    
    
    
    

    protected String assignID(String idOld, DhElement e) {}

    protected void unassignID(String id) {}


    
    
    
    
    

    private void ensureStyleMgr(){}

    /**
     * Retrieves a DhStyle object with the named
     * style for this document. ms.wfc.html.DhStyle.html">style object</a> for this document with the named
     * <i>style</i>.<p>
     * <em>Note this method is not used in the normal course of programming this package.</em>
     * @param style The string name of the style you are looking for (e.g. ".myClass")
     * @return The style object that corresponds to the <i>style</i> parameter. <b>null</b> if
     * no such style exists on this document.
     */
    public DhStyle findStyle(String style) {}
    
    final DhStyle internalFindStyle( String style ){}

    /**
     * Retrieves all styles in this document. ms.wfc.html.DhStyle.html">styles</a> on this document. Style
     * objects can be applied to any element using the
     * <a href="com.ms.wfc.html.DhElement.html#setStyle">setStyle</a> method.
     * @return Array of <a href="com.ms.wfc.html.DhStyle.html">styles</a> objects found on this document.
     */
    public DhStyle[] getStyles() {}

    /**
     * Adds an element into this container. ms.wfc.html.DhStyle.html">style object</a> to this document.<p>
     * Note that this is done automatically for you whenever you call the
     * <a href="com.ms.wfc.html.DhElement.html#setStyle">setStyle</a> method on any element.  
     * @param newStyle The <a href="com.ms.wfc.html.DhStyle.html">style object</a> to add to this document.
     */
    public void add( DhStyle newStyle ) {}

    
    
    
    
    

    /**
     * Retrieves the URL source of the current document.   
     * This is only available for bound documents.
     * @return The current URL, or "" if it is unavailable.
     */
    public String getDocumentURL(){}

    /**
     * Retrieves the host name of the server the page is from. 
     * 
     * @return The current host server domain, or "" if it is unavailable.
     */
    public String getDomain(){}

    /**
     * Sets the host domain for the page.   Pages on different frames
     * can have their domains set to the same host to allow communicatoin
     * between frames.
     *
     * @param strDomain The domain to set.
     */
    public void setDomain( String strDomain ){}
    
    
    void setModule(DhModule module) {}
    
    private void setModuleInternal(DhModule module) {}
    
    /**
     * Retrieves the last modified date of the current document. <br>
     * The time is expressed as universal (UTC) time.
     * 
     * @return The document's last modified date, or "" if it is unavailable.
     */
    public String getLastModified() {}

    /**
     * Retrieves the long name of the protocol. 
     * 
     * <p>Examples:<br>
     *
     * <p><i>"Hypertext Transfer Protocol"</i>
     * <p><i>"File Protocol"</i>
     *
     * @return The name of the protocol.
     * @see #getDocumentUrl
     */
    public String getProtocol(){}

    /**
     * Retrieves the referring document.   That is, the document
     * that contained the hyperlink to the current document.  
     *
     * @return The URL of the referring document, or "" if it is unavailable.
     */
    public String getReferrer(){}


    
    
    

    /**
     * Provides a diagnostic snapshot dump of the Dynamic HTML (DHTML) code. 
     *
     * @see #dumpHTML()
     */
    public void dumpDHTML(Object sender, Event e) {}


    /**
     * Displays a diagnostic snapshot dump of the Dynamic HTML code as currently seen by the
     * document host.  This method will open a new browser window and display
     * the source to the generated DHTML currently in play. This is <i>not</i> meant to
     * be an end-user feature, but more of a power-developer diagnostic tool.
     */
    public void dumpHTML() {}


    
    private void dumpHTML( String path ) {}

    
    private String writeHTML() {}

    private String writeHTML(String path) {}
    
    /**
     * Writes a diagnostic snapshot dump of the DHTML code, as currently seen by the document
     * host, to a file.  This method wites
     * the source of the generated DHTML currently in play to a file called <i>path</i>. 
     * This is <i>not</i> meant to
     * be an end-user feature, but more of a power-developer diagnostic tool.
     * 
     * @param path The name of the file to dump the contents to.
     */
    public void writeHTML(IDataStream stream) {}

    private String getADumpPath( String path, String filenameDefault ) {}

    /**
     * Retrieves the viewable size of the document. 
     * @return A Point holding the document's size
     */
    public Point getSize(){}

    /**
     * Retrieves the current location of the document. 
     * @return A Point holding the document's location
     */
    public Point getLocation(){}

    /**
     * Determines whether HEAD and TITLE tags are generated by the getHTML method. 
     * @param fGenerate <b>true</b> to generate, otherwise <b>false</b>
     */
    public void setGenerateTags( boolean fGenerate ){}

    /**
     * @internalonly
     */
    protected int getTagNameID(){}
    
    /**
     * @internalonly
     */
    protected  boolean getBound() {}

    /**
     * @internalonly
     */
    protected  boolean getPeerAvailable() {}

    /**
     * @internalonly
     */
    protected  boolean getUnbound() {}

    
    /**
     * @internalonly
     */
    protected StringBuffer generateHTML( StringBuffer sb ){}
    
    
    
    /**
     *  Sets the current scroll mode.   Can be:     
     *  <ul>
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>AUTO</b></a> -- Browser determines scolling
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>YES</b></a>  -- Scolling is enabled
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>NO</b></a>   -- Scolling is disabled
     *  </ul>     
     * 
     * @param scrollMode The desired scrolling mode from DhScrollBars
     *@see   com.ms.wfc.html.DhScrollBars 
     */        
    public void setScroll( int scrollMode ){}
    
    
    /**
     *  Retrieves the current scroll mode.   Can be:
     *  <p>
     *  <ul>
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>AUTO</b></a> -- Browser determines scolling
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>YES</b></a>  -- Scolling is enabled
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>NO</b></a>   -- Scolling is disabled
     *  </ul>
     * 
     * Note: <b>AUTO</b> and <b>YES</b> are equivelent
     * 
     * @return  The current scrolling mode
     *@see   com.ms.wfc.html.DhScrollBars 
     */        
    public int getScroll(){}

    /**
     * Imports HTML into the document.          
     * @param html        String containing the html to be added to the document.
     * @param fNewSection Boolean defining whether the HTML should be added as a new section in the 
     *                    document or replace the existing document.
     */
    public DhForm importHTML(String html) {}

    /**
     * Imports HTML into the document. 
     * @param inputDataStream an com.ms.wfc.io.IDataStream to read the HTML from.
     */
    public DhForm importHTML( IDataStream inputDataStream ) {}

    /**
     * @internalonly
     */
    public void setHTMLGenerator( DhHTMLGenerator htmlGen ){}

    /**
     * Retrieves the child elements of this element. 
     * @return An array of direct child elements.
     */      
    public DhElement[] getElements(){}

    /**
     * Recursively retrieves all child elements and their children. 
     * @return An array of all child elements
     */
    public DhElement[] getAllElements(){} 
    
    static final String ccPrefix = "&wh-";
    static final String ccNormalPrefix = "com.ms.wfc.html";
    static final boolean convertCodeClasses = false;
    
    static final String convertCodeClass( String codeClass, boolean mangleCC ){}
    

    /**
     * Represents a Hypertext Markup Language (HTML) document. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final EventInfo readyStateChange = new EventInfo(
                                                                       DhDocument.class,"readyStateChange", ReadyStateEventHandler.class,
                                                                       CategoryAttribute.Behavior);
        public void getEvents(IEvents events) {}
    }
}








class DhStyleManager extends DhElement {
    HashTable styleList;

    public DhStyleManager(){}
    
    public int getTagNameID() {}

    protected StringBuffer generateHTML( StringBuffer sb ){}
    
    protected void add( DhStyle newStyle ){}

    
    protected StringBuffer getContent( StringBuffer sb ) {}

    protected void transitionTo(int targetState){}

    protected void refreshFromPeer(){}

    protected DhStyle findStyle( String styleName ){}

    protected DhStyle[] getStyles(){}

    protected void setStylesFromContent( String styles ){}
}


class DhStyleSheetIterator { 
    DhDocument doc;
    IHTMLStyleSheetsCollection coll;

    DhStyleSheetIterator( DhDocument doc ) {}

    DhStyleSheetIterator( IHTMLStyleSheetsCollection ssCollection ){}

    void run() {}

    boolean onRuleCount(int ruleCount, IHTMLStyleSheet sheet) {}

    boolean onStyleRule(IHTMLStyleSheetRule ssrule) {}
}




class DhStyleRuleFinder extends DhStyleSheetIterator { 
    String lookingFor;
    DhStyle     retStyle;

    DhStyleRuleFinder(DhDocument doc, String name) {}

    DhStyleRuleFinder(IHTMLStyleSheetsCollection coll, String name) {}


    boolean onStyleRule(IHTMLStyleSheetRule ssrule) {}

    DhStyle getStyle() {}
}



class DhDHTMLParser extends DhScanner implements DhStringIDs { 
    private DhParseInfo   m_currParseInfo;
    private DhElement     m_top;
    private boolean               m_honorIDs;

    private DhFormatApplier m_formatApplier;

    DhDHTMLParser(IDataStream in, boolean honorIDs) throws IOException {}

    DhDHTMLParser(String html, boolean honorIDs) {}
    
    public void reset(){}

    public void parse() {}

    public DhElement getTop() {}

    public void resetTop(){}
    

    void ensureApplier(){}

    private void ensureElement(DhParseInfo pi) {}


    public boolean onTag(DhParseInfo pi) {}

    public boolean onTagComplete( DhParseInfo pi ){}


    public boolean onTagEnd   (DhParseInfo pi) {}

    public boolean onAttribute(DhParseInfo pi, int dhkey, char[] strKeyName, int valkey, char[] value) {}

    public boolean onStyle    (DhParseInfo pi, int dhkey, int valkey, char[] value) {}

    public boolean onContent  (DhParseInfo pi, char[] value, int cb) {}
}









class DhFormatApplier extends List implements DhStringIDs {
    
    
    
    List garbagePile;

    DhFormatApplier(){}

    
    
    
    
    styleItem getNewItem(){}

    
    
    
    
    void applyStyles( DhElement element ){}

    
    
    
    
    boolean pushFormatTag( DhParseInfo pi ){}

    
    
    
    
    String convertHTMLSizeToCSS( String htmlSize ){}

    
    
    
    void popFormatTag( DhParseInfo pi ){}

    
    styleItem peekStyle(){}

    
    void pushStyle( int tagId, int styleKey, int valKey, long idNum, boolean isAttr ){}

    
    void pushStyle( int tagId, int styleKey, String strVal, long idNum, boolean isAttr ){}  

    
    void popStyle(){}

    
    
    class styleItem{
        int tagId;
        int key;
        int iValue;
        String strValue;
        long idNum;
        boolean isAttr;
    }
}