//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhEditListener;
import com.ms.wfc.html.event.DhTextListener;
import com.ms.wfc.html.om.IHTMLInputTextElement;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLControlElement;
import com.ms.com.Variant;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;

/**
 * Implements an HTML edit box control.   Edit boxes can be
 * multiline, single line, or single line password styles.  Password edit boxes behave
 * like single line edit boxes, except their contents are masked by '*' character and are not
 * displayed in the HTML representation at runtime 
 *
 * @security(checkClassLinking=on)
 */
public class DhEdit extends DhElement { 
    static private final int ES_SINGLELINE  = DhStringIDs.STR_TEXT;
    static private final int ES_MULTILINE   = DhStringIDs.STR_TEXTAREA;
    static private final int ES_PASSWORD    = DhStringIDs.STR_PASSWORD;

    int m_type = ES_SINGLELINE;
    boolean m_defType = true;
    String m_text = null;

    /**
     * Creates a blank, single line DhEdit edit box.
     * 
     */
    public DhEdit() {}

    /**
     * Creates a single line DhEdit edit box.
     *
     * @param strText Initial text contents of DhEdit
     * 
     */      
    public DhEdit( String strText ) {}

    /**
     * Creates a DhEdit edit box.
     *
     * @param strText Initial text contents of DhEdit
     * @param multiline  Boolean indicating whether the edit box has multiple lines
     */
    public DhEdit( String strText, boolean multiline ) {}

    /** 
     * Sets the enabled state of the edit box. 
     * @param f Boolean defining the enabled state--default it <b>true</b>
     */
    public void setEnabled(boolean f) {}

    /**
     * Retrieves the enabled state of the edit box. 
     *
     * @param The current caption String.
     */
    public boolean getEnabled(){}


    /**
     * @hidden
     * @internalonly
     */
    protected void initFromPeer( IHTMLElement peer ) {}
    
    /**
     * @hidden
     * @internalonly
     */
    public void mergeSettings( DhElement eSrc, boolean overWrite ) {}
 
    
    /**
     * @internalonly
     */
    protected void init( DhParseInfo ph ) {}

    
    void setType( int nType ) {}

    /**
     * Indicates whether the edit control allows editing on more than one line.   By default, only one line of editing is permitted
     * and ENTER characters are ignored.
     *
     * @return boolean indicating whether or not editing of more than
     *         one line is allowed.
     */
    public boolean getMultiline() {}

    /**
     * Indicates whether the edit control allows editing on more than one line.   By default, only one line of editing is permitted
     * and ENTER characters are ignored.
     *
     * @param value boolean value indicating if editing on more than one line
     *              should be permitted.
     */
    public void setMultiline(boolean multiline) {}

    /**
     * Indicates whether the edit control is being used for password input and must conceal
     * its value. 
     */
    public boolean getPassword() {}

    /**
     * Specifies whether the edit control is being used for password input and must conceal
     * its value.   Password controls must be single line, so if this
     * is set to <b>true</b>, then the Multiline property becomes false.
     *
     * @param value Whether the control is a password control.
     */
    public void setPassword(boolean value) {}

    
    int getType() {}

    /**
     * Sets the wrapping mode for a multiline edit box. 
     * @param wrap true for wrapping, false for no wrapping.
     */
    public void setWordWrap(boolean wrap) {}

    /**
     * Retrieves the current wrapping mode. 
     * @return true if wrapping is active, otherwise false
     */
    public boolean getWordWrap() {}

    /**
     * Sets the number of rows in a multiline edit box. 
     * @param        rows the number of rows
     * @exception WFCInvalidArgumentException if rows <= 0 
     * @exception WFCInvalidArgumentException if rows > 1 and style is not ES_MULTILINE
     */
    public void setRows(int rows) {}

    /**
     * Retrieves the current number of rows for a multiline edit box.   Always returns 1 if
     * style is not ES_MULTILINE.
     *
     * @return number of rows.
     */
    public int getRows() {}

    /** 
     * Sets the number of columns (characters) for the edit box width.   Must be greater than 0.
     * @param cols width of edit box in characters.
     */
    public void setCols(int cols) {}

    /**
     * Retrieves the width, in characters, of the edit box. 
     *
     * @return the width, in characters.
     */
    public int getCols() {}
    
    /**
     * @internalonly
     */        
    protected int getTagNameID() {}

    /**
     * Sets the name of the edit box.   Useful when submitting edit box content through an
     * HTML form.  It represents the HTML 'name' attribute.
     *
     * @param strName The name to assign the control.  This should be unique on the form.
     */
    public void setSubmitName( String strName ) {}

    /**
     * Retrieves the name of the edit box.   The
     * name represents the HTML 'name' attribute. 
     *
     * @see DhEdit#setSubmitName
     * @return Name of the edit box.
     */
    public String getSubmitName( ) {}
    
     
    /**
     * Indicates whether text has changed from its default value.
     *
     * @return boolean.
     */
    public boolean shouldPersistText() {}

    /** 
     * Sets the current text display of the edit box. 
     *
     * @param strText String to display
     */
    public void setText( String strText ){}
    
    /**
     * Clears the text from the edit box. 
     */
    public void clear(){}
    
    /**
     * Retrieves the current text for the edit.  For ES_PASSWORD style edit boxes, 
     * this is the actual string, not the mask.
     *
     * @return Currently displayed string in the edit.  
     */
    public String getText() {}
    
    /**
     * @internalonly
     */
    protected void onStateChange( int stateChange ) {}
    
     /**
     * @hidden
     * @internalonly
     */
    protected StringBuffer getContent(StringBuffer sb) {}
    
    /**
     * Sets the current maximum input length of the edit control in characters.   
     * This value is independent of the  current column width, and only applies to edit
     * boxes of ES_PASSWORD and ES_SINGLELINE types.  Strings set from code can exceed
     * this length; only user input is restricted.
     *
     * @param nMaxLength Maximum input length, in characters.
     */
    public void setMaxLength( int nMaxLength ) {}

    /**
     * Retrieves the current maximum input length for the edit.   If this value is unset, 
     * it may be up to Integer.MAX_VALUE.
     *
     * @return Maximum input length, in characters.
     */
    public int getMaxLength() {}


    /**
     * Retrieves the current read-only mode. 
     *
     * @return True if control is read-only. Otherwise false.
     */
    public boolean getReadOnly() {}

    /**
     * Sets the read-only mode for the edit control. 
     * @param fReadOnly True for read-only, false for read-write.
     */
    public void setReadOnly( boolean fReadOnly ) {}

    /**
     * Sets the input focus to this edit box.  */
    public void focus() {}

    /**
     * @internalonly
     */        
    protected DhEvents createEvents() {}
    
    /** 
     * Assigns a delegate to the gotFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void addOnResize( EventHandler h ) {}

    /**
     * Assigns a delegate to the scroll event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is scrolled.
     *
     * @param h The event handler callback method.
     */
    public final void addOnScroll( ScrollEventHandler h ) {}

    /**
     * Assigns a delegate to the select event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected.
     *
     * @param h The event handler callback method.
     */
    public final void addOnSelect( EventHandler h ) {}

    /**
     * Assigns a delegate to the change event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element's contents changed.
     *
     * @param h The event handler callback method.
     */
    public final void addOnChange( EventHandler h ) {}
    
    /**
     * For databinding support
     * @internalonly
     * @hidden
     */
    public final void addOnTextChanged( EventHandler h ){}
    
    /**
     * For databinding support
     * @internalonly
     * @hidden
     */
    public final void removeOnTextChanged( EventHandler h ){}

    /** 
     * Removes the delegate that is assigned to the focus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnGotFocus(EventHandler h) {}
    
    /**
     * Removes the delegate that is assigned to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnLostFocus(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnResize( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the scroll event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is scrolled.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnScroll( ScrollEventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the select event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnSelect( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the change event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element's contents changed.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnChange( EventHandler h ) {}

/**
 * Implements an HTML edit box control. 
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
    public static class ClassInfo extends DhElement.ClassInfo {
        public static final PropertyInfo multiline = new PropertyInfo(
                                                                      DhEdit.class, "multiline", Boolean.TYPE,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.FALSE,
                                                                      new DescriptionAttribute(Sys.getString("DhEditMultiLine")));
        public static final PropertyInfo password = new PropertyInfo(
                                                                     DhEdit.class, "password", Boolean.TYPE,
                                                                     CategoryAttribute.Behavior,
                                                                     DefaultValueAttribute.FALSE,
                                                                     new DescriptionAttribute(Sys.getString("DhEditPassword")));
        public static final PropertyInfo wordWrap = new PropertyInfo(
                                                                     DhEdit.class, "wordWrap", Boolean.TYPE,
                                                                     CategoryAttribute.Behavior,
                                                                     DefaultValueAttribute.FALSE,
                                                                     new DescriptionAttribute(Sys.getString("DhEditWordWrap")));
        public static final PropertyInfo rows = new PropertyInfo(
                                                                 DhEdit.class, "rows", Integer.TYPE,
                                                                 CategoryAttribute.Behavior,
                                                                 DefaultValueAttribute.ONE,
                                                                 new DescriptionAttribute(Sys.getString("DhEditRows")));
        public static final PropertyInfo cols = new PropertyInfo(
                                                                 DhEdit.class, "cols", Integer.TYPE,
                                                                 CategoryAttribute.Behavior,
                                                                 new DefaultValueAttribute(new Integer(20)),
                                                                 new DescriptionAttribute(Sys.getString("DhEditCols")));
        public static final PropertyInfo submitName =
                                                     new PropertyInfo(DhEdit.class, "submitName", String.class,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.EMPTY_STRING,
                                                                      new DescriptionAttribute(Sys.getString("DhEditSubmitName")));
        public static final PropertyInfo maxLength = new PropertyInfo(
                                                                      DhEdit.class, "maxLength", Integer.TYPE,
                                                                      CategoryAttribute.Behavior,
                                                                      new DefaultValueAttribute(new Integer(2147483647)),
                                                                      new DescriptionAttribute(Sys.getString("DhEditMaxLength")));
        public static final PropertyInfo readOnly = new PropertyInfo(
                                                                     DhEdit.class, "readOnly", Boolean.TYPE,
                                                                     CategoryAttribute.Behavior,
                                                                     DefaultValueAttribute.FALSE,
                                                                     new DescriptionAttribute(Sys.getString("DhEditReadOnly")));

        public static final EventInfo change = new EventInfo(
                                                             DhEdit.class,"change",EventHandler.class,
                                                             CategoryAttribute.Behavior);
        public static final EventInfo gotFocus = new EventInfo(
                                                               DhEdit.class,"gotFocus",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(
                                                                DhEdit.class,"lostFocus",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(
                                                                DhEdit.class,"resize",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo scroll = new EventInfo(
                                                                DhEdit.class,"scroll", ScrollEventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo select = new EventInfo(
                                                             DhEdit.class,"select",EventHandler.class,
                                                             CategoryAttribute.Behavior);

        public String getDefaultEventName() {}

        public void getProperties(IProperties props) {}
        public void getEvents(IEvents events) {}
    }
}