//STRIPPEDSOURCE//

package com.ms.wfc.html;

import com.ms.com.*;

import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLDocument2;
import com.ms.wfc.html.om.IHTMLStyle;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhEventID;

import com.ms.wfc.ax.IObjectIdentity;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.util.IEnumerator;
import com.ms.lang.Delegate;

/**
 * Represents the superclass for all user interface (UI) elements in this package.  An instance
 * of this class should be thought of as the Java representation of a given UI element in
 * an HTML document. <b>DhElement</b>s are never created directly. Instead, you <b>new</b>
 * a derivation of this class and then <b>add</b> the instance to the document (or 
 * a container destined for or already on the document); <i>or</i> you can call 
 * <a href="com.ms.wfc.html.DhDocument.html#findElement">DhDocument.findElement</a>
 * to find and bind to an already existing element, then cast the return to the proper
 * derivation. <p>Also see <a href="com.ms.wfc.html.DhStyle.html">DhStyle</a>, 
 * <a href="com.ms.wfc.html.DhText.html">DhText</a>,
 * <a href="com.ms.wfc.html.DhDocument.html">DhDocument</a>
 * <a href="com.ms.wfc.html.DhModule.html>DhApplet</a>
 * <a href="com.ms.wfc.html.DhForm.html>DhForm</a> 
 *
 * @security(checkClassLinking=on)
 */
public class DhElement extends DhStyleBase { 
    
    static boolean OK_TO_CACHE_ATTRIBUTES = false;
    
    private static boolean OK_TO_EMIT_CODECLASS   = true;

    
    
    private static int  m_nextFreeID = 0;

    
    
    
    
    

    protected DhElement() {}

    protected DhElement( IHTMLElement peer, DhDocument document, String id ) {}

    
    
    
    
    
    

    private     DhDocument                      m_document; 
    private DhElement                   m_parent;

    private static String assignStaticID() {}

    /**
     * Retrieves the document object associated with this element. 
     *
     * @return The <a href="com.ms.wfc.html.DhDocument.html">DhDocument</a> that this element has associated
     * with it.
     */
    public final  DhDocument getDocument() {}

    
     void setDocument( DhDocument document ) {}

    /**
     * Retrieves the module object associated with element. 
     *
     * @return The <a href="com.ms.wfc.html.DhModule.html">DhModule</a> that this element has associated
     * with it.
     */
    public DhModule getModule() {}
    
    /**
     * Retrieves the parent element that contains this element. 
     *
     * @see com.ms.wfc.html.DhDocument#add     
     * @see com.ms.wfc.html.DhForm#add
     *
     * @return The parent element that this element has associated
     * with it.
     */
    public final  DhBaseContainer getParent() {}
    
    final  DhBaseContainer getParent( boolean autoAdd ) {}

    protected  void setParent(DhElement parent) {}

    DhElement findElement( IUnknown peer ) {}

    DhElement findElement( String ID ) {}

    
    
    
    EventHandler m_onSetParent = null;

    /**
     * Assigns a delegate to the setParent event.  
     *
     * @param onSetParent The <a href="com.ms.wfc.html.EventHandler.html">EventHandler</a> callback
     * method to invoke when the parent is set on this element.
     */
    final protected void addOnSetParent(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the setParent event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final protected void removeOnSetParent(EventHandler h) {}

    final protected void fireSetParent() {}
    
    
    
    
    

    private DhEvents            m_events;
    
    /**
     * @internalonly
     */
    public final boolean hasEvents(){}

    /**
     * Retrieves the event object for this element. ms.wfc.html.event.DhEvents.html">event event</a> for this element. Despite 
     * the fact that this method is public in this class, most derivations
     * will hide it.
     *
     * @return The <a href="com.ms.wfc.html.event.DhEvents.html">event event</a> for this element.
     */
    public final DhEvents getEvents() {}

    /**
     * @internalonly
     * @hidden
     * 
     * Set a specific event handler for this element. Most the of the common event handlers
     * have a more direct way of setting the event handler. This method is exposed for
     * cases not covered by the direct set methods.
     *
     * @see #addOnClick
     * @see #addOnKeyPress
     *
     * @param id The instance of an <a href="com.ms.wfc.html.event.DhEventID.html">event id</a> of the specific 
     * event you want to sink. See <a href="com.ms.wfc.html.event.DhEvents.html">DhEvents</a>
     * for some of the possible IDs.
     * @param handler The <a href="com.ms.wfc.html.EventHandler.html">EventHandler</a> callback
     * method to invoke every time the specific event is triggered.
     */
    protected void addEventHandler(Object key, Delegate handler) {}

    /**
     * @internalonly
     * @hidden
     * 
     * Appends the event handlers of the element passed in as a parameter, to this
     * element's event handler list.
     * 
     * @param   e  DhElement containing the event handler list to be added to this element.
     */
    public void appendEventHandlers(DhElement e) {}

    /**
     * @hidden
     * @internalonly
     * 
     * Returns the delegate list for the given event key.
     * 
     * @return  Delegate list of event handlers.
     */
    public final Delegate getEventHandler(Object key) {}

    /**
     * @hidden
     * @internalonly
     */
    protected void removeEventHandler(Object key, Delegate handler) {}
    
    /**
     * @internalonly
     * 
     * This fires the event corresponding to the given key.
     * 
     * @param  key      Key representing the kind of event.
     * @param  e        Event object that encapsulates the event's paramters.
     */   
    protected void fireEvent(DhEventID key, Event e) {}

    
    void clearEvents(){}
    
    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    /**
     * @internalonly
     * @hidden
     */
    public DhElement getEventSender() {}
    
    /**
     * Assigns a delegate to the click event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnClick    ( EventHandler h ) {}
    /**
     * Assigns a delegate to the doubleClick event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnDoubleClick ( EventHandler h ) {}
    /**
     * Assigns a delegate to the dragStart event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnDragStart ( EventHandler h ) {}
    /**
     * Assigns a delegate to the selectStart event.  ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnSelectStart ( EventHandler h ) {}
    /**
     * Assigns a delegate to the filterChange event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnFilterChange ( EventHandler h ) {}    
    /**
     * Assigns a delegate to the help event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnHelp ( HelpEventHandler h ) {}
    /**
     * Assigns a delegate to the keyPress event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnKeyPress ( KeyPressEventHandler h ) {}
    /**
     * Assigns a delegate to the keyDown event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnKeyDown  ( KeyEventHandler h ) {}
    /**
     * Assigns a delegate to the keyUp event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnKeyUp    ( KeyEventHandler h ) {} 
    /**
     * Assigns a delegate to the mouseLeave event.   ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnMouseLeave ( MouseEventHandler h ) {}
    /**
     * Assigns a delegate to the mouseEnter event.   ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnMouseEnter( MouseEventHandler h ) {}
    /**
     * Assigns a delegate to the mouseMove event.   ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnMouseMove( MouseEventHandler h ) {}
    /**
     * Assigns a delegate to the mouseDown event.  ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnMouseDown( MouseEventHandler h ) {}
    /**
     * Assigns a delegate to the mouseUp event.  ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void addOnMouseUp  ( MouseEventHandler h ) {}

    /**
     *  Assigns a delegate to the beforeUpdate event. 
     *  Fires when an element loses focus or the page is attempting to unload when the 
     *  value of the element has changed from the value that was in the element at the 
     *  time it received the focus
     * 
     * @param h The EventHandler delegate to call on this event 
     */
    public final void addOnBeforeUpdate(EventHandler h) {}
    
    /**
     * Assigns a delegate to the afterUpdate event. 
     * @param h The EventHandler delegate to call on this event 
     */
    public final void addOnAfterUpdate(EventHandler h) {}

    /**
     * Assigns a delegate to the errorUpdate event.  
     * 
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnErrorUpdate(EventHandler h) {}

    /**
     * Assigns a delegate to the rowEnter event.  
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnRowEnter(EventHandler h) {}

    /**
     * Assigns a delegate to the rowExit event.  
     * 
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnRowExit(EventHandler h) {}

    /**
     * Assigns a delegate to the dataSetChanged event.
     * For example, when a filter operation takes place. 
     * Also fires when initial data is available from a data source object. 
     *
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnDataSetChanged(EventHandler h) {}

    /**
     * Assigns a delegate to the dataAvailable event. 
     * Frequency of firing is dependent upon the data source object. 
     * 
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnDataAvailable(EventHandler h) {}

    /**
     * Assigns a delegate to the dataSetComplete event. 
     *
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnDataSetComplete(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the click event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnClick    ( EventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the dragStart event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnDragStart ( EventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the selectStart event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnSelectStart ( EventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the filterChange event.ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnFilterChange ( EventHandler h ) {}    
    /**
     * Removes the delegate that is assigned to the doubleClick event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnDoubleClick ( EventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the help event.ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnHelp ( HelpEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the keyPress event.  ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnKeyPress ( KeyPressEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the keyDown event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnKeyDown  ( KeyEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the keyUp event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnKeyUp    ( KeyEventHandler h ) {} 
    /**
     * Removes the delegate that is assigned to the mouseLeave event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnMouseLeave ( MouseEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the mouseEnter event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnMouseEnter( MouseEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the mouseMove event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnMouseMove( MouseEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the mouseDown event.  ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnMouseDown( MouseEventHandler h ) {}
    /**
     * Removes the delegate that is assigned to the mouseUp event. ms.wfc.html.EventHandler.html">event handler</a> method callback.<p>
     * <em>Not all elements support all events exposed in DhElement</em>
     *
     * @param h The event handler callback method.
     */
    final public void removeOnMouseUp  ( MouseEventHandler h ) {}

    /**
     *  Removes the delegate that is assigned to the beforeUpdate event. 
     *  Fires when an element loses focus or the page is attempting to unload when the 
     *  value of the element has changed from the value that was in the element at the 
     *  time it received the focus
     * 
     * @param h The EventHandler delegate to call on this event 
     */       
    public final void removeOnBeforeUpdate(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the afterUpdate event. 
     * @param h The EventHandler delegate to call on this event 
     */        
    public final void removeOnAfterUpdate(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the errorUpdate event. 
     * 
     * @param h The EventHandler delegate to call on this event
     */        
    public final void removeOnErrorUpdate(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the rowEnter event.
     * @param h The EventHandler delegate to call on this event
     */
    public final void removeOnRowEnter(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the rowExit event.
     * 
     * @param h The EventHandler delegate to call on this event
     */        
    public final void removeOnRowExit(EventHandler h) {}

    
    /**
     * Removes the delegate that is assigned to the dataSetChanged event. 
     * Also fires when initial data is available from a data source object. 
     *
     * @param h The EventHandler delegate to call on this event
     */
    public final void removeOnDataSetChanged(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the dataAvailable event. 
     * Frequency of firing is dependent upon the data source object. 
     * 
     * @param h The EventHandler delegate to call on this event
     */        
    public final void removeOnDataAvailable(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the dataSetComplete event.
     *
     * @param h The EventHandler delegate to call on this event
     */        
    public final void removeOnDataSetComplete(EventHandler h) {}

    
    
    
    
    

    private boolean     m_closeTag   = true;

    protected  void setCloseTag(boolean close) {}

    protected  boolean getCloseTag() {}

    private DhHTMLGenerator m_generator = null;

    /**
     * Retrieves the current HTML generator for this element. 
     * @see #setHTMLGenerator
     */
    public DhHTMLGenerator getHTMLGenerator(){}

    /**
     * Sets the HTML generator to use for this element.   This allows you to override
     * the library's default method of generating HTML syntax to represent an element.
     * @see #getHTMLGenerator
     */
    public  void setHTMLGenerator( DhHTMLGenerator htmlGen ){}
    /**
     * Returns a String that contains the representative HTML text for this element
     * and all its child elements.
     *
     * @return The HTML string that represents this element and all its children.
     */
    public final String generateHTML() {}
    
    /**
     * Retrieves a string that contains the representative HTML text for this element and all
     * its child elements. 
     *
     * @return The HTML string that represents this element and all its children.
     */
    public String getHTML(){}
    
    /**
     * @internalonly
     */
    public String toString(){}

    static final String ID_PREFIX = " ID=";
    
    protected  StringBuffer generateHTML(StringBuffer sb) {}

    protected StringBuffer getContent( StringBuffer sb ) {}

    /**
     * Retrieves the string identifier that will be generated when the getHTML
     * method is called. ms.wfc.html.DhStringIDs.html">string id</a> that will be generated when the
     * <code>generateHTML</code> method is called.
     *
     * @returns (int) The <a href="com.ms.wfc.html.DhStringIDs.html">string id</a> for the tag name of this
     * element. (The base class returns -1, an invalid ID.)
     */
    protected int getTagNameID() {}

    /**
     * Retrieves the string that contains the tag name that corresponds to this element given
     * its current state (for example, "SPAN"). g. "SPAN"). <p>
     * <em>Note that this value can change during the life of the instance and in many cases
     * is dependent on specific attribute settings known only to the derivation of this class.</em>
     * <p>This method is not very useful except in special cases.
     */
    public  String getTagName() {}        
    
    protected  void regenerate() {}
    
    
    
    
    
    

    private     DhNameValuePairs        m_attributes;
    
    /**
     * @internalonly
     */
    public final boolean hasAttributes(){}

    DhNameValuePairs getAttributeArray(){}

    protected void init( DhParseInfo ph ) {}


    void setAttrDefault(int attr, boolean defval) {}
    
    
    void setAttribute( int attr ) {}

    
    void setAttribute( int attr, int value ) {}

    
    void setAttribute( int attr, char[] value ) {}

    
    void setAttribute( int attr, String value ) {}

    /**
     * Sets a string attribute, given the name of the attribute according to the Document
     * Object Model (DOM) of Dynamic HTML.  You should call specific attribute methods directly on the element you wish
     * to attribute (e.g. DhImage.setURL).
     * @param strAttr The name of the custom attribute to set
     * @param value A String value
     */
    public void setDOMAttribute(String strAttr, String value) {}

    /**
     * Sets an integer attribute, given the name of the attribute according to the Document
     * Object Model (DOM) of Dynamic HTML.  You should call specific attribute methods directly on the element you wish
     * to attribute (e.g. DhImage.setURL).
     * @param strAttr The name of the custom attribute to set
     * @param value An integer value
     */
    public void setDOMAttributeInt(String strAttr, int value){}

    
    
    void setProperty( int prop, String value ) {}

    
    void setAttributeInt( int attr, int value ) {}

    
    void setAttributeText( String strAttrName, String strValue, boolean fCaseSensitive ){}
    
    static String internalSetAttrText( IHTMLElement peer, String strAttr, String strValue, boolean fCase ){}
    
    void removeAttribute( int attr ) {}

    /**
     * Removes an attribute.  You should call specific attribute methods directly on the element you wish
     * to attribute (e.g. DhImage.setURL).
     * @param attr The name of the custom attribute to remove
     */
    public void removeAttribute(String strAttr) {}


    
    String getAttributeString( int attr ) {}

    
    int getAttributeInt( int attr ) {}

    
    int getAttribute( int attr ) {}

    
    /**
     * Retrieves an integer attribute, given the name of the attribute according to the
     * Document Object Model (DOM) of Dynamic HTML.  You should call specific attribute methods directly on the element you wish
     * to attribute (e.g. DhImage.setURL).
     * @param attr The string id of the attribute to get
     * @return The int value of the attribute
     */
    public int getDOMAttributeInt(String strAttr) {}

    
    /**
     * Retrieves a string attribute, given the name of the attribute according to the Document
     * Object Model (DOM) of Dynamic HTML.  You should call specific attribute methods directly on the element you wish
     * to attribute (e.g. DhImage.setURL).
     * @param attr The string id of the attribute to get
     * @return The int value of the attribute
     */
    public String getDOMAttributeString(String strAttr) {}

    final private int internalGetAttr(int attr, String strAttr, boolean isdhstr, StringBuffer sb) {}


    private void updateAttribute(int attr, String name, String value) {}

    private void updateAttribute(int attr, String name, int value) {}

    private void updateAttributeText( String name, String value ){}

    private boolean m_fDidCodeClass = false;

    private void ensureCodeClass() {}

    static private final char EQ = '=';
    static private final char SP = ' ';
    static private final char DQ = '\"';

    protected StringBuffer getAttributeText( StringBuffer sb ) {}

    private void ensureAttributes() {}

    private  void refreshAttributesFromPeer(){}

    private  void refreshAttributesFromPeer( IHTMLElement peer ){}

    protected void refreshPeerFromAttributes() {}

    
    
    
    
    

    private boolean needSizeFix() {}

    /**
     * Sets the size of the element. 
     *
     * @see #setWidthUnit
     * @see #setHeightUnit
     * @param width The new width of the element.
     * @param height The new height of the element.
     */
    public  void setSize(int w, int h) {}

    /**
     * Sets the width of the element using one of the DhUnits constants to express the
     * units of measurement. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see com.ms.wfc.html.DhStyleBase#getBounds
     * @param w The width value
     * @param unit One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    public  void setWidthUnit( int w, int unit ) {}

    /**
     * Sets the height of the element using one of the DhUnits constants to express the
     * units of measurement. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see com.ms.wfc.html.DhStyleBase#getBounds
     * @param h The height value
     * @param unit One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    public  void setHeightUnit( int h, int unit ) {}

    protected  void onMove() {}
    
    final void ensureParentPositioned( Object s, Event e ){}
    
    
    
    
    
    

    /**
     * Retrieves the string that represents the ToolTip that appears when the user's mouse
     * pointer is hovering over this element. 
     *
     * @see #setToolTip
     * @return Return the ToolTip in a String
     */
    public final String getToolTip() {}

    /**
     * Sets the ToolTip that appears when the user's mouse pointer is hovering over this
     * element. 
     *
     * @param string The string to use for the ToolTip.
     */
    public final void setToolTip(String string) {}


    /**
     * Resets the ToolTip to the default (usually blank).  */
    public final void resetToolTip(){}

    /**
     * @internalonly 
     */
    public final boolean shouldPersistToolTip(){}

    private     DhStyle m_style;

    /**
     * Retrieves the DhStyle style object
     * associated with this element. ms.wfc.html.DhStyle.html">style object</a> associated with this element.
     *
     * @see com.ms.wfc.html.DhStyle
     * @see #setStyle
     * @return The <a href="com.ms.wfc.html.DhStyle.html">style object</a> associated with this element.
     */
    public final DhStyle getStyle() {}

    /**
     * Sets the style object associated with this
     * element. ms.wfc.html.DhStyle.html">style object</a> associated with this element.
     *
     * @param style The style object associated with this element.
     */
    public final void setStyle(DhStyle style) {}

    /**         
     * @internalonly
     */
    public final boolean shouldPersistStyle(){}

    /**
     * Clears any class set with setStyle.  */
    public final void resetStyle(){}
    
     
    String getInheritedStyleString( int key, boolean takeFirst ){}
    
     
    int getInheritedStyleInt( int key ){}
    
    
    
    
    
    
    

    private String m_id;

    /**
     * Sets the ID attribute of the HTML element underlying this class. 
     * This ID is persisted with the 
     * <a href="#generateHTML>generateHTML</a> method. <p>
     * <em>Note</em> that calling this method is not normally part of the usage of this
     * package. The package with automatically generate an ID for all <code>DhElement</code>s
     * even if this method isn't directly called. 
     *
     * @param id The string to use for the ID attribute of the element.
     */
    public final  void setID(String id) {}

    /**
     * Sets the ID for the element being bound.
     * 
     * @param id The string to use for the ID attribute of the element.
     */
    public final DhElement setBindID(String id) {}
    
    /**
     * Retrieves the ID attribute of the HTML element underlying this class. 
     * This ID is one persisted with the 
     * <a href="#generateHTML>generateHTML</a> method. <p>
     * <em>Note</em> that calling this method is not normally part of the usage of this
     * package. The package with automatically generate an ID for all <code>DhElement</code>s
     * even if this method isn't directly called. 
     *
     * @return The string used for the ID attribute of the element.
     */
    public final  String getID() {}

    /**
     * @internalonly
     */
    public final boolean shouldPersistID() {}

    /**
     * Creates a new default ID for this element.  */
    public final void resetID(){}


    
    
    
    
    

    

    private IHTMLElement        m_peer;
    protected boolean                   m_found = false;

    /**
     * Retrieves the underlying HTML peer element for this class.  This method may return <b>null</b>
     * if the element or its parent were never added to a document. Java code that is running in a 
     * trusted environment can freely cast the resulting reference to a specific element peer type 
     * (e.g. com.ms.wfc.html.om.IHTMLElement). This method will always return <b>null</b> if the
     * code is running in a Web server environment.<p>
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em>
     *
     * @return The element peer underlying the HTML peer for this class.
     */
    public IUnknown getPeer() {}

    /**
     * Return the underlying HTML peer element for this class.  This method may return <b>null</b>
     * even if the element or its parent were added to a document, but there hasn't been occasion to bind
     * to its peer. Java code that is running in a 
     * trusted environment can freely cast the resulting reference to a specific element peer type 
     * (e.g. com.ms.wfc.html.om.IHTMLElement). This method will always return <b>null</b> if the
     * code is running in a Web server environment.<p>
     * Calling <a>getPeer()</a> will retrieve the peer element even if the element hasn't had a 
     * chance to bind to the document yet.<p>
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em>
     *
     * @return The element peer underlying the HTML peer for this class, assuming it is available.
     */
    public final  IUnknown hasPeer() {}

    
    protected IHTMLElement getElementPeer() {}

    /**
     * Called when an instance is created from an existing HTML element. 
     * @param peer The existing peer element
     */
    protected  void initFromPeer( IHTMLElement peer ){}

    protected void setElementPeer( IHTMLElement peer ) {}

    protected void setElementPeer( IHTMLElement peer, boolean transition ) {}

    static private String[] sm_wheres =
    { "BeforeEnd", "AfterBegin", "BeforeBegin", "AfterEnd" };

    private void setSizeDefaults(){}

    protected void makePeer(IHTMLElement parentPeer,boolean fInsert,DhElement relativeTo,int insertFlag) {}        
    
    /**
     * Do we want to doc this?
     * @internalonly
     */
    protected  void setFound() {}
    
    
    
    
    
    
    
    
    
    /**
     * Called when the HTML for this element is added to the running browser document.   At this point,
     * it is possible to retrive the Document Object Model peer object that
     * can be manipulated with this elemement
     */
    protected void onPeerAvailable(){}
    
    /**
     * This method is called when the IHTMLElement Document Object Model peer
     * is set or reset for an element. ms.wfc.html.om.IHTMLElement.html">IHTMLElement</a> Document Object
     * Model peer is set or reset for an element.  The value of the peer that
     * is associated with an element can change several times during
     * the life of the element due to certain operations.
     * 
     * @param newPeer The new IHTMLElement peer item.
     * @see com.ms.wfc.html.om.IHTMLElement
     */
    protected void onSetPeer( IHTMLElement newPeer ){}
    
    /**
     * This overridable function is called when the 
     * <a href="com.ms.wfc.html.DhDocument.html">DhDocument</a> has been
     * set or changed for this element.
     * @param The new DhDocument reference.
     * @see  com.ms.wfc.html.DhDocument
     */
    protected void onSetDocument( DhDocument newDocument ){}
    
    /**
     * Called when the DhElement-derived parent has been set or changed for this element. ms.wfc.html.DhElement.html">DhElement</a> derived parent 
     * has been set or changed for this element.
     * 
     * @param newParent The new parent reference.
     * @see  com.ms.wfc.html.DhElement
     */        
    protected void onSetParent( DhElement newParent ){}

    
    
    
    
    
    /**
     * Sets the alignment of the element.   Specified as one of the 
     * <a href="com.ms.wfc.html.DhAlignment.html">DhAlignment</a>
     * constants.  This alignment property generally affects child elements if
     * this element is a container, otherwise if affects alignment relative
     * to adjacent text.  To center, right, or left align an element relative
     * to the document, wrap it in a <a href="com.ms.wfc.html.DhForm.html">DhForm</a> container.
     *
     * @param nAlign The desired alignment
     */
    public void setAlign( int nAlign ){}

    /**
     * Returns the alignment of the element.   Specified as one of the 
     * <a href="com.ms.wfc.html.DhAlignment.html">DhAlignment</a>
     * constants.
     *
     * @return The desired alignment, or -1 if alignment is uninitialized
     */  
    public final int getAlign( ){}

    /**
     * @internalonly
     */
    public final boolean shouldPersistAlign(){}

    /**
     * Clears any align property.  */
    public final void resetAlign(){}

    
    
    
    
    
    

    private IHTMLStyle m_elementStylePeer;

    protected IHTMLStyle getStylePeer() {}
    
    protected void setStylePeer( IHTMLStyle peer ) {}

    protected void setStylePeerNull() {}

    protected boolean haveStylePeer() {}

    protected String getPeerCssText() {}

    protected void setPeerCssText(String css) {}

    
    
    
    
    

    private int                     m_bindState         = STATE_UNBOUND;

    static protected final int      STATE_UNBOUND       = 0;
    static protected final int      STATE_PEERAVAILABLE = 1;
    static protected final int      STATE_BOUND         = 2;
    static protected final int      STATE_SERVERSENT    = 3;

    protected  boolean getBound() {}

    protected  boolean getPeerAvailable() {}

    protected  boolean getUnbound() {}

    protected  boolean getServerSent(){}

    protected void setServerSent(){}

    /**
     Derivations that keep peers cached around must 
     override this method and destroy that reference.
     */
    protected void onStateChange( int stateChange ) {}

    /**
     * Frees all resources associated with this element.  This method may not be
     * called at runtime. Any resources used by the element should be setup to
     * be released when the element is GC'ed. Inheriting classes should always
     * call <i>super.dispose</i>.
     */
    public void dispose() {}

    /**
     * @hidden
     * 
     * This method moves the elements from one state to another. You can override this method
     * to add additional state-maintanence code for custom elements. You should call 
     * super.transitionTo() when overriding this method.
     * 
     * If the element writer wants just a notification when the state changes, 
     * they should instead add a event handler for the stateChange event.
     * 
     * @param targetState   The state to which the element should move to.
     *                      This is one of:
     *                          STATE_BOUND
     *                          STATE_UNBOUND
     */
    protected void transitionTo(int targetState) {}

     /**
     * @param eSrc A DhElement object to use as the source to clone settings from
     *@internalonly
     */   
    public  void cloneSettings( DhElement eSrc ) {}
    

    /**
     * @param eSrc A DhElement object to use as the source to merge settings from
     * @param overWrite <b>true</b> to overwrite settings on this object
     *@internalonly
     */
    public  void mergeSettings( DhElement eSrc, boolean overWrite ) {}




    
    
    
    
    

    /**
     * @internalonly
     */
    protected static String escapeQuotes( String strUnsafe ){}

    
    /**
     * @internalonly
     */
    protected static String unescapeQuotes( String strSafeString ){}
    
    
    
    /**
     * @internalonly
     */        
    protected static String replaceString( String inString, String search, String replace ){}

    
    


    
    
    
    
    
    

    
    
    

    public Point getSize(){}

    public Point getLocation(){}

    public DhElement[] getElements(){}

    public int getElementCount(){}
    
    /**
     * @hidden
     * @internalonly
     */
    public void setName( String s ){}

    
    
    
    
    

    /**
     * Represents the superclass for all user interface (UI) elements in this package. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhStyleBase.ClassInfo {
        public static final PropertyInfo ID =
                                             new PropertyInfo(DhElement.class, "ID", String.class,
                                                              CategoryAttribute.Appearance,
                                                              new DescriptionAttribute(Sys.getString("DhElementID")));
        public static final EventInfo afterUpdate = new EventInfo(
                                                                  DhElement.class,"afterUpdate", EventHandler.class,
                                                                  CategoryAttribute.Behavior);
        public static final EventInfo beforeUpdate = new EventInfo(
                                                                   DhElement.class,"beforeUpdate", EventHandler.class,
                                                                   CategoryAttribute.Behavior);
        public static final EventInfo click =
                                             new EventInfo(DhElement.class, "click", EventHandler.class,
                                                           CategoryAttribute.Action,
                                                           new DescriptionAttribute(Sys.getString("DhElementClick")));
        public static final EventInfo dataAvailable = new EventInfo(
                                                                    DhElement.class,"dataAvailable", EventHandler.class,
                                                                    CategoryAttribute.Behavior);
        public static final EventInfo dataSetChanged = new EventInfo(
                                                                     DhElement.class,"dataSetChanged", EventHandler.class,
                                                                     CategoryAttribute.Behavior);
        public static final EventInfo dataSetComplete = new EventInfo(
                                                                      DhElement.class,"dataSetComplete", EventHandler.class,
                                                                      CategoryAttribute.Behavior);
        public static final EventInfo doubleClick =
                                                   new EventInfo(DhElement.class, "doubleClick", EventHandler.class,
                                                                 CategoryAttribute.Action,
                                                                 new DescriptionAttribute(Sys.getString("DhElementDoubleClick")));
        public static final EventInfo dragStart = new EventInfo(
                                                                      DhElement.class,"dragStart", EventHandler.class,
                                                                      CategoryAttribute.Behavior);
        public static final EventInfo errorUpdate = new EventInfo(
                                                                  DhElement.class,"errorUpdate", EventHandler.class,
                                                                  CategoryAttribute.Behavior);
        public static final EventInfo filterChange = new EventInfo(
                                                                      DhElement.class,"filterChange", EventHandler.class,
                                                                      CategoryAttribute.Behavior);
        public static final EventInfo help =
                                             new EventInfo(DhElement.class, "help", HelpEventHandler.class,
                                                           CategoryAttribute.Action,
                                                           new DescriptionAttribute(Sys.getString("DhElementHelp")));
        public static final EventInfo keyDown =
                                               new EventInfo(DhElement.class, "keyDown", KeyEventHandler.class,
                                                             CategoryAttribute.Key,
                                                             new DescriptionAttribute(Sys.getString("DhElementKeyDown")));
        public static final EventInfo keyPress =
                                                new EventInfo(DhElement.class, "keyPress", KeyPressEventHandler.class,
                                                              CategoryAttribute.Key,
                                                             new DescriptionAttribute(Sys.getString("DhElementKeyPress")));
        public static final EventInfo keyUp =
                                             new EventInfo(DhElement.class, "keyUp", KeyEventHandler.class,
                                                           CategoryAttribute.Key,
                                                           new DescriptionAttribute(Sys.getString("DhElementKeyUp")));
        public static final EventInfo mouseEnter =
                                                  new EventInfo(DhElement.class, "mouseEnter", MouseEventHandler.class,
                                                                CategoryAttribute.Mouse,
                                                                new DescriptionAttribute(Sys.getString("DhElementMouseEnter")));
        public static final EventInfo mouseDown =
                                                 new EventInfo(DhElement.class, "mouseDown", MouseEventHandler.class,
                                                               CategoryAttribute.Mouse,
                                                               new DescriptionAttribute(Sys.getString("DhElementMouseDown")));
        public static final EventInfo mouseLeave =
                                                  new EventInfo(DhElement.class, "mouseLeave", MouseEventHandler.class,
                                                                CategoryAttribute.Mouse,
                                                                new DescriptionAttribute(Sys.getString("DhElementMouseLeave")));
        public static final EventInfo mouseMove =
                                                 new EventInfo(DhElement.class, "mouseMove", MouseEventHandler.class,
                                                               CategoryAttribute.Mouse,
                                                               new DescriptionAttribute(Sys.getString("DhElementMouseMove")));
        public static final EventInfo mouseUp =
                                               new EventInfo(DhElement.class, "mouseUp", MouseEventHandler.class,
                                                             CategoryAttribute.Mouse,
                                                             new DescriptionAttribute(Sys.getString("DhElementMouseUp")));
        public static final EventInfo rowEnter = new EventInfo(
                                                               DhElement.class,"rowEnter", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo rowExit = new EventInfo(
                                                              DhElement.class,"rowExit", EventHandler.class,
                                                              CategoryAttribute.Behavior);
        public static final EventInfo selectStart = new EventInfo(
                                                              DhElement.class,"selectStart", EventHandler.class,
                                                              CategoryAttribute.Behavior);
        
        public String getDefaultEventName() {}

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}

        public final void removeFocusEvents(IEvents events) {}
    }
    
    Object m_peerData;
    
    
    String getPeerDataAttribute( String attr, boolean fSkipIfSearching ){}
    
        
    String getPeerDataAttribute( String attr, boolean fSkipIfSearching, boolean overWriteAttr ){}
    
    void flushPeerDataCache(){}
    
    
    
    class lateAttributeParser{
        
        String m_string;
        htmlTagTokenizer htt;
        boolean isSearching;
        boolean isDone;
        
        public String toString(){}
        
        lateAttributeParser( String html ){}            
        
        String getAttribute( String attr, boolean overWriteAttr ){}
    }
    
    
    
    
    static final int getFirstNonQuotePos( char c, String s, int startPos ){}
    
    
    static final String getAttributePart( String html, boolean stripStyle, boolean stripID ){}

}


class DhAttributeParser extends DhScanner implements DhStringIDs { 
    DhElement m_element;
    String    m_parseUntil;

    DhAttributeParser( String html, DhElement element, String parseUntil) {}

    public void parse() {}

    public boolean onAttribute(DhParseInfo pi, int dhkey, char[] strKeyName, int valkey, char[] value) {}
}



abstract class baseTokenizer {  
    
    String  m_buffer;
    int  m_buflen;
    int     m_pos = 0; 
    int     m_mark = 0;
    String  m_item = null;
    
    baseTokenizer( String strBuffer ){}

    boolean isDone(){}

    String getTheRest(){}
    
    void setMark(){}
    
    void resetToMark(){}
    
    
    abstract int getItem();

    
    abstract String getString(boolean sawEq);

    String getItemString(){}
    
    char getCurChar(){}

    int findNext( char c ){}
    
    void eatWhiteSpace(){}
    
    void advance(){}
}


class htmlTagTokenizer extends baseTokenizer{  
    static final int  ATTR          = 0;
    static final int  OPEN_TAG      = 1;
    static final int  CLOSE_TAG     = 2;
    static final int  EQUALS        = 3;
    static final int  QUOTED_STRING = 4;
    static final int  DONE          = 5;
    static final int  VALUE         = 6;

    static final String OPEN_TAG_STR  = "<";
    static final String CLOSE_TAG_STR = ">";
    static final String EQUALS_STR    = "=";
    
    boolean m_doneLeadTag = false;
    boolean m_sawEq = false;
    
    htmlTagTokenizer( String strHTML ){}

    boolean inLeadTag(){}
    
    void unGetItem(){}
    
    int getItem(){}

    String getString(boolean sawEq){}        
}