//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.util.IEnumerator;

import com.ms.wfc.html.om.IHTMLElementCollection;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLDocument2;
import com.ms.com.IEnumVariant;
import com.ms.com.Variant;
import com.ms.wfc.core.*;

/**
 * Represents a collection of elements in the HTML document.  You can either <b>new</b>
 * this class directly or just call <a href="com.ms.wfc.html.DhDocument.html#enumerate>DhDocument.enumerate</a>
 * to get the collection.<p>
 *
 * <em>It should be noted that many HTML tags do not map 1-1 into Java classes in this package.
 * Care should be taken when enumerating through the return of <b>next</b>. You should always
 * check the result with an </em><b>instanceof</b><em> check.</em>
 *
 * @security(checkClassLinking=on)
 */
public class DhEnumeration implements IEnumerator { 
    
    /**
     * Used by either DhDocument.enumerate
     * or the DhEnumeration
     * constructor to indicate a collection of all elements on the page.ms.wfc.html.DhDocument.html#enumerate>DhDocument.enumerate</a>
     * or the <a>DhEnumeration</a> constructor to indicate a collection of all elements on the 
     * page. <p>
     * <em>It should be noted that many HTML tags do not map 1-1 into Java classes in this package
     * Care should be taken when enumerating through the return of <b>next</b>. You should always
     * check the result with an </em><b>instanceof</b><em> check.</em>
     */
    public static final int ELEMENTS    = 1;

    /**
     * Used by either DhDocument.enumerate
     * or the DhEnumeration
     * constructor to indicate a collection of all image (IMG) elements on the page.ms.wfc.html.DhDocument.html#enumerate>DhDocument.enumerate</a>
     * or the <a>DhEnumeration</a> constructor to indicate a collection of all Image (IMG) elements 
     * on the page.
     */
    public static final int IMAGES      = 2;

    /**
     * Used by either DhDocument.enumerate
     * or the DhEnumeration
     * constructor to indicate a collection of all link (HREF) elements on the page. ms.wfc.html.DhDocument.html#enumerate>DhDocument.enumerate</a>
     * or the <a>DhEnumeration</a> constructor to indicate a collection of all link (A) elements on the 
     * page.<p>
     * <em>It should be noted that many HTML tags do not map 1-1 into Java classes in this package
     * Care should be taken when enumerating through the return of <b>next</b>. You should always
     * check the result with an </em><b>instanceof</b><em> check.</em>
     */
    public static final int HLINKS      = 3;

    private boolean                 m_server = false;
    private DhDocument              m_document;        
    private IEnumVariant            m_enumVariant;        
    private Variant[]               m_scratch;
    private int[]                   m_iscratch;
    
    private Object                  m_cur;

    
    private DhElement[]             m_elements;
    private int                     m_curIndex = 0;
    private int                     m_length = 0;

    /**
     * You can either <b>new</b>
     * this class directly or just call 
     * <a href="com.ms.wfc.html.DhDocument.html#enumerate>DhDocument.enumerate</a>
     * to get the collection.<p>
     * 
     * @param document A reference to a <a href="com.ms.wfc.html.DhDocument.html>DhDocument</a>
     * @param enumType One of the <a href="#ELEMENTS">legal types</a> of collection.
     */
    public DhEnumeration( DhDocument document, int enumType ) {}

    /**
     * Tests if this enumeration contains more elements. 
     *
     * @return  <code>true</code> if this enumeration contains more elements;
     *          <code>false</code> otherwise.
     */
    public boolean hasMoreItems() {}

    /**
     * Resets the enumerator to the beginning. 
     *
     */
    public void reset() {}

    /**
     * Returns the next element of this enumeration. 
     *
     * @see #next
     * @return     the next element of this enumeration. 
     * @exception  WFCException  if no more elements exist.
     */
    public Object nextItem() {}

    /**
     * Returns the next element of this enumeration.  The result here can be further downcast 
     * (e.g. to DhImage) depending on the type of enumeration this is.
     *
     * <em>It should be noted that many HTML tags do not map 1-1 into Java classes in this package
     * Care should be taken when enumerating through the return of <b>next</b>. You should always
     * check the result with an </em><b>instanceof</b><em> check.</em>
     * @return     the next element of this enumeration
     * * @exception  WFCException  if no more elements exist.
     */
    public DhElement next() {}
    
    private void initItems(){}
    
    private Object getItem(){}
}