//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.util.*;
import com.ms.wfc.core.*;
import com.ms.wfc.ui.ScrollEventHandler;

import com.ms.wfc.html.om.*;
import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhDivListener;

import com.ms.com.Variant;
import com.ms.com.IEnumVariant;
import com.ms.com.*;

/**
 * Represents an element container that uses traditional HTML one-dimensional flow layout.   Elements that
 * are added into this kind of container can not be positioned in xy coordinates but rather
 * "flow" around each other.
 *
 * @security(checkClassLinking=on)
 */
public class DhForm extends DhBaseContainer {
    
    public  static final int METHOD_POST     = 0;
    public  static final int METHOD_GET      = 1;

    private boolean                        m_fAsForm        = false;
    private boolean                        m_paraMode       = false;

    /**
     * Creates the default section container.
     */
    public DhForm() {}

    /**
     * @internalonly
     */ 
    protected DhForm( IHTMLElement peer, DhDocument document, String id ){}

    /**
     *@internalonly
     */
    protected int getTagNameID() {}

    /**
     *@internalonly
     */
    protected void init( DhParseInfo ph ) {}

    /**
     * Adds an element into this container, following all other elements. 
     *
     * @param element The DhElement to add to the end of the flow of this container.
     */
    public void add(DhElement element) {}

    /**
     * Adds an element into this container, following all other elements. ms.wfc.html.DhInsertOptions.html>insertFlag</a> parameter.
     * The valid values for <i>insertFlag</i> are:
     * <UL>
     * <LI><b>END</b> 
     * <LI><b>BEGINNING</b>
     * </UL>
     *
     *  @param element The DhElement to add to this container
     *  @param insertFlag One of the valid and applicable <a href="com.ms.wfc.html.DhInsertOptions.html>insert constants</a>.
     */
    public void add(DhElement element, int insertFlag ) {}

    /**
     * Adds an element into this container, following all other elements. ms.wfc.html.DhInsertOptions.html>insertFlag</a> parameter.
     * The valid values for <i>insertFlag</i> are:
     * <UL>
     * <LI><b>END</b> Insert into the end of the flow or this container. The <i>relativeTo</i> parameter must be <b>null</b>.
     * <LI><b>BEGINNING</b> Insert into the beginning of the flow or this container. The <i>relativeTo</i> parameter must be <b>null</b>.
     * <LI><b>BEFORE</b> Insert before the element referred to by the <i>relativeTo</i> parameter. The <i>relativeTo</i> parameter must not be <b>null</b>.
     * <LI><b>AFTER</b> Insert after the element referred to by the <i>relativeTo</i> parameter. The <i>relativeTo</i> parameter must not be <b>null</b>.
     * </UL>
     *
     *  @param element The DhElement to add to this container
     *  @param relativeTo The DhElement referred to when using the BEFORE or AFTER constants for the <i>insertFlag</i> parameter.
     *  @param insertFlag One of the valid and applicable <a href="com.ms.wfc.html.DhInsertOptions.html>insert constants</a>.
     */
    public void add(DhElement element, DhElement relativeTo, int insertFlag) {}

    /**
     * Forces this DhForm to produce an HTML FORM or DIV section. 
     * @param fAsForm True to set as FORM, false to set as DIV
     */

    public void setAsHTTPForm( boolean fAsForm ) {}

    /**
     * Retrieves the current FORM/DIV state.   FORM state can be set by using setAsHTTPForm()
     * or adding a <a href="com.ms.wfc.html.DhSubmitButton.html>DhSubmitButton</a> into the DhForm.
     *
     * @return true if FORM, false if DIV
     * @see #setAsHTTPForm
     */
    public boolean getAsHTTPForm( ) {}

    /**
     * Moves an element to a new numeric order in the flow. 
     *
     * @param element The DhElement to move.
     * @param newOrder The new numeric order in the flow of this container.
     */
    public void moveElement( DhElement element, int newOrder ) {}

    /**
     * Removes an element from this container.  This element would no longer be visible if it was
     * prior to this call.
     *
     * @param element The DhElement to remove from this container.
     */
    public int remove(DhElement element) {}

    /**
     * Removes all child elements from this container.  These elements would no longer be visible 
     * if they were prior to this call.
     */
    public void removeAll() {}

    /**
     * Appends a new line to the current section.  All elements added after this call will be on a 
     * new line.
     */
    public void newLine() {}

    /**
     * Appends a text string to the current section. 
     * @param text The text string.
     */
    public void addText( String text ) {}

    
    /** 
     * Sets the URL to be called when the form's DhSubmit
     * button is clicked.   Parameters
     * from form fields will be concatenated onto this URL
     *
     * @param strActionURL The URL to be called on submit
     */
    public void setSubmitURL( String strActionURL ) {}
    
    /**
     * Retrieves the current URL that will be called if the form's Submit button is clicked. 
     * @return URL to be called
     * @see #setHTTPSubmitURL
     */
    public String getSubmitURL( ) {}

    /**
     * Retrieves the current HTTP submit method.   Values can be METHOD_GET or METHOD_POST.
     *
     * @return DhForm.METHOD_GET or DhForm.METHOD_POST
     * @see #setHTTPSubmitMethod
     */
    public int getSubmitMethod() {}

    /** 
     * Sets the method to use for submitting the form data.   Can be METHOD_GET or METHOD_POST
     * @param the new HTTP submit method 
     */
    public void setSubmitMethod( int newMethod ) {}

    /**
     *@internalonly
     */
    protected DhEvents createEvents(){}
    
    /**
     * Assigns a delegate to the formSubmit event.
     * @param h The handler to call on a submit action.
     */
    public void addOnFormSubmit( EventHandler h ){};

    /**
     * Assigns a delegate to the formReset event.
     * @param h The handler to call on a reset action.
     */
    public void addOnFormReset( EventHandler h ){};

    /** 
     * Assigns a delegate to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void addOnResize( EventHandler h ) {}

    /**
     * Assigns a delegate to the scroll event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is scrolled.
     *
     * @param h The event handler callback method.
     */
    public final void addOnScroll( ScrollEventHandler h ) {}

    /**
     * Assigns a delegate to the select event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected.
     *
     * @param h The event handler callback method.
     */
    public final void addOnSelect( EventHandler h ) {}

    /**
     * Assigns a delegate to the change event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element's contents changed.
     *
     * @param h The event handler callback method.
     */
    public final void addOnChange( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the formSubmit event. 
     * @param h The handler to call on a submit action.
     */        
    public void removeOnFormSubmit( EventHandler h ){};
    
    /**
     * Removes the delegate that is assigned to the formReset event. 
     * @param h The handler to call on a reset action.
     */
    
    public void removeOnFormReset( EventHandler h ){};

    /** 
     * Removes the delegate that is assigned to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnGotFocus(EventHandler h) {}
    
    /**
     * Removes the delegate that is assigned to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnLostFocus(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnResize( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the scroll event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is scrolled.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnScroll( ScrollEventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the select event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnSelect( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the change event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element's contents changed.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnChange( EventHandler h ) {}

    
    /**
     *@internalonly
     */
    public void setHTMLGenerator( DhHTMLGenerator htmlGen ){}
    
    /**
     * @internalonly
     */
    protected void setElementPeer( IHTMLElement peer ){}
    
    /**
     * @internalonly
     * @hidden
     */
    public void mergeSettings( DhElement eSrc, boolean overWrite ){}


/**
 * Represents an element container that uses traditional HTML one-dimensional flow layout.  
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo asHTTPForm =
                                                     new PropertyInfo(DhForm.class, "asHTTPForm", Boolean.TYPE,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.FALSE,
                                                                      new DescriptionAttribute(Sys.getString("DhFormAsHTTPForm")));
        public static final EventInfo change = new EventInfo(
                                                               DhForm.class,"change",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo formSubmit =
                                                  new EventInfo(DhForm.class, "formSubmit", EventHandler.class,
                                                                CategoryAttribute.Action,
                                                                new DescriptionAttribute(Sys.getString("DhFormHTTPSubmit")));
        public static final EventInfo formReset =
                                                 new EventInfo(DhForm.class, "formReset", EventHandler.class,
                                                               CategoryAttribute.Action,
                                                               new DescriptionAttribute(Sys.getString("DhFormFormReset")));
        public static final EventInfo gotFocus = new EventInfo(
                                                               DhForm.class,"gotFocus",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(
                                                                DhForm.class,"lostFocus",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(
                                                               DhForm.class,"resize",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo scroll = new EventInfo(
                                                               DhForm.class,"scroll", ScrollEventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo select = new EventInfo(
                                                               DhForm.class,"select",EventHandler.class,
                                                               CategoryAttribute.Behavior);

        public void getProperties(IProperties props) {}
        public void getEvents(IEvents events) {}
    }
}








class DhElementArray { 
    protected DhElement[]   m_elements;
    protected int                   m_elementCount;
    private boolean isComplete;

    public DhElementArray(boolean isCompleteP) {}

    protected DhElement[] getElements() {}

    protected int getElementCount() {}

    public boolean getComplete() {}
    
    protected void moveElement( DhElement element, int newPos ) {}

    protected void add( DhBaseContainer newParent, DhElement element, int relativeToPos, int flag ) {}

    
    private void removeInternal(DhElement elem, IHTMLElement peer, DhModule module) {}
    
    public int remove(DhBaseContainer oldParent, DhElement element) {}
    
    
    
    
    public int quickRemove( DhBaseContainer oldParent, DhElement element ){}
    
    public void setComplete() {}
    
    public void setIncomplete(){}

    protected int getElementIndex(DhElement element) {}

    protected DhElement getElementAtIndex( int index ) {}

    protected void removeAll() {}
}


class DhSemaphore extends List { 
    int m_value;
    int m_initValue;
    Thread m_curOwner;

    public DhSemaphore() {}

    public DhSemaphore(int init_value) {}

    public void grab() {}

    public void signal() {}
}



class DhElementVector {
    DhElement[] m_elements;
    int         m_count;
    int         m_size;

    public DhElementVector( int initialSize ){}

    public void ensureSpace( int incrSpace ){}

    public DhElement[] getElements(){}

    public void add( DhElement newElement ){}

    public void add( DhElement[] newElements ){}

    public void reset(){}
}