//STRIPPEDSOURCE//

package com.ms.wfc.html;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhHotSpotListener;

import java.util.StringTokenizer;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.Point;
import com.ms.wfc.ui.Rectangle;


/**
* Implements an object that represents a hotspot in an image map.   A hotspot is an area within the map
* that a user can click to jump to a URL.  DhHotSpot objects are to be added
* to <a href="com.ms.wfc.html.DhImageMap.html">DhImageMap</a> objects.
*
* @security(checkClassLinking=on)
*/
public class DhHotSpot extends DhElement {
    
    /**
    * Default ctor.  Creates a rectangle of 0 height and 0 width
    */
    public DhHotSpot(){}

    /**
    * One-step ctor.
    *
    * @param nShape The shape of the hotspot, from DhHotSpotShapes
    * @param coords an array of <b>int</b>s specifying the coordinates for the hotspot    
    * @see com.ms.wfc.html.DhHotSpotShapes
    */
    public DhHotSpot( int nShape, int[] coords ){}
    
    /**
    * One-step ctor.
    *
    * @param nShape The shape of the hotspot, from DhHotSpotShapes
    * @param coords an array of <b>int</b>s specifying the coordinates for the hotspot
    * @param strURL    The URL to navigate to when the hotpot is clicked.
    * @see com.ms.wfc.html.DhHotSpotShapes
    */
    public DhHotSpot( int nShape, int[] coords, String strURL ){}

    /**
     * Creates a rectangular hotspot from the Rectangle
     * @param r A com.ms.wfc.ui.Rectangle object
     */
    public DhHotSpot( Rectangle r ){}

    /**
    * Retrieves the current coordinate string. 
    * @return The string of the current coordinates
    */
    public String getCoordsString(){}

    /**
    * Retrieves an array of integers representing the current coordinate string. 
    * @return An array of Points.
    * @see com.ms.wfc.ui.Point
    */
    public int[] getCoordsIntArray(){}

    /**
    * Sets the coordinate string for this DhHotSpot using an integer array,
     * a string, or a rectangle. 
    * @param nCoordArray the array of coordinates.
    * @exception WFCException if the coordinates do not match the current
    *            shape type    
    */
    public void setCoords( int[] nCoordArray ){}

    /**
    * Sets the coordinate string for this DhHotSpot using an integer array,
     * a string, or a rectangle. 
    * @param strCoords A string of coordinates appropriate for this shape
    *                  type
    * @exception WFCException if the coordinates do not match the current
    *            shape type
    */
    public void setCoords( String strCoords ){}

    /**
     * Sets the coordinate string for this DhHotSpot using an integer array,
     * a string, or a rectangle. RECTANGLE.
     * @param r A com.ms.wfc.ui.Rectangle object.
     * @see com.ms.wfc.ui.Rectangle     
     */
    public void setCoords( Rectangle r ){}
    
    /**
     * @internalonly
     */
    protected DhEvents createEvents(){}
        
   /** 
     * Assigns a delegate to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h )   
    {}
    
    /**
    * Assigns a delegate to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
    * that is triggered when this element loses focus
    *
    * @param h The event handler callback method.
    */
    public final void addOnLostFocus    ( EventHandler h )   
    {}

    /**
    * Retrieves the current alternate text string that is displayed if the browser cannot
     * display the image. 
    */
    public String getAltText(){}

    /**
    * Sets the alternate text for the hotspot if the browser cannot display the image. 
    * @param strAltText The new alt text string 
    */    
    public void setAltText( String strAltText ){}
 
    /**
    * Retrieves the current shape constant. 
    * @return The shape, from DhHotSpotShapes
    * @see com.ms.wfc.html.DhHotSpotShapes
    */
    public int getShape(){}

    /** 
     * Removes the delegate that is assigned to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnGotFocus(EventHandler h) {}
    
    /**
     * Removes the delegate that is assigned to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnLostFocus(EventHandler h) {}

    /**
    * Sets the shape of this hotspot. 
    *
    * @param nShape The shape of the hotspot, from DhHotSpotShapes
    * @see com.ms.wfc.html.DhHotSpotShapes
    */
    public void setShape( int nShape ){}

    private static String stringFromRectangle( Rectangle r ){}

    private static String stringFromPointArray( Point[] ptArray ){}

    /**
    * Retrieves the target window for this hotspot.   
    * @return The target window name.
    */
    public String getTargetWindow(){}

    /**
    * Sets the target window for this hotspot. 
    * @param strTargetWnd The name of the new target window.
    */
    public void setTargetWindow( String strTargetWnd ){}

        /**
         * @internalonly
         */
        protected int getTagNameID(){}

    /**
    * Retrieves the URL to navigate to if the user selects this hotspot. 
    * @return The current URL
    */
    public String getURL(){}

    /**
    * Sets the URL for this DhHotSpot to navigate to when clicked. 
    */
    public void setURL( String strURL ){}
    
    private void validateCoords( int nShape, int[] coords ){}

    private void validateCoords( int nShape, String strCoords ){}

    /**
     * Implements an object that represents a hotspot in an image map. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhElement.ClassInfo {
        public static final EventInfo gotFocus = new EventInfo(
                                                                  DhHotSpot.class,"gotFocus",EventHandler.class,
                                                                  CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(
                                                                  DhHotSpot.class,"lostFocus",EventHandler.class,
                                                                  CategoryAttribute.Behavior);

        public void getEvents(IEvents events) {}
    }
}