//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;

/**
 * Provides constants for DhHotspot shapes.  DhElement items) into
 * container items.
 *
 * @security(checkClassLinking=on)
 */
public class DhHotSpotShapes extends Enum {
       /**
    * Specifies that the hotspot has a rectangular shape.  Coordinates
    * are specified as "x1, y1, x2, y2"
    * <p>Ex: "<b>new int</b>[]{5,5,15,15}" would create a 10x10 rectangle at (5,5).
    */
    public static final int RECTANGLE = 0;
    
    /**
    * Specifies that the hotspot has a circular shape.  Coordinates
    * are specified as "center x, center y, radius"
    * <p>Ex: "<b>new int</b>[]{12, 19, 7}"
    */    
    public static final int CIRCLE    = 1;
    
    /**
    * Specifies that the hotspot has a polygon shape.  Coordinates
    * are specified as 3 or more coordinate pairs.
    *
    * <p>Ex: "<b>new int</b>[]{10,10,15,15,5,15}" would create a triangle
    */    
    public static final int POLYGON   = 2;

    static int mapToStrId( int n ){}
    
    static int mapFromStrId( int n ){}
    
    
    public static boolean valid(int n) {}
}