//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhHyperlinkListener;
import com.ms.wfc.html.om.IHTMLElementCollection;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.com.*;

import com.ms.wfc.core.*;
import com.ms.wfc.util.*;

/**
 * Creates a jump in the document to a bookmark or element in the current document or to a  different document. 
 *
 * @security(checkClassLinking=on)
 */
public class DhHyperlink extends DhForm { 
    private DhText    m_text;
    private DhImage   m_image;
    private DhElement m_target;
    private boolean   m_defText = true;
    
    /**
     * Creates default (not exactly very useful) hyperlink object.
     * @see #setURL
     * @see #setJumpPoint
     * @see #setText
     */
    public DhHyperlink() {}
    
    /**
     * Creates a "classic" hyperlink that will navigate the user to the document
     * pointed to by the <i>url</i> parameter.
     *
     * @param url Document to hyperlink to.
     * @param text Text that the user sees as the hyperlink
     */
    public DhHyperlink(String url, String text) {}
    
    /**
     * @internalonly
     */
    protected int getTagNameID() {}
    
    /**
     * @internalonly
     */    
    protected void initFromPeer( IHTMLElement peer ){}

    /** 
     * Sets the enabled state of the hyperlink. 
     * @param f Boolean defining the enabled state--default it <b>true</b>
     */
    final public void setEnabled(boolean f) {}
    
    /**
     * Retrieves the enabled state of the hyperlink. 
     *
     * @param The current caption String.
     */
    final public boolean getEnabled(){}
    
    
    /**
     * Retrieves the target URL for the hyperlink. 
     * @return The current url that the user would be navigated to if they clicked on the hyperlink.
     */
    final public String getURL() {}
    
    /**
     * Sets the pointer to the document. 
     *
     * @param url Sets the pointer to the document.
     */
    final public void setURL(String url) {}
    
    /**
     * Sets the destination of this hyperlink to be some element on the current page. 
     *
     * @param target The element you wish the user to jump to when they click on this hyperlink.
     */
    final public void setJumpPoint( DhElement target ) {}
    
    
    private void onTargetSetParent(Object sender, Event e) {}
    
    final void setupTarget(DhElement target) {}
    
    /**
     * @internalonly
     */
    final protected void setupJumpPoint(DhJumpPoint jp) {}
    
    /**
     * Returns the local target of the jump. 
     * 
     * @see #setJumpPoint(DhElement)
     */
    final public DhElement getJumpPoint() {}
    
    /**
     * Determines the window, by identifier, that the browser will put the document into. 
     * @see #setTargetWindow(String)
     * @param targetID One of the #DhLinkTarget stock window IDs.
     */
    final public void setStockTargetWindow( int targetID ) {}
    
    /**
     * Returns the window identifier where the browser will put the document when it is jumped
     * to. 
     * @see #setTargetWindow(String)
     * @param targetID One of the <a href="#HLST_THIS_FRAME">valid</a> stock window IDs.
     */
    final public int getStockTargetWindow() {}
    
    /**
     * Determines the window, by name, that the browser will put the document into. 
     * @see #setStockTargetWindow(int)
     * @param winName The name of a window in a frame set.
     */
    final public void setTargetWindow(String winName) {}
    
    /**
     * Retrieves the name of the window where the browser will put the document when it is
     * jumped to. 
     * @see #setStockTargetWindow(int)
     * @param winName The name of a window in a frame set.
     */
    final public String getTargetWindow() {}
    
    /**
     * Sets the text the user sees in the hyperlink. 
     *
     * @param text String to display to user.
     */
    final public void setText( String text ) {}
    
    void addWashed( DhElement e, DhElement rel, int insertType ){}
    
    /**
     * Retrieves the hyperlink text. 
     * @return The text the user sees in the hyperlink.
     */
    final public String getText() {}
    
    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    /**
     * @hidden
     * @internalonly
     */
    public void mergeSettings( DhElement eSrc, boolean overWrite ) {}
    
    
    /**
     * Creates a jump in the document to a bookmark or element in the current document or to a  different document. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhForm.ClassInfo {
        public static final PropertyInfo text = new PropertyInfo(
            DhHyperlink.class, "text", String.class,
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DhHyperLinkText")));
        public static final PropertyInfo URL = new PropertyInfo(
            DhHyperlink.class, "URL", String.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("DhHyperLinkURL")));
        public static final PropertyInfo targetWindow = new PropertyInfo(
            DhHyperlink.class, "targetWindow", String.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("DhHyperLinkTargetWindow")));
        public static final PropertyInfo stockTargetWindow = new PropertyInfo(
            DhHyperlink.class, "stockTargetWindow", DhLinkTarget.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("DhHyperLinkStockTargetWindow")));
        public void getProperties(IProperties props) {}
    }
}