//STRIPPEDSOURCE//
package com.ms.wfc.html;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.core.*;
import com.ms.wfc.html.event.*;
import com.ms.wfc.ui.ReadyStateEventHandler;
import com.ms.wfc.ui.ReadyStateEvent;

/**
 * Represents an inline frame (&lt;IFRAME&gt;) element. 
 * @security(checkClassLinking=on)
 */
public class DhInlineFrame extends DhElement { 
    EventHandler m_readyHandler;
    
    /**
     * Creates an DhStringIDs.EMPTY frame.
     */
    public DhInlineFrame() {}

    /**
     * Creates an frame with SRC = url.
     * @param url The source of the frame.
     */
    public DhInlineFrame(String url) {}

    /**
     *@internalonly
     */
    protected int getTagNameID() {}

    /**
     * Sets the URL that defines the location of the contents of this frame. 
     *
     * @url Location URL of the frame.
     */
    public void setURL(String url) {}

    /**
     * Retrieves the Uniform Resource Locator (URL) that defines the location of the contents
     * of this frame. 
     *
     * @return Location URL of the frame.
     */
    public String getURL() {}
    /**
     * Retrieves the current document in the frame.
     * @return A DhDocument representing the contents of the frame.
     */
    public DhDocument getFrameDocument(){}
    
    private DhWindow getFrameWindow() {}

    private void gotNewDoc(Object sender, Event evt) {}
    
    
    /**
     *  @internalonly
     */
    protected void onPeerAvailable(){}
    
    
    /**
     *  Sets the current scroll mode.   Can be:
     *  <p>
     *  <ul>
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>AUTO</b></a> -- Browser determines scolling
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>YES</b></a>  -- Scolling is enabled
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>NO</b></a>   -- Scolling is disabled
     *  </ul>
     * 
     * @param scrollMode The desired scrolling mode from DhScrollBars
     *@see   com.ms.wfc.html.DhScrollBars 
     */        
    public void setScroll( int scrollMode ){}
    
    /**
     *  Retrieves the current scrolling mode.   Can be:
     *  <p>
     *  <ul>
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>AUTO</b></a> -- Browser determines scolling
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>YES</b></a>  -- Scolling is enabled
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>NO</b></a>   -- Scolling is disabled
     *  </ul>
     * 
     * @return scrollMode The current scrolling mode
     *@see   com.ms.wfc.html.DhScrollBars 
     */        
    public int getScroll(){}
    
    /**
     * Assigns a delegate to the documentReady event. 
     * @param h A EventHandler to be called when the document is ready
     */
    public void addOnDocumentReady( EventHandler h ){}
    
    /** 
     * Assigns a delegate to the gotFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void addOnResize( EventHandler h ) {}

    /** 
     * Removes the delegate that is assigned to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void removeOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Removes the delegate that is assigned to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void removeOnLostFocus    ( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnResize( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the documentReady event. 
     * @param h The handler to remove
     */
    public void removeOnDocumentReady( EventHandler h ){}
    
    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}

   /**
    * Represents an inline frame (&lt;IFRAME&gt;) element. 
    * @hidden
    * @internalonly
    *
    * @security(checkClassLinking=on)
    */        
    public static class ClassInfo extends DhElement.ClassInfo {
        public static final PropertyInfo URL =
                                              new PropertyInfo(DhInlineFrame.class, "URL", String.class,
                                                               CategoryAttribute.Behavior,
                                                               new DescriptionAttribute(Sys.getString("DhInLineFrameURL")));
        
        public static final PropertyInfo Scroll =
                                                 new PropertyInfo(DhInlineFrame.class, "Scroll", DhScrollBars.class,
                                                                  CategoryAttribute.Behavior,
                                                                  new DescriptionAttribute(Sys.getString("DhInLineFrameScroll")));

        public static final EventInfo documentReady = new EventInfo(DhInlineFrame.class,
                                                               "documentReady", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo gotFocus = new EventInfo(DhInlineFrame.class,
                                                               "gotFocus", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(DhInlineFrame.class,
                                                               "lostFocus", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(DhInlineFrame.class,
                                                               "resize", EventHandler.class,
                                                               CategoryAttribute.Behavior);

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }
}