//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;


/**
 * Provides constants for setting the document's target window. 
 * @security(checkClassLinking=on)
 */
public class DhLinkTarget extends Enum {
    /** 
     * Instructs the browser to put the document into the current frame of the frameset.
     * Used by <a href="#setStockTargetWindow(int)">set/getStockTargetWindow</a>.
     */
    public static final int THIS_FRAME  = 0;

    /**
     * Instructs the browser to put the document into the top-most window, replacing the
     * current frameset.
     * Used by <a href="#setStockTargetWindow(int)">set/getStockTargetWindow</a>.
     */
    public static final int TOP_FRAME   = 1;

    /**
     * Instructs the browser to put the document into a new top-level browser window.
     * Used by <a href="#setStockTargetWindow(int)">set/getStockTargetWindow</a>.
     */
    public static final int NEW_WINDOW  = 2;

    /**
     * Instructs the browser to put the document into the window that is the parent of the
     * current window.
     * Used by <a href="#setStockTargetWindow(int)">set/getStockTargetWindow</a>.
     */
    public static final int PARENT_DOC  = 3;

    public static boolean valid(int n) {}
}