//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;

/**
 * Provides constants and support for list types in a DhBulletedList control. ms.wfc.html.DhBulletedList.html">DhBulletedList</a>
 * @see com.ms.wfc.html.DhBulletedList
 *
 * @security(checkClassLinking=on)
 */
public class DhListType extends Enum {
    /**
     * Represents a list in which each item has a small bullet. */
    public final static int         BULLETED                = 0;
    
    /**
     * Represents a list in which each item has a large bullet. */
    public final static int         DIR                = 1;

    /**
     * Represents a list in which each item has a large bullet.  Similar to MENU
     */
    public final static int         MENU               = 2;

    /**
     * Represents a list in which each item has an assigned number. */
    public final static int         NUMBERED                = 3;
    
    /**
     * Represents a list in which each item has an assigned lowercase roman numeral. */        
    public final static int         SMALL_ROMAN     = 4;
    
    /**
     * Represents a list in which each item has an assigned uppercase roman numeral. */        
    public final static int         LARGE_ROMAN     = 5;
    
    /**
     * Represents a list in which each item has an assigned lowercase letter. */        
    public final static int         SMALL_LETTER    = 6;
    
    /**
     * Represents a list in which each item has an assigned uppercase letter.
     */
    public final static int         LARGE_LETTER    = 7;

    public static boolean valid(int n) {}
}