//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhObjectListener;
import com.ms.wfc.html.DhCantAddElementException;
import com.ms.com.*;

import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLObjectElement;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.ReadyStateEventHandler;

/**
 * Creates an object from an existing ActiveX/COM or Java object and adds it to the  document.  Simply point this class 
 * at the URL or the CLASSID. 
 *
 * @security(checkClassLinking=on)
 */
public class DhObjectFactory extends DhBaseContainer { 
    DhParams m_params;

    /**
     * The default ctor.
     */
    public DhObjectFactory() {}

    /**
     * One step construction, the <i>classid</i> refers to the registered CLSID of the 
     * object, in string form
     *
     * @param classid The string form CLSID of the object
     */
    public DhObjectFactory(String classid) {}


    /**
     * One step construction, the <i>_Guid</i> object of the object
     *
     * @param iid The _Guid of the object to instantiate
     * @see com.ms.com._Guid
     */
    public DhObjectFactory( _Guid iid ) {}


    /**
     *@internalonly
     */
    protected int getTagNameID() {}
    
    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    /**
     * Retrieves the object's class identifier, which is equivalent to the CLASSID parameter
     * of the OBJECT tag in HTML. 
     *
     * @return The classid of the object.
     */
    public String getClassid() {}

    /**
     * Sets the object's current class identifier, which is equivalent to the CLASSID
     * parameter of the OBJECT tag in HTML. 
     *
     * @param classid The classid of the object.
     */
    public void setClassid(String classid) {}

    /**
     * Retrieves the object's current class identifier, which is equivalent to the CLASSID
     * parameter of the OBJECT tag in HTML. ms.com._Guid.html">_Guid object </a>.
     *
     * @return The clsid _Guid of the object.
     *@see com.ms.com._Guild 
     */
    public _Guid getClsid() {}

    /**
     * Sets the object's class identifier, which is equivalent to the CLASSID parameter of the
     * OBJECT tag in HTML. ms.com._Guid.html">_Guid object </a>..
     *
     * @param guid The _Guid representing the object.
     * @see com.ms.com._Guid
     */
    public void setClsid(_Guid guid) {}

    /**
     * Retrieves the object's current programmatic identifer (ProgID), which is equivalent to
     * the PROGID parameter of the OBJECT tag. 
     *
     * @return The PROGID of the object.
     */
    public String getProgid() {}

    /**
     * Sets the object's programmatic identifier (ProgID).
     *
     * @param progid The PROGID representing the object.
     */
    public void setProgid(String progid) {}


    /**
     * Retrieves the object's current codebase, which is equivalent to the CODEBASE parameter
     * of the OBJECT tag in HTML. 
     *
     * @return The codebase of the object.
     */
    public String getCodeBase() {}

    /**
     * Sets the object's code base, which is equivalent to the CODEBASE parameter of the
     * OBJECT tag in HTML. 
     *
     * @param url The codebase of the object.
     */
    public void setCodeBase(String url) {}

    /**
     * Sets the Java class name of the object, which is equivalent to the CODE parameter of
     * the OBJECT tag in HTML.
     *
     * @return The className of the object.
     */
    public String getCodeClassName() {}

    /**
     * Sets the Java class name of the object, which is equivalent to the CODE parameter of
     * the OBJECT tag in HTML.
     *
     * @param className The className of the object.
     */
    public void setCodeClassName(String className) {}

    
    
    

    /**
     * Retrieves the object representing the HTML OBJECT instantiated. 
     *
     * @return Object representing the OBJECT instanstiated.
     */
    public Object getObjectPeer() {}

    /**
     * Retrieves the IDispatch interface implemented by the object currently
     * instantiated. 
     * This object can be used along with com.ms.com.Dispatch class to invoke methods
     * exposed through the controls' IDispatch.
     *
     * @return Object representing the IDispatch interface of the OBJECT instanstiated.
     */
    public Object getDispatchPeer() {}

    
    
    

    /**
     * Retrieves the value of the parameter. 
     *
     * @param param Name of the parameter.
     */
    public String getValue(String param) {}

    /**
     * Adds a new parameter to the object. 
     *
     * @param param The name of the parameter.
     * @param value The value of the parameter.
     */
    public void addParam(String param, String value) {}

    /**
     * Removes a parameter from the list of parameters for the OBJECT. 
     *
     * @param param The name of the parameter.
     */
    public void removeParam(String param) {}

    
    
    

    /**
     * Retrieves a string representing the HTML of the contents. 
     *
     * @return StringBuffer.
     */
    protected StringBuffer getContent(StringBuffer sb) {}

    
    /**
     * Adds an element as the child of the object tag. 
     *
     * @param h The DhElement to be added.
     */
    protected void add(DhElement h) {}

    /**
     * @internalonly
     * 
     * @param eSrc A DhElement object to use as the source to merge settings from
     * @param overWrite <b>true</b> to overwrite settings on this object
     */
    public void mergeSettings( DhElement eSrc, boolean overWrite ) {}
    
    /**
     * Called when an instance is created from an existing HTML element. 
     * @param peer The existing peer element
     */
    protected void initFromPeer(IHTMLElement peer) {}
    
    
    
    

    /**
     * Assigns a delegate to the readyStateChange event.   
     * 
     * @param h The EventHandler delegate to call on this event
     */
    public final void addOnReadyStateChange(ReadyStateEventHandler h) {}

    public final void addOnError(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the readyStateChange event.
     * 
     * @param h The EventHandler delegate to call on this event
     */        
    public final void removeOnReadyStateChange(ReadyStateEventHandler h) {}

    
    public final void removeOnError(EventHandler h) {}

/**
 * Creates an object from an existing ActiveX/COM or Java object and adds it to the  document. 
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo classid =
                                                  new PropertyInfo(DhObjectFactory.class, "classid", String.class,
                                                                   CategoryAttribute.Behavior,
                                                                   DefaultValueAttribute.EMPTY_STRING,
                                                                   new DescriptionAttribute(Sys.getString("DhObjectFactoryClassID")));
        public static final PropertyInfo progid =
                                                 new PropertyInfo(DhObjectFactory.class, "progid", String.class,
                                                                  CategoryAttribute.Behavior,
                                                                  DefaultValueAttribute.NULL,
                                                                  new DescriptionAttribute(Sys.getString("DhObjectFactoryProgID")));
        public static final PropertyInfo codeBase =
                                                   new PropertyInfo(DhObjectFactory.class, "codeBase", String.class,
                                                                    CategoryAttribute.Behavior,
                                                                    DefaultValueAttribute.EMPTY_STRING,
                                                                    new DescriptionAttribute(Sys.getString("DhObjectFactoryCodeBase")));
        public static final PropertyInfo codeClassName =
                                                        new PropertyInfo(DhObjectFactory.class, "codeClassName", String.class,
                                                                         CategoryAttribute.Behavior,
                                                                         DefaultValueAttribute.EMPTY_STRING,
                                                                         new DescriptionAttribute(Sys.getString("DhObjectFactoryCodeClassName")));

        public static final EventInfo click = new EventInfo(DhElement.ClassInfo.click,
                                                                BrowsableAttribute.NO);
        public static final EventInfo doubleClick = new EventInfo(DhElement.ClassInfo.doubleClick,
                                                                BrowsableAttribute.NO);
        public static final EventInfo dragStart = new EventInfo(DhElement.ClassInfo.dragStart,
                                                                BrowsableAttribute.NO);
        public static final EventInfo error = new EventInfo(
                                                            DhObjectFactory.class,"error", EventHandler.class,
                                                            CategoryAttribute.Behavior);
        public static final EventInfo filterChange = new EventInfo(DhElement.ClassInfo.filterChange,
                                                                BrowsableAttribute.NO);
        public static final EventInfo help = new EventInfo(DhElement.ClassInfo.help,
                                                                BrowsableAttribute.NO);
        public static final EventInfo keyDown = new EventInfo(DhElement.ClassInfo.keyDown,
                                                                BrowsableAttribute.NO);
        public static final EventInfo keyPress = new EventInfo(DhElement.ClassInfo.keyPress,
                                                                BrowsableAttribute.NO);
        public static final EventInfo keyUp = new EventInfo(DhElement.ClassInfo.keyUp,
                                                                BrowsableAttribute.NO);
        public static final EventInfo mouseDown = new EventInfo(DhElement.ClassInfo.mouseDown,
                                                                BrowsableAttribute.NO);
        public static final EventInfo mouseEnter = new EventInfo(DhElement.ClassInfo.mouseEnter,
                                                                BrowsableAttribute.NO);
        public static final EventInfo mouseLeave = new EventInfo(DhElement.ClassInfo.mouseLeave,
                                                                BrowsableAttribute.NO);
        public static final EventInfo mouseMove = new EventInfo(DhElement.ClassInfo.mouseMove,
                                                                BrowsableAttribute.NO);
        public static final EventInfo mouseUp = new EventInfo(DhElement.ClassInfo.mouseUp,
                                                                BrowsableAttribute.NO);
        public static final EventInfo readyStateChange = new EventInfo(
                                                                       DhObjectFactory.class,"readyStateChange", ReadyStateEventHandler.class,
                                                                       CategoryAttribute.Behavior);
        public static final EventInfo selectStart = new EventInfo(DhElement.ClassInfo.selectStart,
                                                                BrowsableAttribute.NO);

        public void getProperties(IProperties props) {}

        public void getEvents(IEvents events) {}
    }
}