//STRIPPEDSOURCE//
package com.ms.wfc.html;
import com.ms.wfc.html.om.*;
import com.ms.com.Variant;
import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhEventID;
import com.ms.wfc.html.event.DhOptionButtonListener;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.lang.Delegate;


/**
 * Implements an intrinsic HTML radio button control with a text label.   Radio button groups
 * allow for mutually-exclusive choices from a list of options.
 *
 *
 * @security(checkClassLinking=on)
 */
public class DhRadioButton extends DhBaseContainer { 
    private         DhInnerRadioButton      m_radio;
    private         DhText                  m_text;
    
    
    int             m_align = LeftRightAlignment.RIGHT;
    
    /**
     * Default ctor creates a blank DhRadioButton with no check or text label.  Set the values
     * to initialize them.
     */
    public DhRadioButton() {}

    /**
     * Constructs a RIGHT aligned radio button.
     * @param strText the label text to display with the button
     * @param fChecked the initial checked state of the button.
     */
    public DhRadioButton( String strText, boolean fChecked ) {}

    /**
     *@internalonly
     */
    protected int getTagNameID() {}

    /**
     * @internalonly
     */
    protected void setParent(DhElement parent){}

    
    /** 
     * Sets the enabled state of the button. 
     * @param f Boolean defining the enabled state--default it <b>true</b>
     */
    public void setEnabled(boolean f) {}

    /**
     * Retrieves the enabled state of the button. 
     *
     * @param The current caption String.
     */
    public boolean getEnabled(){}
    /**
     * Sets the selected state of the radio button.   If this button is bound, and is a
     * member of a group, setting its value may affect other DhRadioButton items in the group.
     * 
     * @param fValue True to add the check, false to clear it.
     * @see  #setSubmitName
     * @see  #getSubmitName
     */
    public void setChecked( boolean fValue ) {}

    /**
     * Retrieves the selected state of the radio button. 
     *
     * @return True if the button is checked, false if not.
     */
    public boolean getChecked() {}

    public void setName( String n ) {}

    public String getName( ) {}

    /**
     * Sets the text label of the button. 
     *
     * @param strText the label of the button.
     */
    public void   setText( String strText ) {}

    /**
     * Retrieves the current text label for the radio button. 
     *
     * @return The text label.
     *
     */      
    public String getText( ) {}
    
    
    /**
     * Retrieves the current alignment.   Can be RIGHT or LEFT.
     *
     * @return The current alignment, from LeftRightAlignment.
     */
    public int getTextAlign() {}

    /**
     * Sets the current alignment. 
     * <p>Example:
     * <pre>
     *  RIGHT: <SPAN FOR=rbox><INPUT ID=rbox TYPE="RADIO" VALUE=1  NAME="ex" CHECKED>Right Aligned Label</SPAN>
     *  LEFT:  <SPAN FOR=rbox2>Left Aligned Label<INPUT ID=rbox2 NAME="ex" TYPE="RADIO" VALUE=2></SPAN>
     * </pre>
     *
     * @param newAlignment LeftRightAlignment.LEFT or LeftRightAlignment.RIGHT
     * @see com.ms.wfc.ui.LeftRightAlignment
     */

    public void setTextAlign( int newAlignment ) {}

    /** 
     * Sets the submit name for this radio button.   DhRadioButtons within the same group
     * are mutally exclusive.  That is, only one can be selected at a given time.  Additionally,
     * group names are used for HTTP form submission.  This property represtents the HTML 'name' 
     * attiribute.  
     * 
     * <p>Note: the <i>strName</i> cannot have spaces, otherwise a com.ms.wfc.core.WFCInvalidArgumentException is thrown
     *
     * @param strName The group name.  Group names must be unique per document.
     * @exception com.ms.wfc.core.WFCInvalidArgumentException If there is a space in the name.
     */
    public void setSubmitName( String strName ) {}

    /**
     * Retrieves the submit name for this radio button control.   The submit name denotes which groups of
     * radio buttons are connected.  Only one DhRadioButton in a group can be selected at a time.
     *
     * @return The group name.
     * @see #setSubmitName
     */
    public String getSubmitName( ) {}

    /** 
     * Sets the submit value for this radio button.   DhRadioButtons within the same group
     * are mutally exclusive.  That is, only one can be selected at a given time, and the selected
     * item's value will be transmitted in the HTTP submit string as [<i>SubmitName</i>]=[<i>SubmitValue</i>]
     *
     * @param strName The group name.  Group names must be unique per document.
     */
    public void setSubmitValue( String strValue ) {}

    /**
     * Retrieves the submit value for this radio button control.   
     *
     * @return The group name.
     * @see #setSubmitValue
     */
    public String getSubmitValue( ) {}

    
    /**
     * Sets the input focus to this control.  */
    public void focus() {}

    
    

    
    /**
     * Set a specific event handler for this element. Most the of the common event handlers
     * have a more direct way of setting the event handler. This method is exposed for
     * cases not covered by the direct set methods.
     *
     * @see #addOnClick
     * @see #addOnKeyPress
     *
     * @param id The instance of an <a href="com.ms.wfc.html.event.DhEventID.html">event id</a> of the specific 
     * event you want to sink. See <a href="com.ms.wfc.html.event.DhEvents.html">DhEvents</a>
     * for some of the possible IDs.
     * @param handler The <a href="com.ms.wfc.html.EventHandler.html">EventHandler</a> callback
     * method to invoke every time the specific event is triggered.
     */
    protected void addEventHandler( Object id, Delegate handler ) {}
    
    /**
     * Appends the event handlers of the element passed in as a parameter, to this
     * element's event handler list.
     * 
     * @param   e  DhElement containing the event handler list to be added to this element.
     */
    public void appendEventHandlers(DhElement e) {}
    
    /**
     * Removes a specific event handler, which will no longer be called when the specified
     * event occurs.  Most DhEvents have a specialized remove method which is a more direct
     * way of removing the event handler.  This method is exposed for
     * cases not covered by the direct remove methods.
     *
     * @see #removeOnClick
     * @see #removeOnKeyPress
     *
     * @param id The instance of an <a href="com.ms.wfc.html.event.DhEventID.html">event id</a> of the specific 
     * event you want to stop sinking. See <a href="com.ms.wfc.html.event.DhEvents.html">DhEvents</a>
     * for some of the possible IDs.
     * @param handler The <a href="com.ms.wfc.html.EventHandler.html">EventHandler</a> callback
     * method which should no longer be invoked when the specific event is triggered.
     */
    protected void removeEventHandler(Object id, Delegate handler) {}

    /**
     * @internalonly
     */
    public  void add(DhElement element, DhElement relativeTo, int insertFlag ) {}

    /**
     * @internalonly
     */     
    public   void add(DhElement element, DhElement relativeTo ) {}

    /**
     * @internalonly
     */     
    public   void add(DhElement element ) {}

    /**
     * @internalonly
     */     
    protected void addWashed( DhElement e, DhElement relTo, int insertFlag ) {}

    
    private void ensureText() {}

    private void ensureRadio() {}
    
    private void handleClick(Object sender, com.ms.wfc.core.Event e) {}

    /**
     * @hidden
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    /**
     * @hidden
     * @internalonly
     */
    protected void init( DhParseInfo ph ) {}

    /** 
     * Sets the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element's contents change.
     */
    final public void addOnChange   ( EventHandler h ) {}
    
    /** 
     * Assigns a delegate to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void addOnResize(EventHandler h) {}

    /**
     * Assigns a delegate to the select event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void addOnSelect( EventHandler h ) {}
    
    /**
     * Removes the <a href="com.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element's contents change
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void removeOnChange (EventHandler h) {}
    
    /** 
     * Removes the handler for the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnGotFocus(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnLostFocus(EventHandler h) {}
    
    
    /**
     * Add a handler to be called when the selected state of the button is changed.
     * @param h A DhEventHandler delegate
     */
    final public void addOnCheckedChanged   ( EventHandler h ) {}
    
    /**
     * Remove a handler to be called when the selected state of the button is changed.
     * @param h A DhEventHandler delegate
     */    
    final public void removeOnCheckedChanged (EventHandler h ){}
    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void removeOnResize(EventHandler h) {}
    /**
     * Removes the delegate that is assigned to the select event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is selected
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void removeOnSelect(EventHandler h) {}
    
    /**
     *  @internalonly
     */
    public void setElementPeer( IHTMLElement peer ){}
    
    
    
    private final IHTMLElement findLabelText( IHTMLElement inputPeer ){}
    
    
    /**
     * Implements an intrinsic HTML radio button control with a text label. 
     * @hidden
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo enabled =
                                                  new PropertyInfo(DhRadioButton.class, "enabled", Boolean.TYPE,
                                                                   CategoryAttribute.Appearance,
                                                                   DefaultValueAttribute.TRUE,
                                                                   new DescriptionAttribute(Sys.getString("DhRadioButtonEnabled")));
        
        public static final PropertyInfo value =
                                                new PropertyInfo(DhRadioButton.class, "checked", Boolean.TYPE,
                                                                 CategoryAttribute.Behavior,
                                                                 DefaultValueAttribute.FALSE,
                                                                 new DescriptionAttribute(Sys.getString("DhRadioButtonChecked")));
        public static final PropertyInfo text =
                                               new PropertyInfo(DhRadioButton.class, "text", String.class,
                                                                CategoryAttribute.Behavior,
                                                                new DescriptionAttribute(Sys.getString("DhRadioButtonText")));
        public static final PropertyInfo submitName =
                                                     new PropertyInfo(DhRadioButton.class, "submitName", String.class,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.EMPTY_STRING,
                                                                      new DescriptionAttribute(Sys.getString("DhRadioButtonSubmitName")));
        public static final PropertyInfo submitValue =
                                                      new PropertyInfo(DhRadioButton.class, "submitValue", String.class,
                                                                       CategoryAttribute.Behavior,
                                                                       new DefaultValueAttribute(new String("on")),
                                                                       new DescriptionAttribute(Sys.getString("")));
        public static final EventInfo gotFocus = new EventInfo(
                                                               DhRadioButton.class,"gotFocus",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(
                                                                DhRadioButton.class,"lostFocus",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(
                                                                DhRadioButton.class,"resize",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo select =
                                              new EventInfo(DhRadioButton.class, "select", EventHandler.class,
                                                            CategoryAttribute.Action,
                                                            new DescriptionAttribute(Sys.getString("DhCheckBoxSelect")));
        
         public static final EventInfo change =
                                              new EventInfo(DhRadioButton.class, "checkedChanged", EventHandler.class,
                                                            CategoryAttribute.Action,
                                                            new DescriptionAttribute(Sys.getString("DhCheckBoxChange")));
        

        public void getProperties(IProperties props) {}

        public void getEvents(IEvents events) {}
    }
}


class DhInnerRadioButton extends DhButtonBase { 
    DhRadioButton container;

    public DhInnerRadioButton() {}

    
    public DhInnerRadioButton(DhRadioButton container) {}

    public DhInnerRadioButton( DhRadioButton container, boolean fChecked ) {}

    protected int buttonType(){};

    public void setParent( DhElement parent ){}


    public void setValue( boolean fChecked ) {}
    
    public boolean getValue() {}

    public void setSubmitName( String s ) {}

    public String getSubmitName( ) {}

    public void setSubmitValue( String s ) {}

    public String getSubmitValue( ) {}

    protected DhEvents createEvents() {}
    
    /**
     * @hidden
     * @internalonly
     */
    public DhElement getEventSender() {}
}