//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;

/**
 * Implements a reset button control for HTTP form submission.  The reset button resets the state
 * of all controls on the form back to their initial values.
 * 
 * Adding a DhResetButton to a DhForm object will cause the DhForm to represent an HTML form
 * element
 *
 * @see com.ms.wfc.html.DhForm
 *
 * @security(checkClassLinking=on)
 */
public class DhResetButton extends DhButtonBase { 
    /**
     * The default ctor creates a DhResetButton with the caption "Reset"
     */
    public DhResetButton() {}

    /**
     * Creates a DhResetButton with the specified caption
     */
    public DhResetButton( String caption ) {}

    /**
     * @internalonly
     */
    protected int buttonType(){}

    /**
     * Sets the button caption. 
     * @param strCaption The new caption String
     */
    public void setText( String strCaption ) {}

    /**
     * Retrieves the button's current text caption. 
     * @return The button caption.
     */
    public String getText() {}

/**
 * Implements a reset button control for HTTP form submission.
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
        public static class ClassInfo extends DhButtonBase.ClassInfo {
            public static final PropertyInfo text =
                                                   new PropertyInfo(DhResetButton.class, "text", String.class,
                                                                    new DefaultValueAttribute(Sys.getString("DhResetButtonDefaultText")),
                                                                    CategoryAttribute.Appearance,
                                                                    new DescriptionAttribute(Sys.getString("DhResetButtonText")));

            public void getProperties(IProperties props) {}
        }
}