//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.*;
import com.ms.wfc.html.event.DhControlElementListener;
import com.ms.wfc.html.event.DhEvents;

import com.ms.com.Variant;

import com.ms.wfc.core.*;

/**
 * Implements a row in a DhTable table.&nbsp; ms.wfc.html.DhTable.html>table</a> row. 
 * Make sure to see the <a href="commshtml_ovr.html#tables">overview</a> 
 * for working with tables. 
 *
 * @security(checkClassLinking=on)
 */
public class DhRow extends DhBaseContainer { 
    /**
     * Creates an DhStringIDs.EMPTY row.
     */
    public DhRow() {}

    /**
     *@internalonly
     */
    protected int getTagNameID() {}

    /**
     *@internalonly
     */
    protected void makePeer(IHTMLElement parentPeer,boolean fInsert,DhElement relativeTo,int insertFlag) {}

    /**
     * Adds a cell to end of this row. 
     *
     * @param cell The <a href="com.ms.wfc.html.DhCell.html">cell</a> to add to this row.
     */
    public void add(DhCell cell) {}
    
    /**
     * @internalonly
     */
    protected void regenerate() {}
    
    /**
     *  Removes an cell from this row. 
     * @param The <a href="com.ms.wfc.html.DhCell.html">cell</a> to remove from this row.
     */
    public void remove( DhCell cell ){}

    /**
     * Returns the cell at the specified ordinal position. 
     * @param nCol The ordinal column position
     * @return The cell at position <i>nCol</i>
     */
    public DhCell getCell( int nCol ){}
    
    /**
     * Returns the array of cells in this row. 
     * @return An array of cells contained within this row  
     */
    public DhCell[] getCells(){}

    /**
     * Returns the number of columns in this row. 
     * @return The number of columns.
     */
    public int getColumnCount(){}

    
    /**
     * Retrieves the ordinal record number displayed by the current row. 
     * @return The corresponding absolute record number to this row.
     */
    public int getRecordNumber() {}
    
    /**
     *  Retrieves the row number for this row if it is currently within a table. 
     * @return The row number, or <b>-1</b> if the row is not in a table body.
     */
    public int getRowNumber(){}


    /**
     Adds a cell to end of this row. 
     * @internalonly
     */
    protected void add(DhElement e) {}        
    
    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    /** 
     * Assigns a delegate to the gotFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void addOnResize( EventHandler h ) {}

    /** 
     * Removes the delegate that is assigned to the gotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void removeOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Removes the delegate that is assigned to the lostFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void removeOnLostFocus    ( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized.
     *
     * @param h The event handler callback method.
     */
    public final void removeOnResize( EventHandler h ) {}

    /**
     * @hidden 
     * @internalonly 
     */
    protected int removeWashed( DhElement element ){}

    


        /**
         * Implements a row in a DhTable table.&nbsp; 
         * @hidden
         * @internalonly
         *
         * @security(checkClassLinking=on)
         */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo columnCount =
                                                      new PropertyInfo(DhRow.class, "columnCount", Integer.TYPE,
                                                                       CategoryAttribute.Appearance,
                                                                       new DescriptionAttribute(Sys.getString("DhRowColumnCount")));

        public static final EventInfo gotFocus = new EventInfo(DhRow.class,
                                                               "gotFocus", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(DhRow.class,
                                                               "lostFocus", EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(DhRow.class,
                                                               "resize", EventHandler.class,
                                                               CategoryAttribute.Behavior);

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }
}



class DhHeaderFooterRow extends DhBaseContainer {
    
    int mode;
    static final int HEADER = 0;
    static final int FOOTER = 1;
    
    public DhHeaderFooterRow(){};

    public DhHeaderFooterRow( DhTable parent, DhRow r, int type ){}
    
    public void addToParent( DhTable parentTable ){}
    
    protected void makePeer(IHTMLElement parentPeer,boolean fInsert,DhElement relativeTo,int insertFlag) {}
    
    

    public void setRow( DhRow r ){}

    public DhRow getRow(){}

    protected int getTagNameID() {}

    protected void add( DhElement e ){}
    
    protected int remove( DhRow r ){}
    
    protected int removeWashed( DhElement element ){}
    
     /**
     * @internalonly
     */
    protected  void regenerate() {}

}





class DhHeaderRow extends DhHeaderFooterRow{
    DhHeaderRow(){}
}



class DhFooterRow extends DhHeaderFooterRow{
    
    DhFooterRow(){}
}