//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.*;
import com.ms.com.Variant;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhSelectListener;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;

/**
 * Represents the base class for the DhComboBox  and DhListBox controls.  
 * It is not intended to be instantiated. 
 *
 * @security(checkClassLinking=on)
 */
public abstract class DhSelectBox extends DhBaseContainer { 
    
    /**
     * @internalonly
     */
    protected DhSelectBox( ) {}
    
    /**
     * @internalonly
     */
    protected int getTagNameID() {}       

    /** 
     * Sets the enabled state of the element. 
     * @param f Boolean defining the enabled state--default it <b>true</b>
     */
    public void setEnabled(boolean f) {}

    /**
     * Retrieves the enabled state of the element. 
     *
     * @param The current caption String.
     */
    public boolean getEnabled(){}

    /**
     *@internalonly
     */
    protected DhEvents createEvents() {}
    
    /** 
     * Assigns a delegate to the gotFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h A EventHandler to be invoked when this element receives input focus
     */
    public final void addOnGotFocus  ( EventHandler h ) {}
    
    /**
     * Assigns a delegate to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h The event handler callback method.
     */
    public final void addOnLostFocus    ( EventHandler h ) {}



    /**
     * Adds a delegate to the selectIndexChanged event.
     * @param h The event handler for the change event
     */
    final public void addOnSelectedIndexChanged    ( EventHandler h ) {}

    /**
     * Assigns a delegate to the resize event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void addOnResize(EventHandler h) {}
 
    /** 
     * Removes the delegate that is assigned to the onGotFocus event. ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when the current element receives input focus.    
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnGotFocus(EventHandler h) {}
    
    /**
     * Removes the delegate that is assigned to the lostFocus event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element loses focus
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    public final void removeOnLostFocus(EventHandler h) {}

    /**
     * Removes the delegate that is assigned to the selectedIndexChanged event.
     * @param h The event handler for the change event
     */    
    final public void removeOnSelectedIndexChanged    ( EventHandler h ) {}

    /**
     * Removes the delegate that is assigned to the resize event.ms.wfc.html.EventHandler.html">event handler</a> method callback
     * that is triggered when this element is resized
     *
     * @param h  The EventHandler delegate to call on this event 
     */
    final public void removeOnResize(EventHandler h) {}
 
    /**
     * Retrieves the number of items currently in the list. 
     * @return Number of items
     */
    public int getItemCount() {}
    
    /**
     * Adds an item to the end of the list. 
     * @param strText The text for the new item
     */
    public void addItem( String strText ) {}

    /**
     * Adds an item to the end of the list. 
     * @param strText The text for the new item
     * @param fSelected Sets the item's selected state
     */
    public void addItem( String strText, boolean fSelected ) {}

    /**
     * Adds an item to the end of the list. 
     * @param strText The text for the new item
     * @param fSelected Sets the item's selected state
     * @param strValue Sets the VALUE attribute for this item.  This is useful for HTTP form submit strings.
     */
    public void addItem( String strText, boolean fSelected, String strValue ) {}       

    /**
     * Inserts an item into the list at the selected index. 
     *
     * @param index Zero-based index at which to add new item
     * @param strText The text for the new item
     */
    public void insertItem( int index, String strText ) {}

    /**
     * Inserts an item into the list at the selected index. 
     *
     * @param index Zero-based index at which to add new item
     * @param strText The text for the new item
     * @param fSelected The selected state of the new item
     */
    public void insertItem( int index, String strText, boolean fSelected ) {}
    
    /**
     * Inserts an item into the list at the selected index. 
     *
     * @param index Zero-based index at which to add new item
     * @param strText The text for the new item
     * @param strValue The value attribute for this item.  Used for HTTP form submissions.
     */
    public void insertItem( int index, String strText, boolean fSel, String strValue ) {}

    /**
     * Updates the attributes of a particular item.   If index does not correspond to an item currrently
     * in the list, a new item with the specified attributes is added to the list. 
     * <P> Specifing a parameter as null will leave its value unchanged.  Use "" to clear a string value.
     *
     *
     * @param index The index of the item to be updated.
     * @param strText The new text of the item
     * @param fSel The new selected state of the item
     * @param strValue The new value attribute of the item (for HTTP form submissions)
     */
    public void setItem( int index, String strText, boolean fSel, String strValue ) {}
    
    /**
     * Sets the items in the list.  This will replace all existing items in the box
     * @param strings An array of String items to set into to the box
     */
    public final void setItems( String[] strings ){}
    
    /**
     * Sets the items in the list.  This will replace any exisiting items in the box
     * @param strings An array of String items to set into to the DhListBox or DhComboBox
     * @param selected an array of boolean items specifying if the corresponding items are to be selected     
     */
    public final void setItems( String[] strings, boolean[] selected ){}

    /**
     * Sets the items in the list.  This will replace any exisiting items in the box
     * @param strings An array of String items to set into to the box
     * @param selected An array of boolean items specifying if the corresponding items are selected     
     * @param submitValues An array of String items to set as the submitValues of the corresponding items
     */
    public final void setItems( String[] strings, boolean[] selected, String[] submitValues ){}


    /**
     * Sets the text attribute of the specified item.  If index is a value out of the list's range,
     * an WFCInvalidArgumentException is thrown.
     *
     * @param index The zero-based index of the item
     * @param strText The new text for the item
     * @exception WFCInvalidArgumentException if index is not a valid item.
     */
    public void setItemText( int index, String strText ) {}

    /**
     * Retrieves the text for the item at the specified index.  Use -1 to get the text of the currently selected item.  
     * @param index the zero-based index of the item that you want the text for, or -1 for the currently selected item.
     * @return The text of the item indicated by index, or "" if -1 is used and no item is selected
     */
    public  String getItemText( int index ) {}
    
    /**
     * Retrieves an array of the text items in the list. 
     * @return A String[] of the items, or <b>null</b> if there are none
     */
    public String[] getItemsText(){}
    
    /**
     *  Retrieves the text for the currently selected item.
     * @return The text of the item, or "" if no item is selected
     */
    public String getText(){}
    
    /**
     * Updates the value attribute of an item.
     *
     * @param index The index of the referenced item
     * @param strValue The new value string
     * @throws WFCInvalidArgumentException if index is not in the list.
     */
    public void setItemSubmitValue( int index, String strValue ) {}

    /**
     * Retrieves the submit value for the item at index.  The submit value is used in HTTP form submissions.  
     * @param index the zero-based index of the item that you want the submit value for, or -1 for the currently selected item.
     * @return the submit value string for the item index.
     */
    public String getItemSubmitValue( int index ) {}
    
    /**
     * Retrieves an array of text items corresponding to the submit value of the items in the
     * list. 
     * @return A String[] of the items submit values, or an empty array if there are none
     */
    public String[] getItemsSubmitValue(){}
    
    
    /**
     *  Retrieves the value for the selected item.  If multiple items are selected, it returns
     *  the value from the first selected item.
     * @return The submit value of the first selected item, of "" if none is selected.
     */
    public String getSelectedSubmitValue(){}
    
    /**
     * Removes an indexed item from the list. 
     *
     * @param index Index of the item user wishes to remove.
     */
    public void removeItem( int index ) {}

    /**
     * Removes all items from the control. 
     */
    public void removeAll() {}

    /**
     * Retrieves the index of the currently selected item.   For multiple select
     * DhListBoxes, it is the first selected item.  To retrieve any other selected items,
     * iterate over the list using <a href="com.ms.wfc.html.DhSelectBox.isSelected">isSelected()</a>.
     *
     * @return The index (zero-based) of the first selected item.
     * @see #isSelected
     */
    public int getSelectedIndex() {}

    /**
     * Retrieves the current selected state of an item.   Returns false if index does not
     * correspond to an item in the list.
     *
     * @param Zero-based index of item to query.
     */
    public boolean getSelected( int index ) {}
    
    /**
     * Retrieves an array that contains the zero-based indices of all currently selected items.
     * @return Returns an integer array containing the zero-based indices of all currently selected items. 
     * In a single-selection list box, returns an array containing a single element. 
     * If there are no selected items in the list box, returns an empty array. 
     */
    public int [] getSelectedIndices(){}

    /**
     * Sets the selected state of a particular item in the list.   If the list is multiple-select
     * enabled, this item will not affect other selected items.  Otherwise, other selection(s) will be
     * cleared.
     *
     * @param index Zero-based index of the item to update
     * @param value true to select, false to clear.
     */
    public void setSelected( int index, boolean value ) {}
    
    /**
     * Sets the current selected index. 
     * @param index The zero-based index of the item to select
     */
    public void setSelectedIndex( int index ){}

    /**
     * Sets the name of the select box.   This is used for HTTP form submissions and represents
     * the HTML 'name' attribute.
     * 
     * @param strName The name to be transmitted for the select box.
     */
    public void setSubmitName( String strName ) {}

    /**
     * Retrieves the name of the select box.   The name attribute is used for HTTP form submissions.
     *
     * @return The name of the select box.
     * @see #setSubmitName
     */
    public String getSubmitName( ) {}       
    
    /**
     * Finds the first item in the list that starts with the specified string. 
     * @param s The string to match. Any string that begins with the specified characters is considered a match. 
     * @return Returns the zero-based index of the item found; returns -1 if no match is found 
     */
    public int findString( String s ){}
    
    /**
     * Finds the first item in the list that starts with the specified string.
     * @param s The string to match. Any string that begins with the specified characters is considered a match. 
     * @param startIndex The zero-based index of the item before the first item to be searched. Set to -1 to search from the beginning of the list box. 
     * @return Returns the zero-based index of the item found; returns -1 if no match is found 
     */    
    public final int findString( String s, int startIndex ){}
    
    /**
     * Finds the first item in the list that matches the specified string exactly. 
     * @param s The string to match.
     * @return Returns the zero-based index of the item found; returns -1 if no match is found 
     */
    public int findStringExact( String s ){}
    
    /**
     * Finds the first item in the list that matches the specified string exactly.
     * @param s The string to match.
     * @param startIndex The zero-based index of the item before the first item to be searched. Set to -1 to search from the beginning of the list box. 
     * @return Returns the zero-based index of the item found; returns -1 if no match is found 
     */    
    public final int findStringExact( String s, int startIndex ){}
    
    private final int findStringInternal( String s, int startIndex, boolean exact ){}
    
    
    /**
     * Sets the input focus to this control.  */
    public void focus() {}
    
    void setStyle( int key, String value ){}
    
    
    int removeWashed(DhElement element) {}

    /**
     * @hidden
     * @internalonly
     */
    public void add(DhElement element ) {}

/**
 * Represents the base class for the DhComboBox  and DhListBox controls. 
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo submitName =
                                                     new PropertyInfo(DhSelectBox.class, "submitName", String.class,
                                                                      CategoryAttribute.Behavior,
                                                                      new DescriptionAttribute(Sys.getString("DhSelectBoxSubmitName")));
        public static final EventInfo selectedIndexChanged =
                                                       new EventInfo(DhSelectBox.class, "selectedIndexChanged", EventHandler.class,
                                                                     CategoryAttribute.Action,
                                                                     new DescriptionAttribute(Sys.getString("DhSelectBoxSelectionChange")));
        public static final EventInfo gotFocus = new EventInfo(
                                                               DhSelectBox.class,"gotFocus",EventHandler.class,
                                                               CategoryAttribute.Behavior);
        public static final EventInfo lostFocus = new EventInfo(
                                                                DhSelectBox.class,"lostFocus",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        public static final EventInfo resize = new EventInfo(
                                                                DhSelectBox.class,"resize",EventHandler.class,
                                                                CategoryAttribute.Behavior);
        
        public static final PropertyInfo enabled =
                                                      new PropertyInfo(DhSelectBox.class, "enabled", Boolean.TYPE,
                                                                       DefaultValueAttribute.TRUE,
                                                                       CategoryAttribute.Appearance,
                                                                       new DescriptionAttribute(Sys.getString("DhSelectBoxEnabled")));
            
          


        public void getProperties(IProperties props) {}
        public void getEvents(IEvents events) {}
    }
}


class DhSelectListItem extends DhElement implements DhStringIDs  {
    public  String                m_text;
    
    
    
    public DhSelectListItem() {}

    public DhSelectListItem( String strText, boolean fSel, String strVal ) {}

    protected int getTagNameID(){}
    
    public String getValue() {}

    public void setValue( String v ) {}
    
    public void setText( String s ){}
    
    public String getText(){}
    
    protected StringBuffer getContent( StringBuffer sb ){}
    
    public void setSelected( boolean fSel ){}

    public boolean getSelected(){}
    
    protected void makePeer(IHTMLElement parentPeer,boolean fInsert,DhElement relativeTo,int insertFlag) {}
    
    
    protected IHTMLElement getElementPeer(){}
    
    protected void initFromPeer( IHTMLElement peer ){}
    
}