//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.html.om.IHTMLRuleStyle;
import com.ms.wfc.html.om.IHTMLStyle;
import com.ms.wfc.html.om.IHTMLStyleSheetRule;
import com.ms.com.*;

/**
 * Represents a collection of properties that can be freely applied to any element. <p>
 * The fundamental usage scenario for this class is to create instances of this
 * class and apply them liberally using 
 * <a href="com.ms.wfc.html.DhElement.html#setStyle">setStyle</a>.
 * <p>Make sure to check out the <a href="commshtml_ovr.html#styles">overview</a> 
 * of using and applying styles.
 *
 * @security(checkClassLinking=on)
 */
public class DhStyle extends DhStyleBase { 
    private IHTMLStyleSheetRule     m_ssrulePeer;
    private IHTMLRuleStyle          m_ruleStylePeer;
    private String                          m_name;

    /**
     *@internalonly
     */
    protected DhStyle(IHTMLStyleSheetRule ssrule) {}

    /**
     * You are welcome to "name" your style and therefore control the underlying HTML
     * that is generated by this object, however this is completely handled in the 
     * default empty constructor case for you.
     *
     * @see #DhStyle()
     * @param name Name of style to use for underlying HTML generation.
     */
    public DhStyle(String name) {}

    private static int sm_nextname;

    /**
     * Use this constructor to create the default style object.
     */
    public DhStyle() {}

    /**
     * Retrieves the underlying name for this style object as seen by the HTML object.  This
     * is a very advanced feature and is not part of the normal usage scenarios.
     *
     * @return The string name of the style rule.
     */
    public String getName() {}

    /**
     * Sets the underlying name for the style object as seen by the HTML object.  This
     * is a very advanced feature and is not part of the normal usage scenarios.
     *
     * @param name The string name of the style rule.
     */
    public void setName(String name) {}

    protected IHTMLRuleStyle getRuleStylePeer() {}

    protected void setRuleStylePeer( IHTMLRuleStyle peer ) {}


    
    
    
    
    /**
     *@internalonly
     */
    protected IHTMLStyle getStylePeer(){}

    void setStylePeerAttribute( String attrName, Variant attrValue, int flags ){}

    Variant getStylePeerAttribute( String attrName, int flags ){}

    boolean removeStylePeerAttribute( String attrName, int flags ){}

    
    
    

    /**
     * @internalonly
     */      
    protected void setStylePeerNull() {}
    
    /**
     * @internalonly
     */ 
    protected boolean haveStylePeer() {}

    
    /**
     * @internalonly
     */ 
    protected String getPeerCssText() {}

    
    /**
     * @internalonly
     */ 
    protected void setPeerCssText(String css) {}       
    

    /**
     * Represents a collection of properties that can be freely applied to any element. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends DhStyleBase.ClassInfo {
    }
}