//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;
import com.ms.wfc.ui.*;
import com.ms.wfc.ax.*;
import com.ms.com.*;

import com.ms.com.Variant;
import com.ms.lang.Delegate;
import com.ms.wfc.html.om.IHTMLStyle;
import com.ms.wfc.html.om.IHTMLRuleStyle;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLStyle;
import com.ms.wfc.util.List;
import java.util.StringTokenizer;



/**
 * Provides the superclass for classes that support  styles, such as DhStyle and DhElement objects.  Classes that extend DhStyleBase
 * are said to have certain typographic and other visual
 * properties such as "colors", "fonts", etc.
 * This class is <b>abstract</b> and therefore cannot be instantiated.
 *
 * @see #DhStyle
 * @see #DhElement 
 *
 * @security(checkClassLinking=on)
 */
public abstract class DhStyleBase extends com.ms.wfc.core.Component { 
    public final int UNINITIALIZED = DhStringIDs.EMPTY;
    int m_defaultUnit;

    static DhSynchronizer s_dhsync = new DhSynchronizer();
    
    /**
     *@internalonly
     */
    public DhStyleBase() {}

    /**
     * @internalonly
     */ 
    public DhStyleBase(int unit) {}


    /**
     *@internalonly
     */
    public static boolean OK_TO_CACHE_STYLES = false;

    private static String colorTable = 
                                      " ALICEBLUE=F0F8FF ANTIQUEWHITE=FAEBD7 AQUA=00FFFF AQUAMARINE=7FFFD4 AZURE=F0FFFF BEIGE=F5F5DC BISQUE=FFE4C4 BLACK=000000 BLANCHEDALMOND=FFEBCD BLUE=0000FF BLUEVIOLET=8A2BE2 BROWN=A52A2A BURLYWOOD=DEB887 CADETBLUE=5F9EA0 CHARTREUSE=7FFF00 CHOCOLATE=D2691E CORAL=FF7F50 CORNFLOWER=6495ED CORNSILK=FFF8DC CRIMSON=DC143C CYAN=00FFFF DARKBLUE=00008B DARKCYAN=008B8B DARKGOLDENROD=B8860B DARKGRAY=A9A9A9 DARKGREEN=006400 DARKKHAKI=BDB76B DARKMAGENTA=8B008B DARKOLIVEGREEN=556B2F DARKORANGE=FF8C00 DARKORCHID=9932CC DARKRED=8B0000 DARKSALMON=E9967A DARKSEAGREEN=8FBC8B DARKSLATEBLUE=483D8B DARKSLATEGRAY=2F4F4F DARKTURQUOISE=00CED1 DARKVIOLET=9400D3 DEEPPINK=FF1493 DEEPSKYBLUE=00BFFF DIMGRAY=696969 DODGERBLUE=1E90FF FIREBRICK=B22222 FLORALWHITE=FFFAF0 FORESTGREEN=228B22 FUCHIA=FF00FF GAINSBORO=DCDCDC GHOSTWHITE=F8F8FF GOLD=FFD700 GOLDENROD=DAA520 GRAY=808080 GREEN=008000 GREENYELLOW=ADFF2F HONEYDEW=F0FFF0 HOTPINK=FF69B4 INDIANRED=CD5C5C INDIGO=4B0082 IVORY=FFFFF0 KHAKI=F0E68C" +
                                      " LAVENDER=E6E6FA LAVENDERBLUSH=FFF0F5 LAWNGREEN=7CFC00 LEMONCHIFFON=FFFACD LIGHTBLUE=ADD8E6 LIGHTCORAL=F08080 LIGHTCYAN=E0FFFF LIGHTGOLDENRODYELLOW=FAFAD2 LIGHTGREEN=90EE90 LIGHTGREY=D3D3D3 LIGHTPINK=FFB6C1 LIGHTSALMON=FFA07A LIGHTSEAGREEN=20B2AA LIGHTSKYBLUE=87CEFA LIGHTSLATEGRAY=778899 LIGHTSTEELBLUE=B0C4DE LIGHTYELLOW=FFFFE0 LIME=00FF00 LIMEGREEN=32CD32 LINEN=FAF0E6 MAGENTA=FF00FF MAROON=800000 MEDIUMAQUAMARINE=66CDAA MEDIUMBLUE=0000CD MEDIUMORCHID=BA55D3 MEDIUMPURPLE=9370DB MEDIUMSEAGREEN=3CB371 MEDIUMSLATEBLUE=7B68EE MEDIUMSPRINGGREEN=00FA9A MEDIUMTURQUOISE=48D1CC MEDIUMVIOLETRED=C71585 MIDNIGHTBLUE=191970 MINTCREAM=F5FFFA MISTYROSE=FFE4E1 MOCCASIN=FFE4B5 NAVAJOWHITE=FFDEAD NAVY=000080 OLDLACE=FDF5E6 OLIVE=808000 OLIVEDRAB=6B8E23 ORANGE=FFA500 ORANGERED=FF4500 ORCHID=DA70D6 PALEGOLDENROD=EEE8AA PALEGREEN=98FB98 PALETURQUOISE=AFEEEE PALEVIOLETRED=DB7093 PAPAYAWHIP=FFEFD5 PEACHPUFF=FFDAB9 PERU=CD853F PINK=FFC0CB PLUM=DDA0DD POWDERBLUE=B0E0E6 PURPLE=800080" +
                                      " RED=FF0000 ROSYBROWN=BC8F8F ROYALBLUE=4169E1 SADDLEBROWN=8B4513 SALMON=FA8072 SANDYBROWN=F4A460 SEAGREEN=2E8B57 SEASHELL=FFF5EE SIENNA=A0522D SILVER=C0C0C0 SKYBLUE=87CEEB SLATEBLUE=6A5ACD SLATEGRAY=708090 SNOW=FFFAFA SPRINGGREEN=00FF7F STEELBLUE=4682B4 TAN=D2B48C TEAL=008080 THISTLE=D8BFD8 TOMATO=FF6347 TURQUOISE=40E0D0 VIOLET=EE82EE WHEAT=F5DEB3 WHITE=FFFFFF WHITESMOKE=F5F5F5 YELLOW=FFFF00 YELLOWGREEN=9ACD32 ";

    
    
    
    private static String knownSystemColors =
                                             " ACTIVEBORDER ACTIVECAPTION APPWORKSPACE BACKGROUND BUTTONFACE BUTTONHIGHLIGHT BUTTONSHADOW BUTTONTEXT CAPTIONTEXT GRAYTEXT HIGHLIGHT HIGHLIGHTTEXT INACTIVEBORDER INACTIVECAPTION INACTIVECAPTIONTEXT INFOBACKGROUND INFOTEXT MENU MENUTEXT SCROLLBAR THREEDDARKSHADOW THREEDFACE THREEDHIGHLIGHT THREEDLIGHTSHADOW THREEDSHADOW WINDOW WINDOWFRAME WINDOWTEXT ";
    
    DhExtraStyles m_extraStyles;

    private  void ensureExtraStyles(){}
    
    /**
     * Executes the specified delegate on the thread that owns this element's underlying peer. Exceptions that are raised during the call will be
     * propapgated back to the caller.
     *
     * @param method A delegate that contains a method to be called in in the element's
     *               thread context.  The delegate can be an instance of EventHandler,
     *               in which case the <i>sender</i> parameter will contain this
     *               element, and the <i>event</i> parameter will contain Event.EMPTY.
     *               The delegate can also be an instance of MethodInvoker, or any
     *               other delegate that takes a void parameter list.  A call to 
     *               an EventHandler or MethodInvoker delegate will be faster than a
     *               call to another type of delegate.
     * @return the return value from the delegate being invoked, or <b>null</b>
     *         if the delegate has no return value.
     *
     * @see com.ms.wfc.app.MethodInvoker
     */
    public final Object invoke(Delegate method) {}

    /**
     * Executes the specified delegate on the thread that owns this element's underlying peer. Exceptions that are raised during the call will be
     * propapgated back to the caller.
     *
     * @param method A delegate to a method that takes parameters of the same number
     *               and type that are contained in <i>args</i>.
     * @param args   An array of objects to pass as arguments to the given method.  This
     *               can be <b>null</b> if no arguments are needed.
     * @return the return value from the delegate being invoked, or <b>null</b>
     *         if the delegate has no return value.
     */
    public final Object invoke(Delegate method, Object args[]) {}

    
    
    
    
    

    /**
     * Sets the text color (and other foreground objects). 
     *
     * @param color The new foreground color.
     */
    final public void setForeColor(Color color) {}

    /**
     * Retrieves the text foreground color property. 
     *
     * @return (Color) The current foreground color.
     */
    final public Color getForeColor() {}

    /**
     * Determines whether the foreground color will be persisted. 
     *
     * @return (boolean).
     */
    public boolean shouldPersistForeColor() {}
    
    /**
     * Resets the foreground color to the default inherited setting.  
     */
    final public void resetForeColor(){}
    
    /**
     * Sets the background color of the element.  If never set, the background color used is 
     * that of the container.
     *
     * @param color The new background color for this element.
     */
    final public void setBackColor(Color color) {}

    /**
     * Retrieves the background color property. 
     *
     * @return (Color) The current background color.
     */
    final public Color getBackColor() {}

    /**
     * Determines whether the background color will be persisted. 
     *
     * @return (boolean).
     */
    public boolean shouldPersistBackColor() {}
    
    /**
     * Resets the background color to the default inherited setting.  
     */
    final public void resetBackColor(){}

    static String makeAColor(Color color) {}

    static Color getAColor(String x) {}

    
    private static int lookupColor(String colorName) {}
    
    
    private static int mapColor(int color) {}

    
    
    
    
    

    /**
     * Sets the clipping rectangle.   Regions outside the clipping rectangle
     * will not be drawn.
     * @param r The clipping rectangle
     */
    public void setClip( Rectangle r ){}

    /**
     * Sets the clipping rectangle. 
     * @param strClip The clip string
     */
    public void setClip( String strClip ){}

    
    String getClipString(){}

    /**
     * Retrieves the current clipping rectangle.   If values are undefined or "auto",
     * <b>null</b> is returned.
     * 
     * @return A Rectangle with the current clip rect values.
     */
    public Rectangle getClipRect(){}

    /**
     * Determines whether the clipping region should be persisted. 
     *
     * @return (boolean).
     */
    public boolean shouldPersistClip() {}
    
    /**
     * Resets the clipping region to the default inherited setting.  
     */
    public void resetClip(){}
    

    
    
    
    
    
    

    private  final void ensureBorders() {}
    
    /**
     * Sets border values for all sides of the item. 
     * @param borderStyle One of the <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a> constants.
     * @param borderWidth The integer border width
     * @param borderWidthUnit One of the <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * @param borderColor The border color
     * @see com.ms.wfc.html.DhBorderStyle
     * @see com.ms.wfc.html.DhUnits
     * @see com.ms.wfc.ui.Color
     */
    public void setBorder( int borderStyle, int borderWidth, int borderWidthUnit, Color borderColor ){}

    private void setStylePeerText() {}
    
    /**
     * Sets the border width to the value and unit specified.   
     *
     * @param borderMask The border sides you want to set.  Can be any combination of DhBorders.ALL, DhBorders.LEFT, DhBorders.RIGHT, DhBorders.TOP, DhBorders.BOTTOM.
     * @param nWidth The numerical width of the border
     * @param nUnitKey The unit key to assign to the width.  See <a href="com.ms.wfc.html.DhUnits.html>DhUnits</a> for values.
     * @see com.ms.wfc.html.DhBorders
     */      
    public void setBorderWidth( int borderMask, int nWidth, int nUnitKey ) {}

    /**
     * Sets the border width to the value and unit specified.   
     *
     * @param nWidth The numerical width of the borders
     * @param nUnitKey The unit key to assign to the width.  See <a href="com.ms.wfc.html.DhUnits.html>DhUnits</a> for values.
     */      
    public void setBorderWidth( int nWidth, int nUnitKey ) {}
    
    /**
     * Sets the style to specified value constant.  
     *
     * @param borderMask The border sides you want to set.  Can be any combination of DhBorders.ALL, DhBorders.LEFT, DhBorders.RIGHT, DhBorders.TOP, DhBorders.BOTTOM.
     * @param borderStyle One of the <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a> constants.
     * @see com.ms.wfc.html.DhBorders
     * @see com.ms.wfc.html.DhBorderStyle
     */      
    public void setBorderStyle( int borderMask, int borderStyle ) {}

    /**
     * Sets the style to specified value constant.  
     *
     * @param borderKey One of the <a href="com.ms.wfc.html.DhBorderStyle.html">DhBorderStyle</a> constants.
     * @see com.ms.wfc.html.DhBorderStyle
     */      
    public void setBorderStyle( int borderKey ) {}
    
    /**
     * Sets the border color to the specified Color value. 
     * 
     * @param borderMask The border sides you want to set.  Can be any combination of DhBorders.ALL, DhBorders.LEFT, DhBorders.RIGHT, DhBorders.TOP, DhBorders.BOTTOM.
     * @param color A Color object to be the new border color.
     */
    public void setBorderColor( int borderMask, Color color ) {}

    /**
     * Sets the border color to the specified Color value. ms.wfc.html.DhColor.html">DhColor</a>.
     * 
     * @param color A Color object to be the new border color.
     */
    public void setBorderColor( Color color ) {}
    
    /**
     * Retrieves the DhBorderInfo class with information about the current
     * border state. ms.wfc.html.DhBorderInfo.html">DhBorderInfo</a> class with info about the current 
     * border state.
     * 
     * @return border information class.
     */
    public DhBorderInfo getBorderInfo() {}

    /**
     * Updates the border styles for this element. 
     *
     * @param biNew The class containing the new state of the borders.  String values are used over integer settings in the strucuture.
     */
    public void setBorderInfo( DhBorderInfo biNew ) {}
    
    /**
     * Determines whether the border settings will be persisted. 
     * @return <b>true</b> if no border settings exist.
     */
    public boolean shouldPersistBorder(){}
    
        
    /**
     * Clears the current border settings. 
     */
    public final void resetBorder(){}

    
    
    
    
    

    private  final void ensureMargins(){}

    /**
     * Sets the width of all the margins to the specified value. 
     * @param nWidth the width of the margins
     * @param nUnit  the unit of the margins, see <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a>
     */
    public void setMarginWidth( int nWidth, int nUnit ){}

    /**
     * Sets the width of all the margins to the specified value. 
     * @param nMarginMask A combination of the margins you wish to effect, see 
     * <a href="com.ms.wfc.html.DhMargins.html>DhMargins</a>.
     * @param nWidth the width of the margins
     * @param nUnit  the unit of the margins, see <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a>
     */
    public void setMarginWidth( int nMarginMask, int nWidth, int nUnit ){}

    /**
     * Retrieves a DhMarginWidthInfo class describing the current margin
     * settings for this element. ms.wfc.html.DhMarginWidthInfo.html">DhMarginWidthInfo</a> class
     * describing the current margin settings for this element
     * @return A <a href="com.ms.wfc.html.DhMarginWidthInfo.html">DhMarginWidthInfo</a> class
     */
    public DhMarginWidthInfo getMarginWidthInfo(){}

    /**
     * Sets the margins widths. ms.wfc.html.DhMarginWidthInfo.html">DhMarginWidthInfo</a> class.
     * @param <a href="com.ms.wfc.html.DhMarginWidthInfo.html">DhMarginWidthInfo</a> with settings
     */
    public void setMarginWidthInfo( DhMarginWidthInfo mwi ){}
    
    /**
     * Determines whether the margin settings will be persisted. 
     * @return <b>true</b> if no margin settings exist.
     */
    public boolean shouldPersistMargin(){}
    
    /**
     * Clears the current margin settings. 
     */
    public void resetMargin(){}

    
    
    
    
    

    private final  void ensurePaddings(){}

    /**
     * Sets the width of all paddings to the specified value. 
     * @param nWidth the width of the Paddings
     * @param nUnit  the unit of the Paddings, see <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a>
     */
    public void setPaddingWidth( int nWidth, int nUnit ){}
    
    /**
     * Sets the width of all paddings to the specified value. 
     * @param nPaddingMask A combination of the Paddings you wish to effect, see 
     * <a href="com.ms.wfc.html.DhPaddings.html>DhPaddings</a>.
     * @param nWidth the width of the Paddings
     * @param nUnit  the unit of the Paddings, see <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a>
     */
    public void setPaddingWidth( int nPaddingMask, int nWidth, int nUnit ){}

    /**
     * Retrieves a DhPaddingWidthInfo class describing the current padding
     * width settings for this element. ms.wfc.html.DhPaddingWidthInfo.html">DhPaddingWidthInfo</a> class
     * describing the current Padding settings for this element
     * @return A <a href="com.ms.wfc.html.DhPaddingWidthInfo.html">DhPaddingWidthInfo</a> class
     */
    public DhPaddingWidthInfo getPaddingWidthInfo(){}

    /**
     * Sets the padding widths according to those in the DhPaddingWidthInfo
     * class. ms.wfc.html.DhPaddingWidthInfo.html">DhPaddingWidthInfo</a> class.
     * @param <a href="com.ms.wfc.html.DhPaddingWidthInfo.html">DhPaddingWidthInfo</a> with settings
     */
    public void setPaddingWidthInfo( DhPaddingWidthInfo mwi ){}
    
    
    /**
     * Determines whether the padding settings will be persisted. 
     * @return <b>true</b> if no padding settings exist.
     */
    public boolean shouldPersistPadding(){}
    
    /**
     * Clears the current padding settings. 
     */
    public void resetPadding(){}

    
    
    
    
    
    

    boolean m_fMoved = false;
    boolean m_fSized = false;

    /**
     *@internalonly
     */
    protected void onMove() {}

    /**
     *@internalonly
     */
    protected void onSize() {}

    /**
     * Sets the position and size of the element. 
     *
     * @see #setWidthUnit
     * @see #setHeightUnit
     * @see #setTopUnit
     * @see #setLeftUnit
     * @see #setSize
     * @see #setLocation
     * @param x The left-coordinate of the position.
     * @param y The top-coordinate of the position.
     * @param width The new width of the element.
     * @param height The new height of the element.
     */
    final public void setBounds(int x, int y, int width, int height) {}

    /**
     * Sets the position and size of the element. 
     *
     * @see #setWidthUnit
     * @see #setHeightUnit
     * @see #setTopUnit
     * @see #setLeftUnit
     * @param rect <a href="com.ms.wfc.ui.Rectangle.html">Rectangle</a> The position and dimensions of the element
     */
    final public void setBounds(Rectangle rect) {}

    /**
     * Sets the position of the element. 
     *
     * @see #setTopUnit
     * @see #setLeftUnit
     * @param x The left-coordinate of the position.
     * @param y The top-coordinate of the position.
     */
    public void setLocation(int x, int y) {}

    /**
     * Sets the position of the element. 
     *
     * @see #setTopUnit
     * @see #setLeftUnit
     * @param pt The new location of the element
     */
    public void setLocation( Point pt ) {}


    /**
     * Sets the size of the element. 
     *
     * @see #setWidthUnit
     * @see #setHeightUnit
     * @param width The new width of the element.
     * @param height The new height of the element.
     * @exception WFCInvalidArgumentException if width or height are less than 0
     */
    public void setSize(int w, int h) {}

    /**
     * Sets the size of the element. 
     *
     * @see #setWidthUnit
     * @see #setHeightUnit
     * @param pt The new width and height of the element.
     * @exception WFCInvalidArgumentException if width or height are less than 0
     */
    public void setSize(Point pt) {}

    /**
     * Retrieves the size of the element. 
     *
     * @see #getWidthUnit
     * @see #getHeightUnit
     * @return (Point) The size of the element
     */
    public Point getSize() {}

    /**
     *@internalonly
     */
    public boolean shouldPersistSize() {}
    
    /**
     * Clears any size attributes and allows the element to be sized by the layout engine
     * (usually Microsoft Internet Explorer).  */
    public void resetSize(){}

    /**
     * Retrieves the position (or location) of the element. 
     *
     * @see #getTopUnit
     * @see #getLeftUnit
     * @return (Point) The location of the element
     */
    public Point getLocation() {}

    /**
     *@internalonly
     */
    public boolean shouldPersistLocation() {}
    
    /**
     *  Clears the location and allows the element to be positioned by the layout engine
     * (usually Microsoft Internet Explorer).  */
    public void resetLocation(){}

    /**
     * Retrieves the position and size of the element. 
     *
     * @see #getWidthUnit
     * @see #getHeightUnit
     * @see #getTopUnit
     * @see #getLeftUnit
     * @return (<a href="com.ms.wfc.ui.Rectangle.html">Rectangle</a>) The location of the element
     */
    final public Rectangle getBounds() {}

    /**
     * Sets the width of the element. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #getBounds
     * @param w The width value
     * @param unit One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    public void setWidthUnit( int w, int unit ) {}

    /**
     * Sets the height of the element. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #setBounds
     * @param h The height value
     * @param unit One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    public void setHeightUnit( int h, int unit ) {}

    /**
     * Sets the left position of the element. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #setBounds
     * @param v The left position value
     * @param unit One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    final public void setLeftUnit( int v, int unit ) {}

    /**
     * Sets the top position of the element. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #setBounds
     * @param t The top position value
     * @param unit One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    final public void setTopUnit( int t, int unit ) {}

    /**
     * Retrieves the width unit. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #getBounds
     * @return (int) One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    final public int getWidthUnit() {}

    /**
     * Retrieves the height unit. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #getBounds
     * @return (int) One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    final public int getHeightUnit() {}

    /**
     * Retrieves the left position unit. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #getBounds
     * @return (int) One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    final public int getLeftUnit() {}

    /**
     * Retrieves the top position unit. ms.wfc.html.DhUnits.html">DhUnits</a> constants
     * to express the units of measurement.
     *
     * @see #getBounds
     * @return (int) One of <a href="com.ms.wfc.html.DhUnits.html">DhUnits</a> constants to express the units of measurement.
     */
    final public int getTopUnit() {}

    /**
     * Retrieves the z-index (layering) ordering of this element with respect to its
     * container. 
     *
     * @see #setZIndex
     * @return (int) The z-index value set by setZIndex
     */  
    public int getZIndex() {}

    /**
     * Sets the z-index (layering) order of this element relative to the other elements in its
     * container.  The lower the number the further back this element is displayed. The element
     * with the highest number z-index in any given container will be display over all other
     * elements.
     *
     * @param i The z-index value of this element
     */
    public void setZIndex( int i ) {}

    /**
     * @internalonly
     */
    public boolean shouldPersistZIndex() {}
    
    /**
     * Clears any z-index setting.  */
    public void resetZIndex(){}

    /**
     * Sets the visiblility of the element.   
     * @param visible <b>true</b> to allow element to be rendered, otherwise <b>false</b>
     */
    public void setVisible( boolean visible ){}

    /**
     * Retrieves the visibility state of this element. 
     *
     * @return <b>true</b> if element is visble, <b>false</b> if not.
     */
    public boolean getVisible(){}

    /**
     *@internalonly
     */
    protected boolean getFixed(){}

    /**
     *@internalonly
     */
    protected void setFixed(){}
    
    
    
    /**
     * Sets the cascading style sheet's position style to absolute.   <i>Absolute</i> positioning
     * sets the element at an offset from the origin of it's first positioned parent
     * by the <i>left</i> and <i>top</i> settings.
     * 
     * @return <b>true</b> if <i>position</i> style is set to <i>absolute</i>
     * @see #getPosRelative
     * @see #getPosAbsolute
     * @see #setPosRelative
     */
    public void setPosAbsolute(){}
    
    /**
     * Determines whether the position style in the cascading style sheet is set to absolute.   <i>Absolute</i> positioning
     * sets the element at an offset from the origin of it's first positioned parent
     * by the <i>left</i> and <i>top</i> settings.
     * 
     * @return <b>true</b> if <i>position</i> style is set to <i>absolute</i>
     * @see #getPosRelative
     * @see #setPosAbsolute
     * @see #setPosRelative
     */
    public boolean getPosAbsolute(){}

    /**
     * Determines whether the position style in the cascading style sheet is set to relative.   <i>Relative</i> positioning
     * sets the element at an offset from where it would normally be positioned in the 
     * HTML layout by the <i>left</i> and <i>top</i> settings.
     * 
     * @return <b>true</b> if  <i>position</i> style is set to <i>relative</i>
     * @see #getPosAbsolute
     * @see #setPosAbsolute
     * @see #setPosRelative
     */
    public boolean getPosRelative(){}

    /**
     * Sets the cascading style sheet's position style to relative.   <i>Relative</i> positioning
     * sets the element at an offset from where it would normally be positioned in the 
     * HTML layout by the <i>left</i> and <i>top</i> settings.
     * 
     * @see #getPosAbsolute
     * @see #setPosAbsolute
     * @see #getPosRelative 
     */
    public void setPosRelative(){}

    /**
     * @internalonly
     */
    protected boolean definesCoords() {}

    /**
     *@internalonly
     */
    protected void clearDefinesCoords() {}

    
    
    
    
    

    
    static final int BOLD      = 0x00000001;

    
    static final int ITALIC    = 0x00000002;

    
    static final int UNDERLINE = 0x00000004;

    
    static final int STRIKEOUT = 0x00000008;

    
    void setFont(String name, int size, int style) {}

    
    void setFont(String name, int size) {}

    
    String getFontName() {}

    
    int getFontSize() {}
    
    
    int getFontSizeUnit() {}


    
    int getFontStyle() {}

    /**
     * Sets the font value for this element. ms.wfc.ui.Font.html">com.ms.wfc.Font</a> object.
     * @param font The new Font.
     */
    public void setFont(Font font) {}

    /**
     * Retrieves the current font. ms.wfc.ui.Font.html">com.ms.wfc.Font</a> object.
     * @return the current Font.
     */
    public Font getFont() {}
    
    
    
    private int needAmbientFont( String fontName, int fontSize ){}
    
    Font getAmbientFont(){}
    
    int getAmbientBackColor(){}
    
    int getAmbientForeColor(){}
    
    /**
     * Determines whether the font settings will be persisted.   That is, if the font is 
     * inherited from the ambient settings, or if the HTML element has a specific font setting.
     * 
     * @return <b>true</b> if the Font has been manipulated or altered.
     */
    public boolean shouldPersistFont() {}
    
    /**
     * Clears any font settings from the element and allows them to be inherited. 
     */
    public void resetFont(){}

    
    
    
    
    

    /**
     * Sets the cursor style for this element.   
     * See <a href="com.ms.wfc.html.DhCursor.html">DhCursor</a> 
     * for predefined values.
     * 
     * @param nCursor The cursor type
     */
    public void setCursor( int nCursor ){}

    /**
     * Sets the cursor style for this element.   
     * See 
     * <a href="http://www.microsoft.com/msdn/sdk/inetsdk/help/dhtml/references/css/cursor.htm">CSS cursor reference</a>
     * for possible values.
     * 
     * @param strCursor The desired cursor.
     */
    public void setCursor( String strCursor ){}

    
    /**
     * Retrieves the cursor style for this element.   
     * See <a href="com.ms.wfc.html.DhCursor.html">DhCursor</a> 
     * for predefined values.
     * 
     * @return The current cursor type.
     */
    public int getCursor() {}
    
    /**
     *  @internalonly
     */
    public boolean shouldPersistCursor(){}
    
    /**
     *  Resets the current cursor style to the default.  */
    public void resetCursor(){}

    /**
     * Retrieves the cursor style for this element.   
     * See 
     * <a href="http://www.microsoft.com/msdn/sdk/inetsdk/help/dhtml/references/css/cursor.htm">CSS cursor reference</a>
     * for possible values.
     * 
     * @return The current cursor type.
     */    
    public String getCursorString(){}

    
    
    
    
    

    /**
     *   Sets the text alignment style.   
     *   <p>Can be one of values found in <a href="com.ms.wfc.html.DhAlignment.java">DhAlignment</a>:
     *   <p><B>LEFT</B> (default), <B>RIGHT</B>, <B>CENTER</B>, <B>JUSTIFY</B>
     *
     *   @param nAlignment The new alignment setting
     *   @exception WFCInvalidArgumentException if nAlignment is not one of the above values.
     */
    public void setTextAlign( int nAlignment ){}

    /**
     * Retrieves the current text alignment setting. 
     * @return The current alignment as <B>LEFT</B> (default), <B>RIGHT</B>, <B>CENTER</B>, <B>JUSTIFY</B>
     *         from <a href="com.ms.wfc.html.DhAlignment.java">DhAlignment</a>
     * @see #setTextAlign
     */
    public int getTextAlign( ) {}
    
    /**
     *  @internalonly
     */
    public boolean shouldPersistTextAlign(){}
    
    /**
     *  Clears any existing text alignment property.  */
    public void resetTextAlign(){}

    /**
     *   Sets the text vertical alignment style.   
     *   <p>Can be one of values found in <a href="com.ms.wfc.html.DhAlignment.java">DhAlignment</a>:
     *   <p><B>BASELINE</B> (default), <B>SUBSCRIPT</B>, <B>SUPERSCRIPT</B>
     *
     *   @param nVerticalAlign The new alignment setting
     *   @exception WFCInvalidArgumentException if nAlignment is not one of the above values.
     */
    public void setTextVerticalAlign( int nVerticalAlign ){}

    
    /**
     * Retrieves the current text alignment setting. 
     * @return The current alignment as <B>BASELINE</B> (default), <B>SUBSCRIPT</B>, <B>SUPERSCRIPT</B>
     *         from <a href="com.ms.wfc.html.DhAlignment.java">DhAlignment</a>
     * @see #setTextVerticalAlign
     */
    public int getTextVerticalAlign( ){}
    
    /**
     *  @internalonly
     */
    public boolean shouldPersistTextVerticalAlign(){}
    
    /**
     *  Clears any existing vertical text alignment property.  */
    public void resetTextVerticalAlign(){}


    
    
    
    
    

    /**
     *@internalonly
     */
    protected void setStylePeerNull() {}

    /**
     *@internalonly
     */
    protected boolean haveStylePeer() {}

    /**
     *@internalonly
     */
    protected String getPeerCssText() {}

    /**
     *@internalonly
     */
    protected void setPeerCssText(String css) {}

    /**
     *@internalonly
     */
    protected IHTMLStyle getStylePeer(){}
    
    
    
    
    
    

    static final int STATECHANGE_LOCAL_STALE = 0;
    static final int STATECHANGE_PEER_CLOSING = 1;
    static final int STATECHANGE_PEER_STALE = 2;

    
    /**
     *@internalonly
     */
    protected  boolean getServerSent(){}

    /**
     *@internalonly
     */
    protected void onStateChange(int stateChange) {}

    /**
     * Frees all resources associated with this element.  This method may not be
     * called at runtime. Any resources used by the element should be setup to
     * be released when the element is GC'ed. Inheriting classes should always
     * call <i>super.dispose</i>.
     */
    public void dispose() {}

    
    
    
    
    

    private DhNameValuePairs                m_styles;

    DhNameValuePairs getStyleArray(){}
    
    /**
     * @internalonly
     */
    public final boolean hasStyles(){}
    
    
    String getInheritedStyleString( int key ){}
    
    String getInheritedStyleString( int key, boolean takeFirst ){}
    
        
    int getInheritedStyleInt( int key ){}
    
    
    
    
    
    
    void setStylePeerAttribute( String attrName, Variant attrValue, int flags ){}

    Variant getStylePeerAttribute( String attrName, int flags ){}

    
    
    
    
    
    boolean removeStylePeerAttribute( String attrName, int flags ){}

    
    
    
    

    
    void setStyle( int styleKey, int valueKey ) {}

    
    void setStyle( int styleKey, char[] value ) {}

    
    void setStyle( int styleKey, String value ) {}

    
    void setStyleInt( int styleKey, int value ) {}

    
    void setStyleInt( int styleKey, int value, int unitKey ) {}

    /**
     * Sets the style by its cascading style sheet's string value.  You should instead use the more specific style methods
     * (e.g. DhStyleBase.setFont).
     * @param strStyleKey The name of the style to set
     * @param value A String value
     */
    public void setCSSStyle(String strStyleKey, String value) {}

    /**
     * Sets the style by its cascading style sheet's integer value.  You should instead use the more specific style methods
     * (e.g. DhStyleBase.setFont).
     * @param strStyleKey The name of the style to set
     * @param value An int value
     */
    public void setCSSStyleInt(String strStyleKey, int value) {}

    
    
    /**
     * This method can be called to modify 'read-only' style settings of an element on
     * the page.  See the Internet Client SDK documentation for details on read-only 
     * styles.
     * 
     * @param strStyleName The string name of the style to modify.  This is the actual CSS
     *                     style, not the style element property.
     * @param strValue     The new value to set.
     * @param fCaseSensitive <b>true</b> to use case-sensitive search otherwise <b>false</b>
     */
    protected void setStyleText( String strStyleName, String strValue, boolean fCaseSensitive ){}
    
    String internalSetStyleText( IHTMLStyle style, String name, String value, boolean fCase ){}

    
    void removeStyle( int styleKey ) {}

    
    String getStyleString( int styleKey ) {}

    /**
     * Retrieves the style of the cascading style sheet.  You should instead use the more specific style methods
     * (e.g. DhStyleBase.getFontName).
     * @param strStyleKey The name of the style to get
     */
    public String getCSSStyleString(String strStyleKey) {}

    
    int getStyle( int styleKey ) {}

    private String getStyleValue( String strStyle, boolean fCaseSensitive ){}

    /**
     * Retrieves the style number of the cascading style sheet.  You should instead use the more specific style methods
     * (e.g. DhStyleBase.getFontName).
     * @param strStyleKey The name of the style to get
     */
    public int getCSSStyleInt(String strStyleKey) {}

    
    int getStyleInt( int styleKey ) {}

    
    int getStyleUnit( int styleKey ) {}

    protected boolean hasStyleText() {}

    /**
     * Retrieves the underlying text string in the cascading style sheet. 
     * @return The underlying CSS text string for this object. (Note that this is a very advanced feature of the library and is not part of the normal usage scenario.)
     */
    public String getCSSStyleText() {}
    
    /**
     *@internalonly
     */
    protected static void makeUpperCase(char[] rgch) {}

    /**
     *@internalonly
     */
    protected static int getCustomKey(String strKey, int checkBits, DhNameValuePairs table) {}
    
    
    /**
     *@internalonly
     */
    protected StringBuffer getStyleText( StringBuffer sb ) {}

    private  void putCssText() {}

    /**
     *@internalonly
     */
    protected final void refreshPeerFromStyles( boolean replaceExistingCss ) {}
    
    /**
     * @internalonly
     */
    protected void refreshPeerFromStyles( ) {}

    private  final void ensureStyles() {}

    private  void refreshCssFromPeer() {}
    
    /**
     * @hidden
     *@internalonly
     */
    protected  void init(DhParseInfo ph) {}

     
    /**
     * @param sbSrc A stylebase object to use as the source to clone settings from
     *@internalonly
     */
    protected void cloneSettings( DhStyleBase sbSrc ){}
    
    /**
     * @param sbSrc A stylebase object to use as the source to merge settings from
     * @param overWrite <b>true</b> to overwrite settings on this object
     *@internalonly
     */
    protected void mergeSettings( DhStyleBase sbSrc, boolean overWrite ){}

/**
 * Provides the superclass for classes that support  styles, such as DhStyle and DhElement objects. 
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
    public static class ClassInfo extends Component.ClassInfo {
        public static final PropertyInfo backColor =
                                                    new PropertyInfo(DhStyleBase.class, "backColor", Color.class,
                                                                     CategoryAttribute.Appearance,
                                                                     new DefaultValueAttribute(Color.WHITE),
                                                                     new DescriptionAttribute(Sys.getString("DhStyleBaseBackColor")));

        public static final PropertyInfo font =
                                               new PropertyInfo(DhStyleBase.class, "font", Font.class,
                                                                CategoryAttribute.Appearance,
                                                                LocalizableAttribute.YES,
                                                                new DescriptionAttribute(Sys.getString("DhStyleBaseFont")));

        public static final PropertyInfo foreColor =
                                                    new PropertyInfo(DhStyleBase.class, "foreColor", Color.class,
                                                                     CategoryAttribute.Appearance,
                                                                     LocalizableAttribute.YES,
                                                                     new DefaultValueAttribute(Color.WHITE),
                                                                     new DescriptionAttribute(Sys.getString("DhStyleBaseForeColor")));

        public static final PropertyInfo location =
                                                   new PropertyInfo(DhStyleBase.class, "location", Point.class,
                                                                    CategoryAttribute.Position,
                                                                    LocalizableAttribute.YES,
                                                                    new DescriptionAttribute(Sys.getString("DhStyleBaseLocation")));

        public static final PropertyInfo size =
                                               new PropertyInfo(DhStyleBase.class, "size", Point.class,
                                                                CategoryAttribute.Position,
                                                                LocalizableAttribute.YES,
                                                                new DescriptionAttribute(Sys.getString("DhStyleBaseSize")));

        public static final PropertyInfo visible =
                                                  new PropertyInfo(DhStyleBase.class, "visible", Boolean.TYPE,
                                                                   CategoryAttribute.Behavior,
                                                                   LocalizableAttribute.YES,
                                                                   DefaultValueAttribute.TRUE,
                                                                   new DescriptionAttribute(Sys.getString("DhStyleBaseVisible")));

        public static final PropertyInfo zIndex =
                                                 new PropertyInfo(DhStyleBase.class, "zIndex", Integer.TYPE,
                                                                  CategoryAttribute.Behavior,
                                                                  new DescriptionAttribute(Sys.getString("DhStyleBaseZIndex")));

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}

        public final void removeFocusProps(IProperties props) {}

        public void getAttributes(IAttributes attrs) {}    
    }
    
    Object m_peerData;        
    
            
    String getPeerDataStyle( String style, boolean fSkipIfSearching ){}
    
    void flushPeerDataCache(){}
    



                
    class lateStyleParser{
        
        String m_string;
        styleStringTokenizer sst;
        boolean isSearching;
        boolean isDone;
        
        public String toString(){}
        
        lateStyleParser( String styleStr ){}            
        
        String getStyle( String style ){}
    }        
}



class DhCSSParser extends DhScanner { 
    DhStyleBase m_style;

    DhCSSParser( String css, DhStyleBase style) {}

    public void parse() {}

    public boolean onStyle(DhParseInfo pi, int dhkey, int valkey, char[] value) {}
}


class DhStyleSheetParser extends DhCSSParser {
    List  styleList;
    String m_content;

    DhStyleSheetParser( String strSSContent ){}

    public void parse(){}

    public DhStyle[] getStyles(){}
}




class DhExtraStyles {        
    public DhInternalBorders   m_borders;
    public DhInternalMargins   m_margins;
    public DhInternalPaddings  m_paddings;    
}


class DhInternalBorders implements DhStringIDs { 
    
    public static final int   BORDER_ATTR_COLOR              = 0;
    public static final int   BORDER_ATTR_STYLE              = 1;
    public static final int   BORDER_ATTR_WIDTH              = 2;

    
    protected static final int      BORDER_ITEMS            = 3;
    protected static final int      TOP_SIDE_OFFSET       = 0;
    protected static final int      RIGHT_SIDE_OFFSET     = TOP_SIDE_OFFSET + BORDER_ITEMS;  
    protected static final int      BOTTOM_SIDE_OFFSET       = RIGHT_SIDE_OFFSET + BORDER_ITEMS; 
    protected static final int      LEFT_SIDE_OFFSET      = BOTTOM_SIDE_OFFSET + BORDER_ITEMS; 

    protected static final int[]  borderIdArray = { DhStrings.STR_BORDER_TOP, DhStrings.STR_BORDER_RIGHT, DhStrings.STR_BORDER_BOTTOM, DhStrings.STR_BORDER_LEFT };

    protected static final int[]  borderStyleArray = { DhStrings.STR_SOLID, DhStrings.STR_NONE, DhStrings.STR_DOTTED, DhStrings.STR_DASHED, 
                                                       DhStrings.STR_DOUBLE, DhStrings.STR_GROOVE, DhStrings.STR_RIDGE, DhStrings.STR_INSET, DhStrings.STR_OUTSET };

    protected static final int[]  borderWidthArray = { DhStrings.STR_THICK, DhStrings.STR_MEDIUM, DhStrings.STR_THIN, DhStrings.STR_NONE };

    private DhStyleBase     m_parentBase;   
    boolean usingDefStyle;
    boolean usingDefColor;
    boolean usingDefWidth;

    public  DhInternalBorders( DhStyleBase parent ) {}

    protected static boolean getStringBorderStyle( int nTokenId ) {}

    protected static boolean getStringBorderWidth( int nTokenId ) {}


    
    
    
    
    
    
    protected static boolean getStringBorderWidthFormat( char[] szTest ) {}

    
    
    
    
    
    
    
    
    
    
    
    
    
    
    protected static boolean parseBorderValueString( String s, String[] strArray, int nOffset ) {}

    protected String[] getBorderValues( int nMask ) {}

    protected String[] getBorderValues( int nMask, boolean fRefresh ) {}

    
    
    
    
    
    
    
    
    
    
    
    
    protected void setBorderItemHelper( int nMask, int nItem, String strNewVal ) {}

    public void setBorderWidth( int borderMask, String strWidth ) {}

    public void setBorderWidth( String strWidth ) {}

    public void setBorderStyle( int borderMask,  String strStyle ) {}

    public void setBorderStyle( String strStyle ) {}

    public void setBorderColor( int borderMask, String strColor ) {}
    
    public void setBorderColor( int borderMask, int nColor ) {}

    public void setBorderColor( int nColor ) {}

    public void setBorder( int nMask, int nColor, String strStyle, String strWidth ) {}

    public void setBorder( int nMask, String strColor, String strStyle, String strWidth ) {}
    
    public boolean justWidth(){}
    
    public boolean justColor(){}
    
    public boolean justStyle(){}



    
    protected static int getWidthInt( String strWidth ) {}

    
    protected static int getWidthUnit( String strWidth ) {}

    public  DhBorderInfo getBorderInfo() {}

    public  void setBorderInfo( DhBorderInfo biNew ) {}       
}


class DhInternalMargins implements DhStringIDs {

    private DhStyleBase m_sbParent;
    protected static final int[]  marginIdArray = { DhStrings.STR_MARGIN_TOP, DhStrings.STR_MARGIN_RIGHT, DhStrings.STR_MARGIN_BOTTOM, DhStrings.STR_MARGIN_LEFT,
                                                    DhStrings.STR_MARGIN_TOPA, DhStrings.STR_MARGIN_RIGHTA, DhStrings.STR_MARGIN_BOTTOMA, DhStrings.STR_MARGIN_LEFTA};

    public DhInternalMargins( DhStyleBase sbParent ) {}

    public void setMarginWidth( int nWidth, int nUnit ){}

    public void setMarginWidth( int nMarginMask, int nWidth, int nUnit ){}

    
    public  DhMarginWidthInfo getMarginWidthInfo(){}
    
    final private void checkMarginWidthInfo( DhMarginWidthInfo mwi ){}

    public  void setMarginWidthInfo( DhMarginWidthInfo mwi ){}
}


class DhInternalPaddings implements DhStringIDs{

    private DhStyleBase m_sbParent;
    protected static final int[]  paddingIdArray = { DhStrings.STR_PADDING_TOP, DhStrings.STR_PADDING_RIGHT, DhStrings.STR_PADDING_BOTTOM, DhStrings.STR_PADDING_LEFT };
    

    public DhInternalPaddings( DhStyleBase sbParent ) {}

    public void setPaddingWidth( int nWidth, int nUnit ){}

    public void setPaddingWidth( int nPaddingMask, int nWidth, int nUnit ){}

    public  DhPaddingWidthInfo getPaddingWidthInfo(){}
    
    final private void checkPaddingWidthInfo( DhPaddingWidthInfo pwi ){}

    public  void setPaddingWidthInfo( DhPaddingWidthInfo pwi ){}
}


class styleStringTokenizer extends baseTokenizer {
    static final int STYLE = 0;
    static final int VALUE = 1;
    static final int COLON = 2;
    static final int SEMICOLON = 3;
    static final int DONE = 4;
    
    static final String COLON_STR = ":";
    static final String SEMICOLON_STR = ";";
    
    boolean m_sawColon = false;
    
    public styleStringTokenizer( String styleString ){}
    int getItem(){}

    String getString(boolean sawEq){}        

}