//STRIPPEDSOURCE//
package com.ms.wfc.html;

import com.ms.wfc.core.*;

/**
 * Implements a submit button control for HTTP form submission.&nbsp;   The submit button invokes the URL specified in
 * the form's "ACTION" attribute (see <a href="com.ms.wfc.html.DhForm#setHTTPSubmitURL">DhForm.setHTTPSubmitURL()</a>).  
 *  
 * Adding a DhSubmitButton to a DhForm object will cause the DhForm to represent an HTML form
 * element
 *
 * @see com.ms.wfc.html.DhForm
 *
 * @security(checkClassLinking=on)
 */
public class DhSubmitButton extends DhButtonBase { 

    /**
     * The default ctor creates a DhSubmitButton with 
     * 'Submit' as its caption
     */
    public DhSubmitButton() {}

    /**
     * Creates a DhSubmitButton with the specified caption
     *
     * @param strCaption the initial caption for the new button
     */
    public DhSubmitButton( String strCaption ) {}

    /**
     *@internalonly
     */
    protected int buttonType(){}

    /**
     * Sets the button caption. 
     * @param strCaption The new caption String
     */
    public void setText( String strCaption ) {}

    /**
     * Retrieves the button's current text caption. 
     * @return The button caption.
     */
    public String getText() {}
    

        /**
         Implements a submit button control for HTTP form submission.&nbsp; 
         * @hidden
         *@internalonly
         *
         * @security(checkClassLinking=on)
         */
        public static class ClassInfo extends DhButtonBase.ClassInfo {
            public static final PropertyInfo text =
                                                   new PropertyInfo(DhSubmitButton.class, "text", String.class,
                                                                    new DefaultValueAttribute(Sys.getString("DhSubmitButtonDefaultText")),
                                                                    CategoryAttribute.Appearance,
                                                                    new DescriptionAttribute(Sys.getString("DhSubmitButtonText")));

            public static final PropertyInfo submitMethod =
                                                           new PropertyInfo(DhSubmitButton.class, "submitMethod", Integer.TYPE,
                                                                            new DefaultValueAttribute(new Integer(1)),
                                                                            CategoryAttribute.Appearance,
                                                                            new DescriptionAttribute(Sys.getString("DhSubmitButtonSubmitMethod")));

            public static final PropertyInfo submitURL =
                                                        new PropertyInfo(DhSubmitButton.class, "submitURL", String.class,
                                                                         DefaultValueAttribute.EMPTY_STRING,
                                                                         CategoryAttribute.Appearance,
                                                                         new DescriptionAttribute(Sys.getString("DhSubmitButtonSubmitURL")));

            public void getProperties(IProperties props) {}
        }
}