//STRIPPEDSOURCE//

package com.ms.wfc.html;

import com.ms.wfc.html.event.DhEvents;
import com.ms.wfc.html.event.DhTableListener;

import com.ms.wfc.html.om.IHTMLTable;
import com.ms.wfc.html.om.IHTMLTableRow;
import com.ms.wfc.html.om.IHTMLTableSection;
import com.ms.wfc.html.om.IHTMLElementCollection;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.wfc.html.om.IHTMLStyle;

import com.ms.com.*;


import com.ms.wfc.core.*;
import com.ms.wfc.util.*;

import com.ms.wfc.data.*;
import com.ms.wfc.data.ui.*;

/**
 * Creates a table element that can be populated with rows and columns.  Make sure to
 * see the <a href="commshtml_ovr.html#tables">overview</a> for working with tables.
 * This table can also display data from a <a href="com.ms.wfc.data.Recordset.html">com.ms.wfc.data.Recordset</a>
 * in a tabular fashion, optionally using pre-defined formatting.
 *
 * @security(checkClassLinking=on)
 */
public class DhTable extends DhBaseContainer {

    
    
    
    private DhHeaderFooterRow m_header;
    private DhHeaderFooterRow m_footer;
    private boolean           m_fCloneRepeater  = false;
    
    
    
    
    private String      m_error;
    private int         m_nStart = 0;
    private int         m_nEnd = -1;    
    private boolean     m_autoHeader = false;
    private DhRow       m_templateRow = null;

    private int[]       m_bindIndexes;   
    private DataBinding[] m_bindings;
    private IDataSource m_dataSource;
    private String      m_dataMember;    
    private RecordsetProvider m_rsp;
    private EventHandler m_onRSAquire;
    private EventHandler m_onRSRelease;
    
    private DhElement[] dataEventElementArray;   
    private RecordDataBuffer m_sdb = null;        

    
    
    /**
     * Create a default, empty table
     */
    public DhTable(){}
    
    
    /**
     * Initializes the table using a com.ms.wfc.data.IDataSource object, that will be 
     * traversed and displayed within the table
     * 
     * @param dataSource The com.ms.wfc.data.IDataSource to display in this table, with the default data member
     * 
     * @see com.ms.wfc.data.IDataSource
     * @see #setAutoHeader
     */
    public DhTable( IDataSource dataSource ){}
    
    /**
     * Initializes the table using a com.ms.wfc.data.Recordset object,
     * a com.ms.wfc.data.uw.DataBinding object, and a com.ms.wfc.html.DhRow that will
     * be replecated for each record in the recordset and added to the table.
     * 
     * @param dataSource The com.ms.wfc.data.IDataSource to display in this table
     * @param dataSource The string name of the data member to retrieve
     * @param dataBindings An array of com.ms.wfc.data.ui.DataBinding objects that describe
     *                      the data bindings within the <i>repeaterRow</i>
     * @param repeaterRow The com.ms.wfc.html.DhRow with the desired elements and formatting that are bound
     *                      to com.ms.wfc.data.ui.DataBinding object.
     * 
     * @see com.ms.wfc.data.Recordset
     * @see com.ms.wfc.data.ui.DataBinding
     * @see com.ms.wfc.html.DhRow
     * @see #setRepeaterRow     
     * @see #setDataBindings
     */
    public DhTable( IDataSource dataSource, String dataMember, DataBinding[] dataBindings, DhRow repeaterRow ){}
    
    /**
     *@internalonly
     * @hidden
     */
    protected int getTagNameID(){}
    
    /**
     * @internalonly
     * @hidden
     */
    protected void initFromPeer( IHTMLElement peer ){}

    /**
     * Adds a row to this table either at the top or at the bottom or before or after another
     * row, depending on the DhInsertOptions insertFlag
     * parameter. ms.wfc.html.DhInsertOptions.html>insertFlag</a> parameter.
     * The valid values for <i>insertFlag</i> are:
     * <UL>
     * <LI><b>INSERT_END</b> Insert at the bottom of this table. The <i>relativeTo</i> parameter must be <b>null</b>.
     * <LI><b>INSERT_BEGINNING</b> Insert at the top of this table. The <i>relativeTo</i> parameter must be <b>null</b>.
     * <LI><b>INSERT_BEFORE</b> Insert before the row referred to by the <i>relativeTo</i> parameter. The <i>relativeTo</i> parameter must not be <b>null</b>.
     * <LI><b>INSERT_AFTER</b> Insert after the row referred to by the <i>relativeTo</i> parameter. The <i>relativeTo</i> parameter must not be <b>null</b>.
     * </UL>
     *
     *  @param row The <a href="com.ms.wfc.html.DhRow.html">row</a> to add to this table.
     *  @param relativeTo The row referred to when using the INSERT_BEFORE or INSERT_AFTER constants for the <i>insertFlag</i> parameter.
     *  @param insertFlag One of the valid and applicable <a href="com.ms.wfc.html.DhInsertOptions.html>insert constants</a>.
     */
    final public void add(DhRow row, DhRow relativeTo, int insertFlag) {}

    /**
     * Adds a row to this table either at the top or at the bottom or before or after another
     * row, depending on the DhInsertOptions insertFlag
     * parameter. ms.wfc.html.DhInsertOptions.html>insertFlag</a> parameter.
     * The valid values for <i>insertFlag</i> are:
     * <UL>
     * <LI><b>INSERT_END</b> 
     * <LI><b>INSERT_BEGINNING</b>
     * </UL>
     *
     *  @param row The <a href="com.ms.wfc.html.DhRow.html">row</a> to add to this table.
     *  @param insertFlag One of the valid and applicable <a href="com.ms.wfc.html.DhInsertOptions.html>insert constants</a>.
     */
    final public void add(DhRow row, int insertFlag) {}

    /**
     * Adds a row to this table either at the top or at the bottom or before or after another
     * row, depending on the DhInsertOptions insertFlag
     * parameter. 
     *
     *  @param row The <a href="com.ms.wfc.html.DhRow.html">row</a> to add to this table.
     */
    final public void add(DhRow row) {}
    
    void addWashed( DhRow r, DhRow relative, int insertType ){}
    
    
    /**
     * Adds a row to this table either at the top or at the bottom or before or after another
     * row, depending on the DhInsertOptions insertFlag
     * parameter. 
     * @internalonly
     */
    protected void add(DhElement e) {}       

    
    /**
     * Adds a row to this table either at the top or at the bottom or before or after another
     * row, depending on the DhInsertOptions insertFlag
     * parameter. 
     * @internalonly
     */
    protected void add( DhHeaderFooterRow hfrow ){}

    
    /**
     * @internalonly
     */
    protected int removeWashed( DhElement element ){}
    
    /**
     * Assigns a delegate to the readyStateChange event.
     * 
     * @param h The handler to call on a ready state change
     * @see com.ms.wfc.html.DhElement#getReadyState
     */
    final public void addOnReadyStateChange( com.ms.wfc.ui.ReadyStateEventHandler h ){}
    
    /**
     * Removes the delegate that is assigned to the onReadyStateChange event. 
     * 
     * @param h The handler to remove
     * @see com.ms.wfc.html.DhElement#getReadyState
     */
    final public void removeOnReadyStateChange( com.ms.wfc.ui.ReadyStateEventHandler h ){}

    /**
     * Retrieves the cell at the specified location from the table body. 
     *
     * @param nRow The zero-based row number
     * @param nCol The zero-based column number
     * @return The cell at the requested position
     * @exception DhElementNotFoundException if there is no cell at the specified location.
     */
    final public DhCell getBodyCell( int nRow, int nCol ){}        

    /**
     * Set the table's CELLPADDING attribute. 
     * @param padding The integer padding value
     */
    final public void setCellPadding( int padding ){}
    
    /**
     * Retrieves the table CELLPADDING attribute. 
     * @return The integer padding value.
     */    
    final public int getCellPadding(){}

    /**
     * Sets the table's CELLSPACING attribute. 
     * @param spacing The integer padding value
     */    
    final public void setCellSpacing( int spacing ){}

    /**
     * Retrieves the table CELLSPACING attribute. 
     * @return The integer padding value.
     */        
    final public int getCellSpacing(){}

    /**
     * Sets the default (non-CSS) border width for this table. 
     * @param width The thickness value of the border
     */
    final public void setBorder( int width ){}

    /**
     * Retrieves the default (non-CSS) border thickness of the table. 
     * @return width The thickness value of the border
     */
    final public int getBorder(){}

    

    /**
     * @internalonly
     */
    protected StringBuffer getContent( StringBuffer sb ){}

    /**
     * @hidden
     * @internalonly
     */
    protected DhEvents createEvents() {}
    
    
    /**
     * @internalonly
     */
    public DhElement findElement( int n ){}
    

    
    /**
     * @internalonly
     */
    public DhElement findElement( String id ){}


    
    /**
     * @internalonly
     */
    protected DhElement findElement( IHTMLElement peer ){}

    /**
     * Retrieves the footer row if there is one. 
     * @return The footer <a href="com.ms.wfc.html.DhRow.html">DhRow</a>,
     *         or <b>null</b> if no footer DhRow exists.
     */
    final public DhRow getFooterRow(){}        

    /**
     * Sets the footer row to the DhRow element
     * specified. ms.wfc.html.DhRow.html">DhRow</a>
     * specified.
     * 
     * @param r The new footer row, or <b>null</b> to clear the existing footer row
     */
    final public void setFooterRow( DhRow r ){}


    /**
     * Retrieves the header row if there is one. 
     * @return The header <a href="com.ms.wfc.html.DhRow.html">DhRow</a>,
     *         or <b>null</b> if no header DhRow exists.
     */
    final public DhRow getHeaderRow( ){}


    /**
     * Sets the header row to the DhRow specified. ms.wfc.html.DhRow.html">DhRow</a>
     * specified.
     * 
     * @param r The new header row, or <b>null</b> to clear the existing header row
     */
    final public void setHeaderRow( DhRow r ){}

    /**
     * @hidden
     * @internalonly
     */
    protected void makePeer(IHTMLElement parentPeer,boolean fInsert,DhElement relativeTo,int insertFlag){}

    /**
     * @internalonly
     */
    protected void transitionTo( int state ){}
    
    
    public void removeAll(){}

    
    final static String[] bodyEnders = new String[]{ "</TBODY", "<TBODY", "<THEAD", "<TFOOT", "</TABLE" };
    final static int END_TBODY = 0;
    final static int START_TBODY = 1;
    final static int START_THEAD = 2;
    final static int START_TFOOT = 3;
    final static int END_TABLE = 4;
    
    
    /**
     * Removes rows that are not header or footer rows from the table.   In HTML, body rows are any rows that
     * are not contained within a THEAD or TFOOT tag.  The header or footer row will 
     * not be removed.
     */
    final public void removeBodyRows(){}

    
    final  void setInteractiveRows( boolean value ){}

    
    final boolean getInteractiveRows(){}

    
    /**
     * Retrieves the specified row. 
     *
     * @param nRow The zero-based index of the row to retrieve
     * @return The row at position <i>nRow</i>
     * @exception DhElementNotFoundException if the row is not in the table
     */
    final public DhRow getBodyRow( int nRow ){}
    
    /**
     * Retrieves an array of all rows in the table body (excluding the header and footer). 
     * @return An array of all the body rows
     */
    final public DhRow[] getBodyRows(){}

    /**
     * Retrieves the number of rows in the table, including header and footer rows. 
     * @return The total number of rows
     */
    public int getTotalRowCount(){}
    
    /**
     * Retrieves the number of body rows in the table. 
     * @return The number of body rows
     */    
    public int getBodyRowCount(){}
    
    /**
     * @internalonly
     */
    public void setHTMLGenerator( DhHTMLGenerator htmlGen ){}
    
    
    
    
    
    
    /**
     * Sets the data source for this table. ms.wfc.data.IDataSource data source for this table.  
     * 
     * <P><i><b>WARNING: If the table has existing body
     * rows, they will be replaced when the table's data is generated.</b></i>
     * @param dataSource An com.ms.wfc.data.IDataSource object
     * @see com.ms.wfc.data.IDataSource     
     */
    public void setDataSource( IDataSource dataSource ){}
    
    /**
     * Retrieves the currently set com.ms.wfc.data.IDataSource object. ms.wfc.data.IDataSource object.
     * @return The currently set com.ms.wfc.data.IDataSource object, or <b>null</b> if none is set.
     * @see com.ms.wfc.data.Recordset
     */
    public IDataSource getDataSource(){}
    
    /**
     * Sets the currently selected data member to retrieve.
     * @param dataMember The currently selected data member.  <b>null</b> will select the default ("") data member.
     */
    public void setDataMember( String dataMember ){}
    
    /**
     * Retrieves the currently selected data member. 
     * @return The currently selected data member.  If none has been set, returns "" or <b>null</b>
     */
    public String getDataMember(){}
    
    /**
     * Specifies the template row that will be cloned for each record of data in the
     * recordset.   Specify elements within the row that you would like to
     * have bound to data by attaching them to a <a href="com.ms.wfc.data.ui.DataBinding.html">DataBinding</a> object.
     * 
     * <p>If there are DhEvents set on elements within the <i>repeaterRow</i>, they will be duplicated
     * for all the rows of data. It is important to note that event duplication is expensive and adding
     * many event handlers to the repeater row will slow table generation considerably.  It is often better
     * to set the DhEvents on just the row or table and to use event bubbling to handle them.
     * 
     * @param repeaterRow A DhRow with the desired formatting and data bound elements
     */
    public void setRepeaterRow( DhRow repeaterRow ){}
    
    /**
     * Retrieves the current template repeater row. 
     * 
     * @return The current template repeater row, or <b>null</b> if none is set.
     * @see #setRepeaterRow
     */
    public DhRow getRepeaterRow(){}
    
    /**
     * Sets the DataBinding objects that are to be associated with elements in the
     * template repeater row. ms.wfc.ui.DataBinding objects that are to be associated with
     * elements in the template repeater row.  Each DataBinding must reference a 
     * column in the current Recordset, and an object in the repeater row.  If no
     * repeater row is specified, these bindings are ignored and the table displays
     * the default data formatting.
     * 
     * @param dataBindings An array of com.ms.data.ui.DataBinding objects
     * @see #setRepeaterRow
     * @see com.ms.wfc.ui.DataBinding
     */
    public void setDataBindings( DataBinding[] dataBindings ){}
    
    /**
     * Retrieves the DataBinding objects that are associated with elements in the
     * template repeater row. ms.wfc.ui.DataBinding objects that are  associated with
     * elements in the template repeater row.  Each DataBinding must reference a 
     * column in the current Recordset, and an object in the repeater row.  If no
     * repeater row is specified, these bindings are ignored and the table displays
     * the default data formatting.
     * 
     * @param dataBindings An array of com.ms.data.ui.DataBinding objects
     * @see #setRepeaterRow
     * @see com.ms.wfc.ui.DataBinding.
     */    
    public DataBinding[] getDataBindings(){}
    
    private int[] getBindingIndexes(DhRow r ){}
    
    /**
     * Enables or disables automatic generation of column headers.   If enabled,
     * A header row with the column names will be automatically added
     * to the table when it is generated.  
     * 
     * <P> Note: this only functions for tables generated without a repeater template row.
     * 
     * @param fAuto <b>true</b> to generate header rows, <b>false</b> to disable.     
     * @exception WFCInvalidStateException if <i>fAuto</i> is true and the table has a repeater row.
     */
    public void setAutoHeader( boolean fAuto ){}

    /**
     * Retrieves the current header generation mode.   Note, auto headers will only be generated
     * in tables that do not have a repeater row specified.
     * 
     * @return <b>true</b> if a header row will be created if a templat row is not specified
     * , <b>false</b> if not.
     * @see #setAutoHeader
     */
    public boolean getAutoHeader( ){}


    /**
     * Sets the range of records that will be displayed in the table.   These numbers
     * reflect absolute, zero-based record positions.

     * @param nStartRecord The first record to display
     * @param nEndRecord  The final record to display
     */
    public void setRecordRange( int nStartRecord, int nEndRecord ){}

    /**
     * Retrieves the beginning of the current record range. 
     * @return The record range beginning.  Default is 0.
     * @see #setRecordRange
     */
    public int getRangeStart(){}

    /**
     * Retrieves the end of the current record range. 
     * @return The record range end.  Default is -1 indicating records will be displayed until
     * end of recordset.
     * @see #setRecordRange
     */    
    public int getRangeEnd(){}

    /**
     * Refreshes the table's data if it is bound to the document. 
     */
    public void refresh(){}      
    
    private void applyDataBindings( int[] bindingIndexes, DhRow r ){}
    
    static final String s_decoPrefix = "~^*{";
    static final String s_decoPostfix = "}*^~";
    static final int    SIZE_BUMP = 8192;

    
    
    
    private StringBuffer populateRows( StringBuffer sb, int nRows, boolean createNewRows, Recordset rs ){}
    
    private final RecordDataBuffer getSDB( DhRow r, boolean allCells, DhElement[] elems, String[] colNames, boolean newRows ){}
    
    
    
    
    private final String stripIdsAndFixupOffsets( String cleanString, int[] dataOffsets, int[] idOffsets ){}
    
    private DhElement[] eventElems;
    
    
    
    
    private final int[] computeIdOffsets( String cleanString, DhElement rootElement ){}
    
    private final boolean getEventElements( DhElement rootElement ){}
    
    private final List getEventElements( DhElement rootElement, List eList ){}
    
    private final int[] computeDataOffsets( String[] colNames, String dataString, boolean needSort ){}
    
    private final String formatField ( com.ms.wfc.data.Field f ){}
    
    private String replaceNull( String baseValue ){}
    
    private final void bindDataEventElements(){}

    private final DhElement cloneDataElement( DhElement rBase, boolean recurse ){}

    /**
     * @internalonly
     */
    protected StringBuffer generateHTML(StringBuffer sb){}
    
    private final Recordset getRS(){}
    
    private final void onRecordsetReleased( Object s, Event e ){}
    
    private final void onRecordsetAquired( Object s, Event e ){}
    
    
    private final void updateBindings(){}

    private final StringBuffer internalGetContent_Data( StringBuffer sb ){}
    
    /** 
     * Retrieves the current data page size, in rows, to display in a databound operation. 
     */
    public int getPageSize(){}

    /**
     * Sets the display page size for this table when bound to data. 
     * @param nPageSize The number of records to display per page
     * @see #showNextPage
     * @see #showPreviousPage
     */
    public void setPageSize( int nPageSize ){}

    /**
     * Displays the next page of data in the table. 
     * @see #setPageSize
     * @see #setRecordRange
     */
    public void showNextPage(){}

    /**
     * Displays the previous page of data in the table. 
     * @see #setPageSize
     * @see #setRecordRange
     */
    public void showPreviousPage(){}

    
    /**
     *  @internalonly
     *  @hidden
     */
    protected void regenerate(){}
    
    /**
     * Sets the alignment of the table.   
     * @param alignType The alignment type for this table, from DhAlignment
     * @exception WFCInvalidArgumentExcpeption If <i>alignType</i> is text-specific such as DhAlignment.JUSTIFY,
     * DhAlignment.SUPERSCRIPT, DhAlignment.SUBSCRIPT
     */
    public void setAlign( int alignType ){}
    
    
/**
 * Creates a table element that can be populated with rows and columns. 
 * @hidden
 * @internalonly
 *
 * @security(checkClassLinking=on)
 */        
    public static class ClassInfo extends DhBaseContainer.ClassInfo {
        public static final PropertyInfo bodyRowCount =
                                                       new PropertyInfo(DhTable.class, "bodyRowCount", Integer.TYPE,
            CategoryAttribute.Appearance,
            PersistableAttribute.NO,
            new DescriptionAttribute(Sys.getString("DhTableRowCount")));
        public static final PropertyInfo totalRowCount =
                                                        new PropertyInfo(DhTable.class, "totalRowCount", Integer.TYPE,
            CategoryAttribute.Appearance,
            PersistableAttribute.NO,
            new DescriptionAttribute(Sys.getString("DhTableRowCount")));
        public static final PropertyInfo pageSize =
                                                   new PropertyInfo(DhTable.class, "pageSize", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("DhTablePageSize")));
        public static final EventInfo readyStateChange = new EventInfo(DhTable.class, "readyStateChange",
                                                                       com.ms.wfc.ui.ReadyStateEventHandler.class,
                                                                       CategoryAttribute.Behavior);
                                                                       

        public void getProperties(IProperties props) {}
        
        public void getEvents(IEvents events) {}
    }
    
     
    class RecordDataBuffer{
        
        String[] buffers;    
        boolean[] dataItems;
        String endChunk;
        int cleanLen;
        
        RecordDataBuffer( String cleanString, int[] dataOffsets, int[] idOffsets ){}
        
        public StringBuffer getString( StringBuffer sb, String[] dataValues, String[] idValues ){}            
        
        public int getNumValues(){}
    }
    
}









class DhParentProxyContainer extends DhBaseContainer {

    
    public DhParentProxyContainer(){}

    public DhParentProxyContainer( DhElement parent ){};

    public void add( DhElement e ){}

    protected void addWashed(DhElement element, DhElement relativeTo, int insertFlag ){}

    public int remove( DhElement e ){}

    public void removeAll(){}

    protected int removeWashed(DhElement element){}   

    
}


class DhPeerTreeInfo {
    protected Class[] m_childClasses;
    protected int m_curItem;
}