//STRIPPEDSOURCE//

package com.ms.wfc.html;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;

/**
 * Defines mode constants for the DhText class. ms.wfc.html.DhText.html">DhText</a>
 *
 * @security(checkClassLinking=on)
 */
public class DhTextMode extends Enum {

    /**
     * Specifies that the text contents will behave with normal HTML flow. */
    public final static int FLOW = 0;

    /**
     * Specifies that the text contents will be rendered in a fixed font and all white space,
     * such as spaces, tabs, carriage returns, and line feeds, will also be rendered.) will also be renedered.  The element will also
     * appear as a block element with a leading and trailing linebreak, unless 
     * otherwise positioned.
     */        
    public final static int RESPECT_SPACE = 1;

    /**
     * Specifies that the text contents will be rendered with no line breaks and will be
     * clipped at the edge of the document rather than wrapping.
     */
    public final static int NO_BREAK = 2;

    
    static int mapToStrId( int textMode ){}

    static int mapFromStrId( int strId ){}

    public static boolean valid(int n) {}
}