//STRIPPEDSOURCE//
package com.ms.wfc.html;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;

/**
 * Provides constants for various unit types in DHTML. 
 * @security(checkClassLinking=on)
 */
public class DhUnits extends Enum {
    /**
     * Represents an unspecified or absent type. */
    public static final int NULL    = 0;

    /**
     * Represents the color type. */
    public static final int COLOR   = 1;

    /**
     * Represents the percentage (%) type. */
    public static final int PERCENT = 2;
    
    /**
     * Represents the centimeter (cm) type. */
    public static final int CM      = 3;
    
    /**
     * Represents the relative height of the element's font (em). */
    public static final int EM      = 4;
    
    /**
     * Represents an x height (ex). */
    public static final int EX          = 5;
    
    /**
     * Represents an inches (in) type. */
    public static final int INCH        = 6;
    
    /**
     * Represents a millimeter (mm) type. */
    public static final int MM          = 7;
    
    /**
     * Represents a pica (pc) type. */
    public static final int PC          = 8;
    
    /**
     * Represents a pixel (px) type. */
    public static final int PIXEL   = 9;
    
    /**
     * Represents a point (pt) type. */
    public static final int POINT   = 10;

    /**
     * Represents the auto type. */
    public static final int AUTO        = 11;

    static int mapToStrId( int n ){}

    static int mapFromStrId( int strId ){}

    public static boolean valid(int n) {}
}