//STRIPPEDSOURCE//

package com.ms.wfc.html;

import com.ms.wfc.html.om.IHTMLDocument2;
import com.ms.wfc.html.om.IHTMLWindow2;
import com.ms.wfc.html.om.IHTMLBodyElement;
import com.ms.wfc.html.om.IHTMLFramesCollection2;
import com.ms.wfc.html.om.IHTMLLocation;
import com.ms.wfc.html.om.IOmHistory;
import com.ms.wfc.html.om.IOmNavigator;
import com.ms.wfc.html.om.IHTMLDialog;

import com.ms.com.Variant;
import com.ms.com.ComFailException;
import com.ms.com.IUnknown;
import com.ms.com.IServiceProvider;
import com.ms.com.*;

import com.ms.wfc.core.*;
import com.ms.wfc.ax.IObjectIdentity;

/**
 * Encapsulates an HTML window. 
 * @security(checkClassLinking=on)
 */
public class DhWindow { 
    private IHTMLWindow2   m_windowPeer;
    private IHTMLDocument2 m_documentPeer;
    private DhDocument     m_document;
    static  private DhWindow m_firstWindow = null;
    private DhWindow m_nextWindow;

    
    DhWindow() {}

    
    DhWindow(IHTMLWindow2 window, IHTMLDocument2 docPeer, DhDocument document) {}

    protected void finalize() throws Throwable {}
    
    private static void addToList(DhWindow window) {}

    static void removeFromList(DhWindow window) {}

    /**
     * Retrieves the underlying HTML peer element for this class.  This method may return <b>null</b>
     * if the document is not bound to this class. Java code that is running in a 
     * trusted environment can freely cast the resulting reference to a specific element peer type 
     * (e.g. com.ms.wfc.html.om.IHTMLWindow2). This method will always return <b>null</b> if the
     * code is running in a Web server environment.<p>
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em>
     *
     * @return The element peer underlying the HTML peer for this class.
     */
    final protected IHTMLWindow2 getWindowPeer() {}

    /**
     * Retrieves the underlying HTML peer element for this class.  This method may return <b>null</b>
     * if the document is not bound to this class. Java code that is running in a 
     * trusted environment can freely cast the resulting reference to a specific element peer type 
     * (e.g. com.ms.wfc.html.om.IHTMLWindow2). This method will always return <b>null</b> if the
     * code is running in a Web server environment.<p>
     * <em>Note that calling this method represents a very advanced usage scenario. Normally you would
     * never use this method.</em>
     *
     * @return The element peer underlying the HTML peer for this class.
     */
    final public IUnknown getPeer() {}

    /** 
     * Retrieves the document contained in this window. 
     * The result can be null if the document is not accessible (because of security restrictions, for
     * example).
     *
     * @return The document associated with this window.
     */
    public DhDocument getDocument() {}

    /** 
     * Retrieves the parent of this window. 
     *
     * @return The parent window of this window.
     */
    public DhWindow getParent() {}

    private DhWindow createWindow(IHTMLWindow2 windowPeer) {}

    /** 
     * Retrieves an array of DhWindow objects, one for each frame enclosed in this
     * window. 
     *
     * @return The array of windows defining the enclosed frames.
     */
    public DhWindow[] getFrames() {}

    /** 
     * Retrieves the first frame that has the specified name. 
     * This name has to be unique. Otherwise, we return null.
     *
     * @param name Name of the frame we are looking for.
     * @return The window defining the enclosed frame having the given name.
     */
    public DhWindow getFrame(String name) {}

    
    final static private DhWindow findWindow(IHTMLWindow2 windowPeer) {}

    /** 
     * Displays a modal user message box. 
     *
     * @param s Message to display.
     */
    final public void messageBox( String s ) {}

    /**
     * Displays a string on the status bar of the window host (typically the browser). 
     *
     * @param s The string to display in the status bar.
     */
    final public void setStatus(String s ) {}

    /**
     * Sets or removes the focus of the current window. 
     *
     * @param focus True = set focus and False = remove focus.
     */
    final public void focus(boolean focus) {}

    /**
     * Retrieves a string representing the URL of the window's document. 
     *
     * @return Location URL of the window.
     */
    final public String getURL() {}

    /**
     * Retrieves a search string passed to the document. 
     * @return Search segment of URL of the window.
     */
    final public String getSearchString() {}

    /**
     * Retrieves a hash string passed to the document. 
     * @return Hash segment of URL of the window.
     */
    final public String getHashString() {}

    /**
     * Sets the name of the current window. 
     *
     * @param name Name of the window (cannot have spaces in it).
     */
    final public void setName(String name) {}

    /**
     * Retrieves a string representing the name of the window. 
     *
     * @return Name of the window.
     */
    final public String getName() {}

    /**
     * Opens a new URL in this window with the specified name and properties.
     *
     * @param url  String defining the URL of the new location.
     * @param name Name of the window (cannot have punctuation in it).
     * @param wi   Structure defining the appearance and size of the new window.
     * @param fReplace Boolean defining whether we need to replace the current contents.
     */
    final public DhWindow open(String url, String name, DhWindowInfo wi, boolean fReplace) {}

    private void acquireDocumentPeer() {}
    
    final void setNewDocument(EventHandler h) {}

    final void startPollingForNewDocument(EventHandler h) {}

    /**
     * Opens a new URL in this window with the specified name and properties. 
     *
     * @param url  String defining the URL of the new location.
     */
    final public void navigate(String url, EventHandler h) {}

    /**
     * Retrieves the number of entries in the window's history. 
     */
    final public int getHistoryLength() {}
    
    /**
     * Loads the previous URL in the history list. 
     *
     * @param delta Number of pages to go back relative to the current page.
     */
    final public void goBackInHistory(int delta, EventHandler h) {}

    /**
     * Loads the next URL in the history list. 
     *
     * @param delta Number of pages to go forward relative to the current page.
     */
    final public void goForwardInHistory(int delta, EventHandler h) {}

    /**
     * Loads the previous URL in the history list. 
     *
     * @param delta Number of pages to go back/forward relative to the current page.
     * @return     Unique index representing this navigation.
     */
    final public void goRelativeInHistory(int delta, EventHandler h) {}

    /**
     * Closes the window, and resets its document and window peers to null. 
     */
    public void close() {}

    /**
     * Determines whether the window is closed. 
     *
     * @return Is window closed.
     */
    final public boolean getClosed() {}

    /**
     * Opens an HTML dialog window using the URL as the source of the contents and DhDialogInfo to define the appearance of the
     * dialog window. 
     *
     * Returns a Variant which packages the return value(s) of the dialog
     *
     * @param dialogURL  String defining the URL of the dialog contents.
     * @param dialogArgs Arguments to the document defining the contents.
     * @param di         A structure which defines the appearance of the dialog.
     * @return           A Variant packaging the returned value(s) of the dialog.
     */
    final public Variant showModalDialog(String dialogURL, Variant dialogArgs, DhDialogInfo di) {}

    /**
     * Retrieves the arguments passed to a modal dialog window. 
     *
     * @return     Arguments passed to this dialog through showModalDialog().
     */
    final public Variant getDialogArguments() {}

    /**
     * Sets the return value that will be returned from a modal dialog window. 
     *
     * @return     Arguments passed to this dialog through showModalDialog().
     */
    final public void setReturnValue(Variant retValue) {}

    /**
     * Retrieves the return value from a modal dialog window. 
     *
     * @return     Arguments passed to this dialog through showModalDialog().
     */
    final public Variant getReturnValue() {}
    
    /**
     *  Sets the current scroll mode.   Can be:
     *  <p>
     *  <ul>
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>AUTO</b></a> -- Browser determines scolling
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>YES</b></a>  -- Scolling is enabled
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>NO</b></a>   -- Scolling is disabled
     *  </ul>
     * 
     * @param scrollMode The desired scrolling mode from DhScrollBars
     *@see   com.ms.wfc.html.DhScrollBars 
     */        
    public void setScroll( int scrollMode ){}
    
    /**
     *  Retrieves the current scroll mode.   Can be:
     *  <p>
     *  <ul>
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>AUTO</b></a> -- Browser determines scolling
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>YES</b></a>  -- Scolling is enabled
     *   <li><a href="com.ms.wfc.html.com.ms.wfc.DhScrollBars.html#AUTO">DhScrollBars.<b>NO</b></a>   -- Scolling is disabled
     *  </ul>
     * 
     * Note: <b>AUTO</b> and <b>YES</b> are equivelent
     * 
     * @return  The current scrolling mode
     *@see   com.ms.wfc.html.DhScrollBars 
     */        
    public int getScroll(){}

    
    
    

    DhBrowser m_browser;

    /**
     * Retrieves a representation of the browser. 
     *
     * @return Object representing the browser.
     */
    final public DhBrowser getBrowser() {}
    
    /**
     * Retrieves the topmost ancestor window of this window in the parenting heirarchy.   If this DhWindow is the top, it is returned.
     * 
     * @returns The topmost DhWindow object.
     */
    final public DhWindow getTopWindow(){}

    
    
    

    /**
     * Retrieves a peer that handles events for this window. 
     *
     * @return Peer handling DhEvents of this window.
     */
    final public IUnknown getEventPeer() {}
}


class DhNavigateThread extends Thread { 
    long m_timeout;
    DhWindow m_window;
    String m_url;
    EventHandler m_h;

    public DhNavigateThread(DhWindow window, String url, int timeout, EventHandler h) {}

    private String urlCurrent;
    private void getCurrentURL() {}
    
    public void run() {}
}