//STRIPPEDSOURCE//
package com.ms.wfc.html;
import com.ms.wfc.ui.Rectangle;
import com.ms.wfc.util.HashTable;
import com.ms.wfc.util.IEnumerator;

/**
 * Provides constants for setting features for a new browser or modal dialog window. 
 * See <a href="com.ms.wfc.html.DhWindow.html#open">DhWindow.open</a>
 *
 * @security(checkClassLinking=on)
 */
public class DhWindowInfo
{
        /** 
        * Tells the browser to open a new window using the full screen as size.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showFullScreen;
        /** 
        * Tells the browser to open a new window in theatre mode and show the channel band.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showChannelMode;
        /** 
        * Tells the browser to open a new window with toolbars showing.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showToolbar;
        /** 
        * Tells the browser to open a new window and display the input field for 
        * entering URLs directly into the browser .
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showLocation;
        /** 
        * Tells the browser to open a new window and add directory buttons.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showDirectoryButtons;
        /** 
        * Tells the browser to open a new window with the status bar showing.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showStatusbar;
        /** 
        * Tells the browser to open a new window with the menu bar showing.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showMenubar;
        /** 
        * Tells the browser to open a new window with the scroll bars showing.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean showScrollbars;
        /** 
        * Tells the browser to open a new window and make it resizable using resize handles.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public boolean isResizable;
        /** 
        * Tells the browser to open a new window using the rectangle as the size.
        * Used by <a href="#DhWindow.open()">DhWindow.open()</a>.
        */
        public Rectangle size;

        HashTable m_customFeatures;

        public DhWindowInfo()
        {}

        public DhWindowInfo(Rectangle size)
        {}

        final private String toString(boolean f)
        {}

        public String toString()
        {}

        private StringBuffer addCustomFeaturesToString(StringBuffer sb)
        {}

        /**
        * Adds a new custom feature. 
        * 
        * @param name  Name of the custom feature.
        * @param value Value of the custom feature.
        */
        public void addFeature(String name, String value)
        {}

        /**
        * Removes a custom feature. 
        * 
        * @param name Name of the custom feature.
        */
        public void removeFeature(String name)
        {}

        /**
        * Retrieves the value of the custom feature. 
        * 
        * @param name Name of the custom feature.
        * 
        */
        public String getValue(String name)
        {}
}