//STRIPPEDSOURCE//

package com.ms.wfc.html.event;

import com.ms.wfc.html.DhElement;
import com.ms.wfc.html.DhEventInfo;
import com.ms.wfc.html.om.IHTMLElement;
import com.ms.com.ConnectionPointCookie;
import com.ms.wfc.util.*;
import com.ms.wfc.core.*;
import com.ms.lang.Delegate;

/**
 * Event binder class that bridges the DHTML document object model (DOM) events and the com.ms.wfc.html package.
 * This class can be used for many advanced cases; however, the vast majority of the HTML element
 * wrappers have methods that encapsulate all of this 
 * functionality. See <a href="com.ms.wfc.html.DhElement.html#addOnClick">element.setOnClick</a>
 * as a prime example of this.
 *
 * @security(checkClassLinking=on)
 */
public class DhEvents { 
    public static boolean DO_EVENT_RUNTIME_CHECK = true;

    Component                       m_sender;
    private Class                   m_eventSet;
    private Object                  m_source;
    private ConnectionPointCookie   m_cookie;

    protected DhEvents( Component sender, Object source, Class set) {}

    protected void setEventSet( Class set ){}

    /** 
     * @internalonly
     * 
     * Clones the events from one DhEvents to this one.
     * 
     * @param  evSource The DhEvents that is used as the source of the clone.
     */
    public void cloneEvents(DhEvents evSource) {}

    /**
     * Binds (or unbinds) the source of the DOM events to a derivation of this class.
     *
     * @param source The event trigger object. This is typically an HTML peer (e.g. 
     * com.ms.wfc.html.om.IHTMLButtonElement). If <b>null</b> the trigger object will be "unhooked".
     *
     */
    public void bind( Object source ) {}

    public Component getSender() {}
    
    /**
     * @internalonly
     * 
     * Fires the event for the given DhEventID.
     * 
     * @param  eventID  The ID of the event whose handlers need to be notified.
     */
    protected void fireEvent(DhEventID eventID) {}

    /**
     * Fires the event with the given ID and uses the event object
     * as a parameter for the event handlers.
     * 
     * @param  eventID  Key identifying the event.
     * @param  e        Event object containing the information about the event.
     */
    public void fireEvent(DhEventID eventID, Event e) {}
        
    /**
     * @internalonly
     * 
     * Get the DhEvent structure of this object.
     * 
     * @return  Returns the DhEvent contained in this object.
     */
    protected DhEventInfo getEventInfo() {}

    public static final DhEventID EVENT_LOAD = new DhEventID("onload", DhEventType.GENERIC);
    public static final DhEventID EVENT_UNLOAD = new DhEventID("onunload", DhEventType.GENERIC);
    public static final DhEventID EVENT_BEFOREUNLOAD = new DhEventID("beforeunload", DhEventType.GENERIC);
    public static final DhEventID EVENT_SCROLL = new DhEventID("onscroll", DhEventType.SCROLL);
    public static final DhEventID EVENT_KEYDOWN   = new DhEventID("onkeydown", DhEventType.KEY);
    public static final DhEventID EVENT_HELP = new DhEventID("onhelp", DhEventType.HELP);
    public static final DhEventID EVENT_CLICK = new DhEventID("onclick", DhEventType.GENERIC);
    public static final DhEventID EVENT_MOUSEMOVE = new DhEventID("onmousemove", DhEventType.MOUSE);
    public static final DhEventID EVENT_MOUSEDOWN = new DhEventID("onmousedown", DhEventType.MOUSE);
    public static final DhEventID EVENT_MOUSEUP = new DhEventID("onmouseup", DhEventType.MOUSE);
    public static final DhEventID EVENT_MOUSELEAVE = new DhEventID("onmouseout", DhEventType.MOUSE);
    public static final DhEventID EVENT_MOUSEENTER = new DhEventID("onmouseover", DhEventType.MOUSE);
    public static final DhEventID EVENT_DBLCLICK = new DhEventID("ondblclick", DhEventType.GENERIC);
    public static final DhEventID EVENT_KEYPRESS = new DhEventID("onkeypress", DhEventType.KEYPRESS);
    public static final DhEventID EVENT_SELECTSTART = new DhEventID("onselectstart", DhEventType.GENERIC);
    public static final DhEventID EVENT_DRAGSTART = new DhEventID("ondragstart", DhEventType.GENERIC);
    public static final DhEventID EVENT_BEFOREUPDATE = new DhEventID("onbeforeupdate", DhEventType.GENERIC);
    public static final DhEventID EVENT_ERRORUPDATE = new DhEventID("onerrorupdate", DhEventType.GENERIC);
    public static final DhEventID EVENT_ROWEXIT = new DhEventID("onrowexit", DhEventType.GENERIC);

    public static final DhEventID EVENT_KEYUP = new DhEventID("onkeyup", DhEventType.KEY);
    public static final DhEventID EVENT_FILTERCHANGE = new DhEventID("onfilterchange", DhEventType.GENERIC);
    public static final DhEventID EVENT_AFTERUPDATE = new DhEventID("onafterupdate", DhEventType.GENERIC);
    public static final DhEventID EVENT_ROWENTER = new DhEventID("onrowenter", DhEventType.GENERIC);
    public static final DhEventID EVENT_DATASETCHANGED = new DhEventID("ondatasetchanged", DhEventType.GENERIC);
    public static final DhEventID EVENT_DATAAVAILABLE = new DhEventID("ondataavailable", DhEventType.GENERIC);
    public static final DhEventID EVENT_DATASETCOMPLETE = new DhEventID("ondatasetcomplete", DhEventType.GENERIC);

    public static final DhEventID EVENT_GOTFOCUS = new DhEventID("onfocus", DhEventType.GENERIC);
    public static final DhEventID EVENT_LOSTFOCUS = new DhEventID("onblur", DhEventType.GENERIC);
    public static final DhEventID EVENT_RESIZE = new DhEventID("onresize", DhEventType.GENERIC);
    public static final DhEventID EVENT_READYSTATECHANGE = new DhEventID("onreadystatechange", DhEventType.READYSTATE);
    public static final DhEventID EVENT_ABORT = new DhEventID("onabort", DhEventType.GENERIC);
    public static final DhEventID EVENT_ERROR = new DhEventID("onerror", DhEventType.GENERIC);
    public static final DhEventID EVENT_CHANGE = new DhEventID("onchange", DhEventType.GENERIC);
    public static final DhEventID EVENT_SELECT = new DhEventID("onselect", DhEventType.GENERIC);
    public static final DhEventID EVENT_RESET = new DhEventID("onreset", DhEventType.GENERIC);
    public static final DhEventID EVENT_SUBMIT = new DhEventID("onsubmit", DhEventType.GENERIC);


    final public boolean fireHelp()       {}
    final public boolean fireClick()      {}
    final public void fireMouseMove()     {}
    final public void fireMouseDown()     {}
    final public void fireMouseUp()       {}
    final public void fireMouseLeave()      {}
    final public void fireMouseEnter()     {}
    final public boolean fireDoubleClick()  {}
    final public boolean fireKeyPress()     {}
    final public boolean fireSelectStart()  {}
    final public boolean fireDragStart()    {}
    final public boolean fireBeforeUpdate() {}
    final public boolean fireErrorUpdate()  {}
    final public boolean fireRowExit()      {}
    final public void fireKeyDown()         {}
    final public void fireKeyUp()           {}
    final public void fireFilterChange()    {}
    final public void fireReadyStateChange() {}
    final public void fireAfterUpdate()     {}
    final public void fireRowEnter()        {}
    final public void fireDataSetChanged()  {}
    final public void fireDataAvailable() {}
    final public void fireDataSetComplete()   {}
    final public void fireGotFocus()          {}
    final public void fireLostFocus()         {}
    final public void fireResize()            {}
    final public void fireLoad()              {}
    final public void fireUnload()            {}
    final public void fireAbort()             {}
    final public void fireError()             {}
    final public void fireBeforeUnload()      {}
    final public void fireScroll()            {}
    final public void fireChange()                    {}
    final public void fireSelect()                    {}
    final public void fireReset()                     {}
    final public void fireSubmit()                    {}
}