//STRIPPEDSOURCE//
package com.ms.wfc.io;


import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.com.*;

/**
 * This class maps an IDataStream to an IStream. Instances of this class are
 * created by the <code>DataStream.getComStream()</code> and
 * <code>DataStream.toComStream()</code> methods as needed. You would typically
 * never create instances of this class yourself.<p>
 *
 * The implementation of IStream provided by this class is not complete. In
 * particular, the <code>Clone</code>, <code>CopyTo</code>, and
 * <code>Stat</code> methods return an E_NOTIMPL error code, and the
 * <code>LockRegion</code>, <code>UnlockRegion</code>, and <code>Revert</code>
 * methods are simply empty implementations.
 *
 * @see com.ms.wfc.io.DataStream#getComStream
 * @see com.ms.wfc.io.DataStream#toComStream
 *
 * @security(checkClassLinking=on)
 */
public class ComStreamFromDataStream implements IStream, IDataStreamProvider
{
    protected IDataStream dataStream;

    
    private long virtualPosition = -1;

    public ComStreamFromDataStream(IDataStream dataStream) {}

    private void actualizeVirtualPosition()
    {}
    
    public IStream Clone() {}

    public void Commit(int grfCommitFlags) {}

    public void CopyTo(IStream pstm, long cb, long[] pcbRead, long[] pcbWritten) {}

    public IDataStream getDataStream() {}

    public void LockRegion(long libOffset, long cb, int dwLockType) {}

    protected static void notImplemented() {}

    public int Read(byte[] buffer, int offset, int length) {}

    public void Revert() {}

    public long Seek(long offset, int origin) {}

    public void SetSize(long value) {}

    public void Stat(STATSTG pstatstg, int grfStatFlag) {}

    public void UnlockRegion(long libOffset, long cb, int dwLockType) {}

    public int Write(byte[] buffer, int offset, int length) {}
}