//STRIPPEDSOURCE//
package com.ms.wfc.io;

import com.ms.wfc.core.*;


/**
 * Defines constants that specify file access. 
 * @security(checkClassLinking=on)
 */
public class FileAccess extends Enum
{
    /**
     * Specifies read access to the file. Data can be read from the file and
     * the file pointer can be moved. Combine with WRITE for read-write access.
     */
    public static final int READ = 0x80000000;

    /**
     * Specifies write access to the file. Data can be written to the file and
     * the file pointer can be moved. Combine with READ for read-write access.
     */
    public static final int WRITE = 0x40000000;

    /**
     * Specifies read and write access to the file. Data can be written to the
     * file and the file pointer can be moved. Data can also be read from the 
     * file.
     */
    public static final int READWRITE = READ | WRITE;

    public static boolean valid(int value) {}
}