//STRIPPEDSOURCE//
package com.ms.wfc.io;

import com.ms.wfc.core.*;


/**
 * Defines constants that specify file modes. 
 * @security(checkClassLinking=on)
 */
public class FileMode extends Enum {
    /**
     * Specifies that a new file is to be created; an exception is thrown if the file already
     * exists. An exception is raised if the file already exists.
     */
    public static final int CREATE_NEW = 0x00000001;

    /**
     * Specifies that a new file is to be created; if the file already exists, it is
     * overwritten. If the file already exists, it is overwritten.
     */
    public static final int CREATE = 0x00000002;

    /**
     * Specifies that an existing file is to be opened; an exception is thrown if the file
     * does not exist. An exception is raised if the file does not exist.
     */
    public static final int OPEN = 0x00000003;

    /**
     * Specifies that an existing file is to be opened; otherwise, a new file is created. Otherwise, creates a new file.
     */
    public static final int OPEN_OR_CREATE = 0x00000004;

    /**
     * Specifies that an existing file it to be opened and then truncated so that its size is
     * zero bytes. Once opened, the file is truncated so that its
     * size is zero bytes. The calling process must open the file with at least
     * WRITE access. An exception is raised if the file does not exist.
     */
    public static final int TRUNCATE = 0x00000005;

    public static boolean valid(int value) {}
}