//STRIPPEDSOURCE//
package com.ms.wfc.io;

import com.ms.wfc.core.*;


/**
 * Defines constants that specify file sharing. 
 * @security(checkClassLinking=on)
 */
public class FileShare extends Enum
{
    /**
     * Specifies that the file cannot be shared.  Any request to open the file (by this process or another
     * process) will fail until the file is closed.
     */
    public static final int NONE = 0;

    /**
     * Allows subsequent opening of the file for reading.  If this flag is not
     * specified, any request to open the file for reading (by this process or
     * another process) will fail until the file is closed.
     */
    public static final int READ = 1;

    /**
     * Allows subsequent opening of the file for writing. If this flag is not
     * specified, any request to open the file for writing (by this process or
     * another process) will fail until the file is closed.
     */
    public static final int WRITE = 2;

    /**
     * Allows subsequent opening of the file for writing or reading. If this flag
     * is not specified, any request to open the file for writing or reading (by
     * this process or another process) will fail until the file is closed.
     */
    public static final int READWRITE = READ | WRITE;

    public static boolean valid(int value) {}
}