//STRIPPEDSOURCE//
package com.ms.wfc.io;

/**
 * This interface represents an object that can provide an IDataStream. It is
 * implemented by the ComStreamFromDataStream class, and used by the
 * <code>DataStream.fromComStream</code> method. You would normally never have
 * a reason to implement or use this interface directly.
 *
 * @security(checkClassLinking=on)
 */
public interface IDataStreamProvider
{
    /**
     * Returns the IDataStream associated with the object that implements the
     * IDataStreamProvider interface.
     *
     * @return The IDataStream associated with the object.
     * @see com.ms.wfc.io.DataStream#fromComStream
     */
    public IDataStream getDataStream();
}