//STRIPPEDSOURCE//
package com.ms.wfc.io;

/**
 * This interface represents a writer that can write a sequential stream of
 * characters. The Writer class provides a default implementation of this
 * interface.
 *
 * @see com.ms.wfc.io.Writer
 *
 * @security(checkClassLinking=on)
 */
public interface IWriter
{
    public void close();
    public void flush();
    public void write(char value);
    public void write(char[] buffer);
    public void write(char[] buffer, int index, int count);
    public void write(boolean value);
    public void write(int value);
    public void write(long value);
    public void write(float value);
    public void write(double value);
    public void write(String value);
    public void write(Object value);
    public void writeLine();
    public void writeLine(char value);
    public void writeLine(char[] buffer);
    public void writeLine(char[] buffer, int index, int count);
    public void writeLine(boolean value);
    public void writeLine(int value);
    public void writeLine(long value);
    public void writeLine(float value);
    public void writeLine(double value);
    public void writeLine(String value);
    public void writeLine(Object value);
}