//STRIPPEDSOURCE//
package com.ms.wfc.io;

import com.ms.wfc.core.*;

/**
 * Implements a reader that reads from a string. 
 *
 * @see com.ms.wfc.io.Reader
 * @see com.ms.wfc.io.StringWriter
 *
 * @security(checkClassLinking=on)
 */
public class StringReader extends Reader
{
    private String s;
    private int pos;
    private int length;

    /**
     * Constructs a StringReader for the given string.
     *
     * @param s The string to read.
     */
    public StringReader(String s) {}

    /**
     * Closes this StringReader object.  Following a call to this method, the string
     * reader will appear to have no further characters.
     */
    public void close() {}

    /**
     * Retrieves the next available character without actually reading it from the underlying
     * string.  The current position of the TextReader is not
     * changed by this operation. The returned value is -1 if no further
     * characters are available.
     *
     * @return The next character to be read, or -1 if no further characters
     * are available.
     */
    public int peek() {}

    /**
     * Reads the next character from the underlying string.  The returned value
     * is -1 if no further characters are available.
     *
     * @return The next character from the underlying string, or -1 if no
     * further characters are available.
     */
    public int read() {}

    /**
     * Reads the next character from the underlying string.  This method will read up to
     * <code>count</code> characters from this TextReader into the
     * <code>buffer</code> character array starting at position
     * <code>index</code>. Returns the actual number of characters read.
     *
     * @param buffer The character array to read data into.
     * @param index Starting index in the buffer.
     * @param count The number of characters to read.
     * @return The total number of characters read into the buffer. This may
     * be less than the number of characters requested if that many characters
     * aren't currently available, or zero if the end of the underlying string
     * is reached.
     */
    public int read(char[] buffer, int index, int count) {}

    /**
     * Reads a line.  A line is defined as a sequence of characters followed by
     * a carriage return ('\r'), a line feed ('\n'), or a carriage return
     * immediately followed by a line feed. The resulting string does not
     * contain the terminating carriage return and/or line feed. The returned
     * value is null if the end of the underlying string has been reached.
     *
     * @return The next line from the underlying string, or null if the end of
     * the underlying string is reached.
     */
    public String readLine() {}
}