//STRIPPEDSOURCE//
package com.ms.wfc.io;

import com.ms.wfc.core.*;

/**
 * Implements a writer that writes to a string buffer and allows the resulting sequence of  characters to be presented as a string. 
 *
 * @see com.ms.wfc.io.StringReader
 * @see com.ms.wfc.io.Writer
 *
 * @security(checkClassLinking=on)
 */
public class StringWriter extends Writer
{
    private StringBuffer sb;

    /**
     * Constructs a new StringWriter. A new StringBuffer is automatically
     * created and associated with the new StringWriter.
     */
    public StringWriter() {}

    /**
     * Constructs a new StringWriter that writes to the given StringBuffer.
     */
    public StringWriter(StringBuffer sb) {}

    /**
     * Retrieves the underlying StringBuffer object. This is either the StringBuffer
     * that was passed to the constructor, or the StringBuffer that was
     * automatically created.
     *
     * @return The underlying StringBuffer.
     */
    public StringBuffer getStringBuffer() {}

    /**
     * Writes a character to the underlying string buffer. 
     *
     * @param value The character to write.
     */
    public void write(char value) {}

    /**
     * Writes a character to the underlying string buffer. 
     * This method will write <code>count</code> characters of data into this
     * StringWriter from the <code>buffer</code> character array starting at
     * position <code>index</code>.
     *
     * @param buffer The character array to write data from.
     * @param index Starting index in the buffer.
     * @param count The number of characters to write.
     */
    public void write(char[] buffer, int index, int count) {}

    /**
     * Writes a character to the underlying string buffer.  If the given string is
     * null, nothing is written.
     *
     * @param value The string to write.
     */
    public void write(String value) {}

    /**
     * Retrieves a string containing the characters written to this StringWriter
     * object.
     *
     * @return String containing the characters written to the TextWriter.
     */
    public String toString() {}
}