//STRIPPEDSOURCE//
package com.ms.wfc.io;

import com.ms.wfc.util.*;
import com.ms.dll.*;

/**
 * Creates a Windows input/output (I/O) error exception class.  This class is used to report I/O errors
 * that originate from the operating system.
 *
 * @security(checkClassLinking=on)
 */
public class WinIOException extends IOException
{
    private int errorCode;

    /**
     * Creates a WinIOException based on the last operating system error. The
     * constructor calls the <code>com.ms.dll.DllLib.getLastWin32Error</code>
     * method to fetch the last operating system error code and constructs an
     * error message based on that error code.<p>
     *
     * When using J/Direct to call a Windows API function, if the function
     * reports an error, you can turn that error into a WinIOException using
     * this constructor.
     *
     * @see #WinIOException(int)
     * @see #WinIOException(int,String)
     */
    public WinIOException() {}

    /**
     * Creates a WinIOException based on a given error code. The constructor
     * calls the <a href="com.ms.wfc.util.Utils.html#getSystemErrorMessage">
     * Utils.getSystemErrorMessage</a> method to construct an error message
     * based on the given error code.
     *
     * @see #WinIOException()
     * @see #WinIOException(int,String)
     */
    public WinIOException(int errorCode) {}

    /**
     * Creates a WinIOException with a given error code and error message.
     *
     * @see #WinIOException()
     * @see #WinIOException(int,String)
     */
    public WinIOException(int errorCode, String s) {}

    /**
     * Retrieves the error code associated with this exception.   The error
     * code is the same as those returned by the Win32 API GetLastError().
     * Win32 SDK Documentation should be consulted for full information on
     * these errors.
     *
     * @return The operating system error code for the exception.
     */
    public int getErrorCode() {}
}