//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Various components will let you configure their appearance.  For many of
 * the basic ones, you can choose a "deafult" or "button-like" appearance.
 * This enumeration lets you control this.
 *
 * @security(checkClassLinking=on)
 */
public class Appearance extends Enum {

    /**
     * Indicates that the component should draw normally or with it's "default"
     * UI.
     */
    public static final int         NORMAL              = 0;

    /**
     * Indicates that the component should draw itself like a windows push
     * button.
     */
    public static final int         BUTTON              = 1;


    /**
     * Ensures that the given value is valid within this enumeration.
     */
    public static boolean valid(int value) {}
}