//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines constants that specify which sides of a rectangle to apply a  three-dimensional border to. 
 *
 * @see Graphics
 *
 * @security(checkClassLinking=on)
 */
public final class Border3DSide {

    /**
     * Draws a three-dimensional border on the left side of a rectangle.
     */
    public static final int LEFT = win.BF_LEFT;

    /**
     * Draws a three-dimensional border on the upper side of a rectangle.
     */
    public static final int TOP = win.BF_TOP;

    /**
     * Draws a three-dimensional border on the right side of a rectangle.
     */
    public static final int RIGHT = win.BF_RIGHT;

    /**
     * Draws a three-dimensional border on the lower side of a rectangle.
     */
    public static final int BOTTOM = win.BF_BOTTOM;

    /**
     * Fills in the interior of the rectangle with the color defined for three-dimensional
     * controls instead of with the background color for the form.
     */
    public static final int MIDDLE = win.BF_MIDDLE;

    private static final int ALL = LEFT | TOP | RIGHT | BOTTOM | MIDDLE;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}