//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines constants that specify the kind of three-dimensional border to apply to a  rectangle. 
 *
 * @security(checkClassLinking=on)
 */
public final class Border3DStyle extends Enum {
    
    /**
     * Specifies that the border should be drawn outside the specified rectangle, preserving
     * the dimensions of the rectangle for drawing.
     */
    public static final int ADJUST = win.BF_ADJUST;

    /**
     * Specifies a raised outer edge and a sunken inner edge.
     */
    public static final int BUMP = win.EDGE_BUMP;

    /**
     * Specifies a sunken inner edge and a raised outer edge.
     */
    public static final int ETCHED = win.EDGE_ETCHED;

    /**
     * Specifies a border with no three-dimensional effects.
     */
    public static final int FLAT = win.BF_FLAT | win.EDGE_SUNKEN;

    /** 
     * Specifies raised inner and outer edges.
     */
    public static final int RAISED = win.EDGE_RAISED;

    /**
     * Specifies a raised inner edge and no outer edge.
     */
    public static final int RAISEDINNER = win.BDR_RAISEDINNER;

    /**
     * Specifies a raised outer edge and no inner edge.
     */
    public static final int RAISEDOUTER = win.BDR_RAISEDOUTER;

    /**
     * Specifies sunken inner and outer edges.
     */
    public static final int SUNKEN = win.EDGE_SUNKEN;

    /**
     * Specifies a sunken inner edge and no outer edge.
     */
    public static final int SUNKENINNER = win.BDR_SUNKENINNER;

    /**
     * Specifies a sunken outer edge and no inner edge.
     */
    public static final int SUNKENOUTER = win.BDR_SUNKENOUTER;

    private static final int ALL = ADJUST | BUMP | ETCHED | FLAT | RAISED |
        RAISEDINNER | RAISEDOUTER | SUNKEN |SUNKENINNER | SUNKENOUTER;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}