//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines the brush style constants on which you can base Brush objects.
 * @see Brush
 *
 * @security(checkClassLinking=on)
 */
public class BrushStyle extends Enum {
    
    /**
     * Specifies a hatched brush consisting of backward diagonal lines.
     */
    public static final int BACKWARDDIAGONAL = 0;

    /**
     * Specifies a hatched brush consisting of horizontal and vertical crossing lines.
     */
    public static final int CROSS = 1;
    
    /**
     * Specifies a hatched brush consisting of diagonal crossing lines.
     */
    public static final int DIAGONALCROSS = 2;

    /**
     * Specifies a hatched brush consisting of forward diagonal lines.
     */
    public static final int FORWARDDIAGONAL = 3;

    /**
     * Specifies a "hollow" brush. A hollow brush does not paint.
     */
    public static final int HOLLOW = 4;
    
    /**
     * Specifies a hatched brush consisting of horizontal lines.
     */
    public static final int HORIZONTAL = 5;
    
    /**
     * Specifies a pattern brush. A pattern brush is one in which the pattern is based on a
     * bitmap.
     */
    public static final int PATTERN = 6;
    
    /**
     * Specifies a solid-colored brush.
     */
    public static final int SOLID = 7;

    /**
     * Specifies a hatched brush consisting of vertical lines.
     */
    public static final int VERTICAL = 8;

    private static final int MIN = 0;
    private static final int MAX = 8;
	
    /**
     * Retrieves a boolean value that indicates whether a specified value is
     * a valid member of this class.
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}