//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines constants that specify the appearance of a button.   This enum is used with the Graphics drawButton commands to determine
 * how to draw a button.
 * 
 * @see Graphics
 *
 * @security(checkClassLinking=on)
 */
public final class ButtonState {
    
    /**
     * Specifies that the button has a shaded background.
     */
    public static final int CHECKED = win.DFCS_CHECKED;

    /**
     * Specifies that the button is flat.
     */
    public static final int FLAT = win.DFCS_FLAT;

    /**
     * Specifies that the button is disabled.
     */
    public static final int INACTIVE = win.DFCS_INACTIVE;

    /**
     * Specifies that the button is three-dimensional and not pressed.
     */
    public static final int NORMAL = 0;

    /**
     * Specifies that the button is pressed.
     */
    public static final int PUSHED = win.DFCS_PUSHED;

    
    private static final int ALL = FLAT | CHECKED | PUSHED | INACTIVE;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}