//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines constants that specify the kind of caption button to draw.   This enum is used with the Graphics drawCaptionButton command to
 * determine which button to draw.
 * 
 * @see Graphics
 *
 * @security(checkClassLinking=on)
 */
public final class CaptionButton extends Enum {
    
    /**
     * Specifies a Close button.
     */
    public static final int CLOSE = win.DFCS_CAPTIONCLOSE;

    /**
     * Specifies a Help button.
     */
    public static final int HELP = win.DFCS_CAPTIONHELP;

    /**
     * Specifies a Maximize button.
     */
    public static final int MAXIMIZE = win.DFCS_CAPTIONMAX;

    /**
     * Specifies a Minimize button.
     */
    public static final int MINIMIZE = win.DFCS_CAPTIONMIN;

    /**
     * Specifies a Restore button.
     */
    public static final int RESTORE = win.DFCS_CAPTIONRESTORE;

    private static final int MIN = win.DFCS_CAPTIONCLOSE;
    private static final int MAX = win.DFCS_CAPTIONHELP;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}