//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify the appearance of a control that can be checked and  unchecked.   Most commonly you'll find this a CheckBox
 * or a CheckedListBox.  Items can be completely checked, completely
 * unchecked, or, in some cases, partially checed, in which case a shaded
 * checkbox is typically painted instead.
 *
 * @security(checkClassLinking=on)
 */
public class CheckState extends Enum {

    /**
     * Specifies that the control is unchecked. */
    public static final int UNCHECKED     = 0;

    /**
     * Specifies that the control is checked. */
    public static final int CHECKED       = 1;

    /**
     * Specifies that the control is indeterminate (not checked or unchecked). An
     * indeterminate control generally has a shaded appearance.
     */
    public static final int INDETERMINATE = 2;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}
}