//STRIPPEDSOURCE//

package com.ms.wfc.ui;
import com.ms.wfc.util.*;
import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;


/**
 * Encapsulates a column header in a ListView  control. 
 *
 * ColumnHeaders can be added to the ListView using the ListView's
 * addColumn, insertColumn, or setColumns method.
 *
 * @security(checkClassLinking=on)
 */
public class ColumnHeader extends Component implements Cloneable {

    int index = -1;
    String text;
    int width = 60;
    int textAlign;
    ListView listview;

    /**
     * Creates a new ColumnHeader object
     */
    public ColumnHeader() {}

    /**
     * Creates an identical copy of this ColumnHeader object that is not attached to
     * any list view control.  */
    public Object clone() {}

    public void dispose() {}

    /**
     * Retrieves a value that indicates the current text alignment setting for the column
     * header. 
     * @return int  The current alignment as defined in the HorizontalAlignment class
     * @see HorizontalAlignment
     */
    public int getTextAlign() {}

    /**
     * Retrieves the zero-based index of the column header.   This index does not necessarily correspond
     * to the current visual position of the column in the ListView, because the
     * user may orerder columns if the <b>allowColumnReorder</b> property is true.
     *
     * @return int  The index of this column
     */    
    public int getIndex() {}

    /**
     * Retrieves the ListView object associated with
     * this column header.   May be <b>null</b>
     *
     * @return ListView control
     */
    public ListView getListView() {}

    /**
     * Retrieves the text associated with this column header. 
     * @return String   The header text
     */
    public String getText() {}

    /**
     * Retrieves the width of the column header. 
     *
     * @return int   column's width
     */
    public int getWidth() {}

    /**
     * Sets a value that indicates the current text alignment setting for the column header. 
     * @param value  The alignment as defined in the HorizontalAlignment class
     * @see HorizontalAlignment
     */
    public void setTextAlign(int value) {}

    /**
     * Sets the text associated with this column header. 
     * @param str   New column header text
     */
    public void setText(String str) {}

    /**
     * Sets the width of the column header. 
     * @param width     New width for this column in pixels
     */
    public void setWidth(int width) {}

    /**
     * Returns a string representation of this column header
     */
    public String toString() {}


    /**
     * Encapsulates a column header in a ListView  control. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {

        public static PropertyInfo textAlign =
            new PropertyInfo(ColumnHeader.class, "textAlign", HorizontalAlignment.class,
                new DescriptionAttribute(Sys.getString("ColumnAlignment")),
                DefaultValueAttribute.ZERO);

        public static PropertyInfo text =
            new PropertyInfo(ColumnHeader.class, "text", String.class,
                new ValueEditorAttribute(ImmediateStringEditor.class),            
                new DescriptionAttribute(Sys.getString("ColumnCaption")),
                DefaultValueAttribute.EMPTY_STRING);

        public static PropertyInfo width =
            new PropertyInfo(ColumnHeader.class, "width", int.class,
                new DescriptionAttribute(Sys.getString("ColumnWidth")),
                new DefaultValueAttribute(new Integer(60)));

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }

}