//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify the appearance of a combo box. 
 *
 * @security(checkClassLinking=on)
 */
public class ComboBoxStyle extends Enum { 

    /**
     * Specifies a simple combo box, which is an edit control with an attached list box that
     * is always displayed.
     */
    public static final int SIMPLE       = 0;
    
    /**
     * Specifies a drop-down combo box, which is an edit control with an attached list box
     * that is displayed only when the user clicks the drop-down arrow to the right of the edit
     * control.
     */
    public static final int DROPDOWN     = 1;
    
    /**
     * Specifies a drop-down list box, which is a selection field that cannot be edited by the
     * user with an attached list box that is displayed only when the user clicks the drop-down
     * arrow to the right of the selection field.
     */
    public static final int DROPDOWNLIST = 2;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}

}