//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.lang.Delegate;

/**
 * Encapsulates the ContextMenu control.  It basically acts like a regular Menu control,
 * but can be set for the ContextMenu property that most controls have.
 * 
 * @see com.ms.wfc.ui.Menu
 *
 * @security(checkClassLinking=on)
 */
public class ContextMenu extends Menu {

    EventHandler onPopup;

    /**
     * Creates a new ContextMenu object with no items in it by default.
     */
    public ContextMenu() {}

    /**
     * Creates a ContextMenu object with the given MenuItems.
     * 
     * @param   menuItems      These are the starting menu items this context
     *                         menu will display.
     * 
     * @see com.ms.wfc.ui.MenuItem
     */
    public ContextMenu(MenuItem[] menuItems) {}


    /**
     * Assigns a delegate to the popup event.
     * The popup event is fired when the context menu is about to be displayed.
     * The event handler can use this opportunity to add/remove/enable/disable
     * items contained in this menu as appropriate.

     * @param value     Event handler to install for this event.
     */
    public void addOnPopup(EventHandler value) {}

    /**
     * Triggers the popup event.
     * @param e     Event object
     */
    protected void onPopup(Event e) {}

    /**
     * Removes the delegate that is assigned to the popup event.
     *
     * @param value Event handler to be removed.
     */
    public void removeOnPopup(EventHandler value) {}

    /**
     * Displays the context menu over the specified control and at the specified position.  This method
     * doesn't return until the menu is dismissed.
     *
     * @param control   The control that this invocation of the context menu
     *                  is associated with
     * @param pos       The position to display the menu at, in client coordinates
     *                  of the control specified in the <b>control</b> parameter
     */
    public void show(Control control, Point pos) {}

    /**
     * Encapsulates the ContextMenu control.
     * 
     * @see com.ms.wfc.core.ClassInfo
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Menu.ClassInfo {
        public static final EventInfo popup = new EventInfo(
            ContextMenu.class, "popup", EventHandler.class,
            new DescriptionAttribute(Sys.getString("MenuItemOnInitDescr")));

        public void getEvents(IEvents events){}
    }
}