//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify how a control is anchored to the edges of its  container. 
 * 
 * Anchors define to which edges of the container a certain control is
 * bound to. When a control is anchored to an edge, the distance
 * between the control closest edge, and the specified edge, will
 * remain constant.<br>
 * 
 * For example, if a Control has a RIGHT anchor, then the control's
 * right edge will remain a constant distance away from the control's
 * container's right edge when the container resizes.<br>
 *
 * @security(checkClassLinking=on)
 */
public class ControlAnchor extends Enum
{
    public static final int TOP         = 0x01;
    public static final int BOTTOM      = 0x02;
    public static final int LEFT        = 0x04;
    public static final int RIGHT       = 0x08;

    public static final int ALL             = TOP | LEFT | BOTTOM | RIGHT;
    public static final int BOTTOMLEFT      = BOTTOM | LEFT;
    public static final int BOTTOMLEFTRIGHT = LEFT | BOTTOM | RIGHT;
    public static final int BOTTOMRIGHT     = BOTTOM | RIGHT;
    public static final int LEFTRIGHT       = LEFT | RIGHT;
    public static final int NONE            = 0;
    public static final int TOPBOTTOM       = TOP | BOTTOM;
    public static final int TOPBOTTOMLEFT   = TOP | LEFT | BOTTOM;
    public static final int TOPBOTTOMRIGHT  = TOP | RIGHT | BOTTOM;
    public static final int TOPLEFT         = TOP | LEFT;
    public static final int TOPLEFTRIGHT    = LEFT | TOP | RIGHT;
    public static final int TOPRIGHT        = TOP | RIGHT;

    public static boolean valid(int anchor) {}
}