//STRIPPEDSOURCE//
package com.ms.wfc.ui;

/**
 * Encapsulates the information used when creating a control.  It is sent to controls via the
 * <i>getCreateParams()</i> method, which controls override to set up their
 * special information.
 *
 * @security(checkClassLinking=on)
 */
public class CreateParams
{
    /**
     * Name of the window class to subclass. The default value for this field
     * is null, indicating that the window is not a subclass of an existing
     * window class. To subclass an existing window class, store the window
     * class name in this field. For example, to subclass the standard edit
     * control, set this field to "EDIT".
     */
    public String className;
    
    /**
     * The initial caption your control will have.
     */
    public String caption;
    
    /**
     * Window style bits. This must be a combination of WS_XXX style flags and
     * other control-specific style flags.
     */
    public int style;
    
    /**
     * Extended window style bits. This must be a combination of WS_EX_XXX
     * style flags.
     */
    public int exStyle;

    /**
     * Class style bits. This must be a combination of CS_XXX style flags. This
     * field is ignored if the className field is not null.
     */
    public int classStyle;

    /**
     * The left portion of the initial proposed location.
     */
    public int x;
    
    /**
     * The top portion of the initial proposed location.
     */
    public int y;
    
    /**
     * The initially proposed width.
     */
    public int width;
    
    /**
     * The initially proposed height.
     */
    public int height;
    
    /**
     * The controls parent.
     */
    public int parent;
    
    /**
     * Any extra information that the underlying handle might want.
     */
    public Object param;
}