//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;
import com.ms.lang.Delegate;

/**
 * Encapsulates a Windows date and time picker control, which allows users to specify date  and time information. 
 * @security(checkClassLinking=on)
 */
public class DateTimePicker extends Control {
    private static final int TIMEFORMAT_NOUPDOWN = win.DTS_TIMEFORMAT & (~win.DTS_UPDOWN);
    private EventHandler                    onCloseUp;
    private EventHandler                    onDropDown;
    private EventHandler                    onValueChanged;
    private DateTimeFormatEventHandler      onFormat;
    private DateTimeFormatQueryEventHandler onFormatQuery;
    private DateTimeUserStringEventHandler  onUserString;
    private DateTimeWmKeyDownEventHandler   onWmKeyDown;

    private int                             style;    
    
    
    private boolean                         validTime = true;
    private Time                            value = null;    
    private Time                            max = null;
    private Time                            min = null;
    private Color                           calendarForeColor = MonthCalendar.DEFAULT_FORE_COLOR;
    private Color                           calendarTitleBackColor = MonthCalendar.DEFAULT_TITLE_BACK_COLOR;
    private Color                           calendarTitleForeColor = MonthCalendar.DEFAULT_TITLE_FORE_COLOR;
    private Color                           calendarMonthBackground = MonthCalendar.DEFAULT_MONTH_BACK_COLOR;
    private Color                           calendarTrailingText = MonthCalendar.DEFAULT_TRAILING_FORE_COLOR;
    private Font                            calendarFont = null;

    
    
    
    
    
    private String                          customFormat;
    private boolean                         customFormatDisplayed = false;

    /**
     * Creates a DateTimePicker
     */
    public DateTimePicker() {}

    /**
     * Assigns a delegate to the closeUp event. 
     * The CloseUp event occurs when the dropdown calendar is dismissed and
     * disappears.
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnCloseUp(EventHandler value) {}

    /**
     * Assigns a delegate to the valueChanged event. 
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnValueChanged(EventHandler value) {}

    /**
     * Assigns a delegate to the dropDown event. 
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnDropDown(EventHandler value) {}

    /**
     * Assigns a delegate to the format event. 
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnFormat(DateTimeFormatEventHandler value) {}

    /**
     * Assigns a delegate to the formatQuery event. 
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnFormatQuery(DateTimeFormatQueryEventHandler value) {}

    /**
     * Assigns a delegate to the userString event. 
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnUserString(DateTimeUserStringEventHandler value) {}

    /**
     * Assigns a delegate to the wmKeyDown event. 
     *
     * @param value Delegate to call when event is fired.
     */
    public final void addOnWmKeyDown(DateTimeWmKeyDownEventHandler value) {}
    
    
    private int compareMaxTimes(Time t1, Time t2) {}

    
    private int compareMinTimes(Time t1, Time t2) {}

    
    private int compareTimes(Time t1, Time t2) {}
    
    /**
     * Creates the physical window handle.
     * 
     * @see Control.createHandle
     */
    protected void createHandle() {}

    /**
     * Destroys the physical window handle.
     * 
     * @see Control.destroyHandle
     */
    protected void destroyHandle() {}

    /**
     * Retrieves a boolean value indicating whether the user can edit the value in the
     * control by pressing F2.  If this property is set to <b>true</b> then
     * the onUserString event must also be handled to correctly convert
     * the user text into a time.
     * 
     * @return <b>true</b> if free form user strings are allowed
     * 
     * @see #setAllowUserString
     */
    public final boolean getAllowUserString() {}

    /**
     * Retrieves the color used to display text within the current month in the month
     * calendar. 
     * 
     * @return Current CalendarForeColor.
     * 
     * @see #setCalendarForeColor
     */
    public final Color getCalendarForeColor() {}

    /**
     * Retrieves the font currently used by the month calendar of the date and time picker
     * control. 
     * 
     * @return Current CalendarFont.
     * 
     * @see #setCalendarFont
     */
    public final Font getCalendarFont() {}

    /**
     * Retrieves the background color displayed in the month calendar's title. 
     * 
     * @return Current CalendarTitleBackColor
     * 
     * @see #setCalendarTitleBackColor
     */
    public final Color getCalendarTitleBackColor() {}

    /**
     * Retrieves the color used to display text within the month calendar's title. 
     * 
     * @return Current CalendarTitleForeColor
     * 
     * @see #setCalendarTitleForeColor
     */
    public final Color getCalendarTitleForeColor() {}

    /**
     * Retrieves the color used to display text for header and trailing-day days (days from
     * the previous and following month that appear on the current calendar). 
     * 
     * @return Current CalendarTrailingForeColor
     * 
     * @see #setCalendarTrailingForeColor
     */
    public final Color getCalendarTrailingForeColor() {}

    /**
     * Retrieves the background color used within the current month in the month calendar. 
     * 
     * @return Current CalendarMonthBackground
     * 
     * @see #setCalendarMonthBackground
     */
    public final Color getCalendarMonthBackground() {}

    /**
     * Returns the CreateParams used to create this window.
     *
     * @return CreateParams
     */
    protected CreateParams getCreateParams() {}

    /**
     * Retrieves a format string that specifies the custom format used by the control to
     * display date and time information. 
     * 
     * @return Custom format string.
     * 
     * @see #setCustomFormat
     * @see #setFormat
     */
    public final String getCustomFormat() {}

    /**
     * Retrieves a value indicating the whether the control displays date and time information
     * in long date format (for example, "Wednesday, April 7, 1999"), short date format
     * (for example, "4/7/99"), time format (for example, "5:31:34 PM"), or
     * custom format.  This determines the
     * style of format the date is displayed in.
     *
     * @see DateTimePickerFormat
     */
    public final int getFormat() {}

    
    private final boolean getLongDateFormat() {}

    /**
     * Retrieves a value indicating the last date that the control allows the user to select.  <b>null</b> is returned
     * if there is no maximum value.
     * 
     * @return Maximum allowed date.
     * 
     * @see #setMaxDate
     * @see #setMinDate
     */
    public final Time getMaxDate() {}

    /**
     * Retrieves a value indicating the first date that the control allows the user to select.
     *  <b>null</b> is returned if
     * there is no minimum value.
     * 
     * @return Minimum allwed date.
     * 
     * @see #setMinDate
     * @see #setMaxDate
     */
    public final Time getMinDate() {}

    /**
     * Retrieves a value indicating whether the drop-down month calendar will be aligned to
     * the right or left of the edit control of the date time picker control.   The calendar 
     * dropDown can be aligned to the left or right of the control.
     * 
     * @return  the current value of the dropDownAlign property.
     * 
     * @see com.ms.wfc.ui.LeftRightAlignment
     */
    public final int getDropDownAlign() {}

    
    /**
     * Retrieves a boolean value indicating whether it is possible to have no date
     * selected in the control. 
     * 
     * @return Current value of the ShowNone property.
     * 
     * @see #setShowNone
     */
    public final boolean getShowNone() {}

    
    private final boolean getTimeFormat() {}

    /**
     * Retrieves a boolean value indicating whether the control allows the user to
     * select a date by displaying an up/down arrow to the right of the control or whether the
     * control enables the user to display a drop-down calendar in which to select a date. 
     * 
     * @return Current value of the showUpDown property.
     * 
     * @see #setShowUpDown
     */
    public final boolean getShowUpDown() {}
    
    /**
     * Retrieves the date and time value currently displayed in the control.  <b>null</b> is returned if
     * there is no value selected.
     * 
     * @return Current value
     * 
     * @see #setValue
     */
    public final Time getValue() {}

    /**
     * Triggers the closeUp event. 
     * 
     * @param event Event data
     */
    protected void onCloseUp(Event event) {}

    /**
     * Triggers the dropDown event. 
     * 
     * @param event Event data
     * 
     * @see #addOnDropDown
     * @see #removeOnDropDown
     * @see cor.Event
     */
    protected void onDropDown(Event event) {}

    /**
     * Triggers the format event. 
     * 
     * @param event Event data
     * 
     * @see #addOnFormat
     * @see #removeOnFormat
     * @see cor.comctl.DateTimeFormatEvent
     */
    protected void onFormat(DateTimeFormatEvent event) {}

    /**
     * Triggers the formatQuery event. 
     * 
     * @param event Event Data
     * 
     * @see #addOnFormatQuery
     * @see #removeOnFormatQuery
     * @see cor.comctl.DateTimeFormatQueryEvent
     */
    protected void onFormatQuery(DateTimeFormatQueryEvent event) {}

    
    private final void onSysColorChange(Object sender, Event event) {}

    /**
     * Triggers the userString event. 
     * This event will only be fired if AllowUserString is set to true.
     * 
     * @param event Event data
     * 
     * @see #addOnUserString
     * @see #removeOnUserString
     * @see #setAllowUserString
     * @see com.ms.wfc.ui.DateTimeUserStringEvent
     */
    protected void onUserString(DateTimeUserStringEvent event) {}
    
    /**
     * Triggers the valueChanged event. 
     * 
     * @param event Event data
     * 
     * @see #addOnValueChanged
     * @see #removeOnValueChanged
     * @see cor.comctl.DateTimeChangeEvent
     */
    protected void onValueChanged(Event event) {}

    /**
     * Triggers the wmKeyDown event. 
     * 
     * @param event Event data
     * 
     * @see #addOnWmKeyDown
     * @see #removeOnWmKeyDown
     * @see cor.comctl.DateTimeWmKeyDownEvent
     */
    protected void onWmKeyDown(DateTimeWmKeyDownEvent event) {}

    /**
     * Removes the delegate that is assigned to the closeUp event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnCloseUp(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to the dropDown event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnDropDown(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to the format event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnFormat(DateTimeFormatEventHandler value) {}

    /**
     * Removes the delegate that is assigned to the formatQuery event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnFormatQuery(DateTimeFormatQueryEventHandler value) {}

    /**
     * Removes the delegate that is assigned to the userString event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnUserString(DateTimeUserStringEventHandler value) {}

    /**
     * Removes the delegate that is assigned to the valueChanged event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnValueChanged(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to the wmKeyDown event. 
     *
     * @param value Delegate not to fire on when the event is fired.
     */
    public final void removeOnWmKeyDown(DateTimeWmKeyDownEventHandler value) {}

    /**
     * Resets the calendar so that there is no upper limit to the selectable range of dates.   By default value, there is no
     * upper limit.
     */
    public void resetMaxDate() {}

    /**
     * Resets the calendar so that there is no lower limit to the selectable range of dates.   By default value, there is no
     * lower limit.
     */
    public void resetMinDate() {}

    /**
     * Resets the value of the date and time picker control to the current time.   By default, the value is the current time.
     */
    public void resetValue() {}

    /**
     * Resets the date and time display format of the calendar to DateTimePickerFormat.LONG.
     *   By default, the format is LONG.
     */
    public void resetFormat() {}
    
    /**
     * Sets a boolean value indicating whether the user can edit the value in the
     * control by pressing F2.  When set to true the user can edit the 
     * value in the control by pressing F2. When the user is done editing
     * the UserString event occurs, and the control user can interpret the
     * userstring.
     * 
     * @param b New value
     * 
     * @see #getAllowUserString
     * @see #OnUserString
     */
    public final void setAllowUserString(boolean b) {}

    
    private final void setControlColor(int colorIndex, Color value) {}
    
    
    private final void setControlCalendarFont() {}

    
    private final void setAllControlColors() {}

    /**
     * Sets the color used to display text within the current month in the month calendar.  This color is used to display text
     * within the month.
     * 
     * @param value Color to set the CalendarForeColor to.
     * 
     * @see #getCalendarForeColor
     */
    public final void setCalendarForeColor(Color value) {}
    
    /**
     * Sets the font used by the month calendar of the date and time picker control.  The calendar font is used to display text on the 
     * popup calendar.
     * 
     * @param font Font to set the CalendarFont to.
     * 
     * @see #getCalendarFont
     */
    public final void setCalendarFont(Font font) {}
    
    /**
     * Sets the background color displayed in the month calendar's title.  This color is used as the 
     * background for the calendar's title.
     * 
     * @param value Color to set the CalendarTitleBackColor to.
     * 
     * @see #getCalendarTitleBackColor
     */
    public final void setCalendarTitleBackColor(Color value) {}

    /**
     * Sets the color used to display text within the month calendar's title.  This color is used to display
     * the text in the calendar's title.
     * 
     * @param value Color to set the CalendarTitleForeColor to.
     * 
     * @see #getCalendarTitleForeColor
     */
    public final void setCalendarTitleForeColor(Color value) {}
    
    /**
     * Sets the color used to display text for header and trailing-day days (days from the
     * previous and following month that appear on the current calendar).  This color is used to display the 
     * text for the header and trailing day text. Header and trailing days are 
     * the days from the previous and following months that appear on the 
     * current month calendar.
     * 
     * @param value Color to set the CalendarTrailingForeColor to.
     * 
     * @see #getCalendarTrailingForeColor
     */
    public final void setCalendarTrailingForeColor(Color value) {}
    
    /**
     * Sets the background color used within the current month in the month calendar.  This color is used to display the 
     * background within the month.
     * 
     * @param value Color to set the CalendarMonthBackground to.
     * 
     * @see #getCalendarMonthBackground
     */
    public final void setCalendarMonthBackground(Color value) {}

    /**
     * Sets a value indicating the whether the control displays date and time information in
     * long date format (for example, "Wednesday, April 7, 1999"), short date format
     * (for example, "4/7/99"), time format (for example, "5:31:34 PM"), or
     * custom format.  Valid values are:<br>
     * <pre>
     * cor.comctl.DateTimePicker.DateTimePickerFormat.LONG
     * cor.comctl.DateTimePicker.DateTimePickerFormat.SHORT
     * cor.comctl.DateTimePicker.DateTimePickerFormat.TIME
     * cor.comctl.DateTimePicker.DateTimePickerFormat.CUSTOM
     * </pre>
     * 
     * @param format New format
     * 
     * @see #getFormat
     * @see #setCustomFormat
     * @see DateTimePickerFormat
     */
    public final void setFormat(int format) {}

    /**
     * Sets a format string that specifies the custom format used by the control to display
     * date and time information. 
     * 
     * @param sz Custom format string.
     * 
     * @see #getCustomFormat
     * @see #setFormat
     */
    public final void setCustomFormat(String sz) {}

    
    private final void setLongDateFormat(boolean b) {}

    /**
     * Sets a value indicating the last date that the control allows the user to select.  There is no maximum
     * value if Maximum is set to <b>null</b>.
     * 
     * @param date Maximum date value.
     * 
     * @see #getMaxDate
     * @see #setMinDate
     */
    public final void setMaxDate(Time date) {}    

    /**
     * Sets a value indicating the first date that the control allows the user to select.  There is no minimum
     * value if Minimum is set to <b>null</b>.
     * 
     * @param date Minimum date value.
     * 
     * @see #getMinDate
     * @see #setMaxDate
     */
    public final void setMinDate(Time date) {}    

    
    private final void setRange() {}

    /**
     * Sets a value indicating whether the drop-down month calendar will be aligned to the
     * right or left of the edit control of the date time picker control.   This controls how the dropDown is aligned to
     * the control.
     * 
     * @param value     The new alignment for the dropDown.
     * 
     * @see com.ms.wfc.ui.LeftRightAlignment
     */
    public final void setDropDownAlign(int value) {}

    
    private final void setShortDateFormat(boolean b) {}

    /**
     * Sets a boolean value indicating whether it is possible to have no date selected
     * in the control.  When ShowNone is set to true a checkbox
     * is displayed to the left of the date in the control. When the checkbox
     * is unchecked the value of the control is -1 indicating no date is 
     * selected.
     * 
     * @param b New value for ShowNone
     * 
     * @see #getShowNone
     */
    public final void setShowNone(boolean b) {}

    
    private void setStyleBit(boolean flag, int bit) {}

    
    private void setTimeFormat(boolean b) {}

    /**
     * Sets a boolean value indicating whether the control allows the user to select a
     * date by displaying an up/down arrow to the right of the control or whether the control
     * enables the user to display a drop-down calendar in which to select a date.  If showUpDown is set to true then a spin control
     * is used to adjust time values instead of the dropdown calendar.
     * 
     * @param b New value for showUpDown
     * 
     * @see #getShowUpDown
     */
    public final void setShowUpDown(boolean b) {}

    /**
     * Sets the date and time value to display in the control.  If ShowNone is <b>true</b>, setting the value 
     * to <b>null</b> has the effect of selecting a null date.  Otherwise, if ShowNone is
     * <b>false</b>, then setting the value to <b>null</b> will cause the current date and time 
     * to be selected.
     * 
     * @param time Time to display
     * 
     * @see #getValue
     * @see #setShowNone
     */
    public final void setValue(Time time) {}

    /**
     * Retrieves a boolean value indicating whether the value of the maxDate
     * property has been explicitly set. 
     * 
     * @return <b>true</b> if the maxDate should be persisted.
     */
    public boolean shouldPersistMaxDate() {}

    /**
     * Retrieves a boolean value indicating whether the value of the minDate
     * property has been explicitly set. 
     * 
     * @return <b>true</b> if the minDate should be persisted.
     */
    public boolean shouldPersistMinDate() {}

    /**
     * Retrieves a boolean value indicating whether the value property has been
     * explicitly set. 
     * 
     * @return <b>true</b> if the value should be persisted.
     */
    public boolean shouldPersistValue() {}

    public boolean shouldPersistFormat() {}
    
    /**
     * Returns the control as a string
     * 
     * @return String
     * @internalonly
     */
    public String toString() {}

    
    private void updateUpDown() {}

    
    private void wmCloseUp(Message m) {}

    
    private void wmDateTimeChange(Message m) {}
    
    
    private void wmDropDown(Message m) {}
    
    
    private void wmFormat(Message m) {}
    
    private void wmFormatQuery(Message m) {}
    
    private void wmUserString(Message m) {}
    
    private void wmWMKeyDown(Message m) {}
    
    
    private void wmReflectCommand(Message m) {}

    /**
     * Overrided wndProc
     * 
     * @internalonly 
     */
    protected void wndProc(Message m) {}


    /**
     * Encapsulates a Windows date and time picker control, which allows users to specify date  and time information. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Control.ClassInfo {

        public static final PropertyInfo text = new PropertyInfo(
            Control.ClassInfo.text,
            PersistableAttribute.NO);

        public static final PropertyInfo calendarForeColor = new PropertyInfo(
            DateTimePicker.class, "calendarForeColor", Color.class,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(MonthCalendar.DEFAULT_FORE_COLOR),
            new DescriptionAttribute(Sys.getString("DateTimePickerCalendarForeColorDescr")));
        
        public static final PropertyInfo calendarFont = new PropertyInfo(
            DateTimePicker.class, "calendarFont", Font.class,            
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(Font.DEFAULT_GUI),            
            new DescriptionAttribute(Sys.getString("DateTimePickerCalendarFontDescr")));

        public static final PropertyInfo calendarTitleBackColor = new PropertyInfo(
            DateTimePicker.class, "calendarTitleBackColor", Color.class,
            new DefaultValueAttribute(MonthCalendar.DEFAULT_TITLE_BACK_COLOR),
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerCalendarTitleBackColorDescr")));

        public static final PropertyInfo calendarTitleForeColor = new PropertyInfo(
            DateTimePicker.class, "calendarTitleForeColor", Color.class,
            new DefaultValueAttribute(MonthCalendar.DEFAULT_TITLE_FORE_COLOR),
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerCalendarTitleForeColorDescr")));

        public static final PropertyInfo calendarTrailingForeColor = new PropertyInfo(
            DateTimePicker.class, "calendarTrailingForeColor", Color.class,
            new DefaultValueAttribute(MonthCalendar.DEFAULT_TRAILING_FORE_COLOR),
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerCalendarTrailingForeColorDescr")));

        public static final PropertyInfo calendarMonthBackground = new PropertyInfo(
            DateTimePicker.class, "calendarMonthBackground", Color.class,
            new DefaultValueAttribute(MonthCalendar.DEFAULT_MONTH_BACK_COLOR),
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerCalendarMonthBackgroundDescr")));

        
        public static final PropertyInfo value = new PropertyInfo(
            DateTimePicker.class, "value", com.ms.wfc.app.Time.class,
            CategoryAttribute.Behavior,
            BindableAttribute.YES,
            new DescriptionAttribute(Sys.getString("DateTimePickerValueDescr")));

        
        public static final PropertyInfo maxDate = new PropertyInfo(
            DateTimePicker.class, "maxDate", com.ms.wfc.app.Time.class,
            new ValueEditorAttribute(com.ms.wfc.app.Time.Editor.class),
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("DateTimePickerMaxDateDescr")));

        
        public static final PropertyInfo minDate = new PropertyInfo(
            DateTimePicker.class, "minDate", com.ms.wfc.app.Time.class,
            new ValueEditorAttribute(com.ms.wfc.app.Time.Editor.class),
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("DateTimePickerMinDateDescr")));

        public static final PropertyInfo showNone = new PropertyInfo(
            DateTimePicker.class, "showNone", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerShowNoneDescr")));

        public static final PropertyInfo showUpDown = new PropertyInfo(
            DateTimePicker.class, "showUpDown", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerShowUpDownDescr")));

        public static final PropertyInfo customFormat = new PropertyInfo(
            DateTimePicker.class, "customFormat", String.class,
            DefaultValueAttribute.NULL,
            CategoryAttribute.Behavior,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("DateTimePickerCustomFormatDescr")));

        public static final PropertyInfo format = new PropertyInfo(
            DateTimePicker.class, "format", DateTimePickerFormat.class,
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerFormatDescr")));

        public static final PropertyInfo allowUserString = new PropertyInfo(
            DateTimePicker.class, "allowUserString", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("DateTimePickerAppCanParseDescr")));

        public static final PropertyInfo dropDownAlign = new PropertyInfo(
            DateTimePicker.class, "dropDownAlign", LeftRightAlignment.class,
            new DefaultValueAttribute(new Integer(LeftRightAlignment.LEFT)),
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("DateTimePickerDropDownAlignDescr")));
        
        
        public static final EventInfo closeUp = new EventInfo(
            DateTimePicker.class,
            "closeUp", EventHandler.class, CategoryAttribute.Action,
            new DescriptionAttribute(Sys.getString("DateTimePickerOnCloseUpDescr")));

        public static final EventInfo dropDown = new EventInfo(
            DateTimePicker.class, "dropDown", EventHandler.class,
            CategoryAttribute.Action,
            new DescriptionAttribute(Sys.getString("DateTimePickerOnDropDownDescr")));

        public static final EventInfo formatEvent = new EventInfo(
            DateTimePicker.class, "format", DateTimeFormatEventHandler.class,
            CategoryAttribute.Action,
            new DescriptionAttribute(Sys.getString("DateTimePickerOnFormatDescr")));

        public static final EventInfo formatQuery = new EventInfo(
            DateTimePicker.class, "formatQuery", DateTimeFormatQueryEventHandler.class,
            CategoryAttribute.Action,
            new DescriptionAttribute(Sys.getString("DateTimePickerOnFormatQueryDescr")));

        public static final EventInfo userString = new EventInfo(
            DateTimePicker.class, "userString", DateTimeUserStringEventHandler.class,
            CategoryAttribute.Action,
            new DescriptionAttribute(Sys.getString("DateTimePickerOnUserStringDescr")));

        public static final EventInfo valueChanged = new EventInfo(
            DateTimePicker.class, "valueChanged", EventHandler.class,
            CategoryAttribute.Action,
            new DescriptionAttribute(Sys.getString("valueChangedEventDescr")));        

        public static final EventInfo wmKeyDown = new EventInfo(
            DateTimePicker.class, "wmKeyDown", DateTimeWmKeyDownEventHandler.class,
            CategoryAttribute.Key,
            new DescriptionAttribute(Sys.getString("DateTimePickerOnWmKeyDownDescr")));

        public static final PropertyInfo backColor = new PropertyInfo(
            Control.ClassInfo.backColor, BrowsableAttribute.NO, PersistableAttribute.NO);

        public static final PropertyInfo foreColor = new PropertyInfo(
            Control.ClassInfo.foreColor, BrowsableAttribute.NO, PersistableAttribute.NO);

        public void getProperties(IProperties iprop) {}

        public void getEvents(IEvents ievents) {}

        public String getDefaultPropertyName() {}

        public String getDefaultEventName() {}

    }


    
    private static final class EnumChildren extends Callback {

        public int hwndFound = 0;

        public boolean callback(int hwnd, int lParam) {}
    }

    
    class SYSTEMTIMEARRAY {
        public short wYear1;
        public short wMonth1;
        public short wDayOfWeek1;
        public short wDay1;
        public short wHour1;
        public short wMinute1;
        public short wSecond1;
        public short wMilliseconds1;
        public short wYear2;
        public short wMonth2;
        public short wDayOfWeek2;
        public short wDay2;
        public short wHour2;
        public short wMinute2;
        public short wSecond2;
        public short wMilliseconds2;
    }
    
    private static native int SendMessageA(int hwnd, int msg, int wparam, String lparam);
    
    private static native boolean EnumChildWindows(int hwndParent, int lpEnumFunc, int lParam);

}