//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that represent common results returned from dialog boxes. 
 * You can also have a button on a dilaog directly return one of these
 * values to the parenting form, which will cause it close, without having
 * to manually hook up an event handler!
 * 
 * @see com.ms.wfc.ui.Button
 * @see com.ms.wfc.ui.Form
 *
 * @security(checkClassLinking=on)
 */
public class DialogResult extends Enum {
    
    /**
     * Specifies that the result sent from the dialog box is "NONE" (this means that
     * the modal dialog should continue running).  */
    public static final int NONE   = 0;
    
    /**
     * Specifies that the result sent from the dialog box is "OK" (usually sent from
     * a button labeled "OK"). */
    public static final int OK     = 1;
    
    /**
     * Specifies that the result sent from the dialog box is "CANCEL" (usually sent
     * from a button labeled "Cancel"). */
    public static final int CANCEL = 2;
    
    /**
     * Specifies that the result sent from the dialog box is "ABORT" (usually sent
     * from a button labeled "Abort"). */
    public static final int ABORT  = 3;
    
    /**
     * Specifies that the result sent from the dialog box is "RETRY" (usually sent
     * from a button labeled "Retry"). */
    public static final int RETRY  = 4;
    
    /**
     * Specifies that the result sent from the dialog box is "IGNORE" (usually sent
     * from a button labeled "Ignore"). */
    public static final int IGNORE = 5;
    
    /**
     * Specifies that the result sent from the dialog box is "YES" (usually sent
     * from a button labeled "Yes"). */
    public static final int YES    = 6;
    
    /**
     * Specifies that the result sent from the dialog box is "NO" (usually sent from
     * a button labeled "No"). */
    public static final int NO     = 7;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}