//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Provides data for the drawItem  event of a ComboBox, ListBox, StatusBar,  TabStrip, or TabControl control.  It contains all the information needed for the user to
 * paint the given item, including the item index, the Rectangle in which
 * the drawing should be done, and the Graphics object with which the drawing
 * should be done.
 *
 * @security(checkClassLinking=on)
 */
public class DrawItemEvent extends Event {
    
    /**
     * The graphics object with which the drawing should be done.
     */
    public final Graphics graphics;
    
    /**
     * The rectangle outlining the area in which the painting should be
     * done.
     */
    public final Rectangle rect;
    
    /**
     * The index of the item that should be painted.
     */
    public final int index;
    
    /**
     * Miscellaneous state information, such as whether the item is
     * "selected", "focused", or some other such information.  ComboBoxes
     * have one special piece of information which indicates if the item
     * being painted is the editable portion of the ComboBox.
     */
    public final int state;

    /**
     * Creates a new DrawItemEvent with the given parameters.
     * 
     * @param graphics      The graphics with which drawing is to be done.
     * @param rect          The rectangle in which drawing is to be done.
     * @param index         The index of the item that is to be drawn.
     * @param state         Any extra state information that might be useful.
     */
    public DrawItemEvent(Graphics graphics, Rectangle rect,
        int index, int state) {}

    /**
     * Draws the background for the rectangle in which the item is drawn with default Windows
     * control colors. 
     */
    public void drawBackground() {}

    /**
     * Draws a focus rectangle around the item if the item is selected. 
     */
    public void drawFocusRect() {}
}