//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.win32.*;

/**
 * Defines constants that specify state information for a drawing operation.   ComboBoxes
 * have one special piece of information which indicates if the item
 * being painted is the editable portion of the ComboBox.
 *
 * @security(checkClassLinking=on)
 */
public class DrawItemState extends Enum { 
    /**
     * Specifies that the drawing takes place in the edit control of an owner-drawn combo box.
     */    
    public static final int COMBOBOXEDIT = win.ODS_COMBOBOXEDIT;
    /**
     * Specifies that the item being drawn has the focus.
     */
    public static final int FOCUS        = win.ODS_FOCUS;
    /**
     * Specifies that the item being drawn is selected.
     */
    public static final int SELECTED     = win.ODS_SELECTED;
    /**
     * Specifies that the item being drawn is not selected and does not have the focus.
     */
    public static final int NONE         = 0;

    public static boolean valid(int value) {}
}