//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines a group of constants that specify how the elements of a list box or combo box  are drawn.
 * This enumeration is typically used by them to control how this works.
 *
 * @security(checkClassLinking=on)
 */
public class DrawMode extends Enum {

    /**
     * Represents a drawing mode in which all the items in a list box or combo box are painted
     * by the operating system and are of the same size. */
    public static final int NORMAL = 0;

    /**
     * Represents a drawing mode in which the items in the list box or combo box are painted
     * manually, but are of the same height. */
    public static final int OWNERDRAWFIXED = 1;

    /** 
     * Represents a drawing mode in which the items in the list box or combo box are painted
     * manually, but are not necessarily the same size.
     */
    public static final int OWNERDRAWVARIABLE = 2; 

    /**
     * Retrieves a boolean value that indicates whether the specified value
     * is a valid DrawMode constant. */
    public static boolean valid(int value) {}
}