//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.win32.*;

/**
 * Defines the filling modes used by the Graphics  object to fill an area.   
 * 
 * @see Graphics#floodFill 
 *
 * @security(checkClassLinking=on)
 */
public class FloodFillType extends Enum {
    
    /**
     * Specifies that a border flood fill begins filling at a specified point and continues in
     * all directions until it reaches a boundary color.
     */
    public static final int BORDER = win.FLOODFILLBORDER;
    
    /**
     * Specifies that a surface flood fill begins filling the area at a specified point and
     * continues in all directions, filling all adjacent regions containing a specified color.
     */
    public static final int SURFACE = win.FLOODFILLSURFACE;
    
    /**
     * Retrieves a boolean value that indicates whether a specified value is
     * a valid member of this class.
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {} 
}