//STRIPPEDSOURCE//
package com.ms.wfc.ui;












import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;

/** 
 * The FontDescriptor object, like the FontMetrics  object that it extends, provides information about the font that underlies a Font  object.  This information is not normally needed once you
 * have a font, but is very useful if you are building user interface
 * code to select fonts.
 * 
 * @see FontMetrics
 * @see Font
 * @see Graphics
 *
 *
 * @security(checkClassLinking=on)
 */
public class FontDescriptor extends FontMetrics {

    public String fullName;
    public String script;
    public String style;
    public int orientation;
    public int type;

    /** 
     * Creates a FontDescriptor for the given font as it will be rendered into
     * the given Graphics object.
     * 
     * @param font  The font to get the FontDescriptor for.
     * @param gr    The graphics object to render into.
     * 
     * @see Font
     * @see Graphics
     * 
     */
    public FontDescriptor(Font font, Graphics g) {}

    
    private FontDescriptor(NEWTEXTMETRIC ntm, ENUMLOGFONTEX lfex, int fonttype) {}

    
    static class FontEnum extends Callback {

        List infos = new List();

        /**
         * Returns an array of FontDescriptor objects for all fonts.
         * 
         * @param g The graphics object to interrogate.
         * 
         */
        public static final FontDescriptor[] getFonts(Graphics g) {}

        /**
         * Returns an array of FontDescriptor objects for all fonts that match
         * the given character set.
         * 
         * @param g         The graphics object to interrogate.
         * @param charSet   The character set to search for.
         * 
         */
        public static final FontDescriptor[] getFonts(Graphics g, int charSet) {}

        /**
         * Returns an array of FontDescriptor objects for all fonts that match
         * the given face name.
         * 
         * @param g     The graphics object to interrogate.
         * @param name  The font's face name.
         * 
         */
        public static final FontDescriptor[] getFonts(Graphics g, String name) {}

        /**
         * Returns an array of FontDescriptor objects for all fonts that match
         * the given name and character set.
         * 
         * @param g         The graphics object to interrogate.
         * @param charSet   The character set to search for.
         * @param name      The font's face name.
         * 
         */
        public static final FontDescriptor[] getFonts(Graphics g, int charSet, String name) {}

        
        private  FontDescriptor[] getFontDescriptors() {}

        /**
         * Callback method that is used to perform the actual font enumeration.
         */
        public int callback(int logfontex, int newtextmetric, int fonttype, int lparam) {}
    }
}