//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines a group of constants that determine what types of fonts will be listed in a  font dialog box.  This can be a screen, a printer, or both.
 *
 * @security(checkClassLinking=on)
 */
public class FontDevice extends Enum {

    /**
     * Indicates that the font is designed primarily for screen operations.
     */
    public static final int SCREEN  = 1;
    
    /**
     * Indicates that the font is designed primarily for printer use.
     */
    public static final int PRINTER = 2;
    
    /**
     * Indicates that the font is designed to be used both with screens and printers.
     */
    public static final int BOTH    = 3;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}
}