//STRIPPEDSOURCE//
package com.ms.wfc.ui;












import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;

/** 
 * Defines the physical characteristics of a font as it is mapped into a Graphics object. 
 * 
 * @see Font
 * @see Graphics
 *
 * @security(checkClassLinking=on)
 */
public class FontMetrics {

    public int ascent;
    public int averageWidth;
    public int breakChar;
    public int charSet;
    public char defaultChar;
    public int descent;
    public int digitizedAspectX;
    public int digitizedAspectY;
    public int externalLeading;
    public int family;
    public char firstChar;
    public int height;
    public int internalLeading;
    public boolean italic;
    public int maxWidth;
    public char lastChar;
    public String name;
    public int overhang;
    public int pitch;
    public boolean strikeOut;
    public boolean underline;
    public int weight;

    protected Font font;

    /**
     * Empty constructor.  A FontMetrics by itself is practically worthless, but
     * a derived version may have more functionality.
     */
    public FontMetrics() {}

    /** 
     * Creates a FontMetrics for the given font as it will be rendered into
     * the given Graphics object.
     * 
     * @param font  The font to get the FontMetrics for.
     * @param gr    The graphics object to render into.
     * 
     * @see Font
     * @see Graphics
     * 
     */
    public FontMetrics(Font font, Graphics g) {}
    
    /**
     * Retrieves a boolean value that indicates whether the specified object
     * is equivalent to this FontMetrics object.
     * @return true if the given object is equal to this one.
     * 
     * @see java.lang.Object
     */
    public boolean equals(Object obj) {}
    
    /**
     * Retrieves a boolean value that indicates whether the specified FontMetrics
     * object uses the same base font base as this one.
     *
     * @param fi  FontMetrics to test.
     *
     * @return true if the given font info has the same base characteristics
     *         as this font info.
     */
    public boolean equalsBase(FontMetrics fi) {}
    
    /**
     * Initializes this object based on the contents of a Win32 TEXTMETRIC
     * structure.
     * 
     * @param tm    A TEXTMETRIC structure.
     */
    protected final void fillFontMetrics(TEXTMETRIC tm) {}

    /**
     * Retrieves a human-readable, string representation of this object.
     * 
     * @return A human readable String representing this object.
     * 
     * @see java.lang.Object
     */
    public String toString() {}
}