//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates a font's pitch.  A variable pitch font has different
 * widths for different characters.  For example, an "i" will have a smaller
 * width than an "O".  Fixed pitch fonts uses the same width for all characters.
 * 
 * @see Font
 *
 * @security(checkClassLinking=on)
 */
public final class FontPitch extends Enum {

    /**
     * Represents a default pitch.   This is used by the Windows font
     * mapper when you don't care what pitch a font has.
     */
    public static final int DEFAULT = win.DEFAULT_PITCH;
    
    /**
     * Represents a fixed-pitch font.  Each character will have the same
     * width.
     */
    public static final int FIXED = win.FIXED_PITCH;
    
    /**
     * Represents a variable-pitch font.   The width of each character may be
     * different.
     */
    public static final int VARIABLE = win.VARIABLE_PITCH;
    
    private static final int MIN = DEFAULT;
    private static final int MAX = VARIABLE;
    
    /**
     * Retrieves a boolean value that indicates whether the specified value
     * is a valid FontFamily value.
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}