//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;
import com.ms.lang.Delegate;

/**
 * Represents the basic top-level window. 
 *
 * @security(checkClassLinking=on)
 */
public class Form extends Control implements ITopLevelWindow {

    private static final Object EVENT_ACTIVATE = new Object();
    private static final Object EVENT_CLOSING = new Object();
    private static final Object EVENT_CLOSED = new Object();
    private static final Object EVENT_DEACTIVATE = new Object();
    private static final Object EVENT_MDI_CHILD_ACTIVATE = new Object();
    private static final Object EVENT_INPUTLANGCHANGE = new Object();
    private static final Object EVENT_INPUTLANGCHANGEREQUEST = new Object();
    private static final Object EVENT_MENUSTART = new Object();
    private static final Object EVENT_MENUCOMPLETE = new Object();

    
    
    protected static final int FORMSTATE_BORDERSTYLE      =  0x0700; 
    protected static final int FORMSTATE_TASKBAR          =  0x0103;
    protected static final int FORMSTATE_CONTROLBOX       =  0x0104;
    protected static final int FORMSTATE_KEYPREVIEW       =  0x0105;
    protected static final int FORMSTATE_MAXIMIZEBOX      =  0x0106;
    protected static final int FORMSTATE_MINIMIZEBOX      =  0x0107;
    protected static final int FORMSTATE_HELPBUTTON       =  0x0108;
    protected static final int FORMSTATE_STARTPOS         =  0x0309; 
    protected static final int FORMSTATE_WINDOWSTATE      =  0x030b; 
    protected static final int FORMSTATE_PALETTEMODE      =  0x030d;
    protected static final int FORMSTATE_SHOWWINDOWONCREATE =  0x0110;
    protected static final int FORMSTATE_AUTOSCALING      =  0x0111;
    protected static final int FORMSTATE_AUTOSCROLLING    =  0x0112;
    protected static final int FORMSTATE_HSCROLLVISIBLE   =  0x0113;
    protected static final int FORMSTATE_VSCROLLVISIBLE   =  0x0114;
    protected static final int FORMSTATE_USERHASSCROLLED  =  0x0115;
    protected static final int FORMSTATE_SETCLIENTSIZE    =  0x0116;
    protected static final int FORMSTATE_TOPMOST          =  0x0117;

    
    private static final int AUTOSCALE_NOTSET = -1;
    
    
    private static final int SCROLL_PAGE = 100;
    
    private static final int SCROLL_LINE = 5;

    
    private Rectangle   displayRect = null;
    
    private Point       scrollMargin = null;
    
    private Point       requestedScrollMargin = null;
    
    private Point       scrollPosition = null;
    
    private Point autoScaleBaseSize = null;
    
    
    private int formState;
    
    private Control activeControl;
    
    private Control focusedControl;
    
    private IButtonControl acceptButton;
    
    private IButtonControl cancelButton;
    
    private IButtonControl defaultButton;
    
    private Form owner = null;
    
    private Form[] ownedForms = null;
    
    private int ownedFormsCount = 0;
    
    private Control paletteSource;
    
    private Icon icon;
    private Icon smallIcon;
    
    
    private MainMenu mainMenu;
    
    private MainMenu dummyMenu;
    
    private MainMenu curMenu;
    
    private MainMenu mergedMenu;

    
    private int updateMenuHandlesSuspendCount;
    
    private boolean updateMenuHandlesDeferred;

    
    private boolean active;
    
    private int dialogResult;

    
    private MDIClient ctlClient;
    
    private Form formMDIParent;

    
    private Form activeMDIChild;
    
    private boolean useMDIChildProc;

    private AxHost.Container aXContainer;
    
    /**
     * Creates a new form.
     */
    public Form() {}

    
    final boolean activateControl(Control control) {}

    private void updateFocusedControl() {}
    

    /**
     * Adds a control to the form. This visually parents the specified control
     * to the Form.
     *
     * @param control Control to add to the Form
     *
     * @see #remove
     */
    public void add(Control control) {}

    /**
     * Assigns a delegate to the activate event.
     * The activate event is fired when the form is activated.
     *
     * @param value Delegate to call when the event is fired
     *
     * @see com.ms.wfc.core.EventHandler
     * @see #removeOnActivate
     */
    public final void addOnActivate(EventHandler value) {}

    /**
     * Assigns a delegate to the closing event.
     * The Closing event is fired when the form is closed.
     *
     * @param value Delegate to call when the event is fired
     *
     * @see com.ms.wfc.core.CancelEventHandler
     * @see #removeOnClosing
     */
    public final void addOnClosing(CancelEventHandler value) {}

    /**
     * Assigns a delegate to the closed event.
     * The Closed event is fired when the form is closed.
     *
     * @param value Delegate to call when the event is fired
     *
     * @see com.ms.wfc.core.EventHandler
     * @see #removeOnClosed                
     */
    public final void addOnClosed(EventHandler value) {}

    /**
     * Assigns a delegate to the deactivate event.
     * The deactivate event is fired when the form is deactivated.
     *
     * @param value Delegate to call when the event is fired
     *
     * @see com.ms.wfc.core.EventHandler
     * @see #removeOnDeactivate
     */
    public final void addOnDeactivate(EventHandler value) {}

    /**
     * Assigns a delegate to the mdiChildActivate event. 
     * The MDIChildActivate occurs when a MDIChild window is activated.
     *
     * @param value Delegate to call when the event is fired.
     *
     * @see com.ms.wfc.core.EventHandler
     * @see #removeOnMDIChildActivate
     */
    public final void addOnMDIChildActivate(EventHandler value) {}

    public final void addOnMenuComplete(EventHandler value) {}
    
    public final void addOnMenuStart(EventHandler value) {}
    
    /**
     * Assigns a delegate to the inputLangChange event. 
     * The InputLangChange event is fired after the input language has changed
     * for this form.
     *
     * @param value Delegate to call when the event is fired.
     *
     * @see com.ms.wfc.ui.InputLangChangeEventHandler
     * @see #removeOnInputLangChange
     */
    public final void addOnInputLangChange(InputLangChangeEventHandler value) {}

    /**
     * Assigns a delegate to the inputLangChangeRequest event. 
     * The InputLangChangeRequest event is fired when the user attempts to
     * change the input language for this form. If the event is cancel then
     * the input language will not change.
     *
     * @param value Delegate to call when the event is fired.
     *
     * @see com.ms.wfc.ui.InputLangChangeRequestEventHandler
     * @see #removeOnInputLangChangeRequest
     */
    public final void addOnInputLangChangeRequest(InputLangChangeRequestEventHandler value) {}

    /**
     * Adds a form to this Form object's internal list of owned forms. Owned forms are other top level forms
     * that are children of this form.
     *
     * @param ownedForm Form to make owned by this form
     */
    public final void addOwnedForm(Form ownedForm) {}

    /**
     * Adjusts the automatic scroll bars on the form based on current control positions and
     * the currently selected control.
     *
     * @param displayScrollbars Determines if the scrollbars should be displayed
     *
     * @see #getAutoScroll
     */
    protected final void adjustFormScrollbars(boolean displayScrollbars) {}


    private void adjustSystemMenu(int hmenu) {}

    
    private void adjustSystemMenu() {}


    
    private void applyAutoScaling() {}

    
    private void applyClientSize() {}

    /**
     * Checks whether a modal dialog is ready to close. If the dialogResult
     * property is not DialogResult.NONE, the onClosing and onClosed events
     * are fired. A return value of true indicates that both events were
     * successfully dispatched and that event handlers did not cancel closing
     * of the dialog. User code should never have a reason to call this method.
     * It is public only so that the Application class can call it from a
     * modal message loop.
     */
    public final boolean checkCloseDialog() {}

    /**
     * Closes the form.
     */
    public final void close() {}

    
    private Point computeWindowSize(Point clientSize) {}

    
    private Point computeWindowSize(Point clientSize, int style, int exStyle) {}

    private AxHost.Container findAxContainer() {}

    AxHost.Container createAxContainer() {}

    
    private boolean assignActiveControl(Control value) {}

    
    void controlRemoved(Control control) {}

    /**
     * Creates the handle for the form.
     * 
     * If a subclass overrides this function, it must call the super implementation.
     *
     * @see Control.createHandle
     */
    protected void createHandle() {}

    /**
     * Calls the default window procedure for this form. 
     * 
     * If a subclass overrides this function, it must call the super implementation.
     *
     * @see Control.defWndProc
     */
    protected void defWndProc(Message m) {}

    /**
     * Releases all the system resources associated with this form. 
     * If a subclass overrides this function, it must call the super implementation.
     */
    public void dispose() {}

    
    private void fillInCreateParamsBorderIcons(CreateParams cp) {}

    
    private void fillInCreateParamsBorderStyles(CreateParams cp) {}

    
    private void fillInCreateParamsStartPosition(CreateParams cp) {}

    
    private void fillInCreateParamsWindowState(CreateParams cp) {}

    
    private void focusActiveControl() {}

    /**
     * Retrieves the current accept button for this form. 
     *
     * @return Control that current is the acceptButton
     *
     * @see #setAcceptButton
     */
    public final IButtonControl getAcceptButton() {}

    
    boolean getActive() {}

    /**
     * Retrieves the current active control.
     *
     * @return Current active control.
     *
     * @see #setActiveControl
     */
    public final Control getActiveControl() {}

    /**
     * Retrieves the currently active multiple document interface (MDI) child window. Will return <b>null</b> if
     * there are no MDIChild windows.
     *
     * @return Active MDIChild window
     */
    public final Form getActiveMDIChild() {}

    /**
     * Retrieves a boolean value that indicates whether the form is currently
     * configured to adjust its size to fit the height of the font used on the form and to scale
     * its child controls. When AutoScale is set
     * to <b>true</b> the form will adjust the size of the form to fit the height
     * of the font that is used on the form. All child controls will also be scaled.
     * This allows the form to resize to fit systems with Large Fonts and 
     * international systems.
     *
     * @return Current value of the AutoScale property
     *
     * @see #setAutoScale
     */
    public final boolean getAutoScale() {}

    /**
     * Retrieves the base size used for autoscaling.  The AutoScaleBaseSize is used
     * internally to determine how much to scale the form when AutoScaling is
     * used.
     * 
     * @return base autoScaling size
     * 
     * @see #getAutoScaleBaseSize
     * @see #setAutoScale
     * @hidden
     * @internalonly
     */
    public final Point getAutoScaleBaseSize() {}
    
    /**
     * Retrieves a boolean value that indicates whether the form will allow
     * scrolling of the form's contents when controls are located outside the form's bounds. When AutoScroll is
     * set to <b>true</b> the form will allow the user to scroll the contents of
     * the form if any child controls are placed outside the bounds of the form.
     * This allows the form to have a virtual size that is larger than the 
     * current form bounds.
     *
     * @return current value of the AutoScroll property
     *
     * @see #setAutoScroll
     */
    public final boolean getAutoScroll() {}

    /**
     * Retrieves the width and height of the autoscroll margin.
     * The margins define the width and height of the border around each
     * control. This border is used to determine when scrollbars are
     * needed on the form, and where to scroll to when a control is
     * selected.<p>
     *
     * @return current value of the AutoScrollMargin property
     *
     * @see #setAutoScrollMargin
     */
    public final Point getAutoScrollMargin() {}

    /**
     * Retrieves the current autoscroll position.  The
     * AutoScrollPosition property is used internally to adjust the position
     * of controls that there placed on the Form throught the form designer.
     *
     * @return Current value of the AutoScrollPosition property
     *
     * @see #setAutoScrollPosition
     * @hidden 
     * @internalonly
     */
    public final Point getAutoScrollPosition() {}

    
    final AxHost.Container getAxContainer() {}

    /**
     * Retrieves the form's current border style. The border style
     * of the Form determines how the outer edge of the Form appears. In addition
     * certain border styles prevent the form from being sized.
     *
     * @return Current value of the BorderStyle property.
     *
     * @see #setBorderStyle
     */
    public final int getBorderStyle() {}

    /**
     * Retrieves the form's cancel button. The cancel button will be "clicked"
     * when the user presses escape.
     *
     * @return Current cancelButton
     *
     * @see #setCancelButton
     */
    public final IButtonControl getCancelButton() {}

    java.lang.reflect.Field[] getContainedControls() {}

    Object getFieldValue(java.lang.reflect.Field field) {}


    /**
     * Retrieves a CreateParams object that describes the settings used to
     * create the form.
     * If a subclass overrides this function, it must call the super implementation.
     *
     * @return CreateParams used to create the window.
     *
     * @see Control.getCreateParams
     */
    protected CreateParams getCreateParams() {}

    /**
     * Retrieves a boolean value that indicates whether this form has a
     * control box. If ControlBox
     * is set to <b>true</b> the control box will be displayed in the upper
     * left corner of the caption bar. The control box is where the user
     * can click to access the system menu.
     *
     * @return Current value of the ControlBox property.
     *
     * @see #setControlBox
     */
    public final boolean getControlBox() {}

    /**
     * Retrieves the current display rectangle.  The display rectangle
     * is the virtual display area that is used to layout components.
     * The position and dimensions of the Form's display rectangle
     * change during autoScroll.
     * 
     * @return current display rectangle.
     */
    public Rectangle getDisplayRect() {}

    /**
     * Retrieves the bounds of the form in desktop coordinates. 
     *
     * @return bounds of the form in desktop coordinates.
     *
     * @see #setDesktopBounds
     */
    public final Rectangle getDesktopBounds() {}

    /**
     * Retrieves the location of the form in desktop coordinates. 
     *
     * @return location of the form in desktop coordinates.
     *
     * @see #setDesktopLocation
     */
    public final Point getDesktopLocation() {}

    /**
     * Retrieves the dialog result which designates the value that is returned from
     * this form when it is displayed as a modal dialog.
     *
     * @return current value of the DialogResult property.
     *
     * @see #setDialogResult
     */
    public final int getDialogResult() {}

    /**
     * Retrieves this form's parent.
     *
     * @return Form that this form is parented to.
     */
    public final Form getForm() {}

    /**
     * Retrieves the bits associated with the requested formstate.
     *
     * @return Value of the formState property
     *
     * @see setFormState
     * @see hasFormState
     */
    protected final int getFormState(int flag) {}

    /**
     * Retrieves a boolean value that indicates whether this form contains a
     * help button. If HelpButton
     * is set to <b>true</b> then a small question mark will appear in the 
     * caption bar to the left of the minimize, maximize, and close buttons.
     *
     * @return Current value of the HelpButton property
     *
     * @see #setHelpButton
     */
    public final boolean getHelpButton() {}

    /**
     * Retrieves a boolean value that indicates whether the horizontal scroll
     * bar is currently displayed.
     * @return Current value of the HScroll property
     *
     * @see #setHScroll
     */
    protected final boolean getHScroll() {}

    /**
     * Retrieves the form's current icon.
     *
     * @return Current value of the Icon property.
     *
     * @see #setIcon
     */
    public final Icon getIcon() {}

    /**
     * Retrieves a boolean value that indicates whether this form is set to
     * receive key events for contained controls before the controls receive them.
     *
     * @return Current value of the KeyPreview property.
     *
     * @see #setKeyPreview
     */
    public final boolean getKeyPreview() {}

    /**
     * Retrieves the bounds of this form in its maximized state. Classes that extend form
     * can override this function to provide new bounds for the form when
     * it is maximized. This function will get called when the form is being
     * resized.
     *
     * @return Bounds of the form when it is maximized.
     *
     * @see getMaxTrackSize
     * @see getMinTrackSize
     * @see SystemInformation.getPrimaryMonitorMaximizedWindowSize
     */
    protected Rectangle getMaximizedBounds() {}

    /**
     * Retrieves the maximum size to which this form can be resized. Classes that extend
     * form can override this function to provide a new maximum size for the
     * form. This function will get called when the form is being resized.
     *
     * @return Maximum size the form can be sized to.
     *
     * @see getMaximizedBounds
     * @see getMinTrackSize
     * @see SystemInformation.getMaxWindowTrackSize
     */
    protected Point getMaxTrackSize() {}

    /**
     * Retrieves the minimum size to which this form can be resized. Classes that extend
     * form can override this function to provide a new minimum size for the
     * form. This function will get called when the form is being resized.
     *
     * @return Minimum size the form can be sized to.
     *
     * @see getMaximizedBounds
     * @see getMaxTrackSize
     * @see SystemInformation.getMinWindowTrackSize
     */
    protected Point getMinTrackSize() {}

    /**
     * Retrieves a boolean value that indicates whether a maximize button is
     * displayed in the upper-right corner of the form.
     *
     * @return Current value of the maximizeBox property.
     *
     * @see #setMaximizeBox
     */
    public final boolean getMaximizeBox() {}

    /**
     * Retrieves a boolean value that indicates whether this form is an MDI
     * child form. 
     *
     * @return True if this is an MDI Child
     *
     * @see setMDIParent
     */
    public final boolean getIsMDIChild() {}

    public final Form[] getMDIChildren() {}
    
    /**
     * Retrieves the control that is the MDI client region.
     *
     * @return MDI Client control
     */
    public final MDIClient getMDIClient() {}

    /**
     * Retrieves a boolean value that indicates whether this form is an MDI
     * container.
     *
     * @return True if this form is an MDI container
     */
    public final boolean getIsMDIContainer() {}

    /**
     * Retrieves the current MDI parent of this form. 
     *
     * @return Current MDI Parent of this form.
     *
     * @see #setMDIParent
     */
    public final Form getMDIParent() {}

    /**
     * Retrieves the current menu for this form. 
     *
     * @return Current Menu for this form.
     *
     * @see #setMenu
     */
    public final MainMenu getMenu() {}

    /**
     * Retrieves a boolean value indicating whether this form contains a menu
     * bar.
     *
     * @return True if this form is a menu bar container
     */
    public final boolean getIsMenuBarContainer() {}

    /**
     * Retrieves the merged menu for the form. This is primarily used when
     * this form is an MDI child that merges its menu with the parent form's
     * menu.
     *
     * @return Merged menu
     */
    public final MainMenu getMergedMenu() {}

    /**
     * Retrieves a boolean value that indicates whether a minimize button is
     * displayed on the current form.
     *
     * @return  the current value of the minimizeBox property.
     *
     * @see setMinimizeBox
     */
    public final boolean getMinimizeBox() {}

    /**
     * Retrieves a boolean value that indicates whether this form is modal.
     *
     * @returns True if this form is currently modal.
     *
     * @see showDialog
     */
    public final boolean getModal() {}

    /**
     * Retrieves the forms owned by this one.
     *
     * @returns Array of forms that are owned by this form.
     *
     * @see addOwnedForm
     * @see removeOwnedForm
     */
    public final Form[] getOwnedForms() {}

    /**
     * Retrieves the owner of this form.
     *
     * @return Form that currently owns this form.
     */
    public final Form getOwner() {}

    /**
     * Retrieves the current palette mode for this form.
     *
     * @return Current value of the PaletteMode property.
     *
     * @see #setPaletteMode
     */
    public final int getPaletteMode() {}

    /**
     * Retrieves the source for the palette being used by this form.
     *
     * @return Current value of the PaletteSource property.
     *
     * @see #setPaletteSource
     */
    public final Control getPaletteSource() {}

    /**
     * Retrieves the visual parent of this form.
     *
     * @return Current value of the ParentForm property
     *
     * @see #setParent
     */
    public final Form getParentForm() {}

    /**
     * Centers the dialog to the screen. This will first attempt to use
     * the <i>owner</i> property to determine the correct screen, then
     * it will try the HWND owner of the form, and finally this will
     * center the form on the same monitor as the mouse cursor.
     * 
     * @internalonly
     */
    protected void centerToScreen() {}
    
    
    /**
     * Retrieves a boolean value that indicates whether this form is
     * currently displayed in the taskbar.
     *
     * @return Current value of the ShowInTaskbar property.
     *
     * @see #setShowInTaskbar
     */
    public final boolean getShowInTaskbar() {}

    /**
     * Retrieves the current start position of this form.
     *
     * @return Current value of teh StartPosition property.
     *
     * @see #setStartPosition
     */
    public final int getStartPosition() {}

    /**
     * Returns true if the form is a top most window, which is higher in Z order than
     * all non-top most windows.
     *
     * @return true if the form is a top most window.
     */
    public final boolean getTopMost() {}

    /**
     * Returns true if the Auto-VertScrollbar is visible
     *
     * @return Current value of the VScroll property
     *
     * @see #setVScroll
     */
    protected final boolean getVScroll() {}

    /**
     * Retrieves the form's window state.
     * @return Current value of the WindowState property.
     *
     * @see #setWindowState
     */
    public final int getWindowState() {}

    /**
     * Returns whether any of the bits in the mask are on.
     *
     * @return True if any of the bits are on.
     *
     * @see setFormState
     * @see getFormState
     */
    protected final boolean hasFormState(int flag) {}

    
    private static void invalidateAll(Control c) {}
    
    
    private void invalidateMergedMenu() {}

    /**
     * Forces the layout of any docked or anchored child controls.
     */
    protected void onLayout(LayoutEvent event) {}

    /**
     * Arranges the MDI children of this form according to a specified value.
     *
     * @see MDILayout
     */
    public void layoutMDI(int value) {}

    
    void menuChanged(int change, Menu menu) {}

    private void menuChanged(int change, Menu menu, Form form) {}

    public void setNewControls(Control[] ctls) {}

    public void setTopLevel(boolean value) {}
    
    
    private void setDisplayRectLocation(int x, int y) {}

    /**
     * Notifies this form that the palette has changed on a child control. The Form then responds by recalculating the palette if 
     * needed.
     */
    public final void notifyPaletteChange() {}

    /**
     * Triggers the activate event.
     *
     * @see #addOnActivate
     * @see #removeOnActivate
     * @see com.ms.wfc.core.Event
     */
    protected void onActivate(Event e) {}

    /**
     * Triggers the closing event.
     *
     * @see #addOnClosing
     * @see #removeOnClosing
     * @see com.ms.wfc.core.CancelEvent
     */
    protected void onClosing(CancelEvent e) {}

    /**
     * Triggers the closed event.
     *
     * @see #addOnClosed
     * @see #removeOnClosed
     * @see com.ms.wfc.core.Event
     */
    protected void onClosed(Event e) {}

    /**
     * Fired when this control is first created.
     */
    protected void onCreateControl() {}

    /**
     * Triggers the deactivate event.
     *
     * @see #addOnDeactivate
     * @see #removeOnDeactivate
     * @see com.ms.wfc.core.Event
     */
    protected void onDeactivate(Event e) {}

    /**
     * Triggers the inputLangChange event.
     *
     * @see #addOnInputLangChange
     * @see #removeOnInputLangChange
     * @see com.ms.wfc.ui.InputLangChangeEvent
     */
    protected void onInputLangChange(InputLangChangeEvent e) {}

    /**
     * Triggers the inputLangChangeRequest event.  If the event is cancel then
     * the input language will not change.
     *
     * @see #addOnInputLangChangeRequest
     * @see #removeOnInputLangChangeRequest
     * @see InputLangChangeRequestEvent
     */
    protected void onInputLangChangeRequest(InputLangChangeRequestEvent e) {}

    /**
     * Triggers the MDIChildActivate event. If a subclass
     * overrides this function, it must call super.onMDIChildActivate.
     *
     * @param form Form that is getting activated
     */
    protected void onMDIChildActivate(Form form) {}

    /**
     * Triggers the MDIChildActivate event.
     *
     * @see #addOnMDIChildActivate
     * @see #removeOnMDIChildActivate
     * @see Event
     */
    protected void onMDIChildActivate(Event e) {}

    /**
     * Triggers the menuStart event. This method will be called when any menu is
     * displayed. This event signifies that the menu modal message loop has been
     * entered.
     *
     * @param e Event
     *
     * @see #onMenuComplete
     */
    protected void onMenuStart(Event e) {}

    /**
     * Triggers the menuComplete event. This method will be called
     * when the menu selection has been completed, regardless of whether the
     * user selected a menu item, or canceled the selection. This event signifies
     * that the menu modal message loop has been exited.
     *
     * @param e Event
     * 
     * @see #onMenuStart
     */
    protected void onMenuComplete(Event e) {}

    /**
     * Called by a child control to indicate that the palette needs to be rendered. */
    protected boolean onNewPalette(boolean fForceBackground) {}

    
    final void performOnInputLangChange(InputLangChangeEvent event) {}

    
    final void performOnInputLangChangeRequest(InputLangChangeRequestEvent event) {}

    public Point pointToClient(Point p) {}

    public Point pointToScreen(Point p) {}

    
    private boolean processArrowKey(boolean forward) {}

    /**
     * Processes a command key. Overrides Control.processCmdKey() to provide
     * additional handling of main menu command keys and MDI accelerators.
     *
     * @param msg original window message.
     * @param keyData key code and modifier flags.
     * @return true to consume the key, false to allow further processing.
     * @see wfc.ui.Control#processCmdKey
     */
    protected boolean processCmdKey(MSG msg, int keyData) {}

    /**
     * Processes a dialog character. Overrides Control.processDialogChar().
     * This method calls the processMnemonic() method to check if the character
     * is a mnemonic for one of the controls on the form. If processMnemonic()
     * does not consume the character, then super.processDialogChar() is
     * called.
     *
     * @param charCode character to pre-process.
     * @return true to consume the character, false to allow further
     * processing.
     * @see wfc.ui.Control#processDialogChar
     */
    protected boolean processDialogChar(char charCode) {}

    /**
     * Processes a dialog key. Overrides Control.processDialogKey(). This
     * method implements handling of the TAB, LEFT, RIGHT, UP, DOWN, RETURN,
     * and ESCAPE keys in dialogs.
     *
     * <p>The method performs no processing on keys that include the ALT or
     * CONTROL modifiers. For the TAB key, the method selects the next control
     * on the form. For the arrow keys,
     * !!!
     * @param keyData key code and modifier flags.
     * @return true to consume the key, false to allow further processing.
     * @see wfc.ui.Control#processDialogKey
     */
    protected boolean processDialogKey(int keyData) {}

    /**
     * UNDONE : ChrisAn, 12/13/1997 - Need description 'processKeyPreview'
     */
    protected boolean processKeyPreview(Message m) {}

    /**
     * UNDONE : ChrisAn, 12/13/1997 - Need description 'processMnemonic'
     */
    protected boolean processMnemonic(char charCode) {}

    
    private boolean processTabKey(boolean forward) {}

    protected void propertyChanged(int property) {}

    public Rectangle rectToClient(Rectangle r) {}

    public Rectangle rectToScreen(Rectangle r) {}

    /**
     * Removes the delegate that is assigned to the activate event.
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onClose
     */
    public final void removeOnActivate(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to the closing event.
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onClose
     */
    public final void removeOnClosing(CancelEventHandler value) {}

    /**
     * Removes the delegate that is assigned to the closed event.
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onClose
     */
    public final void removeOnClosed(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to the deactivate event.
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onClose
     */
    public final void removeOnDeactivate(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to the MDIChildActivate event. 
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onMDIChildActivate
     */
    public final void removeOnMDIChildActivate(EventHandler value) {}

    public final void removeOnMenuComplete(EventHandler value) {}
    
    public final void removeOnMenuStart(EventHandler value) {}
    
    /**
     * Removes the delegate that is assigned to the inputLangChange event.
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onInputLangChange
     */
    public final void removeOnInputLangChange(InputLangChangeEventHandler value) {}

    /**
     * Removes the delegate that is assigned to the inputLangChangeRequest
     * event.
     *
     * @param value Delegate to remove from the list of delegates to fire for
     * this event.
     *
     * @see #onInputLangChangeRequest
     */
    public final void removeOnInputLangChangeRequest(InputLangChangeRequestEventHandler value) {}

    /**
     * Removes a form from this Form object's internal list of owned forms. Also sets the owner of the
     * removed form to null.
     *
     * @param ownedForm Form to remove.
     *
     * @see #addOwnedForm
     */
    public final void removeOwnedForm(Form ownedForm) {}

    
    private void resumeUpdateMenuHandles() {}

    
    void select(boolean directed, boolean forward) {}

    /**
     * Base function that performs scaling of the form.
     *
     * @param x Percentage to scale the form horizontally
     * @param y Percentage to scale the form vertically
     *
     * @see Control.scaleCore
     */
    protected void scaleCore(float x, float y) {}

    
    private void scrollActiveControlIntoView() {}

    /**
     * Sets the accept button for this form. This control must implement
     * IButtonControl to be used as the acceptButton.
     *
     * UNDONE : ChrisAn, 12/13/1997 - What is the acceptButton used for?
     *
     * @param button Control to use as the AcceptButton
     *
     * @see #getAcceptButton
     */
    public final void setAcceptButton(IButtonControl button) {}

    
    final void setActive(boolean value) {}

    
    private void setMDIActive(boolean value) {}
    
    /**
     * Sets the the input focus to the specified control. 
     *
     * @param value Control to make active.
     *
     * @see #getActiveControl
     */
    public final void setActiveControl(Control value) {}

    /**
     * Sets the autoscaling on this form. When AutoScalling is turned on the form
     * will rescale the form based on the base font size when it is created.
     * This makes the form display correctly on large font systems, and systems
     * that have a larger default font then what the form was designed on.
     *
     * @param value Value for the AutoScale property
     *
     * @see #getAutoScale
     */
    public final void setAutoScale(boolean value) {}

    /**
     * Sets the base size used for autoscaling when the form is created. This value is used at form display time to 
     * compute the scaling factor for the form.
     * 
     * @param value Value for AutoScaleBaseSize
     * 
     * @see #getAutoScaleBaseSize
     * @see #setAutoScale
     * 
     * @deprecated
     * @hidden
     * @internalonly
     */
    public final void setAutoScaleBaseSize(int height) {}
    
    /**
     * Sets the base size used for autoscaling when the form is created. This value is used at form display time to 
     * compute the scaling factor for the form.
     * 
     * @param value Value for AutoScaleBaseSize
     * 
     * @see #getAutoScaleBaseSize
     * @see #setAutoScale
     * @hidden
     * @internalonly
     */
    public final void setAutoScaleBaseSize(Point value) {}
    
    /**
     * Specifies whether the form implements autoscrolling. When AutoScrolling is turned, scrollbars
     * will be displayed on the form if any controls are located outside the
     * client region of the form. This allows the user to scroll the client
     * region to make the controls visible.<P>
     *
     * In addition, when AutoScrolling is on, the client region will
     * automatically scroll to make the control with focus visible. This lets
     * the user tab around the form, and always see the control that has focus.
     *
     * @param value Value for the AutoScroll property
     *
     * @see #getAutoScroll
     * @see #setAutoScrollMargin
     */
    public final void setAutoScroll(boolean value) {}

    /**
     * Sets the width and height of the autoscroll margin.
     * The margins define the width and height of the border around each
     * control. This border is used to determine when scrollbars are
     * needed on the form, and where to scroll to when a control is
     * selected.<p>
     *
     * @param value Value for the AutoScrollMargin property
     *
     * @see #getAutoAcrollMargin
     * @see #setAutoScroll
     */
    public final void setAutoScrollMargin(Point value) {}

    /**
     * Sets the width and height of the autoscroll margin.
     * The margins define the width and height of the border around each
     * control. This border is used to determine when scrollbars are
     * needed on the form, and where to scroll to when a control is
     * selected.<p>
     *
     * @param x X Value for the AutoScrollMargin property
     * @param y Y Value for the AutoScrollMargin property
     *
     * @see #getAutoAcrollMargin
     * @see #setAutoScroll
     */
    public final void setAutoScrollMargin(int x, int y) {}

    /**
     * Sets the autoscroll position that is used when the form is created. This will
     * not move the scroll region once the form has been created.
     * 
     * @param value Position for the AutoScroll region.
     * @hidden
     * @internalonly
     */
    public final void setAutoScrollPosition(Point value) {}

    protected void setBoundsCore(int x, int y, int width, int height) {}

    /**
     * Sets the border style for the form. Valid values come from the 
     * BorderStyle enumeration.
     *
     * @param value   New border style for the form
     *
     * @see getBorderStyle
     * @see com.ms.wfc.ui.FormBorderStyle
     */
    public final void setBorderStyle(int value) {}

    /**
     * Sets the cancel button for the form. The cancelButton is "clicked" when
     * the user presses Escape.
     *
     * @param button Button to treat as the cancelButton
     *
     * @see getCancelButton
     */
    public final void setCancelButton(IButtonControl button) {}

    



    /**
     * Specifies whether a control box is to be displayed on this form. If ControlBox is set to
     * true then there is an icon in the upper left corner of the form that
     * has the System Menu on it.
     *
     * @param controlBox Value for the ControlBox property
     *
     * @see #getControlBox
     */
    public final void setControlBox(boolean controlBox) {}

    
    private void setDefaultButton(IButtonControl button) {}


    /**
     * Sets the clientSize of the form. This will adjust the bounds of the form
     * to make the clientSize the requested size.
     *
     * @param x Requested width of the client region
     * @param y Requested height of the client region
     *
     * @see #getClientSize
     */
    protected void setClientSizeCore(int x, int y) {}

    /**
     * Sets the bounds of the form in desktop coordinates. 
     *
     * @param bounds New bounds for the Form in desktop coordinates.
     *
     * @see #setDesktopBounds(int, int, int, int)
     */
    public final void setDesktopBounds(Rectangle bounds) {}

    /**
     * Sets the bounds of the form in desktop coordinates.  Desktop coordinates
     * are based on the working area of the screen, which excludes the Taskbar.
     *
     * @param x X Location for the Form
     * @param y Y Location for the Form
     * @param width Width for the Form
     * @param height Height for the Form
     *
     * @see #setDesktopBounds(Rectangle)
     */
    public final void setDesktopBounds(int x, int y, int width, int height) {}

    /**
     * Sets the location of the form in desktop coordinates. 
     * @param loc Location for the Form
     *
     * @see #setDesktopLocation(int, int)
     * @see #setDesktopBounds(int, int, int, int)
     */
    public final void setDesktopLocation(Point loc) {}

    /**
     * Sets the location of the form in desktop coordinates. 
     *
     * @param x X Location for the Form
     * @param y Y Location for the Form
     *
     * @see #setDesktopLocation(Point)
     * @see #setDesktopBounds(int, int, int, int)
     */
    public final void setDesktopLocation(int x, int y) {}

    /**
     * Sets the value to be returned from the form when it is displayed as a modal dialog.
     *
     * @param value Value to return
     *
     * @see #getDialogResult
     * @see #showDialog
     */
    public final void setDialogResult(int value) {}

    /**
     * This will turn all the bits on or off for the specified FORMSTATE_*
     * property.
     *
     * @param flag FORMSTATE_* property
     * @param value True to turn property on, False to turn it off
     *
     * @see #setFormState(int, int)
     * @see #getFormState
     * @see #hasFormState
     */
    protected final void setFormState(int flag, boolean value) {}

    /**
     * This will set the value of the specified FORMSTATE_* property.
     *
     * @param flag FORMSTATE_* property
     * @param value Value to set the property to
     *
     * @see #setFormState(int, boolean)
     * @see #getFormState
     * @see #hasFormState
     */
    protected final void setFormState(int flag, int value) {}

    
    void setHandle(int value) {}

    /**
     * Specifies whether a "What's This?" help icon should be displayed in the
     * form's caption bar. If HelpButton is true then a "What's This"
     * Help icon will be displayed in the caption bar of the form.
     *
     * @param helpButton New value for the HelpButton property
     *
     * @see #getHelpButton
     */
    public final void setHelpButton(boolean helpButton) {}

    
    private final void setHScroll(boolean value) {}

    /**
     * Sets the icon to be displayed in the caption bar of the form. 
     *
     * @param icon Icon to display
     *
     * @see #getIcon
     */
    public final void setIcon(Icon icon) {}

    /**
     * Specifies whether the form should receive key events for all contained controls before
     * the control receives them. When KeyPreview is set to true then
     * the Form will recieve key events for all the contained controls before the
     * control. This allows the form to catch events like ENTER, etc.
     *
     * @param keyPreview New value for the KeyPreview property
     *
     * @see #getKeyPreview
     */
    public final void setKeyPreview(boolean keyPreview) {}

    /**
     * Sets the MDI parent for this form. The MDIParent must be marked as an
     * MDI container for this to succeed.
     *
     * @param form Form to make this MDI parent of this form
     *
     * @see #getMDIParent
     */
    public final void setMDIParent(Form form) {}

    /**
     * Specifies whether a maximize button should be displayed in this form's caption bar. If maximizeBox is true then the
     * maximize button is displayed in the caption bar of the Form.
     *
     * @param value New value for the maximizeBox property
     *
     * @see #getMaximizeBox
     */
    public final void setMaximizeBox(boolean value) {}

    /**
     * Specifies whether this form is an MDI container. If this is set to true
     * then this form can container other forms in an MDI fashion.
     *
     * @param value New value for the IsMDIContainer property
     *
     * @see #getIsMDIContainer
     */
    public final void setIsMDIContainer(boolean value) {}

    /**
     * Sets the main menu for this form.
     *
     * @param value Menu for this Form.
     *
     * @see #getMenu
     */
    public final void setMenu(MainMenu value) {}

    /**
     * Specifies whether a minimize button should be displayed in the form's caption bar. If minimizeBox is true then the
     * minimize button is displayed in the caption bar of the Form.
     *
     * @param value New value for the minimizeBox property
     *
     * @see #getMinimizeBox
     */
    public final void setMinimizeBox(boolean value) {}

    /**
     * Sets the owner for this form.  This is the same as calling
     * owner.addOwnedForm(this).
     *
     * @param owner New owner for this form
     *
     * @see #getOwner
     * @see #addOwnedForm
     * @see #removeOwnedForm
     */
    public final void setOwner(Form owner) {}

    /**
     * Specifies the palette mode for this form.  Valid values are:
     * <pre>
     *   FormPaletteMode.HALFTONE
     *   FormPaletteMode.NONE
     *   FormPaletteMode.USE_CONTORL
     * </pre>
     *
     * @see #getPaletteMode
     * @see FormPaletteMode
     */
    public final void setPaletteMode(int value) {}

    /**
     * Specifies the source for this form's palette.USE_CONTROL.
     *
     * @see #getPaletteSource
     * @see #setPaletteMode
     */
    public final void setPaletteSource(Control paletteSource) {}

    
    void setParentHandle(int value) {}

    /**
     * Specifies whether this form's icon should be displayed in the Windows taskbar. If ShowInTaskbar is true then the form
     * will be displayed in the Windows Taskbar.
     *
     * @param showInTaskbar New value for the ShowInTaskbar property
     *
     * @see #getShowInTaskbar
     */
    public final void setShowInTaskbar(boolean showInTaskbar) {}


    /**
     * Specifies the initial position of this form. Valid values are:
     * <pre>
     *   FormStartPosition.MANUAL
     *   FormStartPosition.WINDOWS_DEFAULT_LOCATION
     *   FormStartPosition.WINDOWS_DEFAULT_BOUNDS
     *   FormStartPosition.CENTER_SCREEN
     * </pre>
     *
     * @param value New value for the StartPosition
     *
     * @see #getStartPosition
     * @see FormStartPosition
     */
    public final void setStartPosition(int startPosition) {}

    /**
     * Makes a top-level form a top most window, which puts it higher in the Z-order than
     * all non-top most windows, even when not activated.
     *
     * @param value true if a top-level form should be top most, false if it shouldn't.
     *
     * @see #getTopMost
     */
    public final void setTopMost(boolean value) {}

    /**
     * Specifies whether this form is visible.
     *
     * @param value True if the form should be visible
     *
     * @see #getVisible
     */
    public void setVisible(boolean value) {}

    
    private boolean setVisibleScrollbars(boolean horiz, boolean vert) {}

    
    private boolean setDisplayRectSize(int width, int height) {}

    
    private final void setVScroll(boolean value) {}

    /**
     * Specifies the window state for this form. Valid values are:
     * <pre>
     *   FormWindowState.NORMAL
     *   FormWindowState.MAXIMIZED
     *   FormWindowState.MINIMIZED
     * </pre>
     *
     * @see #getWindowState
     * @see FormWindowState
     */
    public final void setWindowState(int value) {}

    public boolean shouldPersistAutoScrollPosition() {}

    /**
     * Displays this form as a modal dialog.
     *
     * @return The DialogResult from the form
     *
     * @see #showDialog(Form)
     */
    public final int showDialog() {}

    /**
     * Displays this form as a modal dialog.
     *
     * @param owner Top-level window that will own the modal dialog (e.g.: com.ms.wfc.ui.Form, com.ms.wfc.html.DhDocument)
     *
     * @return The DialogResult from the form
     *
     * @see #showDialog()
     */
    public final int showDialog(ITopLevelWindow owner) {}

    
    private void suspendUpdateMenuHandles() {}

    
    private void syncScrollbars() {}

    
    private void updateAutoScaleBaseSize() {}           
    
    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    
    private void updateDefaultButton() {}

    
    private void updateHandleWithOwner() {}

    
    private void updateMenuHandles() {}
    
    
    private void updateMenuHandles(MainMenu menu, boolean forceRedraw) {}

    void updateStylesCore() {}

    
    private void updateWindowState() {}

    
    private void wmActivate(Message m) {}

    
    private void wmClose(Message m) {}

    
    private void wmEnterMenuLoop(Message m) {}

    
    private void wmExitMenuLoop(Message m) {}
    
    private void wmGetMinMaxInfo(Message m) {}

    
    private void wmVScroll(Message m) {}

    
    private void wmHScroll(Message m) {}

    
    private void wmInitMenuPopup(Message m) {}

    
    private void wmInputLangChange(Message m) {}

    
    private void wmMDIActivate(Message m) {}

    
    private void wmNCCreate(Message m) {}

    
    private void wmNCDestroy(Message m) {}

    
    private void wmPaletteChanged(Message m) {}

    /**
     * Retrieves the palette currently being used by the form. 
     *
     * @see #setPaletteMode
     * @see #setPaletteSource
     */
    public final Palette getPalette() {}

    
    private void wmQueryNewPalette(Message m) {}

    
    private void wmSetFocus(Message m) {}

    
    private void wmSysCommand(Message m) {}

    
    private void wmSize(Message m) {}

    
    private void wmWindowPosChanged(Message m) {}

    private void wmWindowPosChanging(Message m) {}

    /**
     * Encapsulates the base window procedure for this class.
     *
     * @param m Message sent
     */
    protected void wndProc(Message m) {}
    
        /**
         * Represents the basic top-level window. 
         *
         * @security(checkClassLinking=on)
         */
    public static class ClassInfo extends Control.ClassInfo {
        public static final PropertyInfo acceptButton = new PropertyInfo(
            Form.class, "acceptButton", IButtonControl.class,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("FormAcceptButtonDescr")));

        public static final PropertyInfo autoScale = new PropertyInfo(
            Form.class, "autoScale", Boolean.TYPE,
            LocalizableAttribute.YES,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("FormAutoScaleDescr")));

        public static final PropertyInfo autoScaleBaseSize = new PropertyInfo(
            Form.class, "autoScaleBaseSize", Point.class,
            BrowsableAttribute.NO,
            DefaultValueAttribute.TRUE);

        public static final PropertyInfo autoScroll = new PropertyInfo(
            Form.class, "autoScroll", Boolean.TYPE,
            LocalizableAttribute.YES,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("FormAutoScrollDescr")));

        public static final PropertyInfo autoScrollMargin = new PropertyInfo(
            Form.class, "autoScrollMargin", Point.class,
            LocalizableAttribute.YES,
            new DefaultValueAttribute(new Point(0,0)),
            new DescriptionAttribute(Sys.getString("FormAutoScrollMarginDescr")));

        public static final PropertyInfo autoScrollPosition = new PropertyInfo(
            Form.class, "autoScrollPosition", Point.class,
            BrowsableAttribute.NO);

        public static final PropertyInfo backColor = new PropertyInfo(
            Control.ClassInfo.backColor,
            DefaultValueAttribute.COLOR_CONTROL);

        public static final PropertyInfo borderStyle = new PropertyInfo(
            Form.class, "borderStyle", FormBorderStyle.class,
            LocalizableAttribute.YES,
            new DefaultValueAttribute(new Integer(FormBorderStyle.SIZABLE)),
            new DescriptionAttribute(Sys.getString("FormBorderStyleDescr")));

        public static final PropertyInfo cancelButton = new PropertyInfo(
            Form.class, "cancelButton", IButtonControl.class,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("FormCancelButtonDescr")));

        public static final PropertyInfo clientSize = new PropertyInfo(
            Form.class, "clientSize", Point.class,
            LocalizableAttribute.YES,
            BrowsableAttribute.NO);

        public static final PropertyInfo controlBox = new PropertyInfo(
            Form.class, "controlBox", Boolean.TYPE,
            LocalizableAttribute.YES,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("FormControlBoxDescr")));

        public static final PropertyInfo helpButton = new PropertyInfo(
            Form.class, "helpButton", Boolean.TYPE,
            LocalizableAttribute.YES,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("FormHelpButtonDescr")));

        public static final PropertyInfo icon = new PropertyInfo(
            Form.class, "icon", Icon.class,
            LocalizableAttribute.YES,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("FormIconDescr")));

        public static final PropertyInfo keyPreview = new PropertyInfo(
            Form.class, "keyPreview", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("FormKeyPreviewDescr")));

        public static final PropertyInfo maximizeBox = new PropertyInfo(
            Form.class, "maximizeBox", Boolean.TYPE,
            LocalizableAttribute.YES,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("FormMaximizeBoxDescr")));

        public static final PropertyInfo isMDIContainer = new PropertyInfo(
            Form.class, "isMDIContainer", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("FormIsMDIContainerDescr")));

        public static final PropertyInfo menu = new PropertyInfo(
            Form.class, "menu", MainMenu.class,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("FormMenuDescr")));

        public static final PropertyInfo minimizeBox = new PropertyInfo(
            Form.class, "minimizeBox", Boolean.TYPE,
            LocalizableAttribute.YES,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("FormMinimizeBoxDescr")));

        public static final PropertyInfo paletteMode = new PropertyInfo(
            Form.class, "paletteMode", FormPaletteMode.class,
            new DefaultValueAttribute(new Integer(FormPaletteMode.NONE)),
            new DescriptionAttribute(Sys.getString("FormPaletteModeDescr")));

        public static final PropertyInfo paletteSource = new PropertyInfo(
            Form.class, "paletteSource", Control.class,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("FormPaletteSourceDescr")));

        public static final PropertyInfo showInTaskbar = new PropertyInfo(
            Form.class, "showInTaskbar", Boolean.TYPE,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("FormShowInTaskbarDescr")));

        public static final PropertyInfo size = new PropertyInfo(
            Control.ClassInfo.size, PersistableAttribute.NO);

        public static final PropertyInfo startPosition = new PropertyInfo(
            Form.class, "startPosition", FormStartPosition.class,
            LocalizableAttribute.YES,
            new DefaultValueAttribute(new Integer(FormStartPosition.WINDOWS_DEFAULT_LOCATION)),
            new DescriptionAttribute(Sys.getString("FormStartPositionDescr")));

        public static final PropertyInfo topMost =
                                                  new PropertyInfo(Form.class, "topMost", boolean.class,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("FormTopMostDescr")));

        public static final PropertyInfo windowState =
                                                      new PropertyInfo(Form.class, "windowState", FormWindowState.class,
            LocalizableAttribute.YES,
            new DefaultValueAttribute(new Integer(FormWindowState.NORMAL)),
            new DescriptionAttribute(Sys.getString("FormWindowStateDescr")));

        public static final EventInfo activate = new EventInfo(
            Form.class, "activate", EventHandler.class,
            CategoryAttribute.Focus,
            new DescriptionAttribute(Sys.getString("FormOnActivateDescr")));

        public static final EventInfo closing = new EventInfo(
            Form.class, "closing", CancelEventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("FormOnClosingDescr")));

        public static final EventInfo closed = new EventInfo(
            Form.class, "closed", EventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("FormOnClosedDescr")));

        public static final EventInfo deactivate = new EventInfo(
            Form.class, "deactivate", EventHandler.class,
            CategoryAttribute.Focus,
            new DescriptionAttribute(Sys.getString("FormOnDeactivateDescr")));

        public static final EventInfo inputLangChange = new EventInfo(
            Form.class,
            "inputLangChange",
            InputLangChangeEventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("FormOnInputLangChangeDescr")));

        public static final EventInfo inputLangChangeRequest = new EventInfo(
            Form.class,
            "inputLangChangeRequest", InputLangChangeRequestEventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("FormOnInputLangChangeRequestDescr")));


        public static final EventInfo move = new EventInfo(
            Form.class, "move", EventHandler.class,
            CategoryAttribute.Position,
            new DescriptionAttribute(Sys.getString("FormOnMoveDescr")));

        public static final EventInfo MDIChildActivate = new EventInfo(
            Form.class, "MDIChildActivate", EventHandler.class,
            CategoryAttribute.Position,
            new DescriptionAttribute(Sys.getString("FormOnMDIChildActivateDescr")));

        public static final EventInfo menuComplete = new EventInfo(
            Form.class, "menuComplete", EventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("FormOnMenuCompleteDescr")));

        public static final EventInfo menuStart = new EventInfo(
            Form.class, "menuStart", EventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("FormOnMenuStartDescr")));

        /**
         * Forms shouldn't show up in the toolbox, so we don't inherit from
         * Control's attributes here.
         *
         * @param attrs An IAttributes callback to configure the class's attribute
         *              list.
         *
         * @see #IClassInfo
         * @see #IAttributes
         */
        public void getAttributes(IAttributes attrs) {}

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }
}