//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines enumeration constants that represent the border styles of a form.   This contains the extra styles that
 * are allowed.
 * 
 * @see com.ms.wfc.ui.BorderStyle
 *
 * @security(checkClassLinking=on)
 */
public class FormBorderStyle extends BorderStyle {

    /**
     * Represents a thick, fixed dialog-style border. */
    public static final int FIXED_DIALOG = 3;

    /**
     * Represents a fully resizable border. */
    public static final int SIZABLE = 4;

    /** 
     * Represents a nonresizable tool window border. */
    public static final int FIXED_TOOLWINDOW = 5;

    /** 
     * Represents a resizable tool window border. */
    public static final int SIZABLE_TOOLWINDOW = 6;

    /**
     * Retrieves a boolean
     * value that indicates whether a specified value designates a valid FormBorderStyle constant. */
    public static boolean valid(int value) {}

}