//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constant values that describe the initial position of a form.
 *
 * @security(checkClassLinking=on)
 */
public class FormStartPosition extends Enum {

    /**
     * Specifies that the location and size of the form will determine the starting position.
     */
    public static final int MANUAL = 0;
    /**
     * Specifies that the form will be centered on the current primary monitor, and that its
     * dimensions are determined by the form's size.
     */
    public static final int CENTER_SCREEN = 1;
    /**
     * Specifies that the form will be positioned at the Windows default location with its
     * dimensions determined by the form's size.
     */
    public static final int WINDOWS_DEFAULT_LOCATION = 2;
    /**
     * Specifies that the form will be positioned with the Windows default location and
     * bounds.
     */
    public static final int WINDOWS_DEFAULT_BOUNDS = 3;

    /**
     * Determines whether the specified value is one of the constants defined in this class.
     */
    public static boolean valid(int value) {}
}