//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.html.*;
import com.ms.wfc.html.om.*;
import com.ms.wfc.ax.*;

import com.ms.com.*;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.data.*;
import com.ms.wfc.data.ui.*;
import com.ms.wfc.io.File;
import com.ms.wfc.io.WinIOException;
import com.ms.wfc.ole32.*;
import com.ms.wfc.win32.*;
import com.ms.wfc.util.List;
import com.ms.wfc.html.om.shdocvw.WebBrowser.*;


/**
 * Encapsulates the HTML control. The HTML contents
 * of this control can be controlled programatically using the wfc.html library. To
 * use that feature, add an event handler for the documentReady event, and get hold
 * of the DhDocument representing the HTML contents.
 * 
 * @security(checkClassLinking=on)
 */
public class HTMLControl extends WebBrowser {

    private DhDocument      document  = null;
    private IHTMLDocument2  hdoc      = null;
    private DocumentReadyEventHandler docReady = null;
    private DocumentCompleteHandler docComplete = null;
    private String url = new String("about:blank");

    /**
     * Creates a new HTML control and initializes it.
     */
    public HTMLControl(){}

    /**
     * Adds a WFC control to the HTML control. 
     * 
     * @param  c  The WFC control to be added.
     */
    public final void add(Control c) {}

    /**
     * Adds a WFC control to the HTML control. 
     * 
     * @param  e  The DhElement to be added.
     */
    public final void add( DhElement e ){}

    /**
     * Assigns a delegate to the documentReady event. This event
     * occurs when the DhDocument that encapsulates the HTML contents
     * of this control is ready.
     *
     * @param value New handler to install for this event.
     * @see #removeOnDocumentReady
     */
    public void addOnDocumentReady(DocumentReadyEventHandler handler) {}
    
    /**
     * Binds the elements of a specified array to their peers.
     * 
     * @param  elems  Array of elements that need to be bound to their peers.
     * @exception  WFCException  If the ID does not match existing elements in the HTML content.
     * @exception  WFCException  If the element is already bound to another Java object (through findElement).
     * @exception  WFCException  If the class type of the peer and the given Java object do not match.
     */
    public void setBoundElements(DhElement[] elems) {}
    
    /**
     * Retrieves the document associated with the HTML control.
     * 
     * @return  DhDocument representing the current document.
     */
    public final DhDocument getDocument(){}

    /**
     * Retrieves the address of the page currently displayed in the HTML
     * control.
     * 
     * @return String defining the current address.
     */
    public final String getURL() {}
    
    
    private final boolean initDocument(){}
    
    private void initializeDocument(Object objSender, DocumentCompleteEvent event ) {}

    protected boolean getAmbientProperty(int dispid, Variant var) {}
    
    
    private void navigate(String url) {}

    /**
     *
     Triggers the documentReady event.
     * Call super.onDocumentReady to send this event to any registered event listeners.
     *
     * @param e event
     * @see #addOnDocumentReady
     * @see #removeOnDocumentReady
     */
    protected void onDocumentReady(DocumentReadyEvent e) {}

    /**
     * This method is called by the control when any property changes. Inheriting
     * controls can overide this method to get property change notification on
     * basic properties. Inherting controls must call <i>super.propertyChanged</i>.
     *
     * @param property Property that changed.
     */
    protected void propertyChanged(int property) {}

    /**
     * Removes a control from the HTML control.
     * 
     * @param  c  Control to be removed.
     */
    public final void remove(Control c) {}
    
    /**
     * Removes the delegate that is assigned to the documentReady event. This event
     * occurs when the DhDocument that encapsulates the HTML contents
     * of this control is ready.
     *
     * @param value New handler to install for this event.
     * @see #addOnDocumentReady
     */
    public void removeOnDocumentReady(DocumentReadyEventHandler handler) {}
    
    /**
     * Adds the specified components to the HTML control. Components can only be derived off 
     * com.ms.wfc.ui.Control or com.ms.wfc.ui.DhElement.
     * 
     * @param  comps  Array representing the components to be added to the control.
     */
    public final void setNewComponents(Component[] comps) {}

    /**
     * Adds the specified HTML elements to the HTML control. Components can only be derived off 
     * com.ms.wfc.ui.DhElement.
     * 
     * @param  elems  Array representing the HTML elements to be added to the control.
     */
    public final void setNewHTMLElements(DhElement[] elems) {}
    
    /**
     * Loads the document at the specified URL into the HTML control.
     * 
     * @param url  Address of the page to which to navigate.
     */
    public final void setURL(String url) {}

    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}
    
    /**
     * Inheriting classes should override this method to find out when the
     * handle has been created.
     * Call super.onCreateHandle first.
     *
     * @param e event
     * @see #addOnCreateHandle
     * @see #removeOnCreateHandle
     */
    protected void onCreateHandle(Event e) {}
    
    /** Encapsulates the HTML control.
     * @internalonly
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends AxHost.ClassInfo {
        public static final PropertyInfo url = new PropertyInfo(
                                                                HTMLControl.class, "URL", String.class,
                                                                CategoryAttribute.Behavior,
                                                                new DefaultValueAttribute(new String("about:blank")),
                                                                new DescriptionAttribute(Sys.getString("HTMLControlURLDescr")));

        public static final com.ms.wfc.core.EventInfo DocumentReadyEventInfo = new com.ms.wfc.core.EventInfo (
                                                                                                              HTMLControl.class,
                                                                                                              "documentReady",
                                                                                                              DocumentReadyEventHandler.class );

        public void getAttributes( com.ms.wfc.core.IAttributes attrs ) {}

        public String getDefaultEventName() {}

        public void getEvents(IEvents events) {}
        
        public void getProperties(IProperties props) {}

        public ICustomizer getCustomizer(Object component) {}
    }
}