//STRIPPEDSOURCE//


package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;


/**
 * Encapsulates the Win32 help engine.
 * 
 * @security(checkClassLinking=on)
 */
public class Help {

    public static final int COMMAND_TOPIC = 0x80000001;
    public static final int COMMAND_CONTENTS = 0x80000002;
    public static final int COMMAND_INDEX = 0x80000003;
    public static final int COMMAND_FIND = 0x80000004;

    
    
    
    
    
    private static final int HELP_TAB = 0x000F;
    private static final int TAB_FIND = -1;
    private static final int TAB_INDEX = -2;
    private static final int TAB_CONTENTS = -3;
    
    private static final int HELP_COMMAND = 0x0102;
    private static final int HELP_CONTENTS = 0x0003;
    private static final int HELP_CONTEXT = 0x0001;
    private static final int HELP_CONTEXTMENU = 0x000a;
    private static final int HELP_CONTEXTPOPUP = 0x0008;
    private static final int HELP_FINDER = 0x000b;
    private static final int HELP_FORCEFILE = 0x0009;
    private static final int HELP_HELPONHELP = 0x0004;
    private static final int HELP_INDEX = 0x0003;
    private static final int HELP_KEY = 0x0101;
    private static final int HELP_MULTIKEY = 0x0201;
    private static final int HELP_PARTIALKEY = 0x0105;
    private static final int HELP_QUIT = 0x0002;
    private static final int HELP_SETCONTENTS = 0x0005;
    private static final int HELP_SETINDEX = 0x0005;
    private static final int HELP_SETPOPUP_POS = 0x000d;
    private static final int HELP_SETWINPOS = 0x0203;
    private static final int HELP_TCARD = 0x8000;
    private static final int HELP_TCARD_DATA = 0x0010;
    private static final int HELP_TCARD_OTHER_CALLER = 0x0011;
    private static final int HELP_WM_HELP = 0x000c;
    
    private static final int HH_DISPLAY_TOPIC        =0x0000;
    private static final int HH_HELP_FINDER          =0x0000;  
    private static final int HH_DISPLAY_TOC          =0x0001;  
    private static final int HH_DISPLAY_INDEX        =0x0002;  
    private static final int HH_DISPLAY_SEARCH       =0x0003;  
    private static final int HH_SET_WIN_TYPE         =0x0004;
    private static final int HH_GET_WIN_TYPE         =0x0005;
    private static final int HH_GET_WIN_HANDLE       =0x0006;
    private static final int HH_ENUM_INFO_TYPE       =0x0007;  
    private static final int HH_SET_INFO_TYPE        =0x0008;  
    private static final int HH_SYNC                 =0x0009;
    private static final int HH_ADD_NAV_UI           =0x000A;  
    private static final int HH_ADD_BUTTON           =0x000B;  
    private static final int HH_GETBROWSER_APP       =0x000C;  
    private static final int HH_KEYWORD_LOOKUP       =0x000D;
    private static final int HH_DISPLAY_TEXT_POPUP   =0x000E;  
    private static final int HH_HELP_CONTEXT         =0x000F;  
    private static final int HH_TP_HELP_CONTEXTMENU  =0x0010;  
    private static final int HH_TP_HELP_WM_HELP      =0x0011;  
    private static final int HH_CLOSE_ALL            =0x0012;  
    private static final int HH_ALINK_LOOKUP         =0x0013;  
    private static final int HH_GET_LAST_ERROR       =0x0014;  
    private static final int HH_ENUM_CATEGORY        =0x0015;   
    private static final int HH_ENUM_CATEGORY_IT     =0x0016;  
    private static final int HH_RESET_IT_FILTER      =0x0017;  
    private static final int HH_SET_INCLUSIVE_FILTER =0x0018;  
    private static final int HH_SET_EXCLUSIVE_FILTER =0x0019;  
    private static final int HH_SET_GUID             =0x001A;  

    private static final int WINHELP = 1;
    private static final int HTMLHELP = 2;
    private static final int HTMLFILE = 3;
    
    
    
    private static final byte[] WINHELPMARKER = new byte[] {0x3F, 0x5F, 0x03, 0x00};

    
    
    private static final byte[] HTMLHELPMARKER = new byte[] {0x49, 0x54, 0x53, 0x46};

    /**
     * Displays the contents of a help file. This will 
     * automatically determine if <i>url</i> points to a HTMLHelp or
     * Win32 help file and invoke the correct help system.
     * 
     * 
     * @param parent Control to parent the help dialog to.
     * @param url Path to the HTMLHelp or Win32 help file.
     */
    public static void showHelp(Control parent, String url) {}

    /**
     * Displays the contents of a help file. This will 
     * automatically determine if <i>url</i> points to a HTMLHelp or
     * Win32 help file and invoke the correct help system.
     * 
     * 
     * @param parent Control to parent the help dialog to.
     * @param url Path to the HTMLHelp or Win32 help file.
     * @param topic Topic to display in the file. For HTMLHelp this should
     *        he a reference to a page, for Win32 help this should be the
     *        numeric value of the topic id.
     */
    public static void showHelp(Control parent, String url, String topic) {}

    /**
     * Displays the index of the specified file. This will 
     * automatically determine if <i>url</i> points to a HTMLHelp or
     * Win32 help file and invoke the correct help system.
     * 
     * 
     * @param parent Control to parent the help dialog to.
     * @param url Path to the HTMLHelp or Win32 help file.
     */
    public static void showHelpIndex(Control parent, String url) {}
    public static void showPopup(Control parent, String caption, Point location) {}

    
    private static void showHTMLHelp(Control parent, String url, int command, Object param) {}


    
    private static void showHTMLFile(Control parent, String url, int command, Object param) {}
    
    
    private static void showWinHelp(Control parent, String url, int command, Object param) {}

    /**
     * Displays the contents of a help file. This will 
     * automatically determine if <i>url</i> points to a HTMLHelp or
     * Win32 help file and invoke the correct help system.
     * 
     * COMMAND_TOPIC:<br>
     * This will display the requested topic from <i>url</i>. For Win32 
     * help files <i>param</i> can either be an Integer or a String that 
     * contains a integer value of the topic to display.<p>
     * 
     * COMMAND_CONTENTS:<br>
     * This will display the contents of <i>url</i>. <i>param</i> should be
     * <b>null</b>.<p>
     * 
     * COMMAND_INDEX:<br>
     * This will display the index of <i>url</i>. <i>param</i> should be
     * <b>null</b>.<p>
     * 
     * COMMAND_FIND:<br>
     * This will display the search page of <i>url</i>. <i>param</i> should be
     * <b>null</b>.<p>
     * 
     * <b>NOTE</b> You can also specify any Win32Help or HTMLHelp command directly
     * by using the constant defined by that API as documented in the Win32 SDK.
     * 
     * @param parent Control to parent the help dialog to.
     * @param url Path to the HTMLHelp or Win32 help file.
     * @param command Either COMMAND_TOPIC, COMMAND_CONTENTS, COMMAND_INDEX, or COMMAND_FIND
     * @param param Command specific data
     */
    public static void showHelp(Control parent, String url, int command, Object param) {}

    
    private static int getHelpFileType(String url) {}

    
    private static int mapCommandToWinCommand(int command) {}

    
    private static int mapCommandToHTMLCommand(int command) {}

    
    private static class HELPWININFO {
        public int wStructSize;
        public int x;
        public int y;
        public int dx;
        public int dy;
        public int wMax;
        public String rgchMember;
    }

    
    private static class HH_POPUP {
        int       cbStruct=com.ms.dll.DllLib.sizeOf(HH_POPUP.class);
        int       hinst = 0;
        int       idString = 0;
        String    pszText;
        POINT     pt;
        int       clrForeground = -1;
        int       clrBackground = -1;
        RECT      rcMargins = new Rectangle(-1, -1, -1, -1).toRECT();     
        String    pszFont = null;
    }
    
    private static native int HtmlHelp(int hwndCaller, String pszFile, int uCommand, int dwData);
    
    private static native int HtmlHelp(int hwndCaller, String pszFile, int uCommand, String dwData);
    
    private static native int HtmlHelp(int hwndCaller, String pszFile, int uCommand, HH_POPUP dwData);
    
    private static native boolean WinHelp(int hWndMain, String lpszHelp, int uCommand, int dwData);
    
    private static native boolean WinHelp(int hWndMain, String lpszHelp, int uCommand, String dwData);
    
    private static native int ShellExecute(int hwnd, String lpOperation, String lpFile, String lpParameters, String lpDirectory, int nShowCmd);
}