//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;

/**
 * Contains information specific to hit-testing points for a month calendar control. 
 * HitTestInfo is for informational purposes only; the user should not construct these objects, and
 * cannot modify any of the members.
 *
 * @see com.ms.wfc.ui.MonthCalendar.hitTest(int,int)
 *
 * @security(checkClassLinking=on)
 */
public class HitTestInfo {
    /**
     * The point that was hit-tested
     */
    public final Point       point;
    
    /**
     * Output member that receives an enumeration value from com.ms.wfc.ui.HitArea 
     * representing the result of the hit-test operation.
     *
     * @see com.ms.wfc.ui.HitArea
     */    
    public final int         hitArea;

    /** 
     * The time information specific to the location that was hit-tested.  This value
     * will only be valid at certain values of hitArea.
     *
     * @see com.ms.wfc.app.Time
     * @see com.ms.wfc.ui.HitArea
     */
    public final Time        time;
    
    /**
     * @internalonly
     */
    protected HitTestInfo (Point pt, int area, Time time) {}
}