//STRIPPEDSOURCE//
package com.ms.wfc.ui;



import com.ms.wfc.core.*;

/**
 * This enumeration lists possible value for horizontal alignment of effects,
 * most typically text.  Edit controls, for example, will use this to align
 * their text within the client area.
 * 
 * @see Edit#getTextAlign
 *
 * @security(checkClassLinking=on)
 */
public class HorizontalAlignment extends Enum {

    /**
     * The data is aligned to the left of the region
     */
    public static final int LEFT = 0;

    /**
     * The data is aligned on the right edge of the region
     */
    public static final int RIGHT = 1;

    /**
     * The data is aligned in the centre of the region
     */
    public static final int CENTER = 2;

    /**
     * Returns true if the given value is allowable by this class, or false if not.
     */
    public static boolean valid(int value) {}
}