//STRIPPEDSOURCE//
package com.ms.wfc.ui;



/**
 * Control writers should implement this interface if they distribute
 * their control as an ActiveX control and they have properties they
 * would like settable at design time but are of a type not supported
 * by typical ActiveX container property browsers.  By implementing
 * this interface, the control will expose a "Properties" verb when
 * hosted in an ActiveX container, and when that verb is selected, the
 * showPropertyDialog method will be called.
 *
 * @security(checkClassLinking=on)
 */
public interface IActiveXCustomPropertyDialog
{
	/** 
     * This method should show a modal dialog which contains the UI
     * necessary to manipulate all the properties on the control that
     * are inaccessable to typical ActiveX property browsers.
     *
     * @param owner  The top-level window that is to be the owner
     *               of the dialog
     */
	public void showPropertyDialog(ITopLevelWindow owner);
}