//STRIPPEDSOURCE//
package com.ms.wfc.ui;



/**
 * Control writers should implement this interface if they wish to have their
 * control act like a button on a form. Forms have two places where this might
 * be interesting:  default button processing, and cancel button processing.
 * 
 * Default buttons are notified whenever an unprocessed ENTER key is entered
 * for a form, just like a dialog would be closed.
 * 
 * Similarily, cancel buttons are notified whenever an unprocessed ESC key is
 * found on the form, much like a dialog would be dismissed.
 * 
 * To behave like one of these controls, authors need merely implement this
 * interface.
 *
 * @security(checkClassLinking=on)
 */
public interface IButtonControl {

    
    void notifyDefault(boolean value);
    
    
    void performClick();
}