//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;



/**
 * Defines a group of constants that specify how icons are arranged within a window.
 *
 * @security(checkClassLinking=on)
 */
public class IconArrange extends Enum {

    /**
     * Specifies a default arrangement of icons in which icons remain in the position in which
     * they were last placed by a user.  Icons
     * can be moved around by users, and will remain there when moved.
     */
    public static final int DEFAULT = win.LVA_DEFAULT;

    /**
     * Specifies that icons are arranged along the top of the parent control or window.
     */
    public static final int TOP = win.LVA_ALIGNTOP;

    /**
     * Specifies that icons are arranged along the left of the parent control or window.
     */
    public static final int LEFT = win.LVA_ALIGNLEFT;

    /**
     * Specifies that icons are snapped to an imaginary grid, dividing the parenting control
     * into invisible sections.
     */
    public static final int SNAP_TO_GRID = win.LVA_SNAPTOGRID;

    /**
     * Retrieves a boolean value that indicates
     * whether a specified value designates a valid IconArrange constant.
     */
    public static boolean valid(int value) {}
}