//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines the constants that specify the user action that is required to activate items  in a the list view control and the feedback that is given as the user moves the mouse  pointer over an item. 
 * @security(checkClassLinking=on)
 */
public class ItemActivation extends Enum {

    /**
     * Specifies that the user must double-click to activate items and that no feedback is
     * given as the user moves the mouse pointer over an item.  No feedback is given as
     * the user moves over items.
     */
    public static final int STANDARD = 0;

    /**
     * Specifies that the user must single-click to activate items, that the cursor changes to
     * a hand with a pointing index finger, and that the item text changes color as the user
     * moves the mouse pointer over the item.  The cursor becomes the
     * "pointing finger" shape as the user moves over items and the item
     * text changes color.
     */
    public static final int ONECLICK = 1;

    /**
     * Specifies that that the user must double-click to activate items and that the item text
     * changes color as the user moves the mouse pointer over the item.  Item text changes
     * color as the user moves over items.
     */
    public static final int TWOCLICK = 2;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}
}