//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.win32.*;
import com.ms.wfc.core.*;

/**
 * Defines the constants that specify a portion of the list view item for which to  retrieve the bounding rectangle. 
 *
 * @security(checkClassLinking=on)
 */
public class ItemBoundsPortion extends Enum {

    /**
     * Specifies that the bounding rectangle of the entire item, including the icon, the item
     * text, and the subitem text (in Report view), should be retrieved.
     * In Report View, this also includes subitems.
     */
    public static final int ENTIRE = win.LVIR_BOUNDS;

    /**
     * Specifies that the bounding rectangle of the icon or small icon should be retrieved.
     */
    public static final int ICON = win.LVIR_ICON;

    /**
     * Specifies that the bounding rectangle of the item text should be retrieved.
     */
    public static final int LABEL = win.LVIR_LABEL;

    /**
     * Specifies that the bounding rectangle of the icon or small icon and the item text
     * should be retrieved.  In all views except Report View,
     * this is the same as WHOLE.  In Report View, this rectangle excludes subitems.
     */
    public static final int ITEMONLY = win.LVIR_SELECTBOUNDS;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}
}