//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * This event is sent to a CheckedListBox when the state of one of the
 * CheckBoxes is about to change.  The user of the component can, optionally,
 * set whatever new check state they want by using the "newValue" field.
 *
 * @security(checkClassLinking=on)
 */
public class ItemCheckEvent extends Event {

    /**
     * The index of the item that is about to change.
     */
    public final int index;

    /**
     * The proposed new value of the CheckBox.
     */
    public int newValue;

    /**
     * The current state of the CheckBox.
     */
    public final int currentValue;

    public ItemCheckEvent(int index, int newCheckValue, int currentValue) {}
}