//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;


/**
 * Represents an item in a list view control. 
 * @security(checkClassLinking=on)
 */
public class ListItem implements Cloneable, IConstructable, IPersistable {

    int image           = -1;
    String text;

    ListView listView;
    String[] subItems;

    public ListItem() {}

    /**
     * Creates a ListItem object from an IDataStream.
     */
    public ListItem(IDataStream stream) {}

    public ListItem(String text) {}

    public ListItem(String text, String[] subItems) {}

    public ListItem(String text, int image) {}

    public ListItem(String text, int image, String[] subItems) {}

    public Object clone() {}

    /**
      * Retrieves an array of ConstructorArg
     * objects that describe the data types and values needed to persist this object. 
      * @internalonly
      *
      * Implementation of IConstructable.getConstructorArgs()
      */
    public ConstructorArg[] getConstructorArgs() {}

    /** 
     * Ensures that the list item is visible, scrolling the list view control if necessary. 
     */
    public void ensureVisible() {}

    /**
     * Retrieves a boolean value indicating whether the specified object is equivalent
     * to this ListItem object. 
     * @param li ListItem to test against
     */
    
    public boolean equals(Object obj) {}

    /**
     * Retrieves the specified portion of the bounding rectangle for a list view item. 
     *
     * @return Rectangle associated with the ListItem
     */
    public final Rectangle getBounds() {}

    /**
     * Retrieves the specified portion of the bounding rectangle for a list view item. 
     *
     * @param portion   The portion of the item's rectange desired.
     *                  This must be one of the values from the ItemBoundsPortion enum.
     *
     * @return Rectangle associated with the ListItem
     *
     * @see ItemBoundsPortion
     */
    public final Rectangle getBounds(int portion) {}

    /**
     * Retrieves the file name extension for the file to store the item's persistent data in. 
     *
     * @return a filename extension to use during object persistence.  ListItem does
     *         not use an extension, so this always returns null.
     * @see IPersistable
     */
    public String getExtension() {}
    
    public boolean getChecked() {}

    public boolean getFocused() {}

    /**
     * Retrieves the zero-based index of the item within the list view control. 
     * @return ListItem's index in ListView
     */
    public int getIndex() {}

    /**
     * Retrieves the index of the image that appears next to this item. 
     * @return Image Index 
     */
    
    public int getImageIndex() {}

    public boolean getSelected() {}

    public int getStateImageIndex() {}

    /**
     * Retrieves the specified subitem for this item. 
     * @return Text of selected sub item
     *
     * @exception WFCInvalidArgumentException Thrown if SubItem index
     * is out of bounds.
     */
    public String getSubItem(int index) {}
    
    /**
     * Retrieves the number of subitems associated with this list item. 
     * @return Count of SubItems
     */
    
    public int getSubItemCount() {}

    /**
     * Retrieves all the subitems associated with this list item. 
     * @return SubItem array
     */
    
    public String[] getSubItems() {}

    /**
     * Retrieves the text for this list item. 
     * @return ListItem's text
     */
    
    public String getText() {}

    public void remove() {}

    /**
     * Saves this ListItem object to the specified data stream. 
     *
     * @param stream    The data stream to write to.
     *
     * @see IPersistable
     */
    public void save(IDataStream stream) {}

    public void setChecked(boolean value) {}

    public void setFocused(boolean value) {}

    public void setImageIndex(int value) {}

    public void setSelected(boolean value) {}

    public void setStateImageIndex(int imageIndex) {}

    /**
     * Sets the text for the specified subitem.  If Index >= SubItemCount, then the SubItem array is 
     * grown to match the Index. Anything in between the old array
     * bounds and the new is declared as null.
     *
     * @param index Index to set SubItem at
     * @param text  Text of the sub item to set
     *
     * @exception WFCInvalidArgumentException Thrown if Index < 0 or
     * if Index > # of Current COlumns in the ListView
     * 
     */
    public void setSubItem(int index, String text) {}
    
    /**
     * Sets the subitems for the item. 
     * @param subItems array of Strings representing the text for the
     * new sub items
     *
     * @exception WFCInvalidArgumentException Thrown if # of
     * subitems in new array > # of Current COlumns in the ListView
     * 
     */
    public void setSubItems(String[] subItems) {}

    public void setText(String text) {}

    public String toString() {}


    /**
     * Represents an item in a list view control. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {

        public static PropertyInfo imageIndex =
            new PropertyInfo(ListItem.class, "imageIndex", int.class,
                DefaultValueAttribute.NEGATIVE_ONE);

        public static PropertyInfo subItems =
            new PropertyInfo(ListItem.class, "subItems", String[].class,
            new DefaultValueAttribute(new String[] {}));

        public static PropertyInfo text =
            new PropertyInfo(ListItem.class, "text", String.class,
                new ValueEditorAttribute(ImmediateStringEditor.class),
                DefaultValueAttribute.EMPTY_STRING);

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }
}