//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.util.*;
import com.ms.dll.*;


/**
 * Encapsulates an MDI container. This control
 * should not be created directly, but rather only used by 
 * com.ms.wfc.ui.Form.
 * 
 * @security(checkClassLinking=on)
 */
public class MDIClient extends Control {
    private boolean designMode;
    
    
    
    
    private List children = new List();
    
   
    /**
     * Creates a new MDIClient.
     * 
     * @internalonly 
     */
    public MDIClient() {}

    /**
     * Retrieves a list of the MDI child forms. This list
     * will be sorted by the order in which the children were
     * added to the form, not the current ZOrder.
     * 
     * @return MDI children.
     */
    public Form[] getMDIChildren() {}
    
    /**
     * Adds a child form to the MDI container.  This child must be
     * a Form that is marked as an MDI Child to be added to the
     * container. You should not call this directly, but rather
     * set the child form's (<i>ctl</I>) MDIParent property:
     * <pre>
     * // wrong
     * Form child = new ChildForm();
     * this.getMDIClient().add(child);
     * 
     * // right
     * Form child = new ChildForm();
     * child.setMDIParent(this);
     * </pre>
     * 
     * @param ctl MDIChild Form to add.
     */
    public void add(Control ctl) {}

    /**
     * Removes a child form from the MDI container. 
     * 
     * @param ctl MDIChild Form to remove.
     */
    public void remove(Control ctl) {}

    

    /**
     * Arranges the MDI child forms according to the specified layout value. 
     *
     * @param value Any value from the MDILayout enum class.
     * 
     * @see MDILayout
     */
    public final void layoutMDI(int value) {}

    /**
     * @internalonly
     */
    protected CreateParams getCreateParams() {}

    /**
     * @internalonly
     */
    protected void onResize(Event e) {}

    

    /**
     * @internalonly
     */
    protected void setBoundsCore(int x, int y, int width, int height) {}
    
    
    private void setWindowRgn() {}

    /**
     * @internalonly
     */
    protected void wndProc(Message m) {}


    /**
     * Encapsulates an MDI container.
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Control.ClassInfo {
        public void getAttributes(IAttributes attributes) {}
    }
}