//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;


/**
 * Defines constants that specify the layout of MDI child windows. 
 * @security(checkClassLinking=on)
 */
public class MDILayout extends Enum {

    /**
     * Specifies that all MDI child windows should be cascaded in the available MDIClient region.
     */
    public static final int CASCADE         = 0;
    /**
     * Specifies that all MDI child windows should be tiled vertically in the available MDIClient region.
     */
    public static final int TILE_VERTICAL   = 1;
    /**
     * Specifies that all the MDI child windows should be tiled horizontally horizontally in
     * the available MDIClient region.
     */
    public static final int TILE_HORIZONTAL = 2;
    /**
     * Specifies that all minimized MDI child icons should be arranged within the parent
     * window.
     */
    public static final int ARRANGE_ICONS   = 3;

    /**
     * Retrieves a boolean value that indicates whether a specified value is
     * a valid member of this class.
     * 
     * @param value Value to check
     * 
     * @return <b>true</b> if <i>value</i> is a valid MDILayout value.
     */
    public static boolean valid(int value) {}
}