//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines a group of constants that determine how a menu glyph should be drawn. 
 * 
 * @see Graphics
 *
 * @security(checkClassLinking=on)
 */
public final class MenuGlyph extends Enum {
    
    /**
     * Indicates that a submenu arrow should be drawn.
     */
    public static final int ARROW = win.DFCS_MENUARROW;

    /**
     * Indicates that a menu checkmark should be drawn.
     */
    public static final int CHECKMARK = win.DFCS_MENUCHECK;

    /**
     * Indicates that a menu bullet should be drawn.
     */
    public static final int BULLET = win.DFCS_MENUBULLET;

    private static final int MIN = win.DFCS_MENUARROW;
    private static final int MAX = win.DFCS_MENUBULLET;

    /**
     * Determines whether the specified value is one of the constants defined in this class.
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}