//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify how menus behave when they are merged together.
 *
 * @security(checkClassLinking=on)
 */
public class MenuMerge extends Enum {

    /**
     * Specifies that the menu item should be added alongside an existing item in the merged
     * menu.
     */
    public static final int ADD        = 0;

    /**
     * Indicates that the menu item should replace the existing item at the same position in
     * the merged menu.
     */
    public static final int REPLACE    = 1;

    /**
     * Specifies that the subitems of this item should be merged with those of the existing
     * item at the same position in the merged menu.
     */
    public static final int MERGEITEMS = 2;

    /**
     * Specifies that the menu item should not be included in the merged menu.
     */
    public static final int REMOVE     = 3;

    /**
     * Determines whether the specified value is one of the constants defined in this class.
     */
    public static boolean valid(int value) {}
}