//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify which mouse button was pressed. 
 * 
 * @security(checkClassLinking=on)
 */
public class MouseButton extends Enum {
    
    /**
     * Specifies that the left mouse button was pressed.
     * @see MouseEvent
     */
    public static final int LEFT   = 0x00100000;
    
    /**
     * Specifies that no mouse button was pressed.
     * @see MouseEvent
     */
    public static final int NONE   = 0x00000000;

    /**
     * Specifies that the right mouse button was pressed.
     * @see MouseEvent
     */
    public static final int RIGHT  = 0x00200000;
    
    /**
     * Specifies that the middle mouse button was pressed.
     * @see MouseEvent
     */
    public static final int MIDDLE = 0x00400000;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}