//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Provides data for the the mouseDown,  mouseEnter, mouseLeave, mouseMove, or mouseUp event of a Control object. 
 *
 * @security(checkClassLinking=on)
 */
public class MouseEvent extends Event {

    /**
     * Which button generated this event [if applicable]
     */
    public final int button;
    
    /**
     * If the user has clicked the mouse more than once, this contains the
     * count of clicks so far.
     */
    public final int clicks;
    
    /**
     * The x portion of the coordinate where this event occurred.
     */
    public final int x;
    
    /**
     * The y portion of the coordinate where this event occurred.
     */
    public final int y;
    
    public final int delta;

    /**
     * Creates a new MouseEvent object with the specified information.
     */
    public MouseEvent(int button, int clicks, int x, int y, int delta) {}

    /**
     * Creates a new MouseEvent object with the specified information.
     */
    public MouseEvent(Object extendedInfo, int button, int clicks, int x, int y, int delta) {}
}