//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates the Save As common dialog box control that allows the user to open  a file.   Most
 * of the functionality for this Object is in the FileDialog object.
 *
 * @security(checkClassLinking=on)
 */
public class OpenFileDialog extends FileDialog
{
    /**
     * Retrieves a boolean value indicating whether the dialog box allows multiple
     * files to be selected. 
     *
     * @see #setMultiselect
     */
    public final boolean getMultiselect() {}

    /**
     * Retrieves a boolean value indicating whether the Open as read-only check
     * box is currently selected. 
     *
     * @see #setReadOnlyChecked
     */
    public final boolean getReadOnlyChecked() {}

    /**
     * Retrieves a boolean value indicating whether the dialog box contains an Open
     * as read-only check box that the user can select to open a file in read-only mode. 
     *
     * @see #setShowReadOnly
     */
    public final boolean getShowReadOnly() {}

    /**
     * Resets all dialog box options to their default values. 
     */
    public final void reset() {}

    
    boolean runFileDialog(OPENFILENAME_I ofn) {}

    /**
     * Sets a boolean value indicating whether the dialog box allows multiple files to
     * be selected.  To
     * access the full list of selected filenames, use the getileNames() method.
     */
    public final void setMultiselect(boolean value) {}

    /**
     * Sets a boolean value indicating whether the Open as read-only check box
     * is initially selected when the dialog box opens.  This flag indicates the state of the Read Only check box when
     * the dialog box is closed.
     */
    public final void setReadOnlyChecked(boolean value) {}

    /**
     * Sets a boolean value indicating whether the dialog box contains an Open as
     * read-only check box that the user can select to open a file in read-only mode. 
     */
    public final void setShowReadOnly(boolean value) {}

    /**
     * Encapsulates the Save As common dialog box control that allows the user to open  a file. 
     * @see com.ms.wfc.core.ClassInfo
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends FileDialog.ClassInfo {

        public static final PropertyInfo checkFileExists = new PropertyInfo(
            OpenFileDialog.class, "checkFileExists", Boolean.TYPE,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("OFDcheckFileExistsDescr")));

        public static final PropertyInfo multiselect = new PropertyInfo(
            OpenFileDialog.class, "multiselect", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("OFDmultiSelectDescr")));

        public static final PropertyInfo readOnlyChecked = new PropertyInfo(
            OpenFileDialog.class, "readOnlyChecked", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("OFDreadOnlyCheckedDescr")));

        public static final PropertyInfo showReadOnly = new PropertyInfo(
            OpenFileDialog.class, "showReadOnly", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("OFDshowReadOnlyDescr")));

        public void getProperties(IProperties props) {}
    }
}