//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Provides data for the paint event  of the Control object.   It is fired
 * through the paint event.  It contains the rectangle in which all
 * painting should be done, and the graphics object with which to do the
 * painting.
 * 
 * @see com.ms.wfc.ui.Graphics
 *
 * @security(checkClassLinking=on)
 */
public class PaintEvent extends Event {

    /**
     * Graphics object with which painting should be done.
     */
    public final Graphics graphics;
    
    /**
     * Rectangle into which all painting should be done.
     */
    public final Rectangle clipRect;

    /**
     * Creates a new PaintEvent event with the given graphics and
     * clipping rectangle.
     */
    public PaintEvent(Graphics graphics, Rectangle clipRect) {}
}