//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Represents a container you can use to parent other controls visually. 
 *
 * @security(checkClassLinking=on)
 */
public class Panel extends Control {

    private int borderStyle = BorderStyle.NONE;

    /**
     * Creates a new Panel Object.
     */
    public Panel() {}

    /**
     * Retrieves a value indicating the kind of border the panel has.   This value
     * comes from the com.ms.wfc.ui.BorderStyle enumeration.
     *
     * @return  an integer with the current border style.
     *
     * @see com.ms.wfc.ui.BorderStyle
     */
    public final int getBorderStyle() {}

    /**
     * Returns the parameters needed to create the handle.  Inheriting classes
     * can override this to provide extra functionality.  They should not,
     * however, forget to call super.getCreateParams() first to get the struct
     * filled up with the basic info.
     *
     * @return    a CreateParams object with all the info needed to create
     *            the control.
     *
     * @see com.ms.wfc.ui.CreateParams
     */
    protected CreateParams getCreateParams() {}

    
    private void drawBorder(Graphics gr) {}


    /**
     * Triggers the resize event. 
     * Inheriting controls should use this in favour of actually listening to
     * the event, but should not forget to call super.onResize() to
     * ensure that the event is still fired for external listeners.
     *
     * @param   e       Event to send
     */
    protected void onResize(Event event) {}

    /**
     * Triggers the paint event. 
     * Inheriting controls should use this in favour of actually listening to
     * the event, but should not forget to call super.onPaint() to
     * ensure that the event is still fired for external listeners.
     *
     * @param   e       Event to send
     */
    protected void onPaint(PaintEvent event) {}

    /**
     * Sets a value indicating the kind of border the panel has.   Values are
     * obtained from the com.ms.wfc.ui.BorderStyle enumeration.
     *
     * @param value     The new border style for this Panel.
     *
     * @see com.ms.wfc.ui.BorderStyle
     */
    public final void setBorderStyle(int value) {}

    
    private static String stringFromBorderStyle(int value) {}

    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    /**
     * Represents a container you can use to parent other controls visually. 
     * @see com.ms.wfc.core.ClassInfo
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Control.ClassInfo {

        public static final PropertyInfo borderStyle = new PropertyInfo(
            Panel.class, "borderStyle", com.ms.wfc.ui.BorderStyle.class,
            new DefaultValueAttribute(new Integer(com.ms.wfc.ui.BorderStyle.NONE)),
            new DescriptionAttribute(Sys.getString("PanelBorderStyleDescr")));

        public static final PropertyInfo tabStop = new PropertyInfo(
            Control.ClassInfo.tabStop, DefaultValueAttribute.FALSE);

        public static final PropertyInfo text = new PropertyInfo(
            Control.ClassInfo.text, BrowsableAttribute.NO);

        public String getDefaultEventName() {}

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }
}