//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates a PictureBox control.   The <i>image</i> property 
 * should be set to the image desired.
 *
 * @security(checkClassLinking=on)
 */
public class PictureBox extends Control {

    
    private int borderStyle = BorderStyle.NONE;

    
    private Image image;

    
    private int sizeMode = PictureBoxSizeMode.NORMAL;

    
    private int requestedWidth;
    private int requestedHeight;


    /**
     * Creates a new picture with all default properties and no Image. The
     * default sizeMode will be NORMAL.
     */
    public PictureBox() {}

    
    private void adjustSize() {}

    /**
     * Retrieves the border type for the PictureBox control.  This value
     * comes from the com.ms.wfc.ui.BorderStyle enumeration.
     * 
     * @return  an integer with the current border style.
     * 
     * @see com.ms.wfc.ui.BorderStyle
     */
    public final int getBorderStyle() {}

    /**
     * Returns the parameters needed to create the handle.  Inheriting classes
     * can override this to provide extra functionality.  They should not, 
     * however, forget to call super.getCreateParams() first to get the struct
     * filled up with the basic info.
     *
     * @return    a CreateParams object with all the info needed to create 
     *            the control.
     * 
     * @see com.ms.wfc.ui.CreateParams
     */
    protected CreateParams getCreateParams() {}

    /**
     * Retrieves the image currently displayed by the PictureBox control.
     * 
     * @return  the current Image
     * 
     * @see com.ms.wfc.ui.Image
     */
    public final Image getImage() {}

    /**
     * Retrieves the palette for the image that is currently displayed by the PictureBox
     * control.getPalette() to get the palette from the Image
     * with which we are working instead of choosing a default.  Inheriting
     * classes cannot change this functionality.
     * 
     * @return      the Palette that should be used for this Control.
     */
    public final Palette getPalette() {}

    
    private Point getPreferredSize() {}

    /**
     * Retrieves a value that indicates how the PictureBox control will
     * render the image.  By default, the Image is placed in the upper
     * left of the PictureBoxes client area, and any part of the image
     * too big for the PictureBox is clipped.  Alternatively the image can
     * be stretched to fit the client area, or the control can be sized to
     * always fit the image, or the image can be centered in the client
     * area.  Valid values for this property are taken from the
     * PictureBoxSizeMode enumeration.
     *
     * @return  the current size mode for this PictureBox control.
     *
     * @see com.ms.wfc.ui.PictureBoxSizeMode
     */
    public final int getSizeMode() {}

    /**
     * Overridden onPaint to make sure that the image is painted correctly.
     * @internalonly
     */
    protected void onPaint(PaintEvent pe) {}

    /** 
     * onResize override to invalidate entire control in Stetch mode
     *
     * @internalonly
     */
    protected void onResize(Event e) {}

    /**
     * Sets the border style for the PictureBox control.  Values are
     * obtained from the com.ms.wfc.ui.BorderStyle enumeration.
     * 
     * @param value     The new border style for this Panel.
     * 
     * @see com.ms.wfc.ui.BorderStyle
     */
    public final void setBorderStyle(int value) {}

    /**
     * Overrides Control.setBoundsCore to enforce autoSize.
     * @internalonly
     */
    protected void setBoundsCore(int x, int y, int width, int height) {}

    /**
     * Associates an image with the PictureBox control.  The old image is discarded.
     * The new image will be displayed immediately.
     * 
     * @param value     The new image with which we will work.
     * 
     * @see com.ms.wfc.ui.Image
     */
    public final void setImage(Image value) {}

    /**
     * Sets the sizing mode for the PictureBox control.  By default, the Image is placed in the upper
     * left of the PictureBoxes client area, and any part of the image
     * too big for the PictureBox is clipped.  Alternatively the image can
     * be stretched to fit the client area, or the control can be sized to
     * always fit the image, or the image can be centered in the client
     * area.  Valid values for this property are taken from the
     * PictureBoxSizeMode enumeration.
     *
     * @param   value       The new size mode for this PictureBox
     *
     * @see com.ms.wfc.ui.PictureBoxSizeMode
     */
    public final void setSizeMode(int value) {}

    
    private static String stringFromSizeMode(int value) {}

    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    /**
     * Encapsulates a PictureBox control. 
     * @see com.ms.wfc.core.ClassInfo
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Control.ClassInfo {

        public static final PropertyInfo borderStyle = new PropertyInfo(
            PictureBox.class, "borderStyle", com.ms.wfc.ui.BorderStyle.class,
            new DefaultValueAttribute(new Integer(com.ms.wfc.ui.BorderStyle.NONE)),
            new DescriptionAttribute(Sys.getString("PictureBoxBorderStyleDescr")));

        public static final PropertyInfo image = new PropertyInfo(
            PictureBox.class, "image", Image.class,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("PictureBoxImageDescr")));

        public static final PropertyInfo sizeMode = new PropertyInfo(
            PictureBox.class, "sizeMode", PictureBoxSizeMode.class,
            new DefaultValueAttribute(new Integer(PictureBoxSizeMode.NORMAL)),
            new DescriptionAttribute(Sys.getString("PictureBoxSizeModeDescr")));

        public static final PropertyInfo foreColor = new PropertyInfo(
            Control.ClassInfo.foreColor, BrowsableAttribute.NO);

        public static final PropertyInfo text = new PropertyInfo(
            Control.ClassInfo.text, BrowsableAttribute.NO);

        public static final PropertyInfo font = new PropertyInfo(
            Control.ClassInfo.font, BrowsableAttribute.NO);

        public String getDefaultPropertyName() {}

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }
}