//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * The PictureBox control lets you control how the Image is placed within
 * its client area, or how the control is sized to fit the Image.  This
 * enumeration describes said options.
 *
 * @security(checkClassLinking=on)
 */
public class PictureBoxSizeMode extends Enum {

    /**
     * Indicates that the Image should be placed in the top left of the
     * PictureBoxes client area, should be clipped if the PictureBox is
     * to small, and that no other special processing should occur.
     */
    public static final int      NORMAL = 0;

    /**
     * Indicates that the Image should be "stretched" [shrunken] to fit
     * whatever the current size of the PictureBox control is.
     */
    public static final int     STRETCH_IMAGE = 1;

    /**
     * Indicates that the PictureBox should size itself to fit the current
     * Image.
     */
    public static final int     AUTO_SIZE = 2;

    /**
     * Indicates that, if the PictureBox is larger than the Image, the
     * Image should be centered in the available space in the PictureBox.
     * If the Image is larger than the available space, it is placed in the
     * upper left of the PictureBoxes client area, and is clipped as
     * necessary.
     */
    public static final int     CENTER_IMAGE = 3;

    /**
     * Checks to see if the given value is validin within this Enumeration.
     */
    public static boolean valid(int value) {}
}