//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates a single (x,y) coordinate and the operations that you can perform on such  a coordinate.
 *
 * @security(checkClassLinking=on)
 */
public class Point implements IConstructable, IPersistable
{
    /**
     * The horizontal position of the coordinate
     */
    public int x;

    /**
     * The vertical position of the coordinate
     */
    public int y;

    /**
     * Create a new Point object at 0, 0.
     */
    public Point() {}

    /**
     * Create a new Point object at the given location.
     *
     * @param x     Horizontal poisiton of the point.
     * @param y     Vertical position of the point.
     */
    public Point(int x, int y) {}

    /**
     * Create a new Point object given an existing Point object.
     *
     * @param pt Point object.
     */
    public Point(Point pt) {}

    /**
     * Create a new Point object given a Win32 POINT structure.
     *
     * @param pt    Win32 POINT object.
     */
    public Point(POINT pt) {}

    /**
     * Create a new Point object given a Win32 SIZE structure.
     *
     * @param size  A Win32 SIZE structure.
     */
    public Point(SIZE size) {}

    /**
     * Create a new point object given the coordinates crammed into a 32bit
     * integer.  The low order 16bits are the horizontal [x] coordinate and
     * the higher 16bits are the vertical [y] coordinate.
     *
     * @param dw    Integer with the two coordinate values in it
     */
    public Point(int dw) {}

    public Point(IDataStream stream) {}

    public String getExtension() {}

    public void save(IDataStream stream) {}

    /**
     * Retrieves a Win32 POINT structure representing this object.
     *
     * @return POINT
     */
    public POINT toPOINT() {}

    /**
     * Retrieves a Win32 SIZE structure representing this object. 
     *
     * @return SIZE
     */
    public SIZE toSIZE() {}

    public String toString() {}

    /**
     * Retrieves a boolean value that indicates whether the specified object
     * is equivalent to this one.
     * Doesn't actually test for object identity equality.
     *
     * @param value    Test to see if this object is the same as the current one.
     *
     * @return boolean indicating true if they are the same, false otherwise.
     */
    public boolean equals(Object obj) {}

    public ConstructorArg[] getConstructorArgs() {}


    /**
     * Encapsulates a single (x,y) coordinate and the operations that you can perform on such  a coordinate.
     * @security(checkClassLinking=on)
     */
    public static class Editor extends ValueEditor {

        public int getStyle() {}

        public String getTextFromValue(Object value) {}

        public Object getValueFromText(String text) {}
    }

}