//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines a group of constants that describe the approaches to filling areas in a  polygon.
 *
 * @security(checkClassLinking=on)
 */
public class PolyFillMode extends Enum {

    /**
     * Represents a fill mode in which the
     * system fills the area between odd-numbered and even-numbered polygon sides on each scan
     * line. That is, the system fills the area between the first and 
     * second side, between the third and fourth side, and so on. This mode 
     * is the default. 
     */
    public static final int ALTERNATE = win.ALTERNATE;

    /**
     * Represents a fill mode in which the
     * system uses the direction in which a figure was drawn to determine whether to fill the
     * area. Each line segment in a polygon is drawn in either a clockwise or 
     * a counterclockwise direction. Whenever an imaginary line drawn from an 
     * enclosed area to the outside of a figure passes through a clockwise 
     * line segment, a count is incremented. When the line passes through a 
     * counterclockwise line segment, the count is decremented. The area is 
     * filled if the count is nonzero when the line reaches the outside of 
     * the figure.
     */
    public static final int WINDING = win.WINDING;
                                              
    private static final int MIN = ALTERNATE;
    private static final int MAX = WINDING;
   
    /**
     * Retrieves a boolean
     * value that indicates whether a specified value is a valid member of the PolyFillMode
     * class.
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}