//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;

/**
 * Encapsulates a band on a Rebar control. 
 * @security(checkClassLinking=on)
 */
public class RebarBand extends Component {

    private Color   foreColor           = null;
    private Color   backColor           = null;
    private String  text                = null;
    private int     imageIndex          = -1;
    private Control childControl        = null;
    private int     minChildWidth       = 50;
    private int     minChildHeight      = 20;
    private int     width               = 200;
    private Bitmap  backgroundBitmap    = null;
    private int     initialChildHeight  = 20;
    private int     maxChildHeight      = 100;
    private int     growHeightBy        = 10;
    private int     idealWidth          = 200;
    private int     headerWidth         = 0;
    private int     actualHeaderWidth   = -1;
    private int     index               = 0;
    private boolean bandbreak           = true;
    private boolean displayGripper      = true;
    private boolean allowVariableHeight = false;
    private boolean allowVert           = true;
    private boolean childEdge           = false;
    private boolean fixedBitmap         = true;
    private boolean visible             = true;

    private int         id;
    private Rebar   rebar;

    private static int nextId = 0;

    /**
     * Creates a RebarBand.
     */
    public RebarBand() {}

    /**
     * Retrieves a boolean value indicating whether the specified object is equivalent
     * to this RebarBand object. 
     *
     * @param obj Object to test against for equality.
     * @return whether or not the two objects are equal
     */
    public boolean equals(Object obj) {}

    
    int getActualHeaderWidth() {}

    
    private int getActualHeaderHeight() {}

    
    void forceChildToSize() {}

    /**
     * Retrieves a boolean value indicating whether the rebar control can adjust the
     * height of this band. 
     *
     * @return whether or not variable height is set for
     *         this band.
     */
    public boolean getAllowVariableHeight() {}

    /**
     * Retrieves a boolean value indicating whether this rebar band is displayed when
     * the orientation property of the
     * rebar control is set to Orientation.VERTICAL.
     * 
     *
     * @return whether or not vertical draw is set for
     *         this band.
     */
    public boolean getAllowVertical() {}

    /**
     * Retrieves the currently set back color of this band.
     *
     * @return currently set back color for this band.
     */
    public Color getBackColor() {}

    /**
     * Retrieves the background image associated with this rebar band. 
     *
     * @return currently set background bitmap.
     */
    public Bitmap getBackgroundImage() {}

    /**
     * Retrieves a boolean value indicating whether the rebar band begins a new row in
     * the rebar control or whether it can continue a row started by another rebar band. 
     * 
     * @return BandBreak value.
     * 
     * @see #setBandBreak
     */
    public boolean getBandBreak() {}

    
    private int getBandStyle() {}

    
    int getBandInfoStyle() {}

    /**
     * Retrieves the child control contained by this rebar band. 
     *
     * @return current child.
     */
    public Control getChildControl() {}

    /**
     * Retrieves a boolean value indicating whether the rebar band displays an edge at
     * the top and bottom of the child control. 
     *
     * @return current state for the ChildEdge style.
     */
    public boolean getChildEdge() {}

    /**
     * Retrieves a boolean value indicating whether the background bitmap moves when
     * the rebar band is resized. 
     *
     * @return current state for the FixedBitmap style.
     */
    public boolean getFixedBitmap() {}

    /**
     * Retrieves the current ForeColor of this band.
     *
     * @return current ForeColor color setting.
     */
    public Color getForeColor() {}

    /**
     * Retrieves the step value, in pixels, by which a variable-height rebar band can grow or
     * shrink during resizing. 
     *
     * @return current grow/shrink value for a variable height band.
     */
    public int getGrowBy() {}

    /**
     * Retrieves the width, in pixels, of the rebar band's header. 
     *
     * @return current header width for this band.
     */
    public int getHeaderWidth() {}

    /**
     * Retrieves the ideal width of the rebar band, in pixels. 
     *
     * @return current band's ideal width.
     */
    public int getIdealWidth() {}

    /**
     * Retrieves the index of the image that appears next to this rebar band. 
     *
     * @return current band's imagelist image index.
     */
    public int getImageIndex() {}

    /**
     * Retrieves the zero-based index of the rebar band within the rebar control. 
     *
     * @return current band's index in the parent rebar control.
     */
    public int getIndex() {}

    /**
     * Retrieves the initial height of the rebar band, in pixels.  Used for variable height
     * bands.
     *
     * @return current band's initial display height
     */
    public int getInitialHeight() {}

    /**
     * Retrieves the maximum height of the rebar band, in pixels.  Used for 
     * non variable height bands.
     *
     * @return current band's maximum initial display height.
     */
    public int getMaxInitialHeight() {}

    /**
     * Retrieves the minimum height of the rebar band, in pixels. 
     *
     * @return current band's minimum height for the child window.
     */
    public int getMinChildHeight() {}

    /**
     * Retrieves the minimum width of the rebar band, in pixels. 
     *
     * @return current band's minimum width for the child window.
     */
    public int getMinChildWidth() {}

    
    void getRebarBandInfo(REBARBANDINFO_IE4 rbbi) {}

    /**
     * Gets the bounds of the band.
     *
     * @return the bounds of the band.
     */
    public Rectangle getBounds() {}

    /**
     * Retrieves the header text for the rebar band. 
     *
     * @return current band's header text.
     */
    public String getText() {}

    /**
     * Retrieves the state of the band's Visible style. 
     *
     * @return current band's Visible style state.
     */
    public boolean getVisible() {}

    /**
     * Retrieves a boolean value indicating whether the rebar band has a sizing grip.  
     *
     * @return current band's VisibleGripper style state.
     */
    public boolean getVisibleGripper() {}

    /**
     * Retrieves the width of the rebar band, in pixels.  
     *
     * @return current band's width.
     */
    public int getWidth() {}

    
    boolean getCreated() {}

    /**
     * Maximizes this rebar band within the rebar control. 
     */
    public void maximize() {}

    /**
     * Minimizes this rebar band within the rebar control. 
     */
    public void minimize() {}

    /**
     * Sets a boolean value indicating whether the rebar control can adjust the height
     * of this band. 
     *
     * @param flag The new state of the VariableHeight style.
     */
    public void setAllowVariableHeight(boolean flag) {}

    /**
     * Sets a boolean value indicating whether this rebar band is displayed when the orientation property of the rebar
     * control is set to Orientation.VERTICAL.
     * 
     *
     * @param flag The new state of the Vertical display style.
     */
    public void setAllowVertical(boolean flag) {}

    /**
     * Sets the band's current back color
     *
     * @param backColor The band's new current back color
     */
    public void setBackColor(Color backColor) {}

    /**
     * Sets the background image associated with this rebar band. 
     *
     * @param backgroundImage The band's new background bitmap.
     */
    public void setBackgroundImage(Bitmap backgroundImage) {}

    /**
     * Sets a boolean value indicating whether the rebar band begins a new row in the
     * rebar control or whether it can continue a row started by another rebar band.  If BandBreak is set to true then
     * this band will start on a new row.
     * 
     * @param value New value for the BandBreak property.
     * 
     * @see #getBandBreak
     */
    public void setBandBreak(boolean value) {}

    /**
     * Sets a boolean value indicating whether the rebar band displays an edge at the
     * top and bottom of the child control. 
     *
     * @param flag The new state of the ChildEdge display style.
     */
    public void setChildEdge(boolean flag) {}

    /**
     * Sets the child control contained by this rebar band. 
     *
     * @param childControl  Child control.
     */
    public void setChildControl(Control childControl) {}

    
    void setColorParams() {}

    /**
     * Sets a boolean value indicating whether the background bitmap moves when the
     * rebar band is resized. 
     *
     * @param flag The new state of the FixedBitmap display style.
     */
    public void setFixedBitmap(boolean flag) {}

    /**
     * Sets the fore color for this band.
     *
     * @param foreColor New for color for this band.
     */
    public void setForeColor(Color foreColor) {}

    /**
     * Sets the step value, in pixels, by which a variable-height rebar band can increase or
     * decrease during resizing.  
     * Ignored if not a variable height band.
     *
     * @param growby Pixels to grow by in variable height mode.,
     */
    public void setGrowBy(int growby) {}

    /**
     * Sets the width, in pixels, of the rebar band's header. 
     *
     * @param headerWidth Pixel width for the band's header text.
     */
    public void setHeaderWidth(int headerWidth) {}

    /**
     * Sets the ideal width of the rebar band, in pixels. 
     *
     * @param idealWidth The value to be.
     */
    public void setIdealWidth(int idealWidth) {}

    /**
     * Sets the index of the image that appears next to this rebar band. 
     *
     * @param imageIndex Image Index into the rebar's ImageList.
     */
    public void setImageIndex(int imageIndex) {}

    
    void setInternalIndex(int index) {}

    /**
     * Sets the zero-based index of the band within the rebar control. 
     * 
     * @param index New index for this band.
     * 
     * @see #getIndex
     */
    public void setIndex(int index) {}

    
    void setInfo(int mask) {}


    void setInfo() {}

    /**
     * Sets the initial height of the band, in pixels. 
     *
     * @param initHeight Initial height of band in Rebar control.
     */
    public void setInitialHeight(int initHeight) {}

    /**
     * Sets the maximum height of the rebar band, in pixels. 
     *
     * @param maxInitHeight Maximum initial height of band in Rebar control.
     */
    public void setMaxInitialHeight(int maxInitHeight) {}

    /**
     * Sets the minimum height of the rebar band, in pixels. 
     *
     * @param minChildHeight Minimum initial height of child window
     *                         of this band.
     */
    public void setMinChildHeight(int minChildHeight) {}

    
    void setMinChildParams() {}

    /**
     * Sets the minimum width of the rebar band, in pixels. 
     *
     * @param minChildWidth Minimum initial width of child window of
     *                        this band.
     */
    public void setMinChildWidth(int minChildWidth) {}

    
    void setParent(Rebar parent) {}

    /**
     * @internalonly
     */
    protected void updateStyle() {}

    /**
     * Sets the header text for the rebar band. 
     *
     * @param text Text to be displayed in the header of this band.
     */
    public void setText(String text) {}

    
    void setVariableHeightParams() {}

    /**
     * Sets the state of the band's Visible display style.
     *
     * @param flag The new state of the Visible display style.
     */
    public void setVisible(boolean flag) {}

    /**
     * Sets a boolean value indicating whether the rebar band has a sizing grip. 
     *
     * @param flag The new state of the VisibleGripper display style.
     */
    public void setVisibleGripper(boolean flag) {}

    /**
     * Sets the width of the rebar band, in pixels. 
     *
     * @param width Pixel width for this band.
     */
    public void setWidth(int width) {}

    /**
     * Retrieves a String object that contains information about this rebar band. 
     */
    public String toString() {}

    
    void updateWithLayout() {}

    
    void unrealize() {}


    /**
     * Encapsulates a band on a Rebar control. 
     * @security(checkClassLinking=on)
     */
    public static class ArrayEditor extends ValueEditor {
        public int getStyle(){}
    
        public String getTextFromValue(Object value) {}
    }

    /**
     * Encapsulates a band on a Rebar control. 
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {
        public static final PropertyInfo allowVariableHeight = new PropertyInfo(
            RebarBand.class, "allowVariableHeight", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("RebarBandAllowVariableHeightDescr")));

        public static final PropertyInfo allowVertical = new PropertyInfo(
            RebarBand.class, "allowVertical", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("RebarBandAllowVerticalDescr")));

        public static final PropertyInfo backColor = new PropertyInfo(
            RebarBand.class, "backColor", Color.class,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("RebarBandBackColorDescr")));

        public static final PropertyInfo backgroundImage = new PropertyInfo(
            RebarBand.class, "backgroundImage", Bitmap.class,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("RebarBandBackgroundImageDescr")));
        
        public static final PropertyInfo bandBreak = new PropertyInfo(
            RebarBand.class, "bandBreak", Boolean.TYPE,
            CategoryAttribute.Appearance,
            BrowsableAttribute.NO,
            new DescriptionAttribute(Sys.getString("RebarBandBandBreakDescr")));

        public static final PropertyInfo childControl = new PropertyInfo(
            RebarBand.class, "childControl", Control.class,
            CategoryAttribute.Behavior,
            BrowsableAttribute.NO,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("RebarBandChildControlDescr")));

        public static final PropertyInfo childEdge = new PropertyInfo(
            RebarBand.class, "childEdge", Boolean.TYPE,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("RebarBandChildEdgeDescr")));

        public static final PropertyInfo fixedBitmap = new PropertyInfo(
            RebarBand.class, "fixedBitmap", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("RebarBandFixedBitmapDescr")));

        public static final PropertyInfo foreColor = new PropertyInfo(
            RebarBand.class, "foreColor", Color.class,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("RebarBandForeColorDescr")));

        public static final PropertyInfo growBy = new PropertyInfo(
            RebarBand.class, "growBy", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(10)),
            new DescriptionAttribute(Sys.getString("RebarBandGrowByDescr")));

        public static final PropertyInfo headerWidth = new PropertyInfo(
            RebarBand.class, "headerWidth", Integer.TYPE,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.ZERO,
            new DescriptionAttribute(Sys.getString("RebarBandHeaderWidthDescr")));

        public static final PropertyInfo idealWidth = new PropertyInfo(
            RebarBand.class, "idealWidth", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(200)),
            new DescriptionAttribute(Sys.getString("RebarBandIdealWidthDescr")));

        public static final PropertyInfo imageIndex = new PropertyInfo(
            RebarBand.class, "imageIndex", Integer.TYPE,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.NEGATIVE_ONE,
            new DescriptionAttribute(Sys.getString("RebarBandImageIndexDescr")));

        public static final PropertyInfo initialHeight = new PropertyInfo(
            RebarBand.class, "initialHeight", Integer.TYPE,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(20)),
            new DescriptionAttribute(Sys.getString("RebarBandInitialHeightDescr")));

        public static final PropertyInfo maxInitialHeight = new PropertyInfo(
            RebarBand.class, "maxInitialHeight", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(100)),
            new DescriptionAttribute(Sys.getString("RebarBandMaxInitialHeightDescr")));

        public static final PropertyInfo minChildHeight = new PropertyInfo(
            RebarBand.class, "minChildHeight", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(20)),
            new DescriptionAttribute(Sys.getString("RebarBandMinChildHeightDescr")));

        public static final PropertyInfo minChildWidth = new PropertyInfo(
            RebarBand.class, "minChildWidth", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(50)),
            new DescriptionAttribute(Sys.getString("RebarBandMinChildWidthDescr")));

        public static final PropertyInfo text = new PropertyInfo(
            RebarBand.class, "text", String.class,
            new ValueEditorAttribute(ImmediateStringEditor.class),
            CategoryAttribute.Appearance,
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("RebarBandTextDescr")));

        public static final PropertyInfo visible = new PropertyInfo(
            RebarBand.class, "visible", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("RebarBandVisibleDescr")));

        public static final PropertyInfo visibleGripper = new PropertyInfo(
            RebarBand.class, "visibleGripper", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("RebarBandVisibleGripperDescr")));

        public static final PropertyInfo width = new PropertyInfo(
            RebarBand.class, "width", Integer.TYPE,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.ZERO,
            new DescriptionAttribute(Sys.getString("RebarBandWidthDescr")));

        public void getProperties(IProperties props) {}
    }

}