//STRIPPEDSOURCE//











package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.DllLib;
import com.ms.dll.Callback;
import com.ms.dll.Win32Exception;
import com.ms.lang.Delegate;

/** Encapsulates a Win32 RichEdit control.  The RichEdit is a control that contains formatted text.
 * It supports font selection, boldface, and other type attributes.<p>
 *
 * // UNDONE : RichEdit UNDONES<p>
 * //        :<p>
 * //        : selAlignment - multiple paragraphs with different alignment
 * //        : EN_PROTECTED message processing needs a return value???
 * //        : selAlignment - EM_GETPARAFORMAT doesn't support mixed info.
 * //        : selCharOffset doesn't throw exception for mixed styles, see EM_SETCHARFORMAT
 * //        : selColor doesn't return a null when there is a mixture of colors
 * //        : selIsCharOffset not implemented
 * //        : wordWrap not implemented (is based on the presence of HScroll bar)
 * //        : selPrint not implemented (need a printer class)
 *
 * @security(checkClassLinking=on)
 * @dll.import("riched32", ansi)
 */
public class RichEdit extends Edit implements com.ms.win32.win {

    
    public static final String RICHEDIT_DLL10       = "RichEd32.DLL";
    public static final String RICHEDIT_DLL20       = "RichEd20.DLL";

    
    public static final String RICHEDIT_CLASSA      = "RichEdit20A";
    public static final String RICHEDIT_CLASSW      = "RichEdit20W";

    
    public static final String RICHEDIT_CLASS10A    = "RICHEDIT";

    public static final String DLL_RICHEDIT         = RICHEDIT_DLL10;
    public static final String WC_RICHEDIT          = RICHEDIT_CLASS10A;

    
    
    

    
    private static final int DV_E_DVASPECT      = 0x8004006B;
    private static final int DVASPECT_CONTENT   = 1;
    private static final int DVASPECT_THUMBNAIL = 2;
    private static final int DVASPECT_ICON      = 4;
    private static final int DVASPECT_DOCPRINT  = 8;
    
    
    static final int INPUT                      = 0;
    static final int OUTPUT                     = 1;

    

    
    private static class Module {
        public int handle = 0;
    };
    private static final Module mod             = new Module();

    private static final String NOT_SUPPORTED   = "Not supported at Design time";
    private static final String SZ_RTF_TAG      = "{\\rtf";
    private static final int CHAR_BUFFER_LEN    = 512;

    
    
    private static final Object EVENT_HSCROLL          = new Object();
    private static final Object EVENT_IMECHANGE        = new Object();
    private static final Object EVENT_PROTECTED        = new Object();
    private static final Object EVENT_REQUESTRESIZE    = new Object();
    private static final Object EVENT_SELCHANGE        = new Object();
    private static final Object EVENT_VSCROLL          = new Object();


    
    
    private int         bulletIndent = 0;
    private String      fileName = null;
    private int         hDC = 0;
    private int         rightMargin = 0;
    private boolean     autoWordSelection = false;
    private int         wordWrap = WBF_WORDBREAK | WBF_WORDWRAP |
                                   WBF_LEVEL2 | WBF_OVERFLOW;
    private String      textRTF = null;
    private boolean     fInCtor = true;

    
    
    transient IDataStream bis = null;
    transient IDataStream bos = null;
    private transient int           editStreamProcRoot = 0;
    private transient boolean       protectedError = false;
    private static int logPixelsX = 0;
    private static int logPixelsY = 0; 
    
    
    private int curSelStart;
    private int curSelEnd;
    private short curSelType;
    
    /**
     * Constructs a new RichEdit.
     */
    public RichEdit() {}

    /**
     * Assigns a delegate to the hScroll event.
     * @param handler Delegate that will handle the HScroll event;
     * @see #getOnHScroll
     */
    public void addOnHScroll(EventHandler value) {}

    /**
     * Assigns a delegate to the IMEChange
     * event.
     * @param handler Delegate that will handle the IMEChange event;
     * @see #getOnIMEChange
     */
    public void addOnIMEChange(EventHandler value) {}

    /**
     * Assigns a delegate to the protected
     * event.
     * @param handler Delegate that will handle the Protected event;
     * @see #getonProtected
     */
    public void addOnProtected(EventHandler value) {}

    /**
     * Assigns a delegate to the requestResize
     * event.
     * @param handler Delegate that will handle the RequestResize event;
     * @see #getOnRequestResize
     */
    public void addOnRequestResize(RequestResizeEventHandler value) {}

    /**
     * Assigns a delegate to the selChange
     * event.
     * @param handler Delegate that will handle the SelChange event;
     * @see #getOnSelChange
     */
    public void addOnSelChange(EventHandler value) {}

    /**
     * Assigns a delegate to the vScroll event.
     * @param handler Delegate that will handle the VScroll event;
     * @see #getOnVScroll
     */
    public void addOnVScroll(EventHandler value) {}

    /**
     * Retrieves a boolean
     * value that indicates whether the data in the specified Clipboard format can be pasted into
     * this control.
     * @param  clipFormat  Integer representing the clipboard format.
     */
    public boolean canPaste(DataFormats.Format clipFormat) {}

    
    private static int createCOMPCOLORArray(COMPCOLOR [] colors) {}

    /**
     * Frees the resources allocated by this
     * control. This method may not be
     * called at runtime. Any resources used by the control should be setup to
     * be released when the control is GC'ed. Inheriting classes should always
     * call <i>super.dispose</i>.
     */
    public void dispose() {}

    
    private static native void DragAcceptFiles(int hWnd, boolean fAccept);

    
    private static native int DragQueryFile(int hDrop, int iFile, StringBuffer lpszFile, int cch);

    /**
     * @internalonly
     * 
     * Called to clean up the object before freeing it.
     *
     */
    protected void finalize() throws Throwable {}

    /**
     * Searches the RichEdit
     * control for a specified string.
     * @param       string      String to search for
     * @return      an integer offset where the match was found or -1 if failed.
     */
    public int find(String string) {}

    /**
     * Searches the RichEdit
     * control for a specified string.
     * @param       string      String to search for
     * @param       options     Combination of RichEditFind enum values.
     * @return      an integer offset where the match was found or -1 if failed.
     */
    public int find(String string, int options) {}

    /**
     * Searches the RichEdit
     * control for a specified string.
     * @param       string      String to search for
     * @param       start       Offset to start
     * @param       options     Combination of RichEditFind enum values.
     * @return      an integer offset where the match was found or -1 if failed.
     */
    public int find(String string, int start, int options) {}

    /**
     * Searches the RichEdit
     * control for a specified string.
     * @param       string      String to search for
     * @param       start       Offset to start
     * @param       end         Offset to end
     * @param       options     Combination of RichEditFind enum values.
     * @return      an integer offset where the match was found or -1 if failed.
     * @exception   WFCInvalidEnumException  When an invalid option is specified.
     */
    public int find(String string, int start, int end, int options) {}

    private void fireEvent(Object key, RequestResizeEvent e) {}

    /**
     * Retrieves a boolean
     * value that indicates whether automatic word selection is enabled.
     * 
     * @return True if auto word selection is on. Otherwise, false.
     */
    public boolean getAutoWordSelection() {}
    
    /**
     * Retrieves the indention used in the RichEdit
     * control when the bullet style is applied to the text.
     * @see         #setBulletIndent
     * @return      the format to be used for data output.
     */
    public int getBulletIndent() {}

    private CHARFORMATA getCharFormat(boolean fSelection) {}

    
    private int getCharFormat(int mask, int effect) {}

    /**
     * Retrieves the character closest to the
     * specified point.
     * @param  pt  Point at which we need to locate character from.
     */
    public char getCharFromPosition(Point pt) {}

    
    private boolean getCharInCharSet(char c, String charSet, boolean negate) {}

    
    private static void getCOMPCOLORArray(COMPCOLOR[] colors, int memory) {}

    /**
     * @internalonly
     *
     */
    protected CreateParams getCreateParams() {}

    /**
     * Retrieves a string that contains the
     * control's delimiters.
     * 
     * @return  String containing the delimiters.
     */
    public String getDelimiter() {}
    
    /**
     * Retrieves a string that contains the
     * non-leading punctuation for the RichEdit control.
     * 
     * @return  String containing the non-leading punctuation.
     */
    public String getFollowPunctuation() {}
    
    /**
     * Retrieves the IME color settings of the RichEdit
     * control.
     * Valid only for Asian versions of the OS.
     * 
     * @return RichEditIMEColor object containing the IME color settings.
     */
    public RichEditIMEColor getIMEColor() {}
    
    /**
     * Retrieves the IME options settings of the
     * RichEdit control.
     * Valid only for Asian versions of the OS.
     * 
     * @return integer containing the IME color settings.
     *         The value returned is a combination of RichEditIMEOptions values.
     * @see    #RichEditIMEOptions. 
     */
    public int getIMEOptions() {}
    
    /**
     * Retrieves a string that contains the
     * leading punctuation characters for the RichEdit control.
     * 
     * @return  String containing the leading punctuation.
     */
    public String getLeadPunctuation() {}
    
    /**
     * Retrieves the line number of the line
     * that contains the specified character position.
     * @param       index     the index of the character whose line to be identified
     * @return      the number of the line.
     */
    public int getLineFromChar(int index) {}

    /**
     * Retrieves the delegate assigned to the hScroll
     * event.
     * @return Delegator that will handle the HScroll event.
     * @see #setOnHScroll
     */
    public EventHandler getOnHScroll() {}

    /**
     * Retrieves the delegate assigned to the IMEChange
     * event.
     * @return Delegator that will handle the IMEChange event.
     * @see #setOnIMEChange
     */
    public EventHandler getOnIMEChange() {}

    /**
     * Retrieves the delegate assigned to the protected
     * event.
     * @return Delegator that will handle the Protected event.
     * @see #setonProtected
     */
    public EventHandler getOnProtected() {}

    /**
     * Retrieves the delegate assigned to the requestResize
     * event.
     * @return Delegator that will handle the RequestResize event.
     * @see #setOnIMEChange
     */
    public RequestResizeEventHandler getOnRequestResize() {}

    /**
     * Retrieves the delegate assigned to the selChange
     * event.
     * @return Delegator that will handle the SelChange event.
     * @see #setOnSelChange
     */
    public EventHandler getOnSelChange() {}

    /**
     * Retrieves the delegate assigned to the vScroll
     * event.
     * @return Delegator that will handle the VScroll event.
     * @see #setOnVScroll
     */
    public EventHandler getOnVScroll() {}

    /**
     * Returns the location of the character at the given index. 
     * @param  index Index of the character whose location we need to find.
     */
    public Point getPositionFromChar(int index) {}

    
    private boolean getProtectedError() {}

    
    private String getPunctuation(int pcFlags) {}
    
    /**
     * Returns the text of the RichEdit control, including all RTF codes. 
     * @see         #setRTF
     * @return      the text including all RTF codes
     */
    public String getRTF() {}

    /**
     * Returns the right margin of the RichEdit control. 
     * @see         #setRightMargin
     * @return      the right margin width in pixels.
     */
    public int getRightMargin() {}

    /**
     * Retrieves the paragraph alignment for the
     * RichEdit control.
     * @see         #setSelAlignment
     * @return      Value in the HorizontalAlignment enumeration.
    */
    public int getSelAlignment() {}

    /**
     * Retrieves a boolean
     * value that indicates whether the bullet style is currently applied to the selection or
     * insertion point.
     * @see         #setSelBullet
     * @return      true - if the current selection has the bullet set.
     *              false - otherwise.
     */
    public boolean getSelBullet() {}

    /**
     * Returns a value that determines whether text in the RichEdit control
     * appears on the baseline (normal), as a superscript above the baseline, or as a subscript
     * below the baseline.
     * @see         #setSelCharOffset
     * @return      0 - normal
     *              positive number - superscript, raised by specified number of pixels.
     *              negative number - subscript, lowered by specified number of pixels.
     */
    public int getSelCharOffset() {}

    /**
     * Retrieves the color of the currently
     * selected text.
     * @see         #setSelColor
     * @return      the color of the currently selected text.
     *              Returns null if the selection has more than one color.
     */
    public Color getSelColor() {}

    /**
     * Returns the name of the font used to display the currently selected text
     * or the characters(s) immediately following the insertion point in the
     * RichEdit control. 
     * @see         #setSelFont
     * @return      the name of the font used. Returns null if the selection has more than one font.
     */
    public Font getSelFont() {}
    /**
     * Retrieves the distance between the left
     * edge of the first line of text in the selected paragraph and the left edge of subsequent
     * lines in the same paragraph.
     * @see         #setSelHangingIndent
     * @return      the indentation distance in pixels.
     */
    public int getSelHangingIndent() {}

    /**
     * Retrieves the distance between the left
     * edge of the control and the left edge of the text that is currently selected or that is
     * added at the insertion point.
     * @see         #setSelIndent
     * @return      the distance in pixels
     */
    public int getSelIndent() {}

    /**
     * Retrieves the number of characters
     * currently selected.
     * @see         #setSelLength
     * @return      number of characters
     */
    public int getSelLength() {}

    /**
     * Retrieves a boolean
     * value that indicates whether the current selection is protected.
     * 
     * @return  true/false to indicate if changes can be made to the current selected contents.
     * @see     #setSelProtected
     */
    public boolean getSelProtected() {}
    
    /**
     * Retrieves the currently selected text in
     * a RichEdit control, including all RTF codes.
     * @see         #setSelRTF
     * @return      the text including all RTF codes or empty string
     */
    public String getSelRTF() {}

    /**
     * Returns the distance between the right
     * edge of the RichEdit control and the right edge of the text that is
     * selected or that is added at the current insertion point.
     * @see         #setSelRightIndent
     * @return      the distance in pixels.
     */
    public int getSelRightIndent() {}

    /**
     * Retrieves the absolute tab stop positions
     * in the RichEdit control.
     * @see         #setSelTabs
     * @return      an array of tabstops or null if none exist.
     */
    public int[] getSelTabs() {}

    /**
     * Retrieves the currently selected text in
     * the RichEdit control.
     * @see         #setSelText
     * @return      a String containing the selected text
     */
    public String getSelText() {}

    /**
     * Retrieves the type of the current
     * selection. The returned value is one
     * of the values enumerated in RichEditSelType.
     * 
     * @return  Returns the type of the current selection.
     */
    public int getSelType() {}

    /**
     * Retrieves a boolean
     * value that indicates whether or not English word-breaking occurs in Japanese, Chinese, and
     * Hangeul.
     * This is valid only for Asian versions of the OS.
     * 
     * @return  Returns the Word-break mode for the control. 
     * @see     #setWordBreak
     */
    public boolean getWordBreak() {}
    
    /**
     * Retrieves the type of punctuation table
     * to be used to determine the RichEdit control's word-wrap and word-break
     * layout.
     * This is valid only for Asian versions of the OS.
     * 
     * @return  Returns the Word-break mode for the control. 
     *          The value is one of the enumerations under RichEditWordPunctuation.
     * @see     #setWordBreak
     */
    public int getWordPunctuation() {}
    
    /**
     * Loads a Rich Text Format (RTF) or text file into the RichEdit control.
     * @param       path     location of the file
     * @exception   WFCException  When error occurs during file load operation.
     */
    public void loadFile(String path) {}

    /**
     * Loads a Rich Text Format (RTF) or text file into the RichEdit control.
     * @param       path     location of the file
     * @param       fileType Value from RichEditStreamType
     * @exception   WFCInvalidArgumentException  When an invalid fileType is specified.
     * @exception   WFCException  When error occurs during file load operation.
     */
    public synchronized void loadFile(String path, int fileType) {}

    /**
     * Moves the insertion point up to, but not
     * including, the first character in the RichEdit control that is a member
     * of the specified character set.
     * @param       characterSet    a string of characters to look for
     */
    public void moveInsertionPoint(String characterSet) {}

    /**
     * Moves the insertion point up to, but not
     * including, the first character in the RichEdit control that is a member
     * of the specified character set.
     * @param       characterSet    a string of characters to look for
     * @param       forward         which direction, true = forward
     */
    public void moveInsertionPoint(String characterSet, boolean forward) {}

    /**
     * Moves the insertion point up to, but not
     * including, the first character in the RichEdit control that is a member
     * of the specified character set.
     * @param       characterSet    a string of characters to look for
     * @param       forward         which direction, true = forward
     * @param       negate          selection mode, true = invert specified character set
     */
    public void moveInsertionPoint(String characterSet, boolean forward, boolean negate) {}

    /**
     * @internalonly
     *
     */
    protected void onCreateHandle(Event e) {}

    /**
     * Triggers the hScroll
     * event.
     * @param       the event.
     * @see         #setOnHScroll
     * @see         #getOnHScroll
     */
    protected void onHScroll(Event e) {}

    /**
     * Triggers the IMEChange
     * event.
     * @param       the event.
     * @see         #setOnIMEChange
     * @see         #getOnIMEChange
     */
    protected void onIMEChange(Event e) {}

    /**
     * Triggers the protected
     * event.
     * @param       the event.
     * @see         #setonProtected
     * @see         #getonProtected
     */
    protected void onProtected(Event e) {}

    /**
     * Triggers the requestResize
     * event.
     * @param       the event.
     * @see         #setOnRequestResize
     * @see         #getOnRequestResize
     */
    protected void onRequestResize(RequestResizeEvent e) {}

    /**
     * Triggers the selChange
     * event.
     * @param       the event.
     * @see         #setOnSelChange
     * @see         #getOnSelChange
     */
    protected void onSelChange(Event e) {}

    /**
     * Fires the event indicating that the text property has been changed.
     * Inheriting controls should use this in favour of actually listening to
     * the event, but should not forget to call super.onTextChanged() to
     * ensure that the event is still fired for external listeners.
     *
     * @param   e       Event to send
     */
    protected void onTextChanged(Event e) {}

    /**
     * Triggers the vScroll
     * event.
     * @param       the event.
     * @see         #setOnVScroll
     * @see         #getOnVScroll
     */
    protected void onVScroll(Event e) {}

    /**
     * Pastes data in a specific Clipboard
     * format into the RichEdit control.
     * 
     * @param clipFormat  Clipboard format in which the data should be obtained from the clipboard.
     * @see         wfc.app.DataFormats
     */
    public void paste(DataFormats.Format clipFormat) {}
    
    
    private void paste(DataFormats.Format clipFormat, int hIcon) {}

    /**
     * Forces the recreation of the handle for this control. Inheriting controls
     * must call <i>super.recreateHandle</i>.
     */
    protected synchronized void recreateHandle() {}
    
    /**
     * Removes the delegate that is assigned to
     * the hScroll event.
     * @param handler Delegate that will handle the HScroll event;
     * @see #getOnHScroll
     */
    public void removeOnHScroll(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to
     * the IMEChange event.
     * @param handler Delegate that will handle the IMEChange event;
     * @see #getOnHScroll
     */
    public void removeOnIMEChange(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to
     * the protected event.
     * @param handler Delegate that will handle the Protected event;
     * @see #getonProtected
     */
    public void removeOnProtected(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to
     * the requestResize event.
     * @param handler Delegate that will handle the RequestResize event;
     * @see #getOnHScroll
     */
    public void removeOnRequestResize(RequestResizeEventHandler value) {}

    /**
     * Removes the delegate that is assigned to
     * the selChange event.
     * @param handler Delegate that will handle the SelChange event;
     * @see #getOnSelChange
     */
    public void removeOnSelChange(EventHandler value) {}

    /**
     * Removes the delegate that is assigned to
     * the vScroll event.
     * @param handler Delegate that will handle the VScroll event;
     * @see #getOnVScroll
     */
    public void removeOnVScroll(EventHandler value) {}

    /**
     * Saves the control's contents to a
     * specified location.
     * @param       path     location of the file
     * @exception   WFCInvalidArgumentException  When an invalid fileType is specified.
     * @exception   WFCException  When error occurs during file save operation.
     */
    public void saveFile(String path) {}

    /**
     * Saves the control's contents to a
     * specified location.
     * @param       path     location of the file
     * @param       fileType One of the values from RichEditStreamType.
     * @exception   WFCInvalidArgumentException  When an invalid fileType is specified.
     * @exception   WFCException  When error occurs during file save operation.
     */
    public synchronized void saveFile(String path, int fileType) {}

    /**
     * Sets the background color for the RichEdit control.
     * 
     * @param  color  The new background color of the RichEdit control.
     */
    public void setBackColor(Color color) {}

    /**
     * Specifies whether the control supports auto word selection.
     * @param       autoWordSelection     true if control wants auto word selection.
     * @see         #getAutoWordSelection
     */
    public void setAutoWordSelection(boolean autoWordSelection) {}

    /**
     * Sets the amount of indention to be used
     * in this control when this control is configured to display bullets.
     * @param       bulletIndent    the amount of indent. Indentation, in pixels, of 
     *                              the second line and subsequent lines, relative to the
     *                              starting indentation. The first line is indented if this
     *                              member is negative, or outdented is this member is positive. 
     * @see         #getBulletIndent
     */
    public void setBulletIndent(int bulletIndent) {}

    
    private void setCharFormat(int mask, int effect, int charFormat) {}

    private void setCharFormat(int charRange, CHARFORMATA cf) {}

    /**
     * Sets the delimiters for the RichEdit
     * control.
     * @internalonly
     *
     * Sets the demiliters for the rich edit control. 
     * This is valid only in Asian versions of the operating systems.
     * 
     * @param   punctuation  The string containing the puntuation characters.
     */
    public void setDelimiter(String delimiter) {}
    
    /**
     * Sets the non-leading punctuation for the RichEdit control.  
     * This is valid only in Asian versions of the operating systems.
     * 
     * @param   punctuation  The string containing the puntuation characters.
     */
    public void setFollowPunctuation(String punctuation) {}
    
    /**
     * Sets the fore color of the rich edit control. 
     * 
     * @param  value  Color to be used as the forecolor.
     */
    public void setForeColor(Color value) {}

    /**
     * Sets the color of the IME composition window of the RichEdit control. 
     * This is valid only for Asian versions of the OS.
     * 
     * @param  value  RichEditIMEColor containing the IME Color attributes.
     */
    public void setIMEColor(RichEditIMEColor value) {}
    
    /**
     * Sets options on the IME composition window of the RichEdit control. 
     * This is valid only for Asian versions of the OS.
     * 
     * @param  value  integer containing the IME options.
     *                This should be a combination of RichEditIMEOptions values.
     * @exception   WFCInvalidEnumException  When invalid IME options are specified.
     * @see    RichEditIMEOptions
     */
    public void setIMEOptions(int value) {}
    
    /**
     * Sets the leading punctuation for the RichEdit control.  
     * This is valid only in Asian versions of the operating systems.
     * 
     * @param   punctuation  The string containing the puntuation characters.
     */
    public void setLeadPunctuation(String punctuation) {}
    
    
    private void setPunctuation(int pcFlags, String punctuation) {}
    
    /**
     * Sets the text of a RichEdit control, including all the RTF codes.
     * @param       RichEdit     the text with RTF codes
     * @see         #getRTF
     * @exception   WFCException  When error occurs during set rich text operation.
     */
    public void setRTF(String rtfText) {}

    /**
     * Sets the right margin of the RichEdit
     * control.
     * @param       rightMargin     the right margin width in pixels.
     * @see         #getRightMargin
     */
    public void setRightMargin(int rightMargin) {}

    /**
     * Sets the paragraph alignment for the RichEdit
     * control.
     * @param       selAlignment  - One of the values of HorizontalAlignment
     * @see         #getSelAlignment
     * @exception   WFCInvalidEnumException  When an invalid selAlignment is specified.
     */
    public void setSelAlignment(int selAlignment) {}

    /**
     * Specifies whether the bullet style should
     * be applied to the current selection or insertion point.
     * @param       selBullet     true - to apply bullets to the current selection.
     * @see         #getSelBullet
     */
    public void setSelBullet(boolean selBullet) {}

    /**
     * Determines whether text in the control appears on the baseline, as a superscript above
     * the baseline, or as a subscript below the base line.
     * @param       selCharOffset
     *                  0 - normal
     *                  positive number - superscript, raised by specified number of pixels.
     *                  negative number - subscript, lowered by specified number of pixels.
     * @see         #getSelCharOffset
     */
    public void setSelCharOffset(int selCharOffset) {}

    /**
     * Sets the text color of the currently selected text.
     * 
     * @param       selColor  Color to be set on the selected text.
     * @see         #getSelColor
     */
    public void setSelColor(Color selColor) {}

    /**
     * Sets the font used to display the
     * currently selected characters, or the characters immediately following the insertion
     * point.
     * @see         #setSelFont
     * @return      the name of the font used.
     */
    public void setSelFont(Font font) {}
    
    /**
     * Sets the distance between the left edge of the first line of text in the selected
     * paragraph and the left edge of subsequent lines in the same paragraph.
     * @param       selHangingIndent  the distance in pixels.
     * @see         #getSelHangingIndent
     */
    public void setSelHangingIndent(int selHangingIndent) {}

    /**
     * Sets the distance between the left edge of the control and the left edge of the text
     * that is currently selected or that is added at the insertion point.
     * @param       selIndent  the distance in pixels.
     * @see         #getSelIndent
     */
    public void setSelIndent(int selIndent) {}

    /**
     * Selects the specified number of characters, beginning at the current insertion point.
     * @param       selLength  number of characters
     * @see         #getSelLength
     */
    public void setSelLength(int selLength) {}

    /**
     * Marks the current selection as protected.  This will cause a EN_PPROTECTED
     * event to be fired when an attempt to change these characters is made.
     * 
     * @param  protect  Should protect the current selection or nor.
     * @see    #onProtected
     * @see    #getSelProtected
     */
    public void setSelProtected(boolean protect) {}
    
    /**
     * Sets the currently selected text of a RichEdit control, including the
     * text's RTF codes. 
     * @param       selRTF     the text with RTF codes
     * @see         #getSelRTF
     */
    public void setSelRTF(String selRTF) {}

    /**
     * Sets the distance between the right edge
     * of the control and the right edge of text that is selected or that is added at the current
     * insertion point.
     * @param       selRightIndent  the distance in pixels.
     * @see         #getSelRightIndent
     */
    public void setSelRightIndent(int selRightIndent) {}

    /**
     * Sets the absolute tab stop positions in a
     * RichEdit control. 
     * @param       selTabs  an array of tabstops
     * @exception   WFCInvalidArgumentException  When an invalid selAlignment is specified.
     * @see         #getSelTabs
     */
    public void setSelTabs(int selTabs[]) {}

    /**
     * Sets the selected text in the RichEdit
     * control.
     * @param       selText     the text
     * @see         #getSelText
     */
    public void setSelText(String selText) {}

    
    private static void setupLogPixels(int hDC) {}

    private static int pixel2Twip(int hDC, int v, boolean xDirection) {}

    private static int twip2Pixel(int hDC, int v, boolean xDirection) {}

    /**
     * Enables or disables English word-breaking
     * in Japanese, Chinese, and Hangeul.
     * Also enables/disables Hangeul word-breaking. 
     * 
     * This is valid only for Asian versions of the OS.
     * 
     * @param  enable  Enables/Disables word-wrap mode.
     * @see    #getWordBreak
     */
    public void setWordBreak(boolean enable) {}
    
    /**
     * Sets the type of punctuation table to be
     * used to determine the RichEdit control's word-wrap and word-break layout. This has to used in conjunction with the setWordWrap() and 
     * setWordBreak() methods.
     * 
     * This is valid only for Asian versions of the OS.
     * 
     * @param  punc  Defines the type of punctuation table to be used (from RichEditWordPunctuation).
     * @exception   WFCInvalidEnumException  When an invalid punctuation is specified.
     * @see    #getWordPunctuation
     * @see    RichEditWordPunctuation.
     */
    public void setWordPunctuation(int punc) {}
    
    
    void setWordWrapInternal(boolean enable) {}
    
    /**
     * Selects text in the RichEdit
     * control based on a specified set of characters.
     * @param       characterSet    a string of characters to look for
     */
    public void span(String characterSet) {}

    /**
     * Selects text in the RichEdit
     * control based on a specified set of characters.
     * @param       characterSet    a string of characters to look for
     * @param       forward         which direction to look in, true = forward
     */
    public void span(String characterSet, boolean forward) {}

    /**
     * Selects text in the RichEdit
     * control based on a specified set of characters. If the negate flag is true, then
     * we look for the first character not present in the given set of characters.
     * 
     * @param       characterSet    a string of characters to look for
     * @param       forward         which direction, true = forward
     * @param       negate          selection mode, true = invert specified character set
     */
    public void span(String characterSet, boolean forward, boolean negate) {}

    
    private void spanUpTo(String characterSet, boolean forward, boolean negate, boolean span) {}

    
    private synchronized void streamIn(String string, int flags) {}

    
    private synchronized String streamOut(int flags) {}

    void updateStylesCore() {}
    
    
    private void wmReflectCommand(Message m) {}

    
    void wmReflectNotify(Message m) {}

    
    private void wmSelChange(SELCHANGE selChange) {}
    
    
    private void wmSetFont(Message m) {}

    /**
     * @internalonly
     *
     */
    protected void wndProc(Message m) {}

    protected boolean getIsWndProcAnsi() {}

   /**
     * Encapsulates a Win32 RichEdit control. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Edit.ClassInfo {
        public static final PropertyInfo acceptsReturn = new PropertyInfo(
                                                                      Edit.ClassInfo.acceptsReturn, BrowsableAttribute.NO);
        public static final PropertyInfo allowDrop = new PropertyInfo(
                                                                      Control.ClassInfo.allowDrop, BrowsableAttribute.NO);
        
        public static final PropertyInfo autoSize = new PropertyInfo(
                                                                     Edit.ClassInfo.autoSize,
                                                                     DefaultValueAttribute.FALSE);

        public static final PropertyInfo autoWordSelection = new PropertyInfo(
                                                                              RichEdit.class, "autoWordSelection", Boolean.TYPE,
                                                                              CategoryAttribute.Behavior,
                                                                              DefaultValueAttribute.FALSE,
                                                                              new DescriptionAttribute(Sys.getString("RichEditAutoWordSelection")));

        public static final PropertyInfo bulletIndent = new PropertyInfo(
                                                                         RichEdit.class, "bulletIndent", Integer.TYPE,
                                                                         CategoryAttribute.Behavior,
                                                                         DefaultValueAttribute.ZERO,
                                                                         new DescriptionAttribute(Sys.getString("RichEditBulletIndent")));

        public static final PropertyInfo characterCasing = new PropertyInfo(
                                                                     Edit.ClassInfo.characterCasing,
                                                                     BrowsableAttribute.NO);

        public static final PropertyInfo contextMenu = new PropertyInfo(
                                                                        Control.ClassInfo.contextMenu, BrowsableAttribute.NO);
        
        public static final PropertyInfo delimiter = new PropertyInfo(
                                                                      RichEdit.class, "delimiter", String.class,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.EMPTY_STRING,
                                                                      new DescriptionAttribute(Sys.getString("RichEditDelimiter")));

        public static final PropertyInfo followPunctuation = new PropertyInfo(
                                                                              RichEdit.class, "followPunctuation", String.class,
                                                                              CategoryAttribute.Behavior,
                                                                              DefaultValueAttribute.EMPTY_STRING,
                                                                              new DescriptionAttribute(Sys.getString("RichEditFollowPunc")));

        public static final PropertyInfo iMEColor = new PropertyInfo(
                                                                     RichEdit.class, "IMEColor", RichEditIMEColor.class,
                                                                     CategoryAttribute.Behavior,
                                                                     DefaultValueAttribute.NULL,
                                                                     new DescriptionAttribute(Sys.getString("RichEditIMEColor")));

        public static final PropertyInfo iMEOptions = new PropertyInfo(
                                                                       RichEdit.class, "IMEOptions", Integer.TYPE,
                                                                       CategoryAttribute.Behavior,
                                                                       DefaultValueAttribute.ONE,
                                                                       new DescriptionAttribute(Sys.getString("RichEditIMEOptions")));

        public static final PropertyInfo leadPunctuation = new PropertyInfo(
                                                                            RichEdit.class, "leadPunctuation", String.class,
                                                                            CategoryAttribute.Behavior,
                                                                            DefaultValueAttribute.EMPTY_STRING,
                                                                            new DescriptionAttribute(Sys.getString("RichEditLeadPunc")));

        public static final PropertyInfo multiline = new PropertyInfo(
                                                                      com.ms.wfc.ui.Edit.ClassInfo.multiline,
                                                                      DefaultValueAttribute.TRUE);

        public static final PropertyInfo RTF = new PropertyInfo(
                                                                RichEdit.class, "RTF", String.class,
                                                                BrowsableAttribute.NO,
                                                                PersistableAttribute.NO,
                                                                DefaultValueAttribute.EMPTY_STRING,
                                                                new DescriptionAttribute(Sys.getString("RichEditRTF")));

        public static final PropertyInfo rightMargin = new PropertyInfo(
                                                                        RichEdit.class, "rightMargin", Integer.TYPE,
                                                                        CategoryAttribute.Behavior,
                                                                        DefaultValueAttribute.ZERO,
                                                                        new DescriptionAttribute(Sys.getString("RichEditRightMargin")));

        public static final PropertyInfo passwordChar = new PropertyInfo(
                                                                         Edit.ClassInfo.passwordChar, BrowsableAttribute.NO);

        public static final PropertyInfo scrollBars = new PropertyInfo(
                                                                       Edit.class, "scrollBars", RichEditScrollBars.class,
                                                                       DefaultValueAttribute.ZERO,
                                                                       new DescriptionAttribute(Sys.getString("RichEditScrollBars")));

        public static final PropertyInfo selAlignment = new PropertyInfo(
                                                                         RichEdit.class, "selAlignment", HorizontalAlignment.class,
                                                                         new DefaultValueAttribute(new Integer(HorizontalAlignment.LEFT)),
                                                                         BrowsableAttribute.NO,
                                                                         PersistableAttribute.NO,
                                                                         new DescriptionAttribute(Sys.getString("RichEditSelAlignment")));

        public static final PropertyInfo selBullet = new PropertyInfo(
                                                                      RichEdit.class, "selBullet", Boolean.TYPE,
                                                                      DefaultValueAttribute.FALSE,
                                                                      BrowsableAttribute.NO,
                                                                      PersistableAttribute.NO,
                                                                      new DescriptionAttribute(Sys.getString("RichEditSelBullet")));

        public static final PropertyInfo selCharOffset = new PropertyInfo(
                                                                          RichEdit.class, "selCharOffset", Integer.TYPE,
                                                                          DefaultValueAttribute.ZERO,
                                                                          BrowsableAttribute.NO,
                                                                          PersistableAttribute.NO,
                                                                          new DescriptionAttribute(Sys.getString("RichEditCharOffset")));

        public static final PropertyInfo selColor = new PropertyInfo(
                                                                     RichEdit.class, "selColor", Color.class,
                                                                     LocalizableAttribute.YES,
                                                                     BrowsableAttribute.NO,
                                                                     PersistableAttribute.NO,
                                                                     new DescriptionAttribute(Sys.getString("RichEditSelColor")));

        public static final PropertyInfo selFont = new PropertyInfo(
                                                                    RichEdit.class, "selFont", Font.class,
                                                                    LocalizableAttribute.YES,
                                                                    BrowsableAttribute.NO,
                                                                    PersistableAttribute.NO,
                                                                    new DescriptionAttribute(Sys.getString("RichEditSelFont")));

        public static final PropertyInfo selHangingIndent = new PropertyInfo(
                                                                             RichEdit.class, "selHangingIndent", Integer.TYPE,
                                                                             DefaultValueAttribute.ZERO,
                                                                             BrowsableAttribute.NO,
                                                                             PersistableAttribute.NO,
                                                                             new DescriptionAttribute(Sys.getString("RichEditSelHangingIndent")));

        public static final PropertyInfo selIndent = new PropertyInfo(
                                                                      RichEdit.class, "selIndent", Integer.TYPE,
                                                                      DefaultValueAttribute.ZERO,
                                                                      BrowsableAttribute.NO,
                                                                      PersistableAttribute.NO,
                                                                      new DescriptionAttribute(Sys.getString("RichEditSelIndent")));

        public static final PropertyInfo selLength = new PropertyInfo(
                                                                      RichEdit.class, "selLength", Integer.TYPE,
                                                                      DefaultValueAttribute.ZERO,
                                                                      BrowsableAttribute.NO,
                                                                      PersistableAttribute.NO,
                                                                      new DescriptionAttribute(Sys.getString("RichEditSelLength")));

        public static final PropertyInfo selProtected = new PropertyInfo(
                                                                         RichEdit.class, "selProtected", Boolean.TYPE,
                                                                         DefaultValueAttribute.FALSE,
                                                                         new DescriptionAttribute(Sys.getString("RichEditSelProtected")));

        public static final PropertyInfo selRTF = new PropertyInfo(
                                                                   RichEdit.class, "selRTF", String.class,
                                                                   DefaultValueAttribute.EMPTY_STRING,
                                                                   BrowsableAttribute.NO,
                                                                   PersistableAttribute.NO,
                                                                   new DescriptionAttribute(Sys.getString("RichEditselRTF")));

        public static final PropertyInfo selRightIndent = new PropertyInfo(
                                                                           RichEdit.class, "selRightIndent", Integer.TYPE,
                                                                           DefaultValueAttribute.ZERO,
                                                                           BrowsableAttribute.NO,
                                                                           PersistableAttribute.NO,
                                                                           new DescriptionAttribute(Sys.getString("RichEditSelRightIndent")));

        public static final PropertyInfo selTabs = new PropertyInfo(
                                                                    RichEdit.class, "selTabs", int[].class,
                                                                    BrowsableAttribute.NO,
                                                                    PersistableAttribute.NO,
                                                                    new DefaultValueAttribute(new int[] {}),
                                                                    new DescriptionAttribute(Sys.getString("RichEditSelTabs")));

        public static final PropertyInfo selText = new PropertyInfo(
                                                                    RichEdit.class, "selText", String.class,
                                                                    DefaultValueAttribute.EMPTY_STRING,
                                                                    BrowsableAttribute.NO,
                                                                    PersistableAttribute.NO,
                                                                    new DescriptionAttribute(Sys.getString("RichEditSelText")));

        public static final PropertyInfo wordBreak = new PropertyInfo(
                                                                      RichEdit.class, "wordBreak", Boolean.TYPE,
                                                                      CategoryAttribute.Behavior,
                                                                      DefaultValueAttribute.TRUE,
                                                                      new DescriptionAttribute(Sys.getString("RichEditWordBreak")));

        public static final PropertyInfo wordPunctuation = new PropertyInfo(
                                                                            RichEdit.class, "wordPunctuation", RichEditWordPunctuation.class,
                                                                            CategoryAttribute.Behavior,
                                                                            new DefaultValueAttribute(new Integer(RichEditWordPunctuation.LEVEL2)),
                                                                            new DescriptionAttribute(Sys.getString("RichEditWordPunctuation")));

        public static final EventInfo doubleClick = new EventInfo(
                                                                  Control.ClassInfo.doubleClick, BrowsableAttribute.NO);
        
        public static final EventInfo dragEnter = new EventInfo(
                                                                Control.ClassInfo.dragEnter, BrowsableAttribute.NO);

        public static final EventInfo dragOver = new EventInfo(
                                                               Control.ClassInfo.dragOver, BrowsableAttribute.NO);
        
        public static final EventInfo dragLeave = new EventInfo(
                                                                Control.ClassInfo.dragLeave, BrowsableAttribute.NO);

        public static final EventInfo dragDrop = new EventInfo(
                                                               Control.ClassInfo.dragDrop, BrowsableAttribute.NO);

        public static final EventInfo giveFeedback = new EventInfo(
                                                                   Control.ClassInfo.giveFeedback, BrowsableAttribute.NO);
        
        public static final EventInfo hScroll = new EventInfo(
                                                              RichEdit.class,"hScroll", EventHandler.class,
                                                              CategoryAttribute.Behavior,
                                                              new DescriptionAttribute(Sys.getString("RichEditHScroll")));

        public static final EventInfo iMEChange = new EventInfo(
                                                                RichEdit.class,"IMEChange", EventHandler.class,
                                                                CategoryAttribute.Behavior,
                                                                new DescriptionAttribute(Sys.getString("RichEditIMEChange")));
        
        public static final EventInfo mouseWheel = new EventInfo(
                                                                 Control.ClassInfo.mouseWheel, BrowsableAttribute.YES);
        
        public static final EventInfo protect = new EventInfo(
                                                              RichEdit.class,"protected", EventHandler.class,
                                                              CategoryAttribute.Behavior,
                                                              new DescriptionAttribute(Sys.getString("RichEditProtected")));

        public static final EventInfo queryContinueDrag = new EventInfo(
                                                                        Control.ClassInfo.queryContinueDrag, BrowsableAttribute.NO);
        
        public static final EventInfo requestResize = new EventInfo(
                                                                    RichEdit.class,"requestResize", RequestResizeEventHandler.class,
                                                                    CategoryAttribute.Behavior,
                                                                    new DescriptionAttribute(Sys.getString("RichEditRequestResize")));

        public static final EventInfo selChange = new EventInfo(
                                                                RichEdit.class,"selChange", EventHandler.class,
                                                                CategoryAttribute.Behavior,
                                                                new DescriptionAttribute(Sys.getString("RichEditSelChange")));

        public static final EventInfo vScroll = new EventInfo(
                                                              RichEdit.class,"vScroll", EventHandler.class,
                                                              CategoryAttribute.Behavior,
                                                              new DescriptionAttribute(Sys.getString("RichEditVScroll")));

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }
}


final class EditStreamProc extends Callback {
    private RichEdit RichEdit;

    /**
     * Constructs a new EditStreamProc.
     */
    public EditStreamProc(RichEdit RichEdit) {}

    /**
     * @internalonly
     *
     * This method is the callback used by the DLL to input/output it's
     * data.  The method uses the buffered IO variables bis and bos contained in
     * it's parent to get and put data.
     */
    public int callback(int dwCookie, int buf, int cb, int transferred) {}
}