//STRIPPEDSOURCE//
package com.ms.wfc.ui;




/**
 * Defines the options that can be set on the text of the input method editor (IME)  composition window of a RichEdit control. This is applicable only for Asian-versions of
 * the operating system.
 * 
 * @security(checkClassLinking=on)
 */
public class RichEditIMEColor { 
    /**
     * Specifies the background color of the
     * input method editor (IME) composition window.
     */    
    public Color backColor = Color.CONTROL;
    
    /**
     * Specifies the text color for the input
     * method editor (IME) composition window.
     */
    public Color textColor = Color.CONTROLTEXT;
    
    /**
     * Enables or disables the use of boldfaced
     * text in the input method editor (IME) input window.
     */
    public boolean bold = false;
    
    /**
     * Enables or disables the use of italics in
     * the input method editor (IME) composition window.
     */
    public boolean italic = false;
    
    /**
     * Enables or disables the use of strikeout
     * text in the input method editor (IME) composition window.
     */
    public boolean strikeOut = false;
    
    /**
     * Enables or disables the use of
     * underlining in the input method editor (IME) composition window.
     */
    public boolean underline = false;
    
    /**
     * Enables or disables the protected
     * attribute on text in the input method editor (IME) input window.
     * An attempt to modify them will cause an EN_PROTECTED notification message.
     */
    public boolean protect = false;
    
    public RichEditIMEColor() {}
    
    int getEffects() {}
    
    void setEffects(int dwEffects) {}
}