//STRIPPEDSOURCE//
package com.ms.wfc.ui;




/**
 * Defines constants that represent the options you can set on the RichEdit  control's input method editor (IME) composition window. This is applicable only for Asian-versions of the operating system.
 * 
 * @security(checkClassLinking=on)
 */
public class RichEditIMEOptions extends com.ms.wfc.core.Enum { 
    /**
     * Specifies that input method editor (IME) handling should be disabled.
     */
    static public final int FORCENONE           = 0x0001;
    
    /**
     * Specifies that the input method editor (IME) should be enabled when the control
     * receives the input focus.
     */
    static public final int FORCEENABLE         = 0x0002;
    
    /**
     * Specifies that the (IME) should be disabled when the control receives the input focus.
     */
    static public final int FORCEDISABLE        = 0x0004;
    
    /**
     * Specifies that the input method editor (IME) status window should close when the
     * control receives the input focus.
     */
    static public final int CLOSESTATUSWINDOW   = 0x0008;
    
    /**
     * Specifies that vertical text input should be enabled.
     */
    static public final int VERTICAL            = 0x0020;
    
    /**
     * Specifies that the input method editor (IME) should be activated when the control
     * receives the input focus.
     */
    static public final int FORCEACTIVE         = 0x0040;
    
    /**
     * Specifies that the input method editor (IME) should be made inactive when the control
     * receives the input focus.
     */
    static public final int FORCEINACTIVE       = 0x0080;
    
    /**
     * Specifies that previous input method editor (IME) status should be restored when the
     * control receives the input focus.
     */
    static public final int FORCEREMEMBER       = 0x0100;
    
    /**
     * Specifies that the composition string will not be canceled or determined by focus
     * changes. This allows an application to have separate comosition strings on each rich edit
     * control.
     * This allows an application to have separate comosition strings on each rich edit control.
     */
    static public final int MULTIPLEEDIT        = 0x0400;
    
    public static boolean valid(int value) {}
}