//STRIPPEDSOURCE//
package com.ms.wfc.ui;




/**
 * Defines constants that indicate the type of selection in a RichEdit  control.
 * The actual vale returned by RichEdit.getSelType() is a combination
 * of any of the below options.
 * 
 * @security(checkClassLinking=on)
 */
public class RichEditSelType extends com.ms.wfc.core.Enum { 
    /**
     * Indicates that no text is selected.
     */
    public static final int EMPTY            = 0;

    /**
     * Indicates that text is selected.
     */
    public static final int TEXT             = 1;

    /**
     * Indicates that a single object is selected.
     */
    public static final int OBJECT           = 2;

    /**
     * Indicates that multiple characters are selected.
     */
    public static final int MULTICHAR        = 4;

    /**
     * Indicates that multiple objects are selected.
     */
    public static final int MULTIOBJECT      = 8;

    /**
     * Retrieves a boolean value that indicates whether the specified value
     * is a valid member of this class.
     * 
     * @param value The value to check.
     * 
     * @return <b>true</b> if the value is valid for this class, <b>false</b>
     *         if not.
     */
    public static boolean valid(int value) {}
}