//STRIPPEDSOURCE//
package com.ms.wfc.ui;

/**
 * Defines constants that identify the types of input and output streams used by the RichEdit  control's saveFile and loadFile methods. These stream options are also used the
 * control's text modification methods.
 * 
 * @security(checkClassLinking=on)
 */
public class RichEditStreamType extends com.ms.wfc.core.Enum { 
    /**
     * Indicates that the stream is a Rich Text Format (RTF) stream.
     */
    public static final int RICHTEXT       = 0;

    /**
     * Indicates that the stream is a plain text stream that includes spaces in places of OLE
     * objects.
     */
    public static final int PLAINTEXT      = 1;

    /**
     * Indicates that the stream is an RTF stream with spaces in place of OLE objects.
     */
    public static final int RICH_NOOLEOBJS = 2;

    /**
     * Indicates that the stream is plain text with a textual representation of OLE objects.
     */
    public static final int TEXT_TEXTOLEOBJS = 3;

    /**
     * Retrieves a boolean value that indicates whether a specified value is
     * a valid member of this class.
     * 
     * @param value The value to check.
     * 
     * @return <b>true</b> if the value is valid for this class, <b>false</b>
     *         if not.
     */
    public static boolean valid(int value) {}
}