//STRIPPEDSOURCE//
package com.ms.wfc.ui;

/**
 * Defines the types of punctuation tables that can be used with the RichEdit control's word-wrapping and  word-breaking features. 
 *
 * @security(checkClassLinking=on)
 */
public class RichEditWordPunctuation extends com.ms.wfc.core.Enum { 
    /**
     * Indicates that the control should use the pre-defined Level 1 punctuation table as the
     * default.
     */
    public static final int LEVEL1     = 0x080;

    /**
     * Indicates that the control should use the pre-defined Level 2 punctuation table as the
     * default.
     */
    public static final int LEVEL2     = 0x100;

    /**
     * Indicates that the control should use a custom-defined punctuation table.
     */
    public static final int CUSTOM     = 0x200;
    
    
    static final int ALL = LEVEL1 | LEVEL2 | CUSTOM;

    /**
     * Retrieves a boolean value that indicates whether the specified value
     * is a valid member of this class.
     * 
     * @param value The value to check.
     * 
     * @return <b>true</b> if the value is valid for this class, <b>false</b>
     *         if not.
     */
    public static boolean valid(int value) {}
}