//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;


/**
 * Encapsulates the Save As common dialog box control that allows the user to  specify options for saving a file. 
 * @security(checkClassLinking=on)
 */
public class SaveFileDialog extends FileDialog
{

    /**
     * Retrieves a boolean value indicating whether the dialog box prompts the user for
     * permission to create a file if the user specifies a file that does not exist. 
     *
     * @return <b>true</b> if this dialog will be shown.
     */
    public final boolean getCreatePrompt() {}

    /**
     * Retrieves a boolean value indicating whether the Save As dialog box
     * should display a warning if the user specifies a file name that already exists. 
     *
     * @return <b>true</b> if this dialog will be shown.
     */
    public final boolean getOverwritePrompt() {}

    /**
     * Resets all dialog box options to their default values. 
     */
    public void reset() {}

    /**
     * @internalonly
     * @hidden
     */
    protected boolean runFileDialog(OPENFILENAME_I ofn) {}

    /**
     * Sets a boolean value indicating whether the dialog box prompts the user for
     * permission to create a file if the user specifies a file that does not exist.  If the
     * user chooses to create the file, the dialog box closes and the function
     * returns the specified name; otherwise, the dialog box remains open. 
     */
    public final void setCreatePrompt(boolean value) {}

    /**
     * Sets a boolean value indicating whether the Save As dialog box should
     * display a warning if the user specifies a file name that already exists.  The user must confirm whether to overwrite the file.
     */
    public final void setOverwritePrompt(boolean value) {}


    /**
     * Encapsulates the Save As common dialog box control that allows the user to  specify options for saving a file. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends FileDialog.ClassInfo
    {
        public static final PropertyInfo createPrompt = new PropertyInfo(
            SaveFileDialog.class, "createPrompt", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("SaveFileDialogCreatePrompt")));

        public static final PropertyInfo overwritePrompt = new PropertyInfo(
            SaveFileDialog.class, "overwritePrompt", Boolean.TYPE,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("SaveFileDialogOverWritePrompt")));

        public void getProperties(IProperties props) {}
    }
}