//STRIPPEDSOURCE//


package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates the physical display device.
 *
 * @security(checkClassLinking=on)
 */
public class Screen {

    private final int         hmonitor;
    /**
     * Bounds of the screen
     */
    public final Rectangle    bounds;
    /**
     * Available working area on the screen. This excludes taskbars and other
     * docked windows.
     */
    public final Rectangle    workingArea;
    /**
     * Set to true if this screen is the primary monitor
     */
    public final boolean      primary;
    /**
     * Device name associated with this monitor
     */
    public final String       deviceName;

    
    
    
    
    private static final int PRIMARY_MONITOR = 0xBAADF00D;

    private static final int MONITOR_DEFAULTTONULL       = 0x00000000;
    private static final int MONITOR_DEFAULTTOPRIMARY    = 0x00000001;
    private static final int MONITOR_DEFAULTTONEAREST    = 0x00000002;
    private static final int MONITORINFOF_PRIMARY        = 0x00000001;
    private static boolean multiMonitorSupport = false;

    Screen(int monitor) {}

    public boolean equals(Object obj) {}

    /**
     * Returns a Screen object
     * for the monitor that contains the specified point. If no monitor
     * contains the point, then the nearest monitor to the point is returned.
     */
    public static Screen fromPoint(Point point) {}

    /**
     * Returns a Screen object
     * for the monitor that contains the largest portion of a specified rectangle. If
     * no monitor contains any portion of the rectangle, then the nearest monitor
     * to the rectangle is returned.
     */
    public static Screen fromRectangle(Rectangle rect) {}

    /**
     * Retrieves a Screen
     * object for the monitor that contains the largest portion of the specified control or
     * window. If no monitor contains any portion of the control, then the 
     * nearest monitor to the control is returned.
     */
    public static Screen fromControl(Control control) {}

    /**
     * Retrieves a Screen
     * object for the monitor that contains the largest portion of the specified window.
     * If no monitor contains any portion of the window, then the 
     * nearest monitor to the control is returned.
     */
    public static Screen fromHwnd(int hwnd) {}

    /**
     * Retrieves a Screen
     * object for the primary monitor. For single monitor systems, this is the 
     * only monitor.
     */
    public static Screen getPrimary() {}

    /**
     * Retrieves an array of Screen
     * objects that represents each monitor on the system.
     */
    public static Screen[] getAllScreens() {}

    /**
     * Retrieves the working area for the
     * monitor that is closest to the specified point or that contains the largest region of the
     * specified rectangle or control.
     *
     * @return screen working area.
     *
     * @see #workingArea
     */
    public static Rectangle getWorkingArea(Point pt) {}
    /**
     * Retrieves the working area for the
     * monitor that is closest to the specified point or that contains the largest region of the
     * specified rectangle or control. If <i>rect</i> isn't on any monitor then the
     * working area for the monitor closest to <i>rect</i> is returned.
     *
     * @return screen working area.
     *
     * @see #workingArea
     */
    public static Rectangle getWorkingArea(Rectangle rect) {}
    /**
     * Retrieves the working area for the
     * monitor that is closest to the specified point or that contains the largest region of the
     * specified rectangle or control. If <i>ctl</i> isn't on any monitor then the
     * working area for the monitor closest to <i>ctl</i> is returned.
     *
     * @return screen working area.
     *
     * @see #workingArea
     */
    public static Rectangle getWorkingArea(Control ctl) {}

    /**
     * Retrieves the bounds of the monitor that
     * is closest to the specified point, or that contains the largest region of the specified
     * rectangle or control.
     *
     * @return screen bounds.
     *
     * @see #bounds
     */
    public static Rectangle getBounds(Point pt) {}
    /**
     * Retrieves the bounds of the monitor that
     * is closest to the specified point, or that contains the largest region of the specified
     * rectangle or control. If <i>rect</i> isn't on any monitor then the
     * bounds for the monitor closest to <i>rect</i> is returned.
     *
     * @return screen bounds.
     *
     * @see #bounds
     */
    public static Rectangle getBounds(Rectangle rect) {}
    /**
     * Retrieves the bounds of the monitor that
     * is closest to the specified point, or that contains the largest region of the specified
     * rectangle or control. If <i>ctl</i> isn't on any monitor then the
     * bounds for the monitor closest to <i>ctl</i> is returned.
     *
     * @return screen bounds.
     *
     * @see #bounds
     */
    public static Rectangle getBounds(Control ctl) {}

    public int hashCode() {}

    public String toString() {}


    
    private static class MonitorEnumProc extends com.ms.dll.Callback {
        public List screens = new List();

        public boolean callback(int monitor, int hdc, int lprcMonitor, int lParam) {}
    }

    
    private static class MONITORINFOEX {
        int     cbSize;
        RECT    rcMonitor;
        RECT    rcWork;
        int     dwFlags;
        
        String  dwDevice;
    }

    
    private static class MONITORINFO {
        int     cbSize;
        RECT    rcMonitor;
        RECT    rcWork;
        int     dwFlags;
    }

    
    private static native int GetMonitorInfo(int hmonitor, MONITORINFO info);
    
    private static native int GetMonitorInfo(int hmonitor, MONITORINFOEX info);
    
    private static native int MonitorFromPoint(int x, int y, int flags);
    
    private static native int MonitorFromRect(RECT rect, int flags);
    
    private static native int MonitorFromWindow(int hwnd, int flags);
    
    private static native int EnumDisplayMonitors(int hdc, RECT rcClip, int lpfnEnum, int dwData);
}