//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify which scroll bars appear with a control.   This enumeration is
 * used to let users indicate which ones will be shown.
 *
 * @security(checkClassLinking=on)
 */
public class ScrollBars extends Enum {

    /**
     * Specifies that no scroll bars appear with the control. */
    public static final int NONE       = 0;

    /**
     * Specifies that only a horizontal scroll bar appears with the control. */
    public static final int HORIZONTAL = 1;

    /**
     * Specifies that only a vertical scroll bar appears with the control. */
    public static final int VERTICAL   = 2;

    /**
     * Specifies that both horizontal and vertical scroll bars appear with the control. */
    public static final int BOTH       = 3;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}
}