//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines the constants that specify which scroll bar button is drawn.
 *
 * @security(checkClassLinking=on)
 */
public final class ScrollButton extends Enum {
    
    /**
     * Specifies that a down arrow scroll bar button will be drawn.
     */
    public static final int DOWN = win.DFCS_SCROLLDOWN;

    /**
     * Specifies that a left arrow scroll bar button will be drawn.
     */
    public static final int LEFT = win.DFCS_SCROLLLEFT;

    /**
     * Specifies that a right arrow scroll bar button will be drawn.
     */
    public static final int RIGHT = win.DFCS_SCROLLRIGHT;

    /**
     * Specifies that an up arrow scroll bar button will be drawn.
     */
    public static final int UP = win.DFCS_SCROLLUP;

    private static final int MIN = win.DFCS_SCROLLUP;
    private static final int MAX = win.DFCS_SCROLLRIGHT;

    /**
     * Determines whether the specified value is valid for this class. 
     * 
     * @param value The value to check
     * @return <b>true</b> if the value is valid, <b>false</b> if not.
     */
    public static boolean valid(int value) {}
}