//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify how items in a list are sorted. 
 *
 * @security(checkClassLinking=on)
 */
public class SortOrder extends Enum {

    /**
     * Specifies that the items are not sorted.
     */
    public static final int NONE = 0;
    
    /**
     * Specifies that the items are sorted in ascending order.e. If sorting is done
     * alphabetically, A comes before B, etc ...]
     */
    public static final int ASCENDING = 1;
    
    /**
     * Specifies that the items are sorted in descending order.e. If sorting is done
     * alphabetically, Z comes before Y, etc. ...]
     */
    public static final int DESCENDING = 2;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}