//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.dll.DllLib;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.lang.Delegate;

/**
 * Encapsulates the Windows status bar control. 
 *
 * @security(checkClassLinking=on)
 */
public class StatusBar extends Control {

    private static final int SIZEGRIP_WIDTH = 16;
    private static final int SIMPLE_INDEX = 0xFF;

    private static final Object EVENT_PANELCLICK = new Object();
    private static final Object EVENT_SBDRAWITEM = new Object();

    private boolean             showPanels = false;
    private boolean             layoutDirty = false;
    private int                 panelsRealized = 0;
    private boolean             sizeGrip = true;
    private String              text =  null;
    private Point               lastClick = new Point(0, 0);
    private List                panels = new List();
    private ControlToolTip      tooltips;

    /**
     * Creates a blank new StatusBar control without any panels, and all other
     * values set to their defaults.
     */
    public StatusBar() {}


    /**
     * Adds a panel to the end of the status bar. 
     *
     * @param statusBarPanel The statusBarPanel to add.
     * @return The index of the added panel.
     */
    public int addPanel(StatusBarPanel statusBarPanel) {}

    /**
     * Assigns a delegate to the drawItem event. 
     *
     * @param value The event handler to add.
     */
    public void addOnDrawItem(StatusBarDrawItemEventHandler value) {}

    /**
     * Assigns a delegate to the panelClick event. 
     *
     * @param value The event handler to add.
     */
    public void addOnPanelClick(StatusBarPanelClickEventHandler value) {}

    
    boolean arePanelsRealized() {}

    /**
     * @internalonly
     */
    public Color getBackColor() {}

    /**
     * Overrides Control::getCreateParams()
     *
     * @internalonly
     */
    protected CreateParams getCreateParams() {}

    /**
     * Retrieves a boolean value indicating whether the status bar displays any panels
     * that have been added to it using the addPanel method or whether
     * the status bar displays a single line of text.   The Mode property determines
     * if the StatusBar is simple or not.
     *
     * @return  The mode of the statusbar.
     */
    public boolean getShowPanels() {}

    /**
     * Retrieves all the panels that have been added to the status bar. 
     *
     * @return The array.
     */
    public StatusBarPanel[] getPanels() {}

    /**
     * Retrieves a boolean value indicating whether the status bar has a sizing grip on
     * its right side, which the user can drag to resize the status bar. 
     *
     * @return true if the statusbar has a SizingGrip.
     */
    public boolean getSizingGrip() {}

    /**
     * Retrieves the specified panel on the status bar. 
     *
     * @param index The index of the Panel requested.
     * @return A Panel object.
     */
    public StatusBarPanel getStatusBarPanel(int index) {}

    /**
     * @internalonly
     */
    public String getText() {}

    
    void dirtyLayout() {}

    /**
     * Inserts a panel into the status bar at the specified location. 
     *
     * @param index The location to insert the panel.
     * @param panel The statusBarPanel to insert in the statusbar.
     * @return The index of the added panel.
     */
    public int insertPanel(int index, StatusBarPanel panel) {}

    
    private void applyPanelWidths() {}

    
    private void forcePanelUpdate() {}
    
    /**
     * Overrides Control.onCreateHandle()
     *
     * @internalonly
     */
    protected void onCreateHandle(Event e) {}
    
    protected void onDestroyHandle(Event e) {}
    
    private int getToolTipHandle() {}

    
    private static native boolean EnumChildWindows(int hwndParent, int lpEnumFunc, int lParam);
    
    
    private final class EnumChildren extends com.ms.dll.Callback {

        public int hwndFound = 0;

        public boolean callback(int hwnd, int lParam) {}
    }
    

    /**
     * Triggers the mouseDown event. onMouseDown(MouseEvent)
     */
    protected void onMouseDown(MouseEvent e) {}

    /**
     * Triggers the panelClick event. 
     *
     * param <e> The event data, including the StatusBarPanel clicked.
     */
    protected void onPanelClick(StatusBarPanelClickEvent e) {}

    /**
     * @internalonly
     */
    protected void onLayout(LayoutEvent event) {}

    
    void realizePanels() {}

    /**
     * Removes all panels from the status bar. 
     */
    public void removeAllPanels() {}

    
    void removeAllPanelsWithoutUpdate() {}

    /**
     * Removes the specified panel from the status bar. 
     *
     * @param index The panel to remove.
     * @exception WFCInvalidArgumentException if the index is ...
     */
    public void removePanel(int index) {}

    /**
     * Removes the delegate that is assigned to the drawItem event. 
     *
     * @param value The event handler to remove.
     */
    public void removeOnDrawItem(StatusBarDrawItemEventHandler value) {}
    
    /**
     * Removes the delegate that is assigned to the panelClick event. 
     *
     * @param value The event handler to remove.
     */
    public void removeOnPanelClick(StatusBarPanelClickEventHandler value) {}

    
    void setPanelContentsWidths(boolean newPanels) {}

    /**
     * @internalonly
     */
    public void setBackColor(Color value) {}

    /**
     * Overrides Control.setFont(Font).  This is so we can update the width
     * of any panels that have the StatusBarPAnelAutoSize.CONTENTS property
     * set.
     */
    public void setFont(Font value) {}

    /**
     * Sets a boolean value indicating whether the status bar displays any panels that
     * have been added to it using the addPanel method or whether the
     * status bar displays a single line of text.   The Mode property determines
     * if the statusbar is simple or not.  A simple StatusBar displays only
     * one line of text.
     *
     * @param mode The new Mode of the statusbar.
     */
    public void setShowPanels(boolean value) {}

    /**
     * Replaces the panel at the specified position with a new panel. 
     *
     * @param index The index to change the panel.
     * @param panel The new panel.
     */
    public void setPanel(int index, StatusBarPanel panel) {}

    /**
     * Removes all existing panels from the status bar and adds a set of new panels.   The previous panels will be
     * removed.
     *
     * @param array The new panels.
     */
    public void setPanels(StatusBarPanel[] array) {}

    private void setSimpleText(String text) {}

    /**
     * Sets the text that will appear on the status bar when the showPanels
     * property of the status bar is set to false.   The text property is displayed
     * when the status bar is in simple mode.
     *
     * @param text.
     */
    public void setText(String string) {}

    /**
     * Sets a boolean value indicating whether the status bar has a sizing grip on its
     * right side, which the user can drag to resize the status bar. 
     *
     * @param value True if a sizing grip is desired.
     */
    public void setSizingGrip(boolean value) {}

    
    private void layoutPanels() {}

    protected void onDrawItem(StatusBarDrawItemEvent event) {}
    
    protected void onResize(Event e) {}

    /**
     * TODO: andersh: Chris, this logic should probably be ripped. At the
     * point I commented it out, it would never have any effect since
     * super.onEraseBackground did nothing for non-USERPAINT controls.
     *
     * @internalonly
     */


    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    void updateTooltip(StatusBarPanel panel) {}
    
    private void updatePanelIndex() {}
    
    /**
     * Processes messages for ownerdraw panels.
     *
     * @internalonly
     */
    protected void wmDrawItem(Message m) {}

    
    private void wmNotifyNMClick(NMHDR note) {}

    private void wmNCHitTest(Message m) {}

    /**
     * @internalonly
     */
    protected void wndProc(Message m) {}

    /**
     * Encapsulates the Windows status bar control. 
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Control.ClassInfo {
        public static final PropertyInfo dock = new PropertyInfo(
            Control.ClassInfo.dock, new DefaultValueAttribute(new Integer(ControlDock.BOTTOM)));

        public static final PropertyInfo sizingGrip = new PropertyInfo(
            StatusBar.class, "sizingGrip", boolean.class,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("StatusBarSizingGripDescr")));

        public static final PropertyInfo showPanels = new PropertyInfo(
            StatusBar.class, "showPanels", boolean.class,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("StatusBarShowPanelsDescr")));

        public static final PropertyInfo panels = new PropertyInfo(
            StatusBar.class, "panels", StatusBarPanel[].class,
            DefaultValueAttribute.EMPTY_ARRAY,
            new DescriptionAttribute(Sys.getString("StatusBarPanelsDescr")));

        public static final PropertyInfo tabStop = new PropertyInfo(
            Control.ClassInfo.tabStop, DefaultValueAttribute.FALSE);

        public static final EventInfo drawItem = new EventInfo(
            StatusBar.class, "drawItem",
            StatusBarDrawItemEventHandler.class, CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("StatusBarDrawItem")));
        
        public static final EventInfo panelClick = new EventInfo(
            StatusBar.class, "panelClick",
            StatusBarPanelClickEventHandler.class, CategoryAttribute.Mouse,
            new DescriptionAttribute(Sys.getString("StatusBarOnPanelClickDescr")));

        public String getDefaultEventName() {}

        public String getDefaultPropertyName() {}

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}
    }

    
    private static class ControlToolTip {


        /**
         * Encapsulates the Windows status bar control. 
         * @security(checkClassLinking=on)
         */
        public static class Tool {
            public Rectangle rect;
            public String text;
            protected int id = -1;
        }
        
        private HashTable           tools = new HashTable();
        private int                 messageHookRoot = 0;
        private int                 messageHookHandle = 0;
        private ToolTipWindow       window = null;
        private Control             parent = null;
        private int                 nextId = 0;

        /**
         * Creates a new ControlToolTip.
         * 
         * @param parent Parent control.
         */
        public ControlToolTip(Control parent) {}
        
        private void assignId(Tool tool) {}
        
        private boolean getHandleCreated() {}
        
        public int getHandle() {}

        /**
         * Sets the tool for the specified key. Keep in mind
         * that as soon as setTool is called, the handle for
         * the ControlToolTip is created, and the handle for
         * the parent control is also created. If the parent
         * handle is recreated in the future, all tools must
         * be re-added. The old tool for the specified key
         * will be removed. Passing <b>null</b> in for the
         * <i>tool</i> parameter will result in the tool
         * region being removed.
         * 
         * @param key Unique key to identify the tool with.
         * @param tool Tool to add to the tooltip.
         */
        public void setTool(Object key, Tool tool) {}
        
        /**
         * Returns the tool associated with the specified key,
         * or <b>null</b> if there is no area.
         * 
         */
        public Tool getTool(Object key) {}
        
        
        private void addTool(Tool tool) {}
        private void removeTool(Tool tool) {}
        private void updateTool(Tool tool) {}
        
 
        /**
         * Creates the handle for the control.
         *
         * @internalonly
         */
        protected void createHandle() {}

        /**
         * Destroys the handle for this control.
         *
         * @internalonly
         */
        protected void destroyHandle() {}

        /**
         * Disposes of the component.  Call dispose when the component is no longer needed. 
         * This method removes the component from its container (if the component has a site) 
         * and triggers the dispose event. 
         */
        public void dispose() {}


        /**
         * Returns the createParams to create the window.
         *
         * @return CreateParams
         *
         * @internalonly
         */
        protected CreateParams getCreateParams() {}

        
        private TOOLINFO_T getMinTOOLINFO(Tool tool) {}
        
        
        private TOOLINFO_T getTOOLINFO(Tool tool) {}


        /**
         * Called by the java VM when this component is about to be garbage 
         * collected.  Finalizers in WFC typically mimic the dispose method.
         * 
         * @see #dispose
         */
        protected void finalize() {}

        /**
         * WNDPROC
         *
         * @internalonly
         */
        protected void wndProc(Message msg) {}

        
        private static class ToolTipWindow extends Window {
            com.ms.vm.WeakReference ref;

            ToolTipWindow(ControlToolTip control) {}

            protected void defWndProc(Message m) {}

            protected void wndProc(Message m) {}
        }
    }    
        

}