//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.dll.*;
import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.util.*;
import com.ms.wfc.app.*;
import com.ms.lang.Delegate;

/**
 * Represents a panel in a StatusBar control. 
 *
 * @security(checkClassLinking=on)
 */
public class StatusBarPanel extends Component {

    private static final int DEFAULTWIDTH = 100;
    private static final int DEFAULTMINWIDTH = 10;
    private static final int PANELTEXTINSET = 3;
    private static final int PANELGAP = 2;

    private String          text          = "";
    private String          toolTipText   = "";
    private Icon            icon          = null;
    private int             alignment     = HorizontalAlignment.LEFT;
    private int             borderStyle   = StatusBarPanelBorderStyle.SUNKEN;
    private int             style         = StatusBarPanelStyle.TEXT;

    
    
    StatusBar       parent        = null;
    int             width         = DEFAULTWIDTH;
    int             right         = 0;
    int             minWidth      = DEFAULTMINWIDTH;
    int             autoSize      = StatusBarPanelAutoSize.NONE;
    int             index         = 0;

    /**
     * Creates a new StatusBarPanel object with all default values.
     */
    public StatusBarPanel() {}

    /**
     * @internalonly
     */
    public void dispose() {}

    /**
     * Retrieves a value indicating whether the text in the panel is left-aligned,
     * right-aligned, or centered.   Left center or right.
     *
     * @return The value of the Alignment property.
     */
    public int getAlignment() {}

    /**
     * Retrieves a value indicating whether the panel has a fixed-width, a width that is
     * determined by the panel's contents, or a width that adjusts to share space on the status
     * bar with other panels. 
     * @return The property.
     */
    public int getAutoSize() {}

    /**
     * Retrieves a value indicating whether the panel has a raised border, a sunken border, or
     * no border.   A panel can have a raised, sunken, or
     * no border style.
     *
     * @return The BorderStyle.
     */
    public int getBorderStyle() {}

    
    int getContentsWidth(boolean newPanel) {}

    /**
     * Retrieves the icon displayed in the panel. 
     *
     * @return The icon displayed in the panel.
     */
    public Icon getIcon() {}

    
    private int getIndex() {}

    /**
     * Retrieves the minimum allowed width for the status bar panel. 
     *
     * @return An int representing the minimun width of the panel.
     */
    public int getMinWidth() {}

    /**
     * Retrieves a value indicating whether a panel on a status bar is owner-drawn (to support
     * displaying images or a different font from the rest of the status bar) or system-drawn
     * (the standard setting for displaying text).   It could be TEXT or OWNERDRAW.
     *
     * @return The style.
     */
    public int getStyle() {}

    /**
     * Retrieves the text displayed in the panel. 
     *
     * @return A string with the text.
     */
    public String getText() {}

    /**
     * Retrieves the ToolTip for the panel. (A ToolTip is the text that is displayed when the
     * mouse pointer hovers over the panel.) 
     *
     * @return A string with the tool tip text.
     */
    public String getToolTipText() {}

    /**
     * Retrieves the width, in pixels, of the panel. 
     *
     * @return An int representing the width of the panel.
     */
    public int getWidth() {}

    
    boolean getCreated() {}

    
    void realize() {}

    /**
     * Sets a value indicating whether the text in the panel is left-aligned, right-aligned,
     * or centered.   A Panel can have LEFT, RIGHT, or CENTER
     * text alignment.
     *
     * @param align The new value of the Alignment Property.
     */
    public void setAlignment(int value) {}

    /**
     * Sets a value indicating whether the panel has a fixed-width, a width that is determined
     * by the panel's contents, or a width that adjusts to share space on the status bar with
     * other panels. 
     *
     * @param autoSize The new StatusBarPanelAutoSize value.
     */
    public void setAutoSize(int autoSize) {}

    /**
     * Sets a value indicating whether the panel has a raised border, a sunken border, or no
     * border. 
     *
     * @param border The new style to use.
     */
    public void setBorderStyle(int border) {}
    /**
     * Sets the icon to display in the panel. 
     *
     * @param icon The new icon to display in the panel.
     */
    public void setIcon(Icon icon) {}

    /**
     * Sets the minimum allowed width for the status bar panel. 
     *
     * @param width The new min width.
     */
    public void setMinWidth(int width) {}

    /**
     * Sets a value indicating whether a panel on a status bar is owner-drawn (to support
     * displaying images or a different font from the rest of the status bar) or system-drawn
     * (the standard setting for displaying text).   It could be TEXT or OWNERDRAW.
     *
     * @param style The new style.
     */
    public void setStyle(int style) {}

    private void updateSize() {}

    private void applyContentSizing() {}

    /**
     * Sets the text displayed in the panel. 
     *
     * @param text The new text value.
     */
    public void setText(String text) {}

    /**
     * Sets the ToolTip for the panel. (A ToolTip is the text that is displayed when the mouse
     * pointer hovers over the panel.)
     *
     * @param text The new text value.
     */
    public void setToolTipText(String text) {}

    /**
     * Sets the width, in pixels, of the panel. 
     *
     * @param width The new width.
     */
    public void setWidth(int width) {}

    public String toString() {}

    /**
     * Represents a panel in a StatusBar control. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {

        public static final PropertyInfo alignment = new PropertyInfo(
            StatusBarPanel.class, "alignment", HorizontalAlignment.class,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(HorizontalAlignment.LEFT)),
            new DescriptionAttribute(Sys.getString("StatusBarPanelAlignmentDescr")));

        public static final PropertyInfo autoSize = new PropertyInfo(
            StatusBarPanel.class, "autoSize", StatusBarPanelAutoSize.class,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(StatusBarPanelAutoSize.NONE)),
            new DescriptionAttribute(Sys.getString("StatusBarPanelAutoSizeDescr")));

        public static final PropertyInfo borderStyle = new PropertyInfo(
            StatusBarPanel.class, "borderStyle", StatusBarPanelBorderStyle.class,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(StatusBarPanelBorderStyle.SUNKEN)),
            new DescriptionAttribute(Sys.getString("StatusBarPanelBorderStyleDescr")));

        public static final PropertyInfo icon = new PropertyInfo(
            StatusBarPanel.class, "icon", Icon.class,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("StatusBarPanelIconDescr")));

        public static final PropertyInfo minWidth = new PropertyInfo(
            StatusBarPanel.class, "minWidth", Integer.TYPE,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(DEFAULTMINWIDTH)),
            new DescriptionAttribute(Sys.getString("StatusBarPanelMinWidthDescr")));

        public static final PropertyInfo style = new PropertyInfo(
            StatusBarPanel.class, "style", StatusBarPanelStyle.class,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(StatusBarPanelStyle.TEXT)),
            new DescriptionAttribute(Sys.getString("StatusBarPanelStyleDescr")));

        public static final PropertyInfo text = new PropertyInfo(
            StatusBarPanel.class, "text", String.class,
            new MemberAttribute[] {
                CategoryAttribute.Appearance,
                LocalizableAttribute.YES,
                DefaultValueAttribute.EMPTY_STRING,
                new ValueEditorAttribute(ImmediateStringEditor.class),
                new DescriptionAttribute(Sys.getString("StatusBarPanelTextDescr"))
        });

        public static final PropertyInfo toolTipText = new PropertyInfo(
            StatusBarPanel.class, "toolTipText", String.class,
            CategoryAttribute.Appearance,
            LocalizableAttribute.YES,
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("StatusBarPanelToolTipTextDescr")));

        public static final PropertyInfo width = new PropertyInfo(
            StatusBarPanel.class, "width", Integer.TYPE,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(DEFAULTWIDTH)),
            new DescriptionAttribute(Sys.getString("StatusBarPanelWidthDescr")));

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }
}