//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify how a panel on a status bar autosizes when the  status bar resizes. 
 *
 * @security(checkClassLinking=on)
 */
public class StatusBarPanelAutoSize extends Enum {

    /**
     * Specifies that the width of the panel cannot be changed.
     */
    public static final int NONE        = 1;

    /**
     * Specifies that the panel shares the the available status bar space (the space not taken
     * up by panels with the StatusBarPanelAutoSize.NONE and StatusBarPanelAutoSize.CONTENTS
     * settings) with other panels that have the StatusBarPanelAutoSize.SPRING setting.
     */
    public static final int SPRING      = 2;

    /**
     * Specifies that the width of the panel is determined by its contents.
     */
    public static final int CONTENTS    = 3;
    
    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}