//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Provides data for the panelClick  event of the StatusBar control. 
 * It contains the StatusBarPanel object handle for the panel that was
 * actually clicked.  Since this event extends MouseEvent, it also contains
 * all the information a regular MouseEvent also contains.
 * 
 * @see com.ms.wfc.ui.StatusBarPanel
 * @see com.ms.wfc.ui.MouseEvent
 *
 * @security(checkClassLinking=on)
 */
public class StatusBarPanelClickEvent extends MouseEvent {
    
    /**
     * The panel object that represents the panel clicked.
     */
    public final StatusBarPanel statusBarPanel;

    
    /**
     * Creates a new event of this type with the appropriate information.
     * 
     * @param statusBarPanel    The panel clicked.
     * @param button            Which mouse button was pressed
     * @param clicks            How many times the button has been pressed.
     * @param x                 The x location of the press.
     * @param y                 The y location of the press.
     */
    public StatusBarPanelClickEvent(StatusBarPanel statusBarPanel, int button, int clicks, int x, int y) {}
}