//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify whether a panel on a status bar is owner-drawn (to  support displaying images or a different font from the rest of the status bar) or  system-drawn (the standard setting for displaying text). 
 *
 * @security(checkClassLinking=on)
 */
public class StatusBarPanelStyle extends Enum {

    /**
     * Specifies that the panel is drawn by the system.
     */
    public static final int TEXT        = 1;

    /**
     * Specifies that the panel is owner-drawn.
     */
    public static final int OWNERDRAW   = 2;
    
    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}