//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify where the tabs in a tab control are located.  
 *
 * @security(checkClassLinking=on)
 */
public class TabAlignment extends Enum {

    /**
     * Specifies that the tabs are located at the top of the control.
     */
    public static final int TOP = 0;
    
    /**
     * Specifies that the tabs are located at the bottom of the control.
     */
    public static final int BOTTOM = 1;
    
    /**
     * Specifies that the tabs are located at the left edge of the control.
     */
    public static final int LEFT = 2;
    
    /**
     * Specifies that the tabs are located at the right edge of the control.
     */
    public static final int RIGHT = 3;

    /**
     * Determines whether the specified value is one of the constants defined in this class.  */
    public static boolean valid(int value) {}

}