//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates the tab control.   This control has a lot of the functionality of a TabStrip
 * but manages a list of TabPages which are the 'pages' that appear on each tab.
 *
 * @security(checkClassLinking=on)
 */
public class TabControl extends TabBase {

    /**
     * Adds a tabbed page to this tab control. add.  Only TabPages can be added to the TabControl.
     * 
     * @param control the tabPage being added visually to this TabControl.
     */
    public void add(Control control) {}
    
    /**
     * @internalonly
     */
    public Control getControl(int index) {}

    /**
     * @internalonly
     */
    public Control[] getControls() {}

    /**
     * @internalonly
     */
    public Control [] getNewControls() {}

    public TabPage getSelectedTab() {}

    
    private TabPage getTabPageOfComponent(IComponent comp) {}

    /**
     * Retrieves all the tabbed pages in this control. 
     *
     * @return tabPages the tabPages managed by this tabControl.
     */
    public TabPage[] getTabs() {}
    
    /**
     * @internalonly
     */
    public TCITEM_T getTCITEM(Object item) {}

    /**
     * @internalonly
     */
    protected String getToolTipText(Object item) {}

    /**
     * We override this to Make sure that there are always some tabs at design
     * time.  Inheriting classes should not forget to call 
     * <i>super.onCreateHandle</i>
     * @internaonly
     */
    protected void onCreateHandle(Event e) {}

    protected void onResize(Event e) {}

    
    private void onSelectionChanged(Object sender, Event e) {}
    
    /**
     * Removes the specified tabbed page from this control. remove to properly remove the TabPage.
     * 
     * @param control the tabPage to be removed.
     */
    public void remove(Control control) {}
    
    /**
     * Sets the site object for this component.  The tab control overrides this
     * to access design-time services of the component site.
     * 
     * @param site An IComponentSite object that this component will be sited with,
     *             or <b>null</b> to remove the existing site.
     */
    public void setComponentSite(IComponentSite site) {}
    
    /**
     * Sets the tabbed page that is selected in this control and returns the zero-based index
     * of that tab. equals a tab in the
     * list.  The return value is the index of the tab that was selected,
     * or -1 if no tab was selected.
     *
     * @param tab      Tab to select.
     *
     * @return index    Index of selected tab.
     */
    public final int setSelectedTab(TabPage tab) {}

    /**
     * Adds a set of tabbed pages to the tab control after removing all existing pages. 
     * This has the same functionality as calling setControls.
     *
     * @param tabPages list of tabPages to be managed by this tabControl.
     */
    public void setTabs(TabPage[] tabPages) {}
    
    /**
     * Set the panel selections appropriately
     *
     * @internalonly
     */
    protected void updateTabSelection(boolean fUISelected) {}

    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    /**
     * @internalonly
     * @hidden
     */
    protected void updateStylesCore() {}

    
    void updateTab(TabPage tabPage) {}
    
	/**
     * Encapsulates the tab control. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends TabStrip.ClassInfo {
        
        public ICustomizer getCustomizer(Object component) {}
        
        public static PropertyInfo tabs = new PropertyInfo(
            TabControl.class, "tabs", TabPage[].class,
            new DescriptionAttribute(Sys.getString("TabControlTabsDescr")),
            DefaultValueAttribute.NULL,
            PersistableAttribute.NO);
        
        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }

    /**
     * Encapsulates the tab control. 
     *
     * @security(checkClassLinking=on)
     */
    public class Customizer extends com.ms.wfc.core.Customizer {
        
        public Customizer() {}
        
        /**
         * @see com.ms.wfc.core.ICustomizer.getHitTest
         */
        public boolean getHitTest(Point point) {}
        
        /**
         * Returns the design-time verbs supported by the component associated with
         * the customizer. The verbs returned by this method are typically displayed
         * in a right-click menu by the design-time environment. The return value may
         * be null if the component has no design-time verbs. When a user selects one
         * of the verbs, the performVerb() method is invoked with the the
         * corresponding CustomizerVerb object.
         *
         * NOTE: A design-time environment will typically provide a "Properties..."
         * entry on a component's right-click menu. The getVerbs() method should
         * therefore not include such an entry in the returned list of verbs.
         */
        public CustomizerVerb[] getVerbs() {}
        
        private void onAdd(Object sender, VerbExecuteEvent event) {}
        
        private void onRemove(Object sender, VerbExecuteEvent event) {}
    }   
}