//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.util.*;

/** 
 * Encapsulates a tab in a tab strip.  It contains information
 * about the tab text, toolTipText, and an imageIndex into the TabStrip's imageList.
 * most functions on TabStrip that take TabItems will also take a string which will
 * simply wrap the string in a TabItem.
 *
 * @security(checkClassLinking=on)
 */
public class TabItem extends Component {
    
    TabStrip parent;

    
    private int imageIndex     = -1;
    private Object itemData    = null;
    private String text        = null;
    private String toolTipText = null;
    
    /** 
     * This constructs an empty TabItem.
     */
    public TabItem() {}

    /**
     * This constructs a TabItem with text as the tab's text.
     *
     * @param text The text for the tab.
     */
    public TabItem(String text) {}

    /**
     * @internalonly
     */
    public void dispose() {}

    /**
     * @internalonly
     */
    public boolean equals(Object value) {}

    /** 
     * Retrieves the index of the image that appears on this tab.   This should point to an image
     * in the TabStrip's associated imageList that will appear on the tab, or be -1.
     *
     * @return imageIndex that refers to an image in the associated imageList.
     */
    public final int getImageIndex() {}

    /**
     * Retrieves user data stored in the tab. 
     *
     * @return itemData that was set in by setItemData.
     */
    public final Object getItemData() {}

    /**
     * Retrieves the text displayed on the tab. 
     *
     * @return text for the tab.
     */
    public final String getText() {}

    /**
     * Retrieves the ToolTip text for the tab. 
     *
     * @return toolTipText for the tab.
     */
    public final String getToolTipText() {}

    
    final TCITEM_T getTCITEM() {}

    /** 
     * Sets the index of the image that appears on this tab.   This should point to an image
     * in the TabStrip's associated imageList that will appear on the tab, or be -1.
     *
     * @param imageIndex that refers to an image in the associated imageList.
     */
    public final void setImageIndex(int imageIndex) {}

    /**
     * Sets the user data to store in the tab. 
     *
     * @param itemData data to be stored.
     */
    public final void setItemData(Object itemData) {}

    
    final void setTabParent(TabStrip parent) {}

    /**
     * Sets the text displayed on the tab. 
     *
     * @param text for the tab.
     */
    public final void setText(String text) {}

    /**
     * Sets the ToolTip text for the tab. 
     *
     * @param toolTipText for the tab.
     */
    public final void setToolTipText(String toolTipText) {}

    /** 
     * This returns the text of the tabItem, and appears whenever this object's
     * default printing occurs.
     */
    public String toString() {}

    
    private final void updateParent() {}
    
    /**
     * Encapsulates a tab in a tab strip. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {

        public static PropertyInfo imageIndex = new PropertyInfo(
            TabItem.class, "imageIndex", int.class,
            new ValueEditorAttribute(ImageIndexEditor.class),
            DefaultValueAttribute.NEGATIVE_ONE,
            new DescriptionAttribute(Sys.getString("TabItemImageIndexDescr")));

        public static PropertyInfo text = new PropertyInfo(
            TabItem.class, "text", String.class,
            new ValueEditorAttribute(ImmediateStringEditor.class),
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("TabItemTextDescr")));

        public static PropertyInfo toolTipText = new PropertyInfo(
            TabItem.class, "toolTipText", String.class,
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("TabItemToolTipTextDescr")));

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }
}