//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Encapsulates a tab page in a tab control.   It is essentially
 * a @see Panel with TabItem properties.
 *
 * @security(checkClassLinking=on)
 */
public class TabPage extends Panel {

    private int imageIndex = -1;
    private String toolTipText = "";

    /**
     * Constructs an empty TabPage.
     */
    public TabPage() {}

    /**
     * Constructs a TabPage with text for the tab.
     *
     * @param text The text for this tab.
     */
    public TabPage(String text) {}

    
    final TCITEM_T getTCITEM() {}

    /** 
     * Retrieves the index of the image that appears on this tab.   This should point to an image
     * in the TabControl's associated imageList that will appear on the tab, or be -1.
     *
     * @return imageIndex that refers to an image in the associated imageList.
     */
    public final int getImageIndex() {}

    /**
     * Retrieves the ToolTip text for the tab. 
     *
     * @return toolTipText for the tab.
     */
    public final String getToolTipText() {}

    /** 
     * overrides main setting of our bounds so that we can control our size and that of our
     * TabPages...
     *
     * @param x 
     * @param y
     * @param width
     * @param height
     * @internalonly
     */
    protected void setBoundsCore(int x, int y, int width, int height) {}

    /** 
     * Sets the index of the image that appears on this tab.   This should point to an image
     * in the TabControl's associated imageList that will appear on the tab, or be -1.
     *
     * @param imageIndex that refers to an image in the associated imageList.
     */
    public final void setImageIndex(int imageIndex) {}

    /** 
     * Sets the text displayed on the tab. 
     *
     * @param text for the tab.
     */
    public void setText(String text) {}


    /**
     * Sets the ToolTip text for the tab. 
     *
     * @param toolTipText for the tab.
     */
    public final void setToolTipText(String toolTipText) {}

    /**
     * The text property is what is returned for the TabPages default printing.
     */
    public String toString() {}

    
    final void updateParent() {}

    /**
     * Encapsulates a tab page in a tab control. 
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Panel.ClassInfo { 
        public static PropertyInfo imageIndex = 
                                               new PropertyInfo(
            TabPage.class, "imageIndex", int.class,
            new ValueEditorAttribute(ImageIndexEditor.class),
            DefaultValueAttribute.NEGATIVE_ONE,
            new DescriptionAttribute(Sys.getString("TabItemImageIndexDescr")));

        public static PropertyInfo toolTipText =
                                                new PropertyInfo(
            TabPage.class, "toolTipText", String.class,
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("TabItemToolTipTextDescr")));

        public static PropertyInfo anchor = 
                                           new PropertyInfo(
            Panel.ClassInfo.anchor, BrowsableAttribute.NO);

        public static PropertyInfo dock = 
                                         new PropertyInfo(
            Panel.ClassInfo.dock, BrowsableAttribute.NO);

        public static PropertyInfo enabled = new PropertyInfo(
            Panel.ClassInfo.enabled, BrowsableAttribute.NO);

        public static PropertyInfo location =  new PropertyInfo(
            Panel.ClassInfo.location, BrowsableAttribute.NO);

        public static PropertyInfo size = new PropertyInfo(
            Panel.ClassInfo.size, BrowsableAttribute.NO);

        public static PropertyInfo tabIndex = new PropertyInfo(
            Panel.ClassInfo.tabIndex, BrowsableAttribute.NO);

        public static PropertyInfo tabStop = new PropertyInfo(
            Panel.ClassInfo.tabStop, BrowsableAttribute.NO);

        public static PropertyInfo visible = new PropertyInfo(
            Panel.ClassInfo.visible, BrowsableAttribute.NO);

        public void getAttributes(IAttributes attrs) {}

        public String getDefaultEventName() {}

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }
}