//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify how tabs in a TabStrip or TabControl  control are sized.   This is typically
 * used for the sizing of Tabs in a TabStrip control.
 *
 * @security(checkClassLinking=on)
 */
public class TabSizeMode extends Enum {

    /**
     * Specifies that the size of each tab is determined by the the size of what is displayed
     * on the tab and that the size of tabs in a row are not adjusted to fill the entire width of
     * the container control.  Empty space on the right is left as such
     */
    public static final int             NORMAL = 0;

    /**
     * Specifies that the width of each tab is increased, if necessary, so that each row of
     * tabs fills the entire width of the container control.  This is only applicable to tab
     * strips with more than one row.
     */
    public static final int             FILL_TO_RIGHT = 1;

    /**
     * Specifies that all tabs in a control are the same width. period.
     */
    public static final int             FIXED = 2;
    
    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}