//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * Defines constants that specify where tick marks appear in a trackbar control. 
 *
 * @security(checkClassLinking=on)
 */
public class TickStyle extends Enum {

    /**
     * Specifies that no tick marks are visible in the control. */
    public static final int NONE = 0;

    /**
     * Specifies that tick marks appear on the top of a horizontal control or on the left of a
     * vertical control. */
    public static final int TOPLEFT = 1;

    /**
     * Specifies that tick marks appear on the bottom of a horizontal control or on the right
     * of a vertical control. */
    public static final int BOTTOMRIGHT = 2;

    /**
     * Specifies that tick marks appear on both sides of the control. */
    public static final int BOTH = 3;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}