//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.dll.DllLib;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.lang.Delegate;

/**
 * This class should be used to add a ToolBar to your form.  It can be
 * algined to the top or the bottom of the form.  You can add or remove
 * buttons, and associate the ToolBar with an ImageList
 *
 * @security(checkClassLinking=on)
 */
public class ToolBar extends Control {

    
    private Point buttonSize = new Point(24, 22);
    private boolean haveButtonSize = false;

    
    private boolean button0Invis = false;

    
    private int requestedSize;
    
    static final int DDARROW_WIDTH = 15;

    
    private boolean wrappable = true;

    
    private int appearance = ToolBarAppearance.NORMAL;

    
    private int borderStyle = BorderStyle.NONE;

    
    private ToolBarButton [] buttons;

    
    private int buttonCount = 0;

    
    private boolean dropDownArrows = true;

    
    private int textAlign = ToolBarTextAlign.UNDERNEATH;

    
    private boolean divider = true;

    
    private boolean showToolTips = true;

    
    private boolean autoSize = true;

    
    private ImageList imageList = null;

    
    private int updateCount;

    
    private int maxWidth = -1;

    
    
    private ToolBarButtonClickEventHandler onButtonClick = null;
    private ToolBarButtonClickEventHandler onButtonDropDown = null;

    /**
     * Creates a new blank ToolBar control.  You need to add some buttons
     * to it to make it useful.
     */
    public ToolBar() {}

    /**
     * Adds a new ToolBarButton to the ToolBar.  It is added to the end of
     * the list of existing buttons [if any].
     *
     * @param button    The ToolBarButton to be added after all existing
     *                  buttons.
     */
    public final void addButton(ToolBarButton button) {}

    /**
     * Adds an event handler for the "buttonClick" event notification. This
     * event is sent whenever a button on the ToolBar is clicked.  The
     * handle to the object is passed to listeners of this event.
     * Duplicates adds are not filtered out.
     *
     * @param value New Event Handler to install for this event.
     */
    public final void addOnButtonClick(ToolBarButtonClickEventHandler value) {}

    /**
     * Adds an event handler for the "buttonDropDown" event notification. This
     * event is sent whenever a button on the ToolBar that has the style
     * DROPDOWNBUTTON is pressed.  If the button hasn't been told to
     * automatically display a menu, this event is fired, which lets you
     * display some sort of UI representing the drop-down.
     * Note that uplicates adds are not filtered out.
     *
     * @param value New Event Handler to install for this event.
     */
    public final void addOnButtonDropDown(ToolBarButtonClickEventHandler value) {}

    
    private void adjustSize() {}

    
    void beginUpdate() {}

    
    private void detachImageList(Object sender, Event e) {}

    /**
     * @internalonly
     */
    public synchronized void dispose() {}

    
    void endUpdate() {}

    
    private void forceButtonWidths() {}

    /**
     * Indicates what special appearance characteristics the ToolBar
     * will have.  Examples would be normal or a non-3D flat appearance.
     *
     * @return int  a value from the @see ToolBarAppearance enumeration
     *              with the current appearance value.
     */
    public final int getAppearance() {}

    /**
     * Indicates whether or not the ToolBar control will try and maintain
     * it's own size based on image size, or whether it will just honour
     * any size.
     *
     * @return boolean  true if the control will resize itself based on
     *                  image height [default], false if it will just
     *                  honour whatever size windows tells it to.
     */
    public final boolean getAutoSize() {}

    /**
     * Indicates if the control has a border.
     *
     * @return int      a value from the @see com.ms.wfc.ui.BorderStyle enumeration
     *                  that indicates what type of border this control has.
     */
    public final int getBorderStyle() {}

    /**
     * Retrieves the button at the given index.
     *
     * @param index             The index whose button will be returned
     *
     * @return ToolBarButton   the button at said index
     */
    public final ToolBarButton getButton(int index) {}

    /**
     * Returns a count of buttons currently in the ToolBar
     *
     * @return int  the current number of buttons in the ToolBar
     */
    public final int getButtonCount() {}

    /**
     * Returns an array with all the ToolBarButton objects that we have in
     * our control.
     *
     * @return ToolBarButton []    an array with all our button objects.
     */
    public final ToolBarButton [] getButtons() {}

    /**
     * Returns the size of a button in the ToolBar.  If this is not set,
     * the ToolBar control computes this value on it's own.
     *
     * @return Point    the current size of Buttons in the ToolBar
     */
    public final Point getButtonSize() {}

    /**
     * Returns the parameters needed to create the handle.  Inheriting classes
     * can override this to provide extra functionality.  They should not,
     * however, forget to call super.getCreateParams() first to get the struct
     * filled up with the basic info.
     *
     * @return CreateParams     an object with all the info needed to create
     *                          the control.
     * @internalonly
     */
    protected CreateParams getCreateParams() {}

    /**
     * Indicates whether the ToolBar will display a visual divider at the
     * top of it's surface.  This can help distinguish the ToolBar from
     * adjacent controls, such as Menus, etc.
     *
     * @return boolean  true if the Divider should be shown [deafult], or
     *                  false if it will not.
     */
    public final boolean getDivider() {}

    /**
     * Indicates if little down arrows will show up next to buttons
     * whose style is DropDownButton.
     *
     * @return boolean  true if the dropdown arrow should appear
     */
    public final boolean getDropDownArrows() {}

    /**
     * Returns the ImageList control that has all the main images for this
     * ToolBar.
     *
     * @return ImageList    the ImageList containing all the main images
     *                      for this ToolBar
     */
    public final ImageList getImageList() {}

    /**
     * The method return the size of the images within the toolbar's image
     * list.
     *
     * @return The size of the images in the toolbar.
     */
    public final Point getImageSize() {}

    
    int getPreferredHeight() {}

    
    int getPreferredWidth() {}

    /**
     * Indicates whether or not the ToolBar will show tooltips for each
     * button.  The text of the tip is controlled by the get/setToolTipText
     * methods on the ToolBarButton object.
     *
     * @return boolean      true if tooltips will be shown, false otherwise
     */
    public final boolean getShowToolTips() {}

    /**
     * Indicates whether the text will be replaced with regards the image
     * in the buttons.  They can be placed underneath, or to the right of an
     * image in the button.
     *
     * @return int  an integer from the @see ToolBarTextAlign enumeration
     *              which controls where the text is placed.
     */
    public final int getTextAlign() {}

    /**
     * ToolBar buttons can optionally "wrap" to the next line when the ToolBar
     * becomes too narrow to include all buttons on the same line. Wrapping
     * occurs on separation and nongroup boundaries. This controls whether
     * this is turned on.
     *
     * @return boolean  a boolean indicating whether or not the ToolBar
     *                  will wrap buttons onto a second line.
     */
    public final boolean getWrappable() {}

    /**
     * @internalonly
     */
    protected void insert(int index, ToolBarButton button) {}

    /**
     * Inserts a button at the given index in the ToolBar control.
     *
     * @param index     Index at which to insert the button
     * @param value     The new Button to insert into the ToolBar
     */
    public final void insertButton(int index, ToolBarButton value) {}

    
    private void internalAddButton(ToolBarButton button) {}

    
    void internalSetButton(int index, ToolBarButton value, boolean recreate) {}

    /**
     * Actually goes ahead and fires the buttonClick Event. Inheriting classes
     * should override this in favour of listening to the event.  They should
     * not, however, forget to call super.onButtonClick(e) in order to ensure
     * that all external listeners still receive the event.
     *
     * @param e     ToolBarButtonClickEvent object with the info
     */
    protected void onButtonClick(ToolBarButtonClickEvent e) {}

    /**
     * Actually goes ahead and fires the buttonDropDown Event. Inheriting classes
     * should override this in favour of listening to the event.  They should
     * not, however, forget to call super.onButtonDropDown(e) in order to ensure
     * that all external listeners still receive the event.
     *
     * @param e     ToolBarButtonClickEvent object with the info
     */
    protected void onButtonDropDown(ToolBarButtonClickEvent e) {}

    /**
     * Overridden from the control class so we can add all the buttons
     * and do whatever work needs to be done.
     * Don't forget to call super.onCreateHandle.
     * @internalonly
     */
    protected void onCreateHandle(Event e) {}

    /**
     * The control is being resized.  Make sure the width/height are correct.
     * @internalonly
     * @hidden
     */
    protected void onResize(Event e) {}

    /**
     * Overridden to ensure that the buttons and the control resize properly
     * whenever the font changes.
     * @internalonly
     */
    protected void propertyChanged(int property) {}

    
    private void realizeButtons() {}

    /**
     * @internalonly
     */
    protected void remove(int index) {}

    /**
     * Removes all buttons from the ToolBar control.
     */
    public final void removeAll() {}

    /**
     * Removes the given button from the ToolBar control
     *
     * @param index        Deletes the button at this index.  The
     *                     ToolBarButton object is discarded.
     */
    public final void removeButton(int index) {}

    /**
     * Removes the given handler for the "buttonClick" event.
     * If there are duplicate entries, ALL are removed.
     *
     * @param value Event handler to be removed.
     */
    public final void removeOnButtonClick(ToolBarButtonClickEventHandler value) {}

    /**
     * Removes the given handler for the "buttonDropDown" event.
     * If there are duplicate entries, ALL are removed.
     *
     * @param value Event handler to be removed.
     */
    public final void removeOnButtonDropDown(ToolBarButtonClickEventHandler value) {}

    /**
     * Controls the appearance of this ToolBar control.  Values are obtained
     * from the @see ToolBarAppearance Enumeration.
     *
     * @param   value       The new appearance for this ToolBar
     */
    public final void setAppearance(int value) {}

    /**
     * Controls whether or not the ToolBar control will try and maintain
     * it's own size based on image size, or whether it will just honour
     * any size.
     *
     * @param value  true if the control will resize itself based on
     *               image height [default], false if it will just
     *               honour whatever size windows tells it to.
     */
    public final void setAutoSize(boolean value) {}

    /**
     * Controls whether the edit control has a border. The only
     * valid types are
     */
    public final void setBorderStyle(int value) {}

    /**
     * Overrides Control.setBoundsCore to enforce autoSize.
     * @internalonly
     */
    protected void setBoundsCore(int x, int y, int width, int height) {}

    /**
     * Replaces the button at the given index with the specified button
     *
     * @param index     index at which to replace the button
     * @param value     new Button for the specified index.
     */
    public final void setButton(int index, ToolBarButton value) {}

    /**
     * Sets the full set of buttons with which our ToolBar will work.  Any
     * existing buttons are removed in favour of the new ones.
     *
     * @param value     The new array of buttons this ToolBar should work with
     */
    public final void setButtons(ToolBarButton [] value) {}

    /**
     * Sets the size of a button in the ToolBar.  If this is not set,
     * the ToolBar control computes this value on it's own.
     *
     * @param value         The new size of Buttons.
     */
    public final void setButtonSize(Point value) {}

    /**
     * @internalonly
     */
    public void setComponentSite(IComponentSite value) {}
    
    /**
     * Sets the way in which this ToolBar is docked to it's parent. We need
     * to override this to ensure autoSizing works correctly
     *
     * @param value     From the @see com.ms.wfc.ui.ControlDock enumeration
     */
    public final void setDock(int value) {}

    /**
     * Controls whether the ToolBar will display a visual divider at the
     * top of it's surface.  This can help distinguish the ToolBar from
     * adjacent controls, such as Menus, etc.
     *
     * @param value     true if the Divider should be shown [default], or
     *                  false if it will not.
     */
    public final void setDivider(boolean value) {}

    /**
     * Controls if little down arrows will show up next to buttons
     * whose style is DropDownButton.
     *
     * @param value  true if the dropdown arrow should appear
     */
    public final void setDropDownArrows(boolean value) {}

    /**
     * Sets the ImageList with all the images that we're using for our
     * ToolBar control.
     *
     * @param value     A handle to an ImageList control that we should
     *                  use for our images.
     */
    public final void setImageList(ImageList value) {}
    
    public final void setShowToolTips(boolean value) {}

    /**
     * Controls how the text is aligned with regards the buttons in any given
     * image.  The text can show up under the image or to the right of it.
     *
     * @param value     The desired new text alignment.
     */
    public final void setTextAlign(int value) {}

    /**
     * ToolBar buttons can optionally "wrap" to the next line when the ToolBar
     * becomes too narrow to include all buttons on the same line. Wrapping
     * occurs on separation and nongroup boundaries. This controls whether
     * this is turned on.
     *
     * @param value     Controls whether or not the ToolBar
     *                  will wrap buttons onto a second line.
     */
    public final void setWrappable(boolean value) {}

    /**
     * @internalonly
     */
    public boolean shouldPersistButtonSize() {}

    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    
    void updateButtons() {}

    /**
     * The button clicked was a dropdown button.  If it has a menu specified,
     * show it now.  Otherwise, fire an onButtonDropDown event.
     *
     * @internalonly
     */
    protected void wmNotifyDropDown(Message m) {}

    /**
     * @internalonly
     */
    protected void wmNotifyNeedText(Message m) {}

    /**
     * @internalonly
     */
    protected void wmReflectCommand(Message m) {}

    /**
     * @internalonly
     */
    protected void wndProc(Message m) {}

    /**
     * this is the ClassInfo we expose for the ToolBar control
     *
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Control.ClassInfo {

        public static final PropertyInfo appearance = new PropertyInfo(
            ToolBar.class, "appearance", ToolBarAppearance.class,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(ToolBarAppearance.NORMAL)),
            new DescriptionAttribute(Sys.getString("ToolBarAppearanceDescr")));

        public static final PropertyInfo autoSize = new PropertyInfo(
            ToolBar.class, "autoSize", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("ToolBarAutoSizeDescr")));

        public static final PropertyInfo borderStyle = new PropertyInfo(
            ToolBar.class, "borderStyle", BorderStyle.class,
            CategoryAttribute.Appearance,
            new DefaultValueAttribute(new Integer(BorderStyle.NONE)),
            new DescriptionAttribute(Sys.getString("ToolBarBorderStyleDescr")));

        public static final PropertyInfo buttons = new PropertyInfo(
            ToolBar.class, "buttons", ToolBarButton [].class,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.EMPTY_ARRAY,
            new DescriptionAttribute(Sys.getString("ToolBarButtonsDescr")));

        public static final PropertyInfo buttonSize = new PropertyInfo(
            ToolBar.class, "buttonSize", Point.class,
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("ToolBarButtonSizeDescr")));

        public static final PropertyInfo divider = new PropertyInfo(
            ToolBar.class, "divider", Boolean.TYPE,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("ToolBarDividerDescr")));

        public static final PropertyInfo dropDownArrows = new PropertyInfo(
            ToolBar.class, "dropDownArrows", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            CategoryAttribute.Appearance,
            new DescriptionAttribute(Sys.getString("ToolBarDropDownArrowsDescr")));

        public static final PropertyInfo imageList = new PropertyInfo(
            ToolBar.class, "imageList", ImageList.class,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("ToolBarImageListDescr")));

        public static final PropertyInfo showToolTips = new PropertyInfo(
            ToolBar.class, "showToolTips", Boolean.TYPE,
            CategoryAttribute.Appearance,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("ToolBarShowToolTipsDescr")));

        public static final PropertyInfo tabStop = new PropertyInfo(
            Control.ClassInfo.tabStop, DefaultValueAttribute.FALSE);

        public static final PropertyInfo textAlign = new PropertyInfo(
            ToolBar.class, "textAlign", ToolBarTextAlign.class,
            CategoryAttribute.Behavior,
            new DefaultValueAttribute(new Integer(ToolBarTextAlign.UNDERNEATH)),
            new DescriptionAttribute(Sys.getString("ToolBarTextAlignDescr")));

        public static final PropertyInfo wrappable = new PropertyInfo(
            ToolBar.class, "wrappable", Boolean.TYPE,
            CategoryAttribute.Behavior,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("ToolBarWrappableDescr")));

        public static final EventInfo buttonClick = new EventInfo(
            ToolBar.class, "buttonClick", ToolBarButtonClickEventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("ToolBarButtonClickDescr")));

        public static final EventInfo buttonDropDown = new EventInfo(
            ToolBar.class, "buttonDropDown", ToolBarButtonClickEventHandler.class,
            CategoryAttribute.Behavior,
            new DescriptionAttribute(Sys.getString("ToolBarButtonDropDownDescr")));

        public static final PropertyInfo dock = new PropertyInfo(
            Control.ClassInfo.dock, new DefaultValueAttribute(new Integer(ControlDock.TOP)));

        public static final PropertyInfo text = new PropertyInfo(
            Control.ClassInfo.text, BrowsableAttribute.NO, PersistableAttribute.NO);

        public static final PropertyInfo foreColor = new PropertyInfo(
            Control.ClassInfo.foreColor, BrowsableAttribute.NO, PersistableAttribute.NO);

        public String getDefaultEventName() {}

        public String getDefaultPropertyName() {}

        public void getEvents(IEvents events) {}

        public void getProperties(IProperties props) {}

    }

}