//STRIPPEDSOURCE//

package com.ms.wfc.ui;


import com.ms.dll.DllLib;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;


/**
 * This class is used to describe a button on a ToolBar control. You
 * use the various methods to add, remove, or set the buttons on the ToolBar
 * to actually make them appear or disappear.
 * The most important things to set would be the text and the image.
 *
 * @security(checkClassLinking=on)
 */
public class ToolBarButton extends Component {

    String text;
    String tooltipText;
    boolean enabled = true;
    boolean visible = true;
    boolean pushed = false;
    boolean partialPush = false;
    int imageIndex = -1;
    int style = ToolBarButtonStyle.PUSHBUTTON;

    Object itemData;

    
    

    
    int stringIndex = -1;

    
    ToolBar parent;

    
    Menu dropDownMenu = null;

    /**
     * Creates a new ToolBarButton object
     */
    public ToolBarButton() {}

    public void dispose() {}

    
    private final int findButtonIndex() {}

    /**
     * If the button style is DROPDOWNBUTTON, you can, optionally, specify
     * a context menu that is shown whenever the dropdown button is pressed.  This
     * property lets you control just which menu is shown.  Note that this
     * will ONLY be shown if the button style is DROPDOWNBUTTON
     *
     * @return  Menu    the menu that will be shown when this button
     *                  is pressed.
     */
    public final Menu getDropDownMenu() {}

    /**
     * Indicates if the button is enabled or not.  Disabled buttons are
     * grayed out.
     *
     * @return boolean  true if the button is enabled, otherwise false.
     */
    public final boolean getEnabled() {}

    /**
     * Returns the index of the image that this ToolBarButton is using.
     * The index comes from the parent ToolBar's ImageList
     *
     * @return int      the index into the parent's ImageList of the image
     *                  this button will display.  -1 means there is no
     *                  image associated with this button.
     */
    public final int getImageIndex() {}

    /**
     * Retrieves the data currently associated with this button.  This can be
     * whatever the user wants.
     * NOTE: When Using the Microsoft Visual J++ IDE, only Strings may be
     * entered using the property browser.  Outside the IDE, any Object
     * derived type may, of course, be used.
     *
     * @return Object       the item data associated with this button.
     */
    public final Object getItemData() {}

    /**
     * Indicates whether or not a toggle-styled button is partially pushed
     * or not.
     *
     * @return boolean      true if it's partially pushed, else false
     */
    public final boolean getPartialPush() {}

    /**
     * Indicates whether a toggle-styled button should be marked
     * as pushed or not.  The "pushed" state makes the button inset relative
     * to the others.  This is ignored for all other button styles.
     *
     * @return  boolean     true if the toggle button is pushed in or not.
     */
    public final boolean getPushed() {}

    /**
     * If we are parented and the parent is shown, then this returns the
     * rectangle that this button is currently inhabiting.
     *
     * @return Rectangle    the rectangle in which this button resides.
     */
    public final Rectangle getRect() {}

    /**
     * Returns the style of the ToolBar button.  This will from the
     * @see ToolBarButtonStyle enumeration.
     *
     * @return  int     an Integer indicating the style of this
     *                  button, from the @see com.ms.wfc.ui.ToolBarButtonStyle
     *                  enumeration.
     */
    public final int getStyle() {}

    
    TBBUTTON getTBBUTTON() {}

    
    TBBUTTONINFO getTBBUTTONINFO() {}

    /**
     * Returns the caption that will be displayed in this ToolBar button.
     *
     * @return String   the caption that this button will display in the
     *                  ToolBar.
     */
    public final String getText() {}

    /**
     * If the parent ToolBar has the ToolTip property turned on, then this
     * property describes the text that will be displayed for this button
     *
     * @return  String      the current ToolTip text for this button.
     */
    public final String getToolTipText() {}

    /**
     * Indicates whether the button is visible or not.  If the button
     * is not visible, it will not be shown and will be unable to receive
     * user input
     *
     * @return boolean  true if the button is visible, false otherwise.
     */
    public final boolean getVisible() {}

    
    short getWidth() {}

    /**
     * If the button style is DROPDOWNBUTTON, you can, optionally, specify
     * a context menu that is shown whenever the dropdown button is pressed.  This
     * property lets you control just which menu is shown.  Note that this
     * will ONLY be shown if the button style is DROPDOWNBUTTON
     *
     * @param  value    the menu that will be shown when this button
     *                  is pressed.
     */
    public final void setDropDownMenu(Menu value) {}

    /**
     * Controls whether the button is enabled or not.  Disabled buttons are
     * grayed out.
     *
     * @param value         true if the button is enabled, otherwise false.
     */
    public final void setEnabled(boolean value) {}

    /**
     * Sets the index of the image that this ToolBarButton is using.
     * The index comes from the parent ToolBar's ImageList
     *
     * @param value     the index into the parent's ImageList of the image
     *                  this button will display.  -1 means there is no
     *                  image associated with this button.
     */
    public final void setImageIndex(int value) {}

    /**
     * Allows the user to set some addiitonal information with the button.
     * This data can be in whatever form the user would like.
     *
     * @param value     The new item data for this button
     */
    public final void setItemData(Object value) {}

    /**
     * Sets the style of the ToolBar button.  This will from the
     * @see ToolBarButtonStyle enumeration.
     *
     * @param  value    an Integer indicating the style of this
     *                  button, from the @see com.ms.wfc.ui.ToolBarButtonStyle
     *                  enumeration.
     */
    public final void setStyle(int value) {}

    /**
     * Controls whether or not a toggle-styled button is partially pushed
     * or not.
     *
     * @param value      true if it's partially pushed, else false
     */
    public final void  setPartialPush(boolean value) {}

    /**
     * Indicates whether a toggle buttons styled button should be marked
     * as pushed or not.  The "pushed" state makes the button inset relative
     * to the others.  This is ignored for all other button styles.
     *
     * @param  value     true if the toggle button is pushed in or not.
     */
    public final void setPushed(boolean value) {}

    /**
     * Sets the caption that will be displayed in this ToolBar button.
     *
     * @param value     The new caption for this ToolBar button.
     */
    public final void setText(String value) {}

    /**
     * If the parent ToolBar has the ToolTip property turned on, then this
     * property controls the text that will be displayed for this button
     *
     * @param  value      the new ToolTip text for this button.
     */
    public final void setToolTipText(String value) {}

    /**
     * Controls whether or not the given button is visible or not.
     *
     * @param value     true if the button shoudl be shown, false otherwise
     */
    public final void setVisible(boolean value) {}

    
    private static String stringFromStyle(int value) {}

    /**
     * @internalonly
     */
    public String toString() {}

    
    void updateButton(boolean recreate) {}


    /**
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends com.ms.wfc.core.ClassInfo {

        public static PropertyInfo dropDownMenu = new PropertyInfo(
            ToolBarButton.class, "dropDownMenu", Menu.class,
            DefaultValueAttribute.NULL,
            new ValueEditorAttribute(PopulatedMenusEditor.class),
            new DescriptionAttribute(Sys.getString("ToolBarButtonMenuDescr")));
        public static PropertyInfo enabled = new PropertyInfo(
            ToolBarButton.class, "enabled", boolean.class,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("ToolBarButtonEnabledDescr")));
        public static PropertyInfo imageIndex = new PropertyInfo(
            ToolBarButton.class, "imageIndex", int.class,
            new ValueEditorAttribute(ImageIndexEditor.class),
            DefaultValueAttribute.NEGATIVE_ONE,
            new DescriptionAttribute(Sys.getString("ToolBarButtonImageIndexDescr")));
        public static PropertyInfo itemData = new PropertyInfo(
            ToolBarButton.class, "itemData", Object.class,
            new ValueEditorAttribute(StringEditor.class),
            DefaultValueAttribute.NULL,
            new DescriptionAttribute(Sys.getString("ToolBarButtonItemDataDescr")));
        public static PropertyInfo partialPush = new PropertyInfo(
            ToolBarButton.class, "partialPush", boolean.class,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("ToolBarButtonPartialPushDescr")));
        public static PropertyInfo pushed = new PropertyInfo(
            ToolBarButton.class, "pushed", boolean.class,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("ToolBarButtonPushedDescr")));
        public static PropertyInfo style =  new PropertyInfo(
            ToolBarButton.class, "style", ToolBarButtonStyle.class,
            new DefaultValueAttribute(new Integer(ToolBarButtonStyle.PUSHBUTTON)),
            new DescriptionAttribute(Sys.getString("ToolBarButtonStyleDescr")));
        public static PropertyInfo text = new PropertyInfo(
            ToolBarButton.class, "text", String.class,
            new ValueEditorAttribute(ImmediateStringEditor.class),
            LocalizableAttribute.YES,
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("ToolBarButtonTextDescr")));
        public static PropertyInfo toolTipText = new PropertyInfo(
            ToolBarButton.class, "toolTipText", String.class,
            LocalizableAttribute.YES,
            DefaultValueAttribute.EMPTY_STRING,
            new DescriptionAttribute(Sys.getString("ToolBarButtonToolTipTextDescr")));
        public static PropertyInfo visible = new PropertyInfo(
            ToolBarButton.class, "visible", boolean.class,
            DefaultValueAttribute.TRUE,
            new DescriptionAttribute(Sys.getString("ToolBarButtonVisibleDescr")));

        public String getDefaultPropertyName() {}

        public void getProperties(IProperties props) {}
    }
}