//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * The Button style within a ToolBar.  The Exact appearance of the buttons
 * will depend on the appearance of the ToolBar control.
 *
 * @security(checkClassLinking=on)
 */
public class ToolBarButtonStyle extends Enum {

    /**
     * Indicates that the button should behave like a regular windows button.
     */
    public static final int PUSHBUTTON     = 1;
    
    /**
     * The button remains pressed when clicked.  It acts to show more of a
     * toggled state.
     */
    public static final int TOGGLEBUTTON   = 2;
    
    /**
     * The button acts as a separator between other buttons.  No click events
     * are fired for it.
     */
    public static final int SEPARATOR      = 3;
    
    /**
     * The button is capable of dropping down menus or other windows when
     * pressed.
     */
    public static final int DROPDOWNBUTTON = 4;

    /**
     * Ensures the given value is valid for this enumeration.
     */
    public static boolean valid(int value) {}
}