//STRIPPEDSOURCE//

package com.ms.wfc.ui;

import com.ms.dll.*;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.vm.*;


/**
 * Encapsulates the ToolTip control which provides a tooltip for the  controls on a form.
 *
 * @security(checkClassLinking=on)
 */
public final class ToolTip extends Component implements IExtenderProvider {

    private final static int DEFAULT_DELAY = 500;
    private final static int RESHOW_RATIO = 5;
    private final static int AUTOPOP_RATIO = 10;

    private HashTable           tools = new HashTable();
    private int                 messageHookRoot = 0;
    private int                 messageHookHandle = 0;
    private int[]               delayTimes = new int[4];
    private boolean             auto = true;
    private boolean             showAlways = false;
    private ToolTipWindow       window = null;
    private Control             topLevelControl = null;
    private boolean             activate = true;

    
    
    
    private HashTable           created = new HashTable();
    
    /**
     * Creates a new ToolTip control in the given container.
     * 
     * @param cont      The container with which we are working.
     */
    public ToolTip(IContainer cont) {}
    
    /**
     * Creates a ToolTip.
     */
    public ToolTip() {}
    
    
    private void adjustBaseFromAuto() {}

    private void handleCreated(Object sender, Event event) {}
    private void handleDestroyed(Object sender, Event event) {}

    private void topLevelCreated(Object sender, Event event) {}
    private void topLevelDestroyed(Object sender, Event event) {}
    
    private boolean getHandleCreated() {}
    
    private int getHandle() {}

    /**
     * Returns true if the tooltip can offer an extender property to the 
     * specified target component.
     *
     * @param target Target object to add extender property to.
     *
     * @return True if this tooltip can offer one or more extender properties.
     *
     * @internalonly
     */
    public boolean canExtend(Object target) {}

    /**
     * Creates the handle for the control.
     *
     * @internalonly
     */
    protected void createHandle() {}

    private void createAllRegions() {}

    private void createRegion(Control ctl) {}
        
    private void mouseMove(Object sender, MouseEvent me) {}
        

    /**
     * Destroys the handle for this control.
     *
     * @internalonly
     */
    protected void destroyHandle() {}

    private void destroyRegion(Control ctl) {}

    /**
     * Disposes of the component.  Call dispose when the component is no longer needed. 
     * This method removes the component from its container (if the component has a site) 
     * and triggers the dispose event. 
     */
    public void dispose() {}

    /**
     * Retrieves the automatic delay for the ToolTip control.
     *
     * @return Current value of the Automatic delay property.
     *
     * @see #setAutomaticDelay
     */
    public int getAutomaticDelay() {}

    /**
     * Retrieves the ToolTip control's autopop delay.
     *
     * @return Current value of the AutoPop delay property.
     *
     * @see #setAutoPopDelay
     */
    public int getAutoPopDelay() {}

    /**
     * Returns the createParams to create the window.
     *
     * @return CreateParams
     *
     * @internalonly
     */
    protected CreateParams getCreateParams() {}

    
    private int getDelayTime(int type) {}

    /**
     * Sets the initial delay for the ToolTip control.
     *
     * @return Current value of the Initial delay property.
     *
     * @see #setInitialDelay
     */
    public int getInitialDelay() {}

    
    private TOOLINFO_T getMinTOOLINFO(Control ctl, String caption) {}
    
    private boolean getMessagesHooked() {}
    
    /**
     * Retrieves the current value of the ToolTip control's reshow delay.
     *
     * @return Current value of the Reshow delay property.
     *
     * @see #setReshowDelay
     */
    public int getReshowDelay() {}

    /**
     * Retrieves a boolean value that indicates whether the tooltip window is
     * displayed even when its parent control is not active.
     *
     * @return current ShowAlways value.
     *
     * @see #setShowAlways
     */ 
    public boolean getShowAlways() {}

    
    private TOOLINFO_T getTOOLINFO(Control ctl, String caption) {}

    /**
     * Retrieves the tooltip text associated with the specified control.
     *
     * @param control Control to get the tooltip for.
     *
     * @return ToolTip for the specified control.
     *
     * @see #setToolTip
     */
    public String getToolTip(Control control) {}

    private Control getTopLevelControl() {}
    
    
    private int getWindowFromPoint(Point screenCoords) {}

    
    private synchronized void hookMessages() {}

    
    private int messageHookProc(int nCode, int wParam, int lParam) {}

    /**
     * @internalonly
     */
    protected void recreateHandle() {}


    /**
     * Removes all the tooltips currently associated with the ToolTip
     * control.
     */
    public void removeAll() {}

    /**
     * Sets the automatic delay on the ToolTip control.  When the AutomaticDelay property is set
     * values are given to the AutoPopDelay, InitialDelay, and ReshowDelay based
     * on the AutomaticDelay value. The AutoPopDelay is always set to 10 times
     * the AutomaticDelay, the InitialDelay is set to 1/5 times the 
     * AutomaticDelay, and ReshowDelay is set to the same time as the 
     * AutomaticDelay.
     *
     * @param value New value in Milliseconds.
     *
     * @see #getAutomaticDelay
     * @see #setAutoPopDelay
     * @see #setInitialDelay
     * @see #setReshowDelay
     */
    public void setAutomaticDelay(int value) {}

    /**
     * Sets the autopop delay on a ToolTip control.  This is the length of time the tooltip
     * window remains visible if the pointer is stationary inside a tooltip
     * region.
     *
     * @param value New value in Milliseconds.
     *
     * @see #getAutomaticDelay
     * @see #setAutomaticDelay
     * @see #setInitialDelay
     * @see #setReshowDelay
     */
    public void setAutoPopDelay(int value) {}

    
    private void setDelayTime(int type, int time) {}

    /**
     * Sets the ToolTip control's initial delay.  This is the length of time the pointer 
     * must remain stationary within a tooltip region before the tooltip window
     * appears.
     *
     * @param value New value in Milliseconds.
     *
     * @see #getAutomaticDelay
     * @see #setAutomaticDelay
     * @see #setAutoPopDelay
     * @see #setReshowDelay
     */
    public void setInitialDelay(int value) {}

    /**
     * Sets a boolean value that indicates whether the ToolTip window should
     * be displayed even when its parent control is not active. When ShowAlways is set to true the tooltips
     * will always be displayed, even if the parent form is not active.
     *
     * @param value New value for the ShowAlways property.
     * 
     * @see #getShowAlways
     */
    public void setShowAlways(boolean value) {}

    /**
     * Associates tooltip text with the specified control.
     *
     * @param control Control to set the tooltip for.
     * @param caption ToolTip to display.
     *
     * @see #getToolTip
     */
    public void setToolTip(Control control, String caption) {}

    /**
     * Retrieves a boolean value that indicates whether the ToolTip
     * control is currently active.
     * 
     * @return <b>true</b> if the control is currently activated, or 
     *         <b>false</b> if not.
     */
    public boolean getActivate() {}

    /**
     * Activates or deactivates the ToolTip control.     
     *
     * @param value If <i>true</i>
     *
     */
    public void setActivate(boolean value) {}

    /**
     * Sets the reshow display which designates the time it takes for subsequent ToolTip
     * windows to appear as the mouse pointer moves from one tooltip region to another. This is the length of time it takes for
     * subsequent tooltip windows to appear as the pointer moves from one 
     * tooltip region to another.
     *
     * @param value New value in Milliseconds.
     *
     * @see #getAutomaticDelay
     * @see #setAutomaticDelay
     * @see #setAutoPopDelay
     * @see #setInitialDelay
     */
    public void setReshowDelay(int value) {}

    /**
     * Returns true if the AutomaticDelay property should be persisted.
     *
     * @return True if the property should be persisted.
     *
     * @internalonly
     */
    public boolean shouldPersistAutomaticDelay() {}

    /**
     * Returns true if the AutoPopDelay property should be persisted.
     *
     * @return True if the property should be persisted.
     *
     * @internalonly
     */
    public boolean shouldPersistAutoPopDelay() {}

    /**
     * Returns true if the InitialDelay property should be persisted.
     *
     * @return True if the property should be persisted.
     *
     * @internalonly
     */
    public boolean shouldPersistInitialDelay() {}

    /**
     * Returns true if the ReshowDelay property should be persisted.
     *
     * @return True if the property should be persisted.
     *
     * @internalonly
     */
    public boolean shouldPersistReshowDelay() {}

    /**
     * Called by the java VM when this component is about to be garbage 
     * collected.  Finalizers in WFC typically mimic the dispose method.
     * 
     * @see #dispose
     */
    protected void finalize() {}

    /**
     * Returns a string representation for this control.
     *
     * @return String
     * @internalonly
     */
    public String toString() {}

    
    private synchronized void unhookMessages() {}

    
    private void wmWindowFromPoint(Message msg) {}

    /**
     * WNDPROC
     *
     * @internalonly
     */
    protected void wndProc(Message msg) {}

    
    private class TOOLINFO_CALLBACK {
        public int cbSize;
        public int uFlags;
        public int hwnd;
        public int uId;
        public RECT rect;
        public int hinst;
        public int lpszText;
    }

    
    private class MessageHookProc extends Callback {
        WeakReference ref;

        public MessageHookProc(ToolTip parent) {}

        public int callback(int nCode, int wParam, int lParam) {}
    }

    
    private static class ToolTipWindow extends Window {
        WeakReference ref;

        ToolTipWindow(ToolTip control) {}

        protected void defWndProc(Message m) {}

        protected void wndProc(Message m) {}
    }

    /**
     * Encapsulates the ToolTip control which provides a tooltip for the  controls on a form.
     * @security(checkClassLinking=on)
     */
    public static class ClassInfo extends Component.ClassInfo {

        public static final PropertyInfo activate = new PropertyInfo(
            ToolTip.class, "activate", Boolean.TYPE,
            new DescriptionAttribute(Sys.getString("ToolTipActivateDescr")));

        public static final PropertyInfo automaticDelay = new PropertyInfo(
            ToolTip.class, "automaticDelay", Integer.TYPE,
            new DescriptionAttribute(Sys.getString("ToolTipAutomaticDelayDescr")));

        public static final PropertyInfo autoPopDelay = new PropertyInfo(
            ToolTip.class, "autoPopDelay", Integer.TYPE,
            new DescriptionAttribute(Sys.getString("ToolTipAutoPopDelayDescr")));

        public static final PropertyInfo initialDelay =  new PropertyInfo(
            ToolTip.class, "initialDelay", Integer.TYPE,
            new DescriptionAttribute(Sys.getString("ToolTipInitialDelayDescr")));

        public static final PropertyInfo reshowDelay =  new PropertyInfo(
            ToolTip.class, "reshowDelay", Integer.TYPE,
            new DescriptionAttribute(Sys.getString("ToolTipReshowDelayDescr")));
        
        public static final PropertyInfo showAlways = new PropertyInfo(
            ToolTip.class, "showAlways", Boolean.TYPE,
            DefaultValueAttribute.FALSE,
            new DescriptionAttribute(Sys.getString("ToolTipShowAlwaysDescr")));


        public static final ExtenderInfo toolTip = new ExtenderInfo(
            ToolTip.class, "toolTip", Control.class,
            String.class, 
            DefaultValueAttribute.EMPTY_STRING,
            LocalizableAttribute.YES,
            new DescriptionAttribute(Sys.getString("ToolTipToolTipDescr")));

        public void getAttributes(IAttributes attrs) {}

        public void getProperties(IProperties iprop) {}

        public void getEvents(IEvents ievents) {}

        public void getExtenders(IExtenders iexts) {}
    }
}