//STRIPPEDSOURCE//


package com.ms.wfc.ui;

import com.ms.dll.*;
import com.ms.wfc.app.*;
import com.ms.wfc.core.*;
import com.ms.wfc.io.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;




/**
 * Represents a node in a TreeView control. 
 * For the purposes of adding, removing, and cloning nodes, all child nodes are
 * considered a part of the node and will be added, removed, or cloned along with
 * their root.
 *
 * @security(checkClassLinking=on)
 */
public class TreeNode implements Cloneable, IConstructable, IPersistable {

    int handle;
    String text;
    int imageIndex = -1;
    int selectedImageIndex = -1;

    int index;                  
    int childCount;
    TreeNode[] children;
    TreeNode parent;
    TreeView treeView;

    static TV_ITEM item;         
    static TV_INSERTSTRUCT tvis;

    /**
     * Creates a TreeNode object.
     */
    public TreeNode() {}

    TreeNode(TreeView treeView) {}

    /**
     * Creates a TreeNode object from an IDataStream.
     *
     * @param stream    The data stream to read from.
     * @see IPersistable
     */
    public TreeNode(IDataStream stream) {}

    /**
     * Creates a TreeNode object.
     * 
     * @param text  Label of new node
     */
    public TreeNode(String text) {}

    /**
     * Creates a TreeNode object.
     *
     * @param text      Label of new node
     * @param children  Array of child nodes
     */
    public TreeNode(String text, TreeNode[] children) {}

    /**
     * Creates a TreeNode object.
     *
     * @param text                  Label of new node
     * @param imageIndex            Index of image to display when node is unselected
     * @param selectedImageIndex    Index of image to display when node is selected
     */
    public TreeNode(String text, int imageIndex, int selectedImageIndex) {}

    /**
     * Creates a TreeNode object.
     *
     * @param text                  Label of new node
     * @param imageIndex            Index of image to display when node is unselected
     * @param selectedImageIndex    Index of image to display when node is selected
     * @param children              Array of child nodes
     */
    public TreeNode(String text, int imageIndex, int selectedImageIndex, TreeNode[] children) {}

    /**
     * Adds a child node to the node.   Child node is positioned after siblings.
     *
     * @param text  Label of child node
     */
    public TreeNode addNode(String text) {}

    /**
     * Adds a child node to the node.   Child node is positioned after siblings.
     *
     * @param node  Child node to add
     */
    public void addNode(TreeNode node) {}

    
    private void addSorted(TreeNode node) {}

    private void sortChildren() {}

    /**
     * Begins in-place editing of the node's label text, replacing the label with a
     * single-line edit control containing the text. 
     * Only effective if <b>LabelEdit</b> property is <b>true</b>.
     */
    public void beginEdit() {}

    /**
     * Clones the entire subtree rooted at this node. 
     */
    public Object clone() {}

    /**
     * Collapses the node. 
     */
    public void collapse() {}

    
    private void doCollapse(TreeView tv) {}

    /**
     * Ends in-place editing of the node's label text. 
     *
     * @param cancel indicates if the edit is canceled without being saved
     */
    public void endEdit(boolean cancel) {}

    
    void ensureCapacity() {}

    /** 
     * Ensures that the node is visible, expanding the parent node or scrolling the tree view
     * control, if necessary. 
     */
    public void ensureVisible() {}

    /**
     * Expands the node. 
     */
    public void expand() {}

    
    TreeView findTreeView() {}

    /**
     * Retrieves the bounding rectangle for the node relative to the upper-left corner of the
     * tree view control's client area.  The coordinates
     * are relative to the upper left corner of the TreeView control.
     */
    public Rectangle getBounds() {}

    /**
     * Retrieves a boolean value that indicates whether the check box for the node is
     * checked. 
     */
    public boolean getChecked() {}

    
    private TreeNode[] getChildren() {}

    /**
     * Returns the constructor args for reconstructing this node.
     *
     * @internalonly
     */
    public ConstructorArg[] getConstructorArgs() {}

    /**
     * Retrieves the file name extension for the file to store the node's persistent data in. 
     *
     * @return a filename extension to use during object persistence.  TreeNode does
     *         not use an extension, so this always returns null.
     * @see IPersistable
     */
    public String getExtension() {}
    
    /**
     * Returns the HTREEITEM handle associated with this node.  If the handle
     * has not yet been created, this will force handle creation.
     */
    public int getHandle() {}

    /**
     * Retrieves the first child node that this node contains. 
     */
    public TreeNode getFirstNode() {}

    /**
     * Retrieves the full path to this node. 
     * The path consists of the labels of each of the nodes from the root to this node,
     * each separated by the pathSeperator.
     */
    public String getFullPath() {}

    
    private void getFullPath(StringBuffer path, String pathSeparator) {}

    /**
     * Retrieves the index of the image that appears next to this node. 
     * The image is contained in the ImageList referenced by the <b>imageList</b> property.
     */
    public int getImageIndex() {}

    /**
     * Returns the position of this node in relation to its siblings
     */
    public int getIndex() {}

    /**
     * Retrieves the last child node that this node contains. 
     */
    public TreeNode getLastNode() {}

    /**
     * Retrieves the node immediately after this node in the parent node's child list. 
     */
    public TreeNode getNextNode() {}

    /**
     * Retrieves the first visible node after this node in the tree view control.   It may be a child, sibling,
     * or a node from another branch.
     */
    public TreeNode getNextVisibleNode() {}

    /**
     * Retrieves the child node of this node at the specified zero-based index. 
     */
    public TreeNode getNode(int index) {}

    /**
     * Retrieves a value indicating how many child nodes this node has. 
     */
    public int getNodeCount() {}

    /**
     * Retrieves a value indicating how many child nodes this node has. 
     *
     * @param includeSubTrees   If this is <b>true</b>, the resulting count will include
     *                          all nodes indirectly rooted at this node
     */
    public int getNodeCount(boolean includeSubTrees) {}

    /**
     * Retrieves an array containing all the child nodes in this node. 
     */
    public TreeNode[] getNodes() {}

    /**
     * Retrieves the parent node for this node. 
     */
    public TreeNode getParent() {}

    /**
     * Retrieves the node immediately before this node in the parent node's child list. 
     */
    public TreeNode getPrevNode() {}

    /**
     * Retrieves the last visible node before this node in the tree view control.   It may be a parent, sibling,
     * or a node from another branch.
     */
    public TreeNode getPrevVisibleNode() {}

    /**
     * Retrieves the index of the image that appears next to this node when it is selected. 
     * The image is contained in the ImageList referenced by the <b>imageList</b> property.
     */
    public int getSelectedImageIndex() {}

    
    int getState() {}

    /**
     * Retrieves the label text for this node.  */
    public String getText() {}

    /** 
     * Retrieves the tree view control that contains this node. 
     */
    public TreeView getTreeView() {}

    /**
     * Inserts the specified node as a child of this node at the specified position.   Child node is positioned as specified by <b>index</b>.
     *
     * @param index Position of child node relative to its siblings
     * @param node  Child node to add
     */
    public void insertNode(int index, TreeNode node) {}

    
    private void insertNodeAt(int index, TreeNode node) {}

    /**
     * Retrieves a boolean value indicating whether the user is currently editing this
     * node in the tree view control. 
     */
    public boolean isEditing() {}

    /**
     * Retrieves a boolean value indicating whether this node is currently expanded in
     * the tree view control. 
     */
    public boolean isExpanded() {}

    /**
     * Retrieves a boolean value indicating whether this node is currently selected in
     * the tree view control. 
     */
    public boolean isSelected() {}

    /**
     * Retrieves a boolean value indicating whether this node is currently visible in
     * the tree view control. 
     */
    public boolean isVisible() {}

    
    void realize() {}

    /**
     * Removes this node and all its children from the tree view control.   Child nodes are also removed from the
     * TreeView, but are still attached to this node.
     */
    public void remove() {}

    
    void remove(boolean notify) {}

    /**
     * Removes all children of this node. 
     */
    public void removeAll() {}

    /**
     * Removes the specified child node from this node. 
     *
     * @param index     Child node to remove
     */
    public void removeNode(int index) {}

    private void resetExpandedState(TreeView tv) {}

    /**
     * Saves this TreeNode object to the given data stream. 
     *
     * @param stream    The data stream to write to.
     *
     * @see IPersistable
     */
    public void save(IDataStream stream) {}

    /**
     * Sets a boolean value that indicates whether the check box for the node is
     * checked. 
     *
     * @param value  Specifies whether to check or uncheck the item
     */
    public void setChecked(boolean value) {}

    /**
     * Sets the index of the image that appears next to this node. 
     * The image is contained in the ImageList referenced by the <b>imageList</b> property.
     */
    public void setImageIndex(int value) {}

    /**
     * Replaces the child node at the specified position. 
     *
     * @param index     Index of child node to replace
     * @param node      Replacement node
     */
    public void setNode(int index, TreeNode node) {}

    /**
     * Adds a set of child nodes to this node. 
     *
     * @param nodes     Replacement nodes
     */
    public void setNodes(TreeNode[] nodes) {}

    /**
     * Sets the index of the image that appears next to this node when it is selected. 
     * The image is contained in the ImageList referenced by the <b>imageList</b> property.
     */
    public void setSelectedImageIndex(int value) {}

    /**
     * Sets the label text for this node. 
     */
    public void setText(String value) {}

    /**
     * Expands the node if it is collapsed; collapses the node if it is expanded.  Expand if collapsed or collapse if
     * expanded.
     */
    public void toggle() {}

    /**
     * Retrieves a String that contains the node label text.  */
    public String toString() {}

    
    private void updateNode(int mask) {}
}