//STRIPPEDSOURCE//


package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.util.*;
import com.ms.wfc.win32.*;


/**
 * Contains the amount that the up-down control's value changes when the user clicks an  arrow button and the amount of time that elapses before the change takes effect.   The up-down's acceleration determines the rate that the up-down's
 * position will increment when the user holds down the arrow buttons.
 * 
 * The <i>seconds</i> member indicates the amount of elapsed time, in seconds,  
 * before the position change increment specified by the member <i>increment</i> 
 * is used.  
 * 
 * To set the acceleration information, up-down controls take an array of UpDownAcceleration 
 * objects.  Each UpDownAcceleration object's position increment will come into effect after 
 * the value in the <i>seconds</i> member has elapsed, and will remain in effect until the 
 * amount of time indicated by the subsequent UpDownAcceleration in the array.  If there are 
 * no more elements in the array, then the final UpDownAcceleration object will dictate the
 * position increment.
 *
 * @see com.ms.wfc.ui.UpDown
 * @see com.ms.wfc.ui.UpDown#setAccel(UpDownAcceleration[])
 * @see com.ms.wfc.ui.UpDown#getAccel()
 *
 * @security(checkClassLinking=on)
 */
public class UpDownAcceleration implements IConstructable {
    /** 
     * Specifies the number of seconds that elapse before the value change takes effect in the
     * up-down control.  
     */
    public int seconds = 0;
    /** 
     * Specifies the amount that the value of the up-down control changes. 
     */
    public int increment = 0;

    /**
     * Creates a new UpDownAcceleration object, with default values.
     */
    public UpDownAcceleration() {}

    /**
     * Creates a new UpDownAcceleration object.  
     *
     * @param sec Specifies the <b>seconds</b> member of <b>UpDownAcceleration</b>
     * @param inc Specifies the <b>increment</b> member of <b>UpDownAcceleration</b>
     */
    public UpDownAcceleration (int sec, int inc) {}
    
    /**
     * Retrieves an array of ConstructorArg objects, which have a current value and type.
     *
     * @returns The necessary objects required to initialize an UpDownAcceleration object.
     *          Used by the PropertyBrowser.
     *
     * @see com.ms.wfc.core.IConstructable
     */
    public ConstructorArg[] getConstructorArgs() {}


    /**
     * Contains the amount that the up-down control's value changes when the user clicks an  arrow button and the amount of time that elapses before the change takes effect. 
     * @security(checkClassLinking=on)
     */
    public static class Editor extends ValueEditor {
        public int getStyle() {}        

        public String getTextFromValue(Object value) {}

        public Object getValueFromText(String text) {}
    }
}