//STRIPPEDSOURCE//


package com.ms.wfc.ui;

import com.ms.wfc.core.*;

/**
 * This class contains the enumeration values used by the com.ms.wfc.ui.UpDown control to
 * determine how the up-down control is positioned relative to its buddy control.
 * <b>MANUAL</b> - the position of the upDown control is determined by the programmer
 * <b>RIGHT</b> - the up-down control is positioned next to the left edge of the buddy window. 
 *                The buddy window is moved to the right, and its width is decreased to accommodate 
 *                the width of the up-down control.  
 * <b>LEFT</b> - the up-down control is positioned next to the right edge of the buddy window. 
 *               The width of the buddy window is decreased to accommodate the width of the 
 *               up-down control.  
 *
 * @see com.ms.wfc.ui.UpDown#getAlignment()
 * @see com.ms.wfc.ui.UpDown#setAlignment(int)
 *
 * @security(checkClassLinking=on)
 */
public class UpDownAlignment extends Enum {
    public static final int LEFT                  = 0;
    public static final int RIGHT                 = 1;
    public static final int MANUAL                = 2;

    /**
     * Checks to see that the given value is valid within this enumeration.
     */
    public static boolean valid(int value) {}
}