//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.wfc.util.*;

/**
 * Provides data for the upDownChanged  event of the UpDown object.   This happens when the user requests a change in the 
 * value by pressing the up-down control's up or down arrow.
 *
 * @security(checkClassLinking=on)
 */
public class UpDownChangedEvent extends Event {
    /**
     * Represents the up-down control's current value.  This is for
     * informational use only, as the user cannot modify this value.
     */
    public final int value;
    /**
     * Represents the proposed change to the up-down control's value.
     * The user can modify this to set up-down's new value.  The new
     * value will be equal to the current value + delta.
     */
    public int delta;
  
    /**
     * Creates a new UpDownChangedEvent object.
     *
     * @see com.ms.wfc.ui.UpDown
     */
    public UpDownChangedEvent(int value, int delta) {}
}