//STRIPPEDSOURCE//
package com.ms.wfc.ui;

import com.ms.wfc.core.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;

/**
 * Defines constants that specify how list items are displayed in a list view control. 
 * @security(checkClassLinking=on)
 */
public class ViewEnum extends Enum {

    /**
     * Specifies that each item appears as a full-sized icon with a label below it.
     */
    public static final int LARGEICON = win.LVS_ICON;

    /**
     * Specifies that each item appears on its own line with information arranged in columns.
     * The leftmost column contains the small icon and label, and subsequent
     * columns contain subitems as specified by the application.
     */
    public static final int REPORT = win.LVS_REPORT;

    /**
     * Specifies that each item appears as a small icon with a label to the right of it.
     */
    public static final int SMALLICON = win.LVS_SMALLICON;

    /**
     * Specifies that each item appears as a small icon with a label to the right of it.
     * Items are arranged in columns and cannot be dragged.
     */
    public static final int LIST = win.LVS_LIST;

    /**
     * Determines whether the specified value is one of the constants defined in this class. 
     */
    public static boolean valid(int value) {}
}