//STRIPPEDSOURCE//

package com.ms.wfc.util;

import com.ms.wfc.core.*;

/**
 * Enumerates all the elements in an Object array. 
 *
 * @security(checkClassLinking=on)
 */
public class ArrayEnumerator implements IEnumerator {
    protected Object[] items;
    int iLim;
    int iCur;

    /**
     * Creates a new ArrayEnumerator. This enumerator will iterate through
     * all the items in <i>items</i>.
     * 
     * @param items Object array to enumerate
     */
    public ArrayEnumerator(Object[] items) {}

    /**
     * Creates an identical copy of this enumerator.  This will return a new ArrayEnumerator that
     * refers to the same Object array, but has a unique current location.
     * 
     * @return a clone of this object.
     */
    public Object clone() {}

    /**
     * Determines whether there are more items in the array past the current item. 
     * 
     * @return <b>true</b> if there are more items in the array.
     */
    public boolean hasMoreItems() {}

    /**
     * Retrieves the next item in the array and increments the current position.
     * 
     * @return next item in the array.
     * @throws com.ms.wfc.util.EmptyEnumeratorException if there is no more elements in 
     *         the array.
     */
    public Object nextItem() {}

    /**
     * Resets the current position to the first element of the array. 
     */
    public void reset() {}
}