//STRIPPEDSOURCE//

package com.ms.wfc.util;

import com.ms.wfc.app.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.dll.*;

/**
 * Provides methods to sort arrays. 
 *
 * @security(checkClassLinking=on)
 */
public final class ArraySorter { 
    private Object[] items;
    private IComparer comparer;

    
    private ArraySorter(Object[] items, IComparer comparer) {}

    /**
     * Sorts an object array using the IComparer interface to compare
     * elements.
     * The following example sorts an array of <code>FileInfo</code> object by
     * the <code>size</code> field of each object. Notice the use of an
     * anonymous inner class to implement the <code>IComparer</code> interface
     * "in-situ".
     *<pre>
     *   ArraySorter.sort(files, new IComparer() {
     *       public int compare(Object x, Object y) {
     *           long sx = ((FileInfo)x).size;
     *           long sy = ((FileInfo)y).size;
     *           return sx < sy? -1: sx > sy? 1: 0;
     *       }
     *   });
     *</pre>
     * 
     * @param items The object array to sort.
     * @param comparer The IComparer to use when comparing elements.
     * @see com.ms.wfc.util.IComparer
     */
    public static void sort(Object[] items, IComparer comparer) {}

    /**
     * Sorts an object array using the IComparer interface to compare
     * elements.
     *
     * @param items The object array to sort.
     * @param index The starting index in the array.
     * @param count The number of elements to sort.
     * @param comparer The IComparer to use when comparing elements.
     * @see com.ms.wfc.util.IComparer
     */
    public static void sort(Object[] items, int index, int count, IComparer comparer) {}

    
    private void quickSort(int left, int right) {}
}