//STRIPPEDSOURCE//
package com.ms.wfc.util;

/**
 * A DebugMessageEventHandler defines a callback delegate that can be inserted
 * into message displaying events on the Debug class.  This allows you to easily
 * change the routing of debug events to go to a file, logging database or some
 * other location.  The delegate is declared has multicast, which allows you
 * to route a single message to multiple places at one time.
 *
 * @see Debug
 * @see Debug#addOnDisplayAssert
 * @see Debug#addOnDisplayMessage
 * @see Debug#removeOnDisplayAssert
 * @see Debug#removeOnDisplayMessage
 *
 * @security(checkClassLinking=on)
 */
public multicast delegate void DebugMessageEventHandler(String message);