//STRIPPEDSOURCE//

package com.ms.wfc.util;

/**
 * This interface represents the ability to compare two objects. It is used by
 * the <code>ArraySorter</code> class to implement generic sorting of arrays.
 *
 * @security(checkClassLinking=on)
 */
public interface IComparer {

    /**
     * Compares two objects.  An implementation of this method must return a
     * value less than zero if x is less than y, a value greater than zero if
     * x is greater than y, or zero if x is equal to y.
     */
    public int compare(Object x, Object y);
}