//STRIPPEDSOURCE//

package com.ms.wfc.util;

/**
 * Generic enumeration interface. Objects that implement this
 * interface support sequential scanning of all the contained
 * elements.
 *
 * @security(checkClassLinking=on)
 */
public interface IEnumerator extends Cloneable {
    
    /**
     * Determines whether there are more items to enumerate.
     * 
     * @return <b>true</b> if there are more to enumerate.
     */
    public boolean hasMoreItems();
    
    /**
     * Retrieves the next item.  If the last item has already been retrieved,
     * an exception should be thrown.
     * 
     * @return the next item.
     */
    public Object nextItem();
    
    /**
     * Resets the current location to the first element.
     */
    public void reset();
}