//STRIPPEDSOURCE//

package com.ms.wfc.util;

import com.ms.wfc.core.*;

/**
 * Provides number format styles associated with the Value  formatting methods. ms.wfc.util.Value formatting
 * functions.
 *
 * @security(checkClassLinking=on)
 */
public class NumberFormat extends Enum
{
	/**
	 * Specifies that a leading digit should be used.
	 */
    public static final int LEADING_DIGIT      = 0x00000001;
	/**
	 * Specifies that a leading digit should not be used.
	 */
    public static final int NO_LEADING_DIGIT   = 0x00000002;
	/**
	 * Specifies that negative values should be placed inside parentheses.
	 */
    public static final int NEGATIVE_PARENS    = 0x00000004;
	/**
	 * Specifies that negative values should not be placed inside parentheses.
	 */
    public static final int NO_NEGATIVE_PARENS = 0x00000008;
	/**
	 * Specifies that numbers should be grouped with a thousands separator; for example,
     * "1,000,456".
	 */
    public static final int GROUP_DIGITS       = 0x00000010;
	/**
	 * Specifies that numbers should not be grouped with a thousands separator; for example;
     * "1000456".
	 */
    public static final int NO_GROUP_DIGITS    = 0x00000020;

	/**
	 * Determines whether the specified value is one of the constants defined in this class. 
	 * 
	 * @param value value to test
	 * 
	 * @return <b>true</b> if <i>value</i> is a valid value.
	 */
    public static boolean valid(int value) {}
}