//STRIPPEDSOURCE//

package com.ms.wfc.util;

/**
 * Represents the debug version of the com.ms.dll.Root class.ms.dll.Root class. Usefull in tracking down
 * root leaks. All of the tracking features are only enabled on debug
 * builds, and therefore this class can always be used to allocate
 * roots.
 * 
 * @see com.ms.dll.Root
 *
 * @security(checkClassLinking=on)
 */
public class Root {

    
    

    #if DEBUG
    private static HashTable h = new HashTable(); 
    private static HashTable p = new HashTable(); 
    private static HashTable f = new HashTable();
    #endif
    
    /**
     * Determines whether any roots have been leaked.  This will dump the results
     * of the search to STDIN using com.ms.wfc.util.Debug.print.
     *
     * @conditional(DEBUG) 
     */
    public synchronized static void checkLeaks() {}

    /**
     * Allocates a root object. 
     * 
     * @param o Object to pin
     * 
     * @return root reference of the object
     * 
     * @see com.ms.dll.Root.alloc
     */
    public synchronized static int alloc(Object o) {}

    /**
     * Retrieves the object associated with the root value.
     * 
     * @param root Root reference to an object
     * 
     * @return the object associated with the root value.
     */
    public synchronized static Object get(int root) {}

    /**
     * Frees a root that has been allocated.
     * 
     * @param root Root reference to free.
     */
    public synchronized static void free(int root) {}

}