//STRIPPEDSOURCE//

package com.ms.wfc.util;


import com.ms.wfc.app.*;
import com.ms.wfc.win32.*;
import com.ms.win32.*;
import com.ms.wfc.core.*;
import com.ms.dll.*;
import java.lang.reflect.*;

/**
 * Represents a collection of small utility functions. 
 *
 * @security(checkClassLinking=on)
 */
public final class Utils {

    /**
     * Appends two strings, even if one or both of the strings are null. 
     * 
     * @param s1 Left string
     * @param s2 Right string
     * 
     * @return the combined string.
     */
    public static String appendStrings(String s1, String s2) {}
    
    /**
     * Creates a Win32 POINT structure from the specified coordinates.
     * 
     * @param x X location
     * @param y Y location
     * 
     * @return POINT structure containing the specified values.
     */
    public static POINT createPOINT(int x, int y) {}

    /**
     * Creates a Win32 RECT structure from the specified coordinates. 
     * 
     * @param x X location
     * @param y Y location
     * @param width Width of the rectangle
     * @param height Height of the rectangle
     * 
     * @return RECT structure containing the specified values.
     */
    public static RECT createRECT(int x, int y, int width, int height) {}

    /**
     * Appends the specified format string to the buffer using a string array to apply a
     * format.  
     * <i>format</i> can contain replacable parameters in the form of "%0" - "%9" that
     * will be replace by the elements in the <i>args</i> array.  It also replaces %, with
     * the current locale's list separator.
     * <pre>
     *StringBuffer sb = new StringBuffer(256);
     *String format = "Of %0 and %1, %0 is better";
     *String[] args = { "left", "right" };
     *appendFormat(sb, format, args);
     * </pre>
     * This example would generate the string "Of left and right, left is better".
     * 
     * @param buffer StringBuffer to append the formatted string to.
     * @param format Format string to append.
     * @param args String array to apply to the format.
     * 
     * @see #format
     */
    public static void appendFormat(StringBuffer buffer, String format, String[] args) {}

    /**
     * Compares two strings for equality.
     * 
     * @param left String to compare
     * @param right String to compare
     * 
     * @return <b>true</b> if the strings are equal.
     */
    public static boolean stringsEqual(String left, String right) {}

    /**
     * Compares two strings for case-insensitive equality. 
     * 
     * @param left String to compare
     * @param right String to compare
     * 
     * @return <b>true</b> if the strings are equal.
     */
    public static boolean stringsEqualIgnoreCase(String left, String right) {}

    /**
     * Converts the first letter of a string to lowercase.  This will convert the first letter of the string
     * to a lowercase if, and only if, the second letter is not upper case.
     * 
     * @param name String to decapitalize
     * 
     * @return decapitalized string
     */
    public static String decapitalize(String name) {}

    /**
     * Capitalizes the first letter of a string.  This will convert the first letter of the string
     * to uppercase.
     * 
     * @param name String to capitalize
     * 
     * @return capitalized string
     */
    public static String capitalize(String name) {}

    /**
     * Compares two arrays for equality.  Each element is compared to the 
     * respective element in the opposite array. All tests are safe will
     * <b>null</b> values.
     * 
     * @param array1 Array to compare
     * @param array2 Array to compare
     * 
     * @return <b>true</b> if the arrays are equal.
     */
    public static boolean arraysEqual(Object[] array1, Object[] array2) {}

    /**
     * Compares two objects for equality and checks for null values.
     * 
     * @param obj1 Object to compare
     * @param obj2 Object to compare
     * 
     * @return <b>true</b> if the objects are equal.
     */
    public static boolean equals(Object obj1, Object obj2) {}

    /**
     * Formats a string by replacing all occurrences of %n with the specified
     * strings.
     * 
     * @param format String to format
     * @param arg1 %0 replacement string
     * 
     * @return the formatted string.
     * 
     * @see #appendFormat
     * @see #format(String, String[])
     */
    public static String format(String format, String arg1) {}

    /**
     * Formats a string by replacing all occurrences of %n with the specified
     * strings.
     * 
     * @param format String to format
     * @param arg1 %0 replacement string
     * @param arg2 %1 replacement string
     * 
     * @return the formatted string.
     * 
     * @see #appendFormat
     * @see #format(String, String[])
     */
    public static String format(String format, String arg1, String arg2) {}

    /**
     * Formats a string by replacing all occurrences of %n with the specified
     * strings.
     * 
     * @param format String to format
     * @param arg1 %0 replacement string
     * @param arg2 %1 replacement string
     * @param arg3 %2 replacement string
     * 
     * @return the formatted string.
     * 
     * @see #appendFormat
     * @see #format(String, String[])
     */
    public static String format(String format, String arg1, String arg2,
        String arg3) {}

    /**
     * Formats a string by replacing all occurrences of %n with the specified
     * strings.
     * 
     * @param format String to format
     * @param arg1 %0 replacement string
     * @param arg2 %1 replacement string
     * @param arg3 %2 replacement string
     * @param arg4 %3 replacement string
     * 
     * @return the formatted string.
     * 
     * @see #appendFormat
     * @see #format(String, String[])
     */
    public static String format(String format, String arg1, String arg2,
        String arg3, String arg4) {}

    /**
     * Formats a string by replacing all occurrences of %n with the specified
     * strings.
     * 
     * @param format String to format
     * @param args Array of strings to apply to the format.
     * 
     * @return the formatted string.
     * 
     * @see #appendFormat
     */
    public static String format(String format, String[] args) {}

    /**
     * Represents a collection of small utility functions.  This function correctly
     * returns the superclass of an array class type. For example the superclass
     * of Control[].class will be returned as Component[].class. The standard
     * Java relection APIs will always return Object.class as the superclass
     * of any array type.
     * 
     * @param type Class to get the superclass of.
     * 
     * @return superclass of <i>type</i>
     */
    public static Class getSuperclass(Class type) {}
    
    /**
     * Retrieves the text associated with the last Win32 error.
     * 
     * @return text for the last Win32 error.
     */
    public static String getSystemErrorMessage() {}

    /**
     * Retrieves the text associated with the last Win32 error.
     * 
     * @param errorCode Error to lookup the text for.
     * 
     * @return text associated with <i>errorCode</i>
     */
    public static String getSystemErrorMessage(int errorCode) {}

    /**
     * Creates a string that contains the hexadecimal representation of the integer with the
     * specified number of hexadecimal digits.
     * 
     * @param value integer to create the hex string for.
     * @param digits number of hex digits to put in the string
     * 
     * @return hex representation of <i>value</i>
     */
    public static String intToHex(int value, int digits) {}

    /**
     * Creates a string that contains the hexadecimal representation of the long
     * value with the specified number of hexadecimal digits.
     * 
     * @param value long to create the hex string for.
     * @param digits number of hex digits to put in the string
     * 
     * @return hex representation of <i>value</i>
     */
    public static String longToHex(long value, int digits) {}

    /**
     * Determines whether the string is a valid Java identifier. 
     * 
     * @param s String to check
     * 
     * @return <b>true</b> if <i>s</i> is a valid Java identifier.
     */
    public static boolean getJavaIdentifier(String s) {}


    private static String[] reservedWords = { "abstract", "boolean", "break", "byte",
                                              "case", "catch", "char", "class", "const", "continue", "default", "do",
                                              "double", "else", "extends", "final", "finally", "float", "for", "goto",
                                              "if", "implements", "import", "instanceof", "int", "interface", "long",
                                              "native", "new", "package", "private", "protected", "public", "return",
                                              "short", "static", "super", "switch", "synchronized", "this", "throw",
                                              "throws", "transient", "try", "void", "volatile", "while",
                                              "true", "false", "null", "delegate"};

    /**
     * Determines whether the string is a reserved Java keyword.
     * 
     * @param s String to check.
     * 
     * @return <b>true</b> if <i>s</i> is a reserved Java keyword.
     */
    public static boolean getReservedWord(String s) {}

    private static String[] primitiveWords = { "boolean", "byte", "char", "double", "float", "int", "long", "short"};

    /**
     * Determines whether a string is a Java primitive word.
     * 
     * @param s String to check.
     * 
     * @return <b>true</b> if <i>s</i> is a reserved Java primitive.
     */
    public static boolean getPrimitiveWord(String s) {}

    /**
     * Parses the string for a list of double values.  These values must be 
     * separated by the list character, as determined in the region settings.
     * This is normally a "," (comma).
     * 
     * @param s String to parse
     * 
     * @return array of double values found in <i>s</i>.
     */
    public static double[] parseDblList(String s) {}

    /**
     * Parses the string for a list of integer values.  These values must be 
     * separated by the token.
     * 
     * @param s String to parse
     * @param token Token to search for.
     * 
     * @return array of int values found in <i>s</i>.
     */
    public static int[] parseIntList(String s, char token) {}

    /**
     * Parses the string for a list of integer values.  These values must be 
     * separated by the list character, as determined in the region settings.
     * This is normally a "," (comma).
     * 
     * @param s String to parse
     * 
     * @return array of int values found in <i>s</i>.
     */
    public static int[] parseIntList(String s) {}

    /**
     * Parses the string into substrings that are separated by tokens.
     * 
     * @param s String to parse
     * @param token Token to search for
     * @param wantBlanks if <b>false</b> then empty entries will be removed from the resulting list.
     * 
     * @return array of strings found.
     */
    public static String[] parseStringList(String s, String token, boolean wantBlanks) {}

    /**
     * Parses the string into substrings that are separated by tokens.
     * 
     * @param s String to parse
     * @param token Token to search for
     * 
     * @return array of strings found.
     */
    public static String[] parseStringList(String s, char token) {}

    /**
     * Parses the string into substrings that are separated by tokens. This is 
     * normally a "," (comma).
     * 
     * @param s String to parse
     * 
     * @return array of strings found.
     */
    public static String[] parseStringList(String s) {}

    /**
     * Creates a string that contains the specified character that can be put into a stream
     * that can be compiled.
     * 
     * @param c Character to quote
     * 
     * @return quoted String.
     */
    public static String quotedChar(char c) {}

    /**
     * Creates a string that contains the same value as the specified string and can be put
     * into a compilable quoted string.  A " (quote) character will
     * be placed before and after the contents of the resulting string.
     * 
     * @param s String to quote
     * 
     * @return quoted string.
     */
    public static String quotedString(String s) {}

    /**
     * Creates a string that contains the same value as the specified string and can be put
     * into a compilable quoted string. 
     * 
     * @param s String to quote
     * @param quote Optional character to quote the string with. This will be placed
     *        before and after the contents of the resulting string.
     * 
     * @return quoted string.
     */
    public static String quotedString(String s, String quote) {}

    /**
     * Retrieves the name of the class without the package name.
     * 
     * @param name Full class name
     * 
     * @return class name without the package name.
     */
    public static String stripClassName(String name) {}

    /**
     * Retrieves a substring with the leading and trailing white space removed.
     * 
     * @param s String to trim
     * 
     * @return trimmed string
     */
    public static String trimBlanks(String s) {}

    /**
     * Retrieves a substring with the leading and trailing white space removed.
     * 
     * @param s String to retrieve the substring from
     * @param left Starting index of the substring
     * @param right Ending index of the substring
     * 
     * @return substring of <i>s</i> with leading and trailing whitespace 
     * removed.
     */
    public static String trimBlanks(String s, int left, int right) {}

    /**
     * Retrieves a string that contains each element of the specified strings separated by the
     * specified token.
     * 
     * @param strings Array of strings to unpack
     * @param token Token to insert between elements
     * 
     * @return string containing all the elements of <i>strings</i>.
     */
    public static String unparseStringList(String[] strings, String token) {}

    /**
     * Validates that the string is a valid Java identifier and not a reserved word.  This will through WFCInvalidArgumentExceptions if any condition
     * is not met.
     * 
     * @param s String to validate.
     */
    public static void validateIdentifier(String s) {}

    
    public static Object[] trimArray(Object[] ar, int len) {}

    public static Object[] arrayUnion(Object[] array1, Object[] array2) {}

    public static Object[] appendArrays(Class classType, Object[] array1, Object[] array2) {}
    
}