//STRIPPEDSOURCE//

package com.ms.wfc.win32;

import com.ms.win32.*;



import com.ms.dll.DllLib;
import com.ms.dll.Callback;

/** 
 * @hidden
 * @security(checkDllCalls=off)
 * @security(checkClassLinking=on)
 */
public class Lang {

    
    public static final int CT_CTYPE1            = 0x00000001;     
    public static final int CT_CTYPE2            = 0x00000002;     
    public static final int CT_CTYPE3            = 0x00000004;     

    
    public static final int C1_UPPER             = 0x0001;         
    public static final int C1_LOWER             = 0x0002;         
    public static final int C1_DIGIT             = 0x0004;         
    public static final int C1_SPACE             = 0x0008;         
    public static final int C1_PUNCT             = 0x0010;         
    public static final int C1_CNTRL             = 0x0020;         
    public static final int C1_BLANK             = 0x0040;         
    public static final int C1_XDIGIT            = 0x0080;         
    public static final int C1_ALPHA             = 0x0100;         

    
    public static final int C2_LEFTTORIGHT       = 0x1;            
    public static final int C2_RIGHTTOLEFT       = 0x2;            

    public static final int C2_EUROPENUMBER      = 0x3;            
    public static final int C2_EUROPESEPARATOR   = 0x4;            
    public static final int C2_EUROPETERMINATOR  = 0x5;            
    public static final int C2_ARABICNUMBER      = 0x6;            
    public static final int C2_COMMONSEPARATOR   = 0x7;            

    public static final int C2_BLOCKSEPARATOR    = 0x8;            
    public static final int C2_SEGMENTSEPARATOR  = 0x9;            
    public static final int C2_WHITESPACE        = 0xA;            
    public static final int C2_OTHERNEUTRAL      = 0xB;            

    public static final int C2_NOTAPPLICABLE     = 0x0;            

    
    public static final int C3_NONSPACING        = 0x0001;         
    public static final int C3_DIACRITIC         = 0x0002;         
    public static final int C3_VOWELMARK         = 0x0004;         
    public static final int C3_SYMBOL            = 0x0008;         

    public static final int C3_KATAKANA          = 0x0010;
    public static final int C3_HIRAGANA          = 0x0020;
    public static final int C3_HALFWIDTH         = 0x0040;
    public static final int C3_FULLWIDTH         = 0x0080;
    public static final int C3_IDEOGRAPH         = 0x0100;
    public static final int C3_KASHIDA           = 0x0200;
    public static final int C3_ALPHA             = 0x8000;

    public static final int C3_NOTAPPLICABLE     = 0x0;            


    
    public static final int NORM_IGNORECASE         = 0x00000001;  
    public static final int NORM_IGNORENONSPACE     = 0x00000002;  
    public static final int NORM_IGNORESYMBOLS      = 0x00000004;  

    public static final int NORM_IGNOREWIDTH        = 0x00010000;  
    public static final int NORM_IGNOREKANATYPE     = 0x00020000;  

    public static final int NORM_IGNOREKASHIDA      = 0x00040000;  


    
    public static final int LCMAP_LOWERCASE      = 0x00000100; 
    public static final int LCMAP_UPPERCASE      = 0x00000200; 
    public static final int LCMAP_SORTKEY        = 0x00000400; 

    public static final int LCMAP_HALFWIDTH      = 0x00000800;  
    public static final int LCMAP_FULLWIDTH      = 0x00001000; 
    public static final int LCMAP_HIRAGANA       = 0x00002000;  
    public static final int LCMAP_KATAKANA       = 0x00004000;  


    

    
    public static final int LANG_NEUTRAL                     = 0x00;

    public static final int LANG_ALBANIAN                    = 0x1c;
    public static final int LANG_ARABIC                      = 0x01;
    public static final int LANG_BAHASA                      = 0x21;
    public static final int LANG_BULGARIAN                   = 0x02;
    public static final int LANG_CATALAN                     = 0x03;
    public static final int LANG_CHINESE                     = 0x04;
    public static final int LANG_CZECH                       = 0x05;
    public static final int LANG_DANISH                      = 0x06;
    public static final int LANG_DUTCH                       = 0x13;
    public static final int LANG_ENGLISH                     = 0x09;
    public static final int LANG_FINNISH                     = 0x0b;
    public static final int LANG_FRENCH                      = 0x0c;
    public static final int LANG_GERMAN                      = 0x07;
    public static final int LANG_GREEK                       = 0x08;
    public static final int LANG_HEBREW                      = 0x0d;
    public static final int LANG_HUNGARIAN                   = 0x0e;
    public static final int LANG_ICELANDIC                   = 0x0f;
    public static final int LANG_ITALIAN                     = 0x10;
    public static final int LANG_JAPANESE                    = 0x11;
    public static final int LANG_KOREAN                      = 0x12;
    public static final int LANG_NORWEGIAN                   = 0x14;
    public static final int LANG_POLISH                      = 0x15;
    public static final int LANG_PORTUGUESE                  = 0x16;
    public static final int LANG_RHAETO_ROMAN                = 0x17;
    public static final int LANG_ROMANIAN                    = 0x18;
    public static final int LANG_RUSSIAN                     = 0x19;
    public static final int LANG_SERBO_CROATIAN              = 0x1a;
    public static final int LANG_SLOVAK                      = 0x1b;
    public static final int LANG_SPANISH                     = 0x0a;
    public static final int LANG_SWEDISH                     = 0x1d;
    public static final int LANG_THAI                        = 0x1e;
    public static final int LANG_TURKISH                     = 0x1f;
    public static final int LANG_URDU                        = 0x20;

    
    public static final int SUBLANG_NEUTRAL                  = 0x00;    
    public static final int SUBLANG_DEFAULT                  = 0x01;    
    public static final int SUBLANG_SYS_DEFAULT              = 0x02;    

    public static final int SUBLANG_CHINESE_SIMPLIFIED       = 0x02;    
    public static final int SUBLANG_CHINESE_TRADITIONAL      = 0x01; 
    public static final int SUBLANG_DUTCH                    = 0x01;    
    public static final int SUBLANG_DUTCH_BELGIAN            = 0x02;    
    public static final int SUBLANG_ENGLISH_US               = 0x01;    
    public static final int SUBLANG_ENGLISH_UK               = 0x02;    
    public static final int SUBLANG_ENGLISH_AUS              = 0x03;    
    public static final int SUBLANG_ENGLISH_CAN              = 0x04;    
    public static final int SUBLANG_ENGLISH_NZ               = 0x05;    
    public static final int SUBLANG_ENGLISH_EIRE             = 0x06;    
    public static final int SUBLANG_FRENCH                   = 0x01;    
    public static final int SUBLANG_FRENCH_BELGIAN           = 0x02;    
    public static final int SUBLANG_FRENCH_CANADIAN          = 0x03;    
    public static final int SUBLANG_FRENCH_SWISS             = 0x04;    
    public static final int SUBLANG_GERMAN                   = 0x01;    
    public static final int SUBLANG_GERMAN_SWISS             = 0x02;    
    public static final int SUBLANG_GERMAN_AUSTRIAN          = 0x03;    
    public static final int SUBLANG_ITALIAN                  = 0x01;    
    public static final int SUBLANG_ITALIAN_SWISS            = 0x02;    
    public static final int SUBLANG_NORWEGIAN_BOKMAL         = 0x01;    
    public static final int SUBLANG_NORWEGIAN_NYNORSK        = 0x02;    
    public static final int SUBLANG_PORTUGUESE               = 0x02;    
    public static final int SUBLANG_PORTUGUESE_BRAZILIAN     = 0x01;    
    public static final int SUBLANG_SERBO_CROATIAN_CYRILLIC  = 0x02;    
    public static final int SUBLANG_SERBO_CROATIAN_LATIN     = 0x01;    
    public static final int SUBLANG_SPANISH                  = 0x01;    
    public static final int SUBLANG_SPANISH_MEXICAN          = 0x02;    
    public static final int SUBLANG_SPANISH_MODERN           = 0x03;    


    
    public static final int CTRY_DEFAULT                     = 0;

    public static final int CTRY_AUSTRALIA                   = 61;      
    public static final int CTRY_AUSTRIA                     = 43;      
    public static final int CTRY_BELGIUM                     = 32;      
    public static final int CTRY_BRAZIL                      = 55;      
    public static final int CTRY_CANADA                      = 2;       
    public static final int CTRY_DENMARK                     = 45;      
    public static final int CTRY_FINLAND                     = 358;     
    public static final int CTRY_FRANCE                      = 33;      
    public static final int CTRY_GERMANY                     = 49;      
    public static final int CTRY_ICELAND                     = 354;     
    public static final int CTRY_IRELAND                     = 353;     
    public static final int CTRY_ITALY                       = 39;      
    public static final int CTRY_JAPAN                       = 81;      
    public static final int CTRY_MEXICO                      = 52;      
    public static final int CTRY_NETHERLANDS                 = 31;      
    public static final int CTRY_NEW_ZEALAND                 = 64;      
    public static final int CTRY_NORWAY                      = 47;      
    public static final int CTRY_PORTUGAL                    = 351;     
    public static final int CTRY_PRCHINA                     = 86;      
    public static final int CTRY_SOUTH_KOREA                 = 82;      
    public static final int CTRY_SPAIN                       = 34;      
    public static final int CTRY_SWEDEN                      = 46;      
    public static final int CTRY_SWITZERLAND                 = 41;      
    public static final int CTRY_TAIWAN                      = 886;     
    public static final int CTRY_UNITED_KINGDOM              = 44;      
    public static final int CTRY_UNITED_STATES               = 1;       


    
    public static final int LOCALE_NOUSEROVERRIDE       = 0x80000000;   
    public static final int LOCALE_USE_CP_ACP           = 0x40000000;   

    public static final int LOCALE_ILANGUAGE            = 0x00000001;   
    public static final int LOCALE_SLANGUAGE            = 0x00000002;   
    public static final int LOCALE_SENGLANGUAGE         = 0x00001001;   
    public static final int LOCALE_SABBREVLANGNAME      = 0x00000003;   
    public static final int LOCALE_SNATIVELANGNAME      = 0x00000004;   

    public static final int LOCALE_ICOUNTRY             = 0x00000005;   
    public static final int LOCALE_SCOUNTRY             = 0x00000006;   
    public static final int LOCALE_SENGCOUNTRY          = 0x00001002;   
    public static final int LOCALE_SABBREVCTRYNAME      = 0x00000007;   
    public static final int LOCALE_SNATIVECTRYNAME      = 0x00000008;   

    public static final int LOCALE_IDEFAULTLANGUAGE     = 0x00000009;   
    public static final int LOCALE_IDEFAULTCOUNTRY      = 0x0000000A;   
    public static final int LOCALE_IDEFAULTCODEPAGE     = 0x0000000B;   
    public static final int LOCALE_IDEFAULTANSICODEPAGE = 0x00001004;   
    public static final int LOCALE_IDEFAULTMACCODEPAGE  = 0x00001011;   

    public static final int LOCALE_SLIST                = 0x0000000C;   
    public static final int LOCALE_IMEASURE             = 0x0000000D;   

    public static final int LOCALE_SDECIMAL             = 0x0000000E;   
    public static final int LOCALE_STHOUSAND            = 0x0000000F;   
    public static final int LOCALE_SGROUPING            = 0x00000010;   
    public static final int LOCALE_IDIGITS              = 0x00000011;   
    public static final int LOCALE_ILZERO               = 0x00000012;   
    public static final int LOCALE_INEGNUMBER           = 0x00001010;   
    public static final int LOCALE_SNATIVEDIGITS        = 0x00000013;   

    public static final int LOCALE_SCURRENCY            = 0x00000014;   
    public static final int LOCALE_SINTLSYMBOL          = 0x00000015;   
    public static final int LOCALE_SMONDECIMALSEP       = 0x00000016;   
    public static final int LOCALE_SMONTHOUSANDSEP      = 0x00000017;   
    public static final int LOCALE_SMONGROUPING         = 0x00000018;   
    public static final int LOCALE_ICURRDIGITS          = 0x00000019;   
    public static final int LOCALE_IINTLCURRDIGITS      = 0x0000001A;   
    public static final int LOCALE_ICURRENCY            = 0x0000001B;   
    public static final int LOCALE_INEGCURR             = 0x0000001C;   

    public static final int LOCALE_SDATE                = 0x0000001D;   
    public static final int LOCALE_STIME                = 0x0000001E;   
    public static final int LOCALE_SSHORTDATE           = 0x0000001F;   
    public static final int LOCALE_SLONGDATE            = 0x00000020;   
    public static final int LOCALE_STIMEFORMAT          = 0x00001003;   
    public static final int LOCALE_IDATE                = 0x00000021;   
    public static final int LOCALE_ILDATE               = 0x00000022;   
    public static final int LOCALE_ITIME                = 0x00000023;   
    public static final int LOCALE_ITIMEMARKPOSN        = 0x00001005;   
    public static final int LOCALE_ICENTURY             = 0x00000024;   
    public static final int LOCALE_ITLZERO              = 0x00000025;   
    public static final int LOCALE_IDAYLZERO            = 0x00000026;   
    public static final int LOCALE_IMONLZERO            = 0x00000027;   
    public static final int LOCALE_S1159                = 0x00000028;   
    public static final int LOCALE_S2359                = 0x00000029;   

    public static final int LOCALE_ICALENDARTYPE        = 0x00001009;   
    public static final int LOCALE_IOPTIONALCALENDAR    = 0x0000100B;   
    public static final int LOCALE_IFIRSTDAYOFWEEK      = 0x0000100C;   
    public static final int LOCALE_IFIRSTWEEKOFYEAR     = 0x0000100D;   

    public static final int LOCALE_SDAYNAME1            = 0x0000002A;   
    public static final int LOCALE_SDAYNAME2            = 0x0000002B;   
    public static final int LOCALE_SDAYNAME3            = 0x0000002C;   
    public static final int LOCALE_SDAYNAME4            = 0x0000002D;   
    public static final int LOCALE_SDAYNAME5            = 0x0000002E;   
    public static final int LOCALE_SDAYNAME6            = 0x0000002F;   
    public static final int LOCALE_SDAYNAME7            = 0x00000030;   
    public static final int LOCALE_SABBREVDAYNAME1      = 0x00000031;   
    public static final int LOCALE_SABBREVDAYNAME2      = 0x00000032;   
    public static final int LOCALE_SABBREVDAYNAME3      = 0x00000033;   
    public static final int LOCALE_SABBREVDAYNAME4      = 0x00000034;   
    public static final int LOCALE_SABBREVDAYNAME5      = 0x00000035;   
    public static final int LOCALE_SABBREVDAYNAME6      = 0x00000036;   
    public static final int LOCALE_SABBREVDAYNAME7      = 0x00000037;   
    public static final int LOCALE_SMONTHNAME1          = 0x00000038;   
    public static final int LOCALE_SMONTHNAME2          = 0x00000039;   
    public static final int LOCALE_SMONTHNAME3          = 0x0000003A;   
    public static final int LOCALE_SMONTHNAME4          = 0x0000003B;   
    public static final int LOCALE_SMONTHNAME5          = 0x0000003C;   
    public static final int LOCALE_SMONTHNAME6          = 0x0000003D;   
    public static final int LOCALE_SMONTHNAME7          = 0x0000003E;   
    public static final int LOCALE_SMONTHNAME8          = 0x0000003F;   
    public static final int LOCALE_SMONTHNAME9          = 0x00000040;   
    public static final int LOCALE_SMONTHNAME10         = 0x00000041;   
    public static final int LOCALE_SMONTHNAME11         = 0x00000042;   
    public static final int LOCALE_SMONTHNAME12         = 0x00000043;   
    public static final int LOCALE_SMONTHNAME13         = 0x0000100E;   
    public static final int LOCALE_SABBREVMONTHNAME1    = 0x00000044;   
    public static final int LOCALE_SABBREVMONTHNAME2    = 0x00000045;   
    public static final int LOCALE_SABBREVMONTHNAME3    = 0x00000046;   
    public static final int LOCALE_SABBREVMONTHNAME4    = 0x00000047;   
    public static final int LOCALE_SABBREVMONTHNAME5    = 0x00000048;   
    public static final int LOCALE_SABBREVMONTHNAME6    = 0x00000049;   
    public static final int LOCALE_SABBREVMONTHNAME7    = 0x0000004A;   
    public static final int LOCALE_SABBREVMONTHNAME8    = 0x0000004B;   
    public static final int LOCALE_SABBREVMONTHNAME9    = 0x0000004C;   
    public static final int LOCALE_SABBREVMONTHNAME10   = 0x0000004D;   
    public static final int LOCALE_SABBREVMONTHNAME11   = 0x0000004E;   
    public static final int LOCALE_SABBREVMONTHNAME12   = 0x0000004F;   
    public static final int LOCALE_SABBREVMONTHNAME13   = 0x0000100F;   

    public static final int LOCALE_SPOSITIVESIGN        = 0x00000050;   
    public static final int LOCALE_SNEGATIVESIGN        = 0x00000051;   
    public static final int LOCALE_IPOSSIGNPOSN         = 0x00000052;   
    public static final int LOCALE_INEGSIGNPOSN         = 0x00000053;   
    public static final int LOCALE_IPOSSYMPRECEDES      = 0x00000054;   
    public static final int LOCALE_IPOSSEPBYSPACE       = 0x00000055;   
    public static final int LOCALE_INEGSYMPRECEDES      = 0x00000056;   
    public static final int LOCALE_INEGSEPBYSPACE       = 0x00000057;   

    public static final int LOCALE_FONTSIGNATURE        = 0x00000058;   
    public static final int LOCALE_SISO639LANGNAME      = 0x00000059;   
    public static final int LOCALE_SISO3166CTRYNAME     = 0x0000005A;   

    
    
    public static final int LOCALE_IDEFAULTEBCDICCODEPAGE = 0x00001012;   
    public static final int LOCALE_IPAPERSIZE             = 0x0000100A;   
    public static final int LOCALE_SENGCURRNAME           = 0x00001007;   
    public static final int LOCALE_SNATIVECURRNAME        = 0x00001008;   
    public static final int LOCALE_SYEARMONTH             = 0x00001006;   
    public static final int LOCALE_SSORTNAME              = 0x00001013;   
    public static final int LOCALE_IDIGITSUBSTITUTION     = 0x00001014;   
    
    
    public static final int TIME_NOMINUTESORSECONDS    = 0x00000001;  
    public static final int TIME_NOSECONDS             = 0x00000002;  
    public static final int TIME_NOTIMEMARKER          = 0x00000004;  
    public static final int TIME_FORCE24HOURFORMAT     = 0x00000008;  


    
    public static final int DATE_SHORTDATE             = 0x00000001;  
    public static final int DATE_LONGDATE              = 0x00000002;  
    public static final int DATE_USE_ALT_CALENDAR      = 0x00000004;  


    
    public static final int CAL_ICALINTVALUE           = 0x00000001;   
    public static final int CAL_SCALNAME               = 0x00000002;   
    public static final int CAL_IYEAROFFSETRANGE       = 0x00000003;   
    public static final int CAL_SERASTRING             = 0x00000004;   
    public static final int CAL_SSHORTDATE             = 0x00000005;   
    public static final int CAL_SLONGDATE              = 0x00000006;   
    public static final int CAL_SDAYNAME1              = 0x00000007;   
    public static final int CAL_SDAYNAME2              = 0x00000008;   
    public static final int CAL_SDAYNAME3              = 0x00000009;   
    public static final int CAL_SDAYNAME4              = 0x0000000a;   
    public static final int CAL_SDAYNAME5              = 0x0000000b;   
    public static final int CAL_SDAYNAME6              = 0x0000000c;   
    public static final int CAL_SDAYNAME7              = 0x0000000d;   
    public static final int CAL_SABBREVDAYNAME1        = 0x0000000e;   
    public static final int CAL_SABBREVDAYNAME2        = 0x0000000f;   
    public static final int CAL_SABBREVDAYNAME3        = 0x00000010;   
    public static final int CAL_SABBREVDAYNAME4        = 0x00000011;   
    public static final int CAL_SABBREVDAYNAME5        = 0x00000012;   
    public static final int CAL_SABBREVDAYNAME6        = 0x00000013;   
    public static final int CAL_SABBREVDAYNAME7        = 0x00000014;   
    public static final int CAL_SMONTHNAME1            = 0x00000015;   
    public static final int CAL_SMONTHNAME2            = 0x00000016;   
    public static final int CAL_SMONTHNAME3            = 0x00000017;   
    public static final int CAL_SMONTHNAME4            = 0x00000018;   
    public static final int CAL_SMONTHNAME5            = 0x00000019;   
    public static final int CAL_SMONTHNAME6            = 0x0000001a;   
    public static final int CAL_SMONTHNAME7            = 0x0000001b;   
    public static final int CAL_SMONTHNAME8            = 0x0000001c;   
    public static final int CAL_SMONTHNAME9            = 0x0000001d;   
    public static final int CAL_SMONTHNAME10           = 0x0000001e;   
    public static final int CAL_SMONTHNAME11           = 0x0000001f;   
    public static final int CAL_SMONTHNAME12           = 0x00000020;   
    public static final int CAL_SMONTHNAME13           = 0x00000021;   
    public static final int CAL_SABBREVMONTHNAME1      = 0x00000022;   
    public static final int CAL_SABBREVMONTHNAME2      = 0x00000023;   
    public static final int CAL_SABBREVMONTHNAME3      = 0x00000024;   
    public static final int CAL_SABBREVMONTHNAME4      = 0x00000025;   
    public static final int CAL_SABBREVMONTHNAME5      = 0x00000026;   
    public static final int CAL_SABBREVMONTHNAME6      = 0x00000027;   
    public static final int CAL_SABBREVMONTHNAME7      = 0x00000028;   
    public static final int CAL_SABBREVMONTHNAME8      = 0x00000029;   
    public static final int CAL_SABBREVMONTHNAME9      = 0x0000002a;   
    public static final int CAL_SABBREVMONTHNAME10     = 0x0000002b;   
    public static final int CAL_SABBREVMONTHNAME11     = 0x0000002c;   
    public static final int CAL_SABBREVMONTHNAME12     = 0x0000002d;   
    public static final int CAL_SABBREVMONTHNAME13     = 0x0000002e;   


    
    public static final int ENUM_ALL_CALENDARS         = 0xffffffff;   


    
    public static final int CAL_GREGORIAN        = 1;         
    public static final int CAL_GREGORIAN_US     = 2;         
    public static final int CAL_JAPAN            = 3;         
    public static final int CAL_TAIWAN           = 4;         
    public static final int CAL_KOREA            = 5;         
    public static final int CAL_HIJRI            = 6;         
    public static final int CAL_THAI             = 7;         
    public static final int CAL_HEBREW           = 8;         

    
    public static final int TCI_SRCCHARSET  = 1;
    public static final int TCI_SRCCODEPAGE = 2;
    public static final int TCI_SRCFONTSIG  = 3;

    /***************************************************************************\
    * Typedefs
    *
    * Define all types for the NLS component here.
    \***************************************************************************/

    
    
    
    

    /***************************************************************************\
    * Macros
    *
    * Define all macros for the NLS component here.
    \***************************************************************************/

    
    public static final int MAKELANGID(int primary, int sub) {}

    public static final int PRIMARYLANGID(int lgid) {}

    public static final int SUBLANGID(int lgid) {}




















    public static final int NLS_VALID_LOCALE_MASK  = 0x000fffff;
    public static final int SORT_DEFAULT                     =0x0;     

    public static final int SORT_JAPANESE_XJIS               =0x0;     
    public static final int SORT_JAPANESE_UNICODE            =0x1;     

    public static final int SORT_CHINESE_BIG5                =0x0;     
    public static final int SORT_CHINESE_PRCP                =0x0;     
    public static final int SORT_CHINESE_UNICODE             =0x1;     
    public static final int SORT_CHINESE_PRC                 =0x2;     

    public static final int SORT_KOREAN_KSC                  =0x0;     
    public static final int SORT_KOREAN_UNICODE              =0x1;     

    public static final int SORT_GERMAN_PHONE_BOOK           =0x1;     

    /**
     * Creates an LCID from a LangId
     */
    public static final int MAKELCID(int lgid) {}

    /**
     * Creates an LCID from a LangId
     */
    public static final int MAKELCID(int lgid, int sort) {}

    /**
     *  Get the language id from a locale id.
     */
    public static final int LANGIDFROMLCID(int lcid) {}

    /**
     * Returns the sortid associated with the LCID
     */
    public static final int SORTIDFROMLCID(int lcid) {}


    
    public static final int LANG_SYSTEM_DEFAULT =MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT);
    public static final int LANG_USER_DEFAULT   =MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT);

    public static final int LOCALE_SYSTEM_DEFAULT=  MAKELCID(LANG_SYSTEM_DEFAULT);
    public static final int LOCALE_USER_DEFAULT =    MAKELCID(LANG_USER_DEFAULT);


    /***************************************************************************\
    * Function Prototypes
    *
    * Only prototypes for the NLS APIs should go here.
    \***************************************************************************/

    /** @dll.import("kernel32", unicode, entrypoint="CompareStringW") */
    public static native int CompareStringW(int Locale, int dwCmpFlags, String String1, int cchCount1, String String2, int cchCount2);
    /** @dll.import("kernel32", ansi, entrypoint="CompareStringA") */
    public static native int CompareStringA(int Locale, int dwCmpFlags, byte[] String1, int cchCount1, byte[] String2, int cchCount2);
    /** @dll.import("kernel32", auto) */
    public static native int LCMapString(int Locale, int dwMapFlags, String lpSrcStr, int cchSrc, StringBuffer lpDestStr, int cchDest);
    /** @dll.import("kernel32", auto) */
    public static native int GetLocaleInfo(int Locale, int LCType, StringBuffer lpLCData, int cchData);
    /** @dll.import("kernel32", auto) */
    public static native int GetLocaleInfo(int Locale, int LCType, LOCALESIGNATURE lpLCData, int cchData);
    public static int GetLocaleInfo(int Locale, int LCType, LOCALESIGNATURE lpLCData) {}
    /** @dll.import("kernel32", auto) */
    public static native int GetStringType(int Locale, int dwInfoType, String lpSrcStr, int cchSrc, int[] lpCharType);
    /** @dll.import("kernel32", auto) */
    public static native int GetSystemDefaultLangID();
    /** @dll.import("kernel32", auto) */
    public static native int GetUserDefaultLangID();
    /** @dll.import("kernel32", auto) */
    public static native int GetSystemDefaultLCID();
    /** @dll.import("kernel32", auto) */
    public static native int GetUserDefaultLCID();
    /** @dll.import("kernel32", auto, entrypoint="GetThreadLocale") */
    public static native int GetThreadLCID();
}